package com.baijiayun.groupclassui.container;

import android.annotation.TargetApi;
import android.content.Context;
import androidx.annotation.NonNull;
import androidx.annotation.Nullable;
import android.util.AttributeSet;
import android.view.ViewGroup;

import com.baijiayun.groupclassui.layer.BaseLayerOfProfessionalClass;
import com.baijiayun.groupclassui.window.InteractiveBaseWindow;
import com.baijiayun.groupclassui.window.bottommenu.BottomMenuWindow;
import com.baijiayun.groupclassui.window.bottommenu.LeftMenuWindow;
import com.baijiayun.livebase.context.LPConstants;

/**
 * todo 去掉MenuContainer
 */
public class MenuContainer extends BaseLayerOfProfessionalClass {
    private final String TAG = MenuContainer.class.getCanonicalName();

    private InteractiveBaseWindow bottomMenuWindow;

    public MenuContainer(@NonNull Context context) {
        this(context, null);
    }

    public MenuContainer(@NonNull Context context, @Nullable AttributeSet attrs) {
        this(context, attrs, 0);
    }

    public MenuContainer(@NonNull Context context, @Nullable AttributeSet attrs, int defStyleAttr) {
        super(context, attrs, defStyleAttr);
    }

    @TargetApi(21)
    public MenuContainer(@NonNull Context context, @Nullable AttributeSet attrs, int defStyleAttr, int defStyleRes) {
        super(context, attrs, defStyleAttr, defStyleRes);
    }

    @Override
    public boolean onRoomStatusChange(boolean isRoomActive) {
        boolean isLayerInit = super.onRoomStatusChange(isRoomActive);
        if(isLayerInit){
            if (isRoomActive) {
                initTemplate();
            } else {
                release();
            }
        }
        return true;
    }

    public void initTemplate() {
        if (router == null || router.getLiveRoom() == null) {
            return;
        }
        if (router.getLiveRoom().isAudition()) {
            return;
        }
        if (router.getLiveRoom().getSmallClassTemplateType() == LPConstants.SmallClassTemplateType.ONEONONE) {
            ViewGroup.LayoutParams layoutParams = new ViewGroup.LayoutParams(ViewGroup.LayoutParams.WRAP_CONTENT, ViewGroup.LayoutParams.MATCH_PARENT);
            bottomMenuWindow = new LeftMenuWindow(getContext());
            addView(bottomMenuWindow.getView(), layoutParams);
        } else {
            bottomMenuWindow = new BottomMenuWindow(getContext());
            addView(bottomMenuWindow.getView());
        }
    }

    @Override
    public void onDestroy() {
        super.onDestroy();
        release();
    }

    private void release(){
        compositeDisposable.clear();
        if (bottomMenuWindow != null) {
            bottomMenuWindow.onDestroy();
        }
        bottomMenuWindow = null;
    }
}
