package com.baijiayun.groupclassui.container;

import android.content.Context;
import android.graphics.drawable.ColorDrawable;
import android.text.TextUtils;
import android.util.AttributeSet;
import android.view.ViewGroup;
import android.widget.FrameLayout;
import android.widget.ImageView;

import androidx.annotation.NonNull;
import androidx.annotation.Nullable;

import com.baijiayun.glide.Glide;
import com.baijiayun.groupclassui.R;
import com.baijiayun.groupclassui.global.IRouter;
import com.baijiayun.livebase.utils.ThemeDataUtil;

/**
 * Created by Dujuncan on 2019/2/26
 */
public class RoomBackgroundContainer extends FrameLayout {

    private ImageView ivBg;

    public RoomBackgroundContainer(@NonNull Context context) {
        this(context, null);
    }

    public RoomBackgroundContainer(@NonNull Context context, @Nullable AttributeSet attrs) {
        this(context, attrs, 0);
    }

    public RoomBackgroundContainer(@NonNull Context context, @Nullable AttributeSet attrs, int defStyleAttr) {
        super(context, attrs, defStyleAttr);
    }

    public RoomBackgroundContainer(@NonNull Context context, @Nullable AttributeSet attrs, int defStyleAttr, int defStyleRes) {
        super(context, attrs, defStyleAttr, defStyleRes);
    }

    public void setBgUrl(String url) {
        if (ivBg == null) {
            ivBg = new ImageView(getContext());
        }
        if (!TextUtils.isEmpty(url)) {
            ivBg.setScaleType(ImageView.ScaleType.CENTER_CROP);
            Glide.with(getContext().getApplicationContext())
                    .load(url)
                    .into(ivBg);
        } else {
            ColorDrawable drawable = new ColorDrawable(ThemeDataUtil.getColorFromThemeConfigByAttrId(getContext(), R.attr.base_theme_room_bg_color));
            ivBg.setImageDrawable(drawable);
        }
        addView(ivBg, new ViewGroup.LayoutParams(ViewGroup.LayoutParams.MATCH_PARENT, ViewGroup.LayoutParams.MATCH_PARENT));
    }
}
