package com.baijiayun.groupclassui.container;

import static com.baijiayun.bjyutils.kt.UtilsKt.isEmptySet;
import static com.baijiayun.bjyutils.kt.UtilsKt.removeViewFromParent;
import static com.baijiayun.groupclassui.window.ppt.PPTWindow.PPT_WINDOW_MOVE;
import static com.baijiayun.groupclassui.window.ppt.PPTWindow.PPT_WINDOW_SCALE;

import android.app.Dialog;
import android.content.Context;
import android.graphics.Color;
import android.graphics.PointF;
import android.text.TextUtils;
import android.util.AttributeSet;
import android.util.Pair;
import android.util.SparseArray;
import android.view.Gravity;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.view.ViewParent;
import android.view.WindowManager;
import android.widget.CheckBox;
import android.widget.FrameLayout;
import android.widget.TextView;

import androidx.annotation.NonNull;
import androidx.annotation.Nullable;
import androidx.appcompat.app.AppCompatActivity;

import com.baijiayun.bjyrtcengine.Defines.BJYRtcCommon;
import com.baijiayun.bjyutils.kt.UtilsKt;
import com.baijiayun.bjyutils.log.LPLogger;
import com.baijiayun.bjyutils.query.QueryPlus;
import com.baijiayun.bjyutils.reactivex.RxUtils;
import com.baijiayun.bjyutils.screen.DisplayUtils;
import com.baijiayun.groupclassui.R;
import com.baijiayun.groupclassui.global.EventKey;
import com.baijiayun.groupclassui.global.GroupClassActivity;
import com.baijiayun.groupclassui.layer.BaseLayerOfProfessionalClass;
import com.baijiayun.groupclassui.layer.BlackboardLayer;
import com.baijiayun.groupclassui.layer.DocumentLayer;
import com.baijiayun.groupclassui.layer.VideoLayer;
import com.baijiayun.groupclassui.model.NotifyAwardModel;
import com.baijiayun.groupclassui.model.PlayerViewActionModel;
import com.baijiayun.groupclassui.model.SbbCloseWindowEvent;
import com.baijiayun.groupclassui.util.FECompatUtil;
import com.baijiayun.groupclassui.window.BaseTitledWindow;
import com.baijiayun.groupclassui.window.blackboard.BlackboardListener;
import com.baijiayun.groupclassui.window.blackboard.BlackboardScrollView;
import com.baijiayun.groupclassui.window.coursewaremanage.MediaCoursewarePlayerWindow;
import com.baijiayun.groupclassui.window.group.GroupAwardWindow;
import com.baijiayun.groupclassui.window.ppt.PPTTabLayer;
import com.baijiayun.groupclassui.window.ppt.PPTWindow;
import com.baijiayun.groupclassui.window.toolbar.DrawLineMode;
import com.baijiayun.groupclassui.window.toolbar.ToolbarWindow;
import com.baijiayun.groupclassui.window.toolbox.quiz.QuizWindow;
import com.baijiayun.groupclassui.window.toolbox.randomselect.RandomSelectWindow;
import com.baijiayun.groupclassui.window.toolbox.smallblackboard.SbbUtils;
import com.baijiayun.groupclassui.window.toolbox.smallblackboard.SmallBlackboardStatus;
import com.baijiayun.groupclassui.window.toolbox.smallblackboard.SmallBlackboardWindow;
import com.baijiayun.groupclassui.window.toolbox.timer.StudentTimerWindow;
import com.baijiayun.groupclassui.window.toolbox.timer.TeacherTimerWindow;
import com.baijiayun.groupclassui.window.toolbox.turntable.TurntableWindow;
import com.baijiayun.groupclassui.window.video.VideoContainerWindow;
import com.baijiayun.groupclassui.window.video.VideoWindow;
import com.baijiayun.livebase.context.LPConstants;
import com.baijiayun.livebase.models.GroupItem;
import com.baijiayun.livebase.models.LPJsonModel;
import com.baijiayun.livebase.models.LPUserModel;
import com.baijiayun.livebase.models.imodels.IUserModel;
import com.baijiayun.livebase.utils.FileUtils;
import com.baijiayun.livebase.utils.ThemeDataUtil;
import com.baijiayun.livebase.widgets.dialog.CommonDialog;
import com.baijiayun.livecore.listener.OnPhoneRollCallListener;
import com.baijiayun.livecore.models.LPAnswerModel;
import com.baijiayun.livecore.models.LPDocModel;
import com.baijiayun.livecore.models.LPDocViewElementModel;
import com.baijiayun.livecore.models.LPDocViewUpdateModel;
import com.baijiayun.livecore.models.LPDocumentModel;
import com.baijiayun.livecore.models.LPGroupAwardModel;
import com.baijiayun.livecore.models.LPGroupInfoAwardModel;
import com.baijiayun.livecore.models.LPGroupItem;
import com.baijiayun.livecore.models.LPMotionEvent;
import com.baijiayun.livecore.models.LPPlayerViewUpdateModel;
import com.baijiayun.livecore.models.LPRandomSelectValueModel;
import com.baijiayun.livecore.models.LPRoomRollCallResultModel;
import com.baijiayun.livecore.models.LPSnippetPullReqModel;
import com.baijiayun.livecore.models.LPSnippetPullResModel;
import com.baijiayun.livecore.models.LPSnippetSubmitModel;
import com.baijiayun.livecore.models.LPTimerModel;
import com.baijiayun.livecore.models.LPTurntableModel;
import com.baijiayun.livecore.models.LPUploadDocModel;
import com.baijiayun.livecore.models.LPWebPageInfoModel;
import com.baijiayun.livecore.models.courseware.LPMediaCoursewareModel;
import com.baijiayun.livecore.models.imodels.IMediaModel;
import com.baijiayun.livecore.ppt.PPTView;
import com.baijiayun.livecore.ppt.whiteboard.LaserShapeLayer;
import com.baijiayun.livecore.ppt.whiteboard.shape.BitmapShape;
import com.baijiayun.livecore.utils.LPMediaIdUtils;
import com.baijiayun.liveuibase.base.BaseTitleWindow2;
import com.baijiayun.liveuibase.base.BaseUIConstant;
import com.baijiayun.liveuibase.base.BaseUIConstant.SelectSrc;
import com.baijiayun.liveuibase.base.BaseWindow;
import com.baijiayun.liveuibase.base.RouterListener;
import com.baijiayun.liveuibase.toolbox.answerer.AdminAnswererWindow;
import com.baijiayun.liveuibase.toolbox.answerer.AnswererWindow;
import com.baijiayun.liveuibase.toolbox.browser.BrowserWindow;
import com.baijiayun.liveuibase.toolbox.browser.Tuple;
import com.baijiayun.liveuibase.toolbox.responder.ResponderRobButton;
import com.baijiayun.liveuibase.toolbox.responder.ResponderWindow;
import com.baijiayun.liveuibase.toolbox.rollcall.AdminRollCallWindow;
import com.baijiayun.liveuibase.toolbox.rollcall.RollCallDialogContract;
import com.baijiayun.liveuibase.toolbox.rollcall.RollCallDialogPresenter;
import com.baijiayun.liveuibase.toolbox.rollcall.RollCallWindow;
import com.baijiayun.liveuibase.utils.BaseUtilsKt;
import com.baijiayun.liveuibase.utils.ToastUtil;
import com.baijiayun.liveuibase.widgets.popupwindow.BaseAutoArrangePopupWindow;
import com.baijiayun.liveuibase.widgets.toolbar.BaseDrawWidthSettingWindow;
import com.baijiayun.liveuibase.widgets.toolbar.BaseGraphMenuWindow;
import com.baijiayun.liveuibase.widgets.toolbar.ColorSelectData;
import com.baijiayun.liveuibase.widgets.toolbar.WidthSelectData;

import java.util.ArrayList;
import java.util.Collections;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.Objects;
import java.util.Random;
import java.util.Set;
import java.util.concurrent.ConcurrentHashMap;
import java.util.concurrent.ConcurrentLinkedQueue;
import java.util.concurrent.TimeUnit;

import android_serialport_api.XYConstant;
import android_serialport_api.ZXYBDeviceInfo;
import io.reactivex.Observable;
import io.reactivex.ObservableSource;
import io.reactivex.android.schedulers.AndroidSchedulers;
import io.reactivex.disposables.Disposable;
import io.reactivex.functions.Function;

/**
 * Created by Shubo on 2018/9/11.
 */
public class SyncContainer extends BaseLayerOfProfessionalClass {
    private final String TAG = SyncContainer.class.getCanonicalName();

    private Disposable subscriptionOfDocDel;
    private Disposable subscriptionOfSelectMode;
    private Disposable subscriptionOfDrawLineMode;

    private ConcurrentLinkedQueue<PPTWindow> pptWindows;
    private BrowserWindow browserWindow;
    private ConcurrentLinkedQueue<VideoContainerWindow> videoWindows;
    private ConcurrentLinkedQueue<SmallBlackboardWindow> smallBlackboardWindows;
    private BaseWindow studentTimerWindow, teacherTimerWindow, studentAnswererWindow, teacherAnswererWindow,
            randomSelectWindow, rollCallWindow, adminRollCallWindow, turntableWindow;
    private QuizWindow quizWindow;

    private ConcurrentHashMap<String, LPPlayerViewUpdateModel> cachedViewPositions; // <id, position>

    private BaseLayerOfProfessionalClass documentLayer, blackboardLayer, smallBlackboardLayer,
            browserLayer, toolBoxLayer, randomSelectLayer;
    private PPTTabLayer pptTabLayer;

    private VideoLayer videoLayer;

    private LaserShapeLayer laserShapeLayer; //激光笔显示View

    private BaseTitledWindow maximumWindow;

    private final ViewGroup.LayoutParams lp = new ViewGroup.LayoutParams(ViewGroup.LayoutParams.MATCH_PARENT, ViewGroup.LayoutParams.MATCH_PARENT);

    private ShapePaint shapePaint;
    //保存所有可公开用户的信息，用户显示名称时根据number获取name
    private final Set<IUserModel> sbbAllUserSet = new HashSet<>();
    //缓存media窗口的player_view_update信息，插播、本地媒体切换过程中不会发player_view_update，需要通过缓存来恢复窗口信息
    private LPPlayerViewUpdateModel mediaCachePlayerUpdateModel = new LPPlayerViewUpdateModel();
    private final LPMotionEvent lpMotionEvent = new LPMotionEvent();
    LPDocumentModel mPreviewDocModel = null; // 预览 ppt model

    private boolean pptAuth;
    private int selfWidth, selfHeight;
    private float writingBoardRatio = 1.0f;
    //手写板落笔的pptWindow
    private PPTWindow destPPTWindow;
    private MediaCoursewarePlayerWindow mediaPlayerWindow;
    private RollCallDialogPresenter rollCallDialogPresenter;
    private List<LPDocViewElementModel> webpageUpdateModeList = new ArrayList<>();
    private LPDocViewUpdateModel webpageUpdateModel;

    private Boolean isCheckNotRemind = false;
    private Dialog remindDialog;

    public SyncContainer(@NonNull Context context) {
        super(context);
        initBlackboardLayer();
    }

    public SyncContainer(@NonNull Context context, @Nullable AttributeSet attrs) {
        super(context, attrs, 0);
        initBlackboardLayer();
    }

    public SyncContainer(@NonNull Context context, @Nullable AttributeSet attrs, int defStyleAttr) {
        super(context, attrs, defStyleAttr);
        initBlackboardLayer();
    }

    private void initBlackboardLayer() {
        blackboardLayer = new BlackboardLayer(getContext());
        addView(blackboardLayer.getViewGroup());
        shapePaint = new ShapePaint(DEFAULT_SHAPE_COLOR, DEFAULT_SHAPE_WIDTH);
        ((BlackboardLayer) blackboardLayer).setShapePaint(shapePaint);
    }

    private void initSyncContainer() {
        documentLayer = new DocumentLayer(getContext());
        pptTabLayer = new PPTTabLayer(getContext());
        smallBlackboardLayer = new BaseLayerOfProfessionalClass(getContext());
        browserLayer = new BaseLayerOfProfessionalClass(getContext());
        randomSelectLayer = new BaseLayerOfProfessionalClass(getContext());
        videoLayer = new VideoLayer(getContext());
        laserShapeLayer = new LaserShapeLayer(getContext());
        toolBoxLayer = new BaseLayerOfProfessionalClass(getContext());

        addView(documentLayer.getViewGroup());
        if (BaseUtilsKt.isAdmin(router.getLiveRoom())) {
            addView(pptTabLayer.getViewGroup());
        }
        addView(laserShapeLayer, lp);
        addView(videoLayer.getViewGroup());
        addView(randomSelectLayer);
        addView(browserLayer.getViewGroup());
        addView(smallBlackboardLayer.getViewGroup());
        addView(toolBoxLayer.getViewGroup());
        pptTabLayer.show(false);
        router.setObjectByKey(EventKey.PPTTabLayer, pptTabLayer);
        laserShapeLayer.setOnChangeLaserShapeListener(info -> {
            //修改范围
            if (pptWindows == null) {
                return;
            }
            for (PPTWindow pptWindow : getPPTWindows()) {
                if (pptWindow.isMaxInFull()) {
                    info.isFull = true;
                    pptWindow.getPPTView().getPPTPagePositionInfo(info);
                } else if (pptWindow.isMaxInSync() && !info.isFull) {
                    pptWindow.getPPTView().getPPTPagePositionInfo(info);
                }
            }
        });
    }


    @Override
    public boolean onRoomStatusChange(boolean isRoomActive) {
        boolean isLayerInit = super.onRoomStatusChange(isRoomActive);
        if (isLayerInit) {
            if (!isRoomActive) {
                //暂时只保留blackboardLayer
                //videoLayer已经销毁,fullVideoWindow也跟随销毁
                isFirstCalledHandleVideoWindowPosition = false;
                removeAndDestroy(documentLayer);
                removeAndDestroy(smallBlackboardLayer);
                removeAndDestroy(browserLayer);
                removeAndDestroy(randomSelectLayer);
                removeAndDestroy(videoLayer);
                removeAndDestroy(toolBoxLayer);
                destroyToolBox();
                clearVideoWindows();
                clearPPTWindows();
                if (shapePaint != null) {
                    shapePaint.removeAllListener();
                }
                if (laserShapeLayer != null) {
                    removeView(laserShapeLayer);
                    laserShapeLayer.onDestroy();
                }
                if (pptTabLayer != null) {
                    removeViewFromParent(pptTabLayer);
                }
                if (randomSelectWindow != null) {
                    randomSelectLayer.removeWindow(randomSelectWindow);
                    randomSelectWindow.onDestroy();
                    randomSelectWindow = null;
                }
                removeAndDestroy(randomSelectLayer);
                mPreviewDocModel = null;
                if (mediaPlayerWindow != null) {
                    mediaPlayerWindow.onDestroy();
                    mediaPlayerWindow = null;
                }
            }
        }
        return true;
    }

    public void initView() {
        if (selfWidth != 0) {
            router.setObjectByKey(EventKey.FullScreenWidth, selfWidth);
        }
        ((BlackboardLayer) blackboardLayer).initView();
        initSyncContainer();
        subscribe();
    }

    @Override
    protected void onSizeChanged(int w, int h, int oldw, int oldh) {
        super.onSizeChanged(w, h, oldw, oldh);
        selfWidth = getMeasuredWidth();
        selfHeight = getMeasuredHeight();
        if (router != null) {
            router.setObjectByKey(EventKey.FullScreenWidth, selfWidth);
        }
    }

    private void subscribe() {
        if (router.getLiveRoom() != null) {
            initPPT();
            initBrowser();
            initVideo();
            initTimer();
            initAnswerer();
            initQuiz();
            router.setObjectByKey(EventKey.AllSnippetViewList, new ArrayList<>());
            startSbbObservable();
            startResponderObservable();
            startMediaCoursewareObservable();
            startOtherObservable();
        }
    }

    private void initQuiz() {
        //开始小测
        compositeDisposable.add(router.getLiveRoom().getQuizVM().getObservableOfQuizStart()
                .observeOn(AndroidSchedulers.mainThread())
                .subscribe(jsonModel -> {
                    if (router.getLiveRoom().getCurrentUser().getType() != LPConstants.LPUserType.Teacher) {
                        onQuizArrived(jsonModel, false);
                    }
                }));
        //中途打开
        compositeDisposable.add(router.getLiveRoom().getQuizVM().getObservableOfQuizRes()
                .observeOn(AndroidSchedulers.mainThread())
                .subscribe(jsonModel -> {
                    if (router.getLiveRoom().getCurrentUser().getType() != LPConstants.LPUserType.Teacher) {
                        if (jsonModel != null && jsonModel.data != null) {
                            String quizId = "";
                            if (jsonModel.data.has("quiz_id")) {
                                quizId = jsonModel.data.get("quiz_id").getAsString();
                            }
                            boolean solutionStatus = !jsonModel.data.has("solution") // 没有solution
                                    || jsonModel.data.getAsJsonObject("solution").entrySet().isEmpty() // "solution":{}
                                    || jsonModel.data.getAsJsonObject("solution").isJsonNull();
                            // "solution":"null"
                            boolean endFlag = jsonModel.data.get("end_flag").getAsInt() == 1;
                            //quizid非空、solution是空、没有结束答题 才弹窗
                            if (!TextUtils.isEmpty(quizId) && solutionStatus && !endFlag) {
                                onQuizArrived(jsonModel, false);
                            }
                        }

                    }
                }));
        //结束，只转发h5
        compositeDisposable.add(router.getLiveRoom().getQuizVM().getObservableOfQuizEnd()
                .observeOn(AndroidSchedulers.mainThread())
                .subscribe(jsonModel -> {
                    if (router.getLiveRoom().getCurrentUser().getType() != LPConstants.LPUserType.Teacher) {
                        onQuizEndArrived(jsonModel);
                    }
                }));
        //发答案啦
        compositeDisposable.add(router.getLiveRoom().getQuizVM().getObservableOfQuizSolution()
                .observeOn(AndroidSchedulers.mainThread())
                .subscribe(jsonModel -> {
                    if (router.getLiveRoom().getCurrentUser().getType() != LPConstants.LPUserType.Teacher) {
                        onQuizArrived(jsonModel, true);
                    }
                }));
        compositeDisposable.add(router.getSubjectByKey(EventKey.CloseQuizDialog)
                .observeOn(AndroidSchedulers.mainThread())
                .subscribe(o -> {
                    boolean b = (boolean) o;
                    if (b ^ isQuizSolution) {
                        return;
                    }
                    if (quizWindow != null) {
                        if (toolBoxLayer != null) {
                            toolBoxLayer.removeWindow(quizWindow);
                        }
                        quizWindow.onDestroy();
                        quizWindow = null;
                    }
                }));
    }

    private FrameLayout.LayoutParams getQuizParams() {
        FrameLayout.LayoutParams layoutParams = new FrameLayout.LayoutParams(getContext().getResources().getDimensionPixelSize(R.dimen.bjysc_quiz_width), getContext().getResources().getDimensionPixelSize(R.dimen.bjysc_quiz_height));
        layoutParams.gravity = Gravity.CENTER;
        return layoutParams;
    }

    private void onQuizEndArrived(LPJsonModel jsonModel) {
        if (quizWindow != null) {
            quizWindow.onEndArrived(jsonModel);
        }
    }

    private boolean isQuizSolution = false;

    private void onQuizArrived(LPJsonModel jsonModel, boolean isShow) {
        isQuizSolution = isShow;
        if (quizWindow != null) {
            if (toolBoxLayer != null) {
                toolBoxLayer.removeWindow(quizWindow);
            }
            quizWindow.onDestroy();
        }
        quizWindow = new QuizWindow(getContext(), isShow, jsonModel);
        if (toolBoxLayer != null) {
            toolBoxLayer.addWindow(quizWindow, getQuizParams());
        }
    }

    private String bitmapShapeId;

    private static final int DEFAULT_SHAPE_COLOR = Color.parseColor("#FF1795FF");

    private static final float DEFAULT_SHAPE_WIDTH = 2f;

    private LPConstants.ShapeType lastCustomShapeType = LPConstants.ShapeType.StraightLine; // 记录定制图形的最后一次选择

    private void initPPT() {
        pptAuth = BaseUtilsKt.isAdmin(router.getLiveRoom());
        pptWindows = new ConcurrentLinkedQueue<>();
        laserShapeLayer.setLiveRoom(router.getLiveRoom());
        compositeDisposable.add(router.getLiveRoom().getDocListVM().getObservableOfDocAll()
                .observeOn(AndroidSchedulers.mainThread())
                .subscribe(allModel -> {
                    LPDocumentModel previewDocModel = null;
                    boolean checkNowPreviewExist = false;
                    for (LPDocumentModel docModel : allModel.docList) {
                        if ("0".equals(docModel.id) && docModel.extraModel != null) {
                            getBlackboardLayer().scrollTo(Float.parseFloat(docModel.extraModel.scrollTop));
                            showBlackboardPage(Float.parseFloat(docModel.extraModel.scrollTop));
                        }
                        // 检查当前的预览 ppt 是否依然存在
                        checkNowPreviewExist = checkNowPreviewExist || mPreviewDocModel != null
                                && TextUtils.equals(mPreviewDocModel.getDocId(), docModel.getDocId());
                        // 是否为API上传文件 or 后台上传文件（后台上传文件必定有 lastModified 字段，但Api上传的文件 bindSource 字段为0）
                        boolean isAPIDoc = docModel.lastModified != 0;
                        if (!isAPIDoc || !FileUtils.checkPreviewFileValid(docModel.ext)) {
                            continue;
                        }
                        // 若当前没有预览课件 则使用这个
                        boolean checkTimeAndDocId = previewDocModel == null;
                        if (!checkTimeAndDocId) {
                            // 不为空，使用绑定时间比当前 预览课件 的绑定时间靠后的
                            checkTimeAndDocId = previewDocModel.lastModified < docModel.lastModified;
                        }
                        if (!checkTimeAndDocId && previewDocModel.lastModified == docModel.lastModified) {
                            // 若同一时间绑定的，则使用 docId 更大的
                            checkTimeAndDocId = Integer.parseInt(docModel.getDocId()) > Integer.parseInt(previewDocModel.getDocId());
                        }
                        if (checkTimeAndDocId) {
                            previewDocModel = docModel;
                        }
                    }
                    if (!checkNowPreviewExist && mPreviewDocModel != null) {
                        // 如果当前的预览 ppt 已经不存在，则移除 当前预览 ppt 窗口
                        removeAndDestroyPPTView(mPreviewDocModel.getDocId() + LPConstants.PREVIEW_PPT_DOC_ID_SUFFIX);
                    }
                    handlePreviewDoc(previewDocModel);
                }, throwable -> {

                }));

        compositeDisposable.add(router.getLiveRoom().getDocListVM().getObservableOfDocUpdate()
                .observeOn(AndroidSchedulers.mainThread())
                .subscribe(docModel -> {
                    if (docModel.docUpdateExtraModel == null || docModel.docId == null) {
                        return;
                    }
                    if ("0".equals(docModel.docId)) {
                        getBlackboardLayer().scrollTo(Float.parseFloat(docModel.docUpdateExtraModel.scrollTop));
                        showBlackboardPage(Float.parseFloat(docModel.docUpdateExtraModel.scrollTop));
                    }
                }));

        compositeDisposable.add(router.getLiveRoom().getObservableOfClassStart()
                .observeOn(AndroidSchedulers.mainThread())
                .subscribe(integer -> {
                    if (mPreviewDocModel != null) {
                        // 触发上课时，检查当前的预览课件，如果有预览中的课件，则关闭窗口
                        removeAndDestroyPPTView(mPreviewDocModel.id + LPConstants.PREVIEW_PPT_DOC_ID_SUFFIX);
                    }
                })
        );

        subscriptionOfDocDel = router.getLiveRoom().getDocListVM().getObservableOfDocDelete()
                .filter(s -> !TextUtils.isEmpty(s))
                .observeOn(AndroidSchedulers.mainThread())
                .subscribe(s -> {
                    for (PPTWindow pptWindow : pptWindows) {
                        if (s.equals(pptWindow.getRealDocId())) {
                            documentLayer.removeWindow(pptWindow);
                            pptWindows.remove(pptWindow);
                            pptWindow.onDestroy();

                            // region 同步清理 AllDocViewList
                            List<LPDocViewElementModel> allDocList = router.getListByKey(EventKey.AllDocViewList, LPDocViewElementModel.class);
                            for (LPDocViewElementModel model : allDocList) {
                                if (model.docId.equals(s)) {
                                    allDocList.remove(model);
                                    break;
                                }
                            }
                            router.setObjectByKey(EventKey.AllDocViewList, allDocList);
                            // endregion
                            break;
                        }
                    }
                    refreshPPTWindowCache();
                    pptTabLayer.refreshTabs();
                });

        Disposable disposableOfDocViewUpdate = router.getLiveRoom().getDocListVM().getObservableOfDocViewUpdate()
                .filter(lpDocViewUpdateModel -> TextUtils.isEmpty(lpDocViewUpdateModel.nextAction) || lpDocViewUpdateModel.isFromCache)
                .observeOn(AndroidSchedulers.mainThread())
                .subscribe(lpDocViewUpdateModel -> {
                    // region 检查并更新 doc_view_all
                    if (lpDocViewUpdateModel.all == null) {
                        return;
                    }
                    List<LPDocViewElementModel> tempList = new ArrayList<>();
                    for (LPDocViewElementModel elementModel : lpDocViewUpdateModel.all) {
                        if (checkStoreContainsPPT(elementModel)) {
                            // 上传 ppt 后，在后台删除此 ppt ，会出现 doc all 中没有，但是 lpDocViewUpdateModel 残留的情况
                            // 故显示前 先检查当前 doc all 中是否包含此ppt，没有则不显示
                            tempList.add(elementModel);
                        }
                    }
                    lpDocViewUpdateModel.all = tempList;
                    router.setObjectByKey(EventKey.AllDocViewList, lpDocViewUpdateModel.all);
                    // endregion

                    // doc_view_update 和 doc_all 无法保证时序，有时会出现 doc_view_update 后到无法新建 ppt 窗口问题，这里判断下
                    // 若pptWindows 非空，检查下非空的这个是不是预览 ppt，如果是预览 ppt，依然需要新建
                    boolean needInsertNew = pptWindows.isEmpty() || (pptWindows.size() == 1
                            && ((PPTWindow) pptWindows.toArray()[0]).getId().contains(LPConstants.PREVIEW_PPT_DOC_ID_SUFFIX));
                    if (needInsertNew) {
                        PPTWindow maxPPTWindow = null;
                        boolean hasMaxOrFullPPTWindow = false;
                        for (LPDocViewElementModel elementModel : lpDocViewUpdateModel.all) {
                            PPTWindow pptWindow = newPPTWindow(elementModel);
                            if (elementModel.full == 1) {
                                hasMaxOrFullPPTWindow = true;
                                pptWindow.maxInFull(true);
                            } else if (elementModel.max == 1) {
                                hasMaxOrFullPPTWindow = true;
                                maxPPTWindow = pptWindow;
                            }
                        }
                        if (maxPPTWindow != null) {
                            maxPPTWindow.maxInSync(true);
                        }
                        if (pptWindows.size() > 1 && lpDocViewUpdateModel.isFromCache) {
                            List<PPTWindow> tempWindows = new ArrayList<>(pptWindows);
                            Collections.sort(tempWindows, (o1, o2) -> {
                                if (o1.isPreviewPPT()) {
                                    return 1;
                                }
                                if (o2.isPreviewPPT()) {
                                    return -1;
                                }
                                return (int) (o1.getRealDocIdWithNum() - o2.getRealDocIdWithNum());
                            });
                            pptWindows.clear();
                            pptWindows.addAll(tempWindows);
                        }
                        final PPTWindow fullPPTWindow = router.getValueByKey(EventKey.FullScreenPPTWindow, PPTWindow.class);
                        final PPTWindow topWindow = fullPPTWindow != null ? fullPPTWindow : maxPPTWindow;
                        //把预览课件置顶,且切到max、full状态
                        if (topWindow != null && !pptWindows.isEmpty() && lpDocViewUpdateModel.isFromCache) {
                            PPTWindow previewPPTWindow = null;
                            for (PPTWindow pptWindow : pptWindows) {
                                if (pptWindow.isPreviewPPT()) {
                                    previewPPTWindow = pptWindow;
                                    break;
                                }
                            }
                            if (previewPPTWindow != null && previewPPTWindow.isPreviewPPT() && previewPPTWindow != topWindow) {
                                topWindow.switchTab(previewPPTWindow);
                            }
                        }
                        if (!hasMaxOrFullPPTWindow) {
                            checkExistTopPreviewPPTWindow();
                        }
                        return;
                    }

                    switch (lpDocViewUpdateModel.action) {
                        case "add":
                            addPPTView(lpDocViewUpdateModel);
                            break;
                        case "remove":
                            removeAndDestroyPPTView(lpDocViewUpdateModel.docId);
                            break;
                        case "stick":
                            if (router.getLiveRoom().getCurrentUser().getUserId().equals(lpDocViewUpdateModel.userId)) {
                                return;
                            }
                            if (router.getValueByKey(EventKey.SetFullScreenWindowOn, Boolean.class, false)) {
                                return;
                            }
                            final PPTWindow maxPPTWindow = router.getValueByKey(EventKey.MaxScreenPPTWindow, PPTWindow.class);
                            final PPTWindow fullPPTWindow = router.getValueByKey(EventKey.FullScreenPPTWindow, PPTWindow.class);
                            final PPTWindow topPPTWindow = fullPPTWindow != null ? fullPPTWindow : maxPPTWindow;
                            //顶部是预览课件不处理置顶信令
                            if (topPPTWindow != null && topPPTWindow.isPreviewPPT()) {
                                break;
                            }
                            bringToFront(lpDocViewUpdateModel.docId);
                            break;
                        case "normal":
                            backToNormal(lpDocViewUpdateModel.docId);
                            break;
                        case "max":
                            maximumWindow(lpDocViewUpdateModel.docId);
                            break;
                        case "full":
                            fullscreenWindow(lpDocViewUpdateModel.docId);
                            break;
                        case "reposition":
                            if (router.getLiveRoom().getCurrentUser().getUserId().equals(lpDocViewUpdateModel.userId)) {
                                return;
                            }
                            repositionWindow(lpDocViewUpdateModel);
                            break;
                        default:
                            break;
                    }
                    laserShapeLayer.bringToFront();
                });


        Disposable disposableOfWebpageUpdate = router.getLiveRoom().getToolBoxVM().getObservableOfWebpageUpdate()
                .observeOn(AndroidSchedulers.mainThread())
                .subscribe(this::handleWebpageUpdate);

        Disposable disposableOfAuthPaintColor = router.getLiveRoom().getObservableOfAuthPaintColor()
                .observeOn(AndroidSchedulers.mainThread())
                .subscribe(map -> {
                    if (router.getLiveRoom().getCurrentUser().getType() == LPConstants.LPUserType.Teacher) {
                        return;
                    }
                    //如果学生以前主动改过画笔颜色，收到信令不更新。
                    if (router.getValueByKey(EventKey.IsChangedPaintColor, Boolean.class, false)) {
                        return;
                    }

                    for (String paintColor : map.keySet()) {
                        if (router.getLiveRoom().getCurrentUser().getNumber().equals(map.get(paintColor))) {
                            //更新画笔颜色
                            router.getSubjectByKey(EventKey.DrawColorAllChange).onNext(paintColor);
                            shapePaint.setShapeColor(new ColorSelectData(SelectSrc.Graph, Color.parseColor(paintColor)));
                            shapePaint.setShapeColor(new ColorSelectData(SelectSrc.Text, Color.parseColor(paintColor)));
                            shapePaint.setShapeColor(new ColorSelectData(SelectSrc.Brush, Color.parseColor(paintColor)));
                            shapePaint.setShapeColor(new ColorSelectData(SelectSrc.Marker, Color.parseColor(paintColor)));
                            break;
                        }
                    }
                    if (!ToolbarWindow.preColorCache.isEmpty()) {
                        for (BaseUIConstant.SelectSrc selectSrc : ToolbarWindow.preColorCache.keySet()) {
                            final Integer color = ToolbarWindow.preColorCache.get(selectSrc);
                            if (color != null) {
                                shapePaint.setShapeColor(new ColorSelectData(selectSrc, color));
                            }
                        }
                    }
                });

        Disposable disposableOfCloseWindow = router.getSubjectByKey(EventKey.ClosePPTWindow)
                .ofType(Tuple.class)
                .subscribe(tuple -> {
                    updateToolbarWindow();
                    removeViewFromParent(laserShapeLayer);
                    addView(laserShapeLayer, lp); // 激光笔图层重加和层次调整

                    if (tuple.docId.contains(LPConstants.PREVIEW_PPT_DOC_ID_SUFFIX)) {
                        // 预览 ppt 窗口关闭
                        removeAndDestroyPPTView(tuple.docId);
                        return;
                    }

                    List<LPDocViewElementModel> allDocList = getAllDocList();
                    if (allDocList == null || allDocList.size() == 0) {
                        return;
                    }

                    LPDocViewUpdateModel lpDocViewUpdateModel = new LPDocViewUpdateModel();
                    lpDocViewUpdateModel.docId = tuple.docId;
                    lpDocViewUpdateModel.action = "remove";

                    if (router.getValueByKey(EventKey.AllDocViewList, ArrayList.class) == null) {
                        return;
                    }

                    for (LPDocViewElementModel elementModel : allDocList) {
                        if (elementModel.docId.equals(tuple.docId)) {
                            allDocList.remove(elementModel);
                            lpDocViewUpdateModel.all = allDocList;
                            router.getLiveRoom().getDocListVM().requestDocViewUpdate(lpDocViewUpdateModel);
                            break;
                        }
                    }
                });

        Disposable disposableOfRepositionWindow = router.getSubjectByKey(EventKey.RepositionPPTWindow)
                .ofType(Tuple.class)
                .filter(tuple -> tuple.docId != null)
                .throttleLast(1, TimeUnit.SECONDS)
                .subscribe(tuple -> {
                    List<LPDocViewElementModel> allDocList = getAllDocList();
                    if (allDocList == null || allDocList.isEmpty()) {
                        return;
                    }
                    LPDocViewUpdateModel lpDocViewUpdateModel = new LPDocViewUpdateModel();
                    lpDocViewUpdateModel.docId = tuple.docId;
                    lpDocViewUpdateModel.action = "reposition";
                    if (tuple.action.equals(PPT_WINDOW_MOVE)) {

                        for (LPDocViewElementModel elementModel : allDocList) {
                            if (elementModel.docId.equals(tuple.docId)) {
                                elementModel.x = String.valueOf((float) tuple.width / (float) getWidth());
                                elementModel.y = String.valueOf((float) tuple.height / (float) getHeight());
                                lpDocViewUpdateModel.all = allDocList;
                                router.getLiveRoom().getDocListVM().requestDocViewUpdate(lpDocViewUpdateModel);
                                break;
                            }
                        }
                    } else if (tuple.action.equals(PPT_WINDOW_SCALE)) {
                        for (LPDocViewElementModel elementModel : allDocList) {
                            if (elementModel.docId.equals(tuple.docId)) {
                                elementModel.width = String.valueOf((float) tuple.width / (float) getWidth());
                                elementModel.height = String.valueOf((float) tuple.height / (float) getHeight());
                                lpDocViewUpdateModel.all = allDocList;
                                router.getLiveRoom().getDocListVM().requestDocViewUpdate(lpDocViewUpdateModel);
                                break;
                            }
                        }
                    }

                });

        Disposable disposableOfAddWebpage = router.getSubjectByKey(EventKey.AddWebpage)
                .ofType(BrowserWindow.class)
                .subscribe(window -> {
                    LPDocViewUpdateModel lpWebpageUpdateModel = new LPDocViewUpdateModel();
                    lpWebpageUpdateModel.docId = window.getId();
                    lpWebpageUpdateModel.userId = router.getLiveRoom().getCurrentUser().getUserId();
                    if (window.isAdd) {
                        LPDocViewElementModel lpDocViewElementModel = new LPDocViewElementModel();
                        lpDocViewElementModel.docId = window.getId();
                        final FrameLayout.LayoutParams layoutParams = (FrameLayout.LayoutParams) window.getView().getLayoutParams();
                        lpDocViewElementModel.x = String.valueOf((float) layoutParams.leftMargin / (float) getWidth());
                        lpDocViewElementModel.y = String.valueOf((float) layoutParams.topMargin / (float) getHeight());
                        lpDocViewElementModel.width = String.valueOf((float) window.getView().getWidth() / (float) getWidth());
                        lpDocViewElementModel.height = String.valueOf((float) window.getView().getHeight() / (float) getHeight());
                        lpDocViewElementModel.full = window.isMaxInFull() ? 1 : 0;
                        lpDocViewElementModel.max = window.isMaxInSync() ? 1 : 0;
                        List<LPDocViewElementModel> all = new ArrayList<>();
                        all.add(lpDocViewElementModel);
                        lpWebpageUpdateModel.action = "add";
                        lpWebpageUpdateModel.all = all;
                        webpageUpdateModeList = all;
                    } else {
                        webpageUpdateModeList.clear();
                        lpWebpageUpdateModel.action = "remove";
                        lpWebpageUpdateModel.all = new ArrayList<>();
                    }
                    router.getLiveRoom().getToolBoxVM().requestWebpageUpdate(lpWebpageUpdateModel);
                });

        Disposable disposableOfRepositionWebpage = router.getSubjectByKey(EventKey.RepositionWebpage)
                .ofType(Tuple.class)
                .throttleLast(1, TimeUnit.SECONDS)
                .subscribe(tuple -> {
                    if (webpageUpdateModeList.isEmpty()) {
                        return;
                    }
                    LPDocViewUpdateModel lpDocViewUpdateModel = new LPDocViewUpdateModel();
                    lpDocViewUpdateModel.docId = tuple.docId;
                    lpDocViewUpdateModel.userId = router.getLiveRoom().getCurrentUser().getUserId();
                    lpDocViewUpdateModel.action = "reposition";
                    if (tuple.action.equals(PPT_WINDOW_MOVE)) {
                        for (LPDocViewElementModel elementModel : webpageUpdateModeList) {
                            if (TextUtils.equals(elementModel.docId, tuple.docId)) {
                                elementModel.x = String.valueOf((float) tuple.width / (float) getWidth());
                                elementModel.y = String.valueOf((float) tuple.height / (float) getHeight());
                                lpDocViewUpdateModel.all = webpageUpdateModeList;
                                router.getLiveRoom().getToolBoxVM().requestWebpageUpdate(lpDocViewUpdateModel);
                                break;
                            }
                        }
                    } else if (tuple.action.equals(PPT_WINDOW_SCALE)) {
                        for (LPDocViewElementModel elementModel : webpageUpdateModeList) {
                            if (TextUtils.equals(elementModel.docId, tuple.docId)) {
                                elementModel.width = String.valueOf((float) tuple.width / (float) getWidth());
                                elementModel.height = String.valueOf((float) tuple.height / (float) getHeight());
                                lpDocViewUpdateModel.all = webpageUpdateModeList;
                                router.getLiveRoom().getToolBoxVM().requestWebpageUpdate(lpDocViewUpdateModel);
                                break;
                            }
                        }
                    }
                });

        Disposable disposableOfResetToolbarMode = router.getSubjectByKey(EventKey.ResetToolbarStatus)
                .ofType(Boolean.class)
                .subscribe(aBoolean -> {
                    if (aBoolean) {
                        shapePaint.setPPtEditMode(LPConstants.PPTEditMode.Normal);
                    } else {
                        shapePaint.setPPtEditMode(LPConstants.PPTEditMode.PPTTouchMode);
                    }
                    showTitleFooter();
                    ((BlackboardScrollView) getBlackboardLayer().getBlackImageWindow().getView()).setScrollEnable(true);
                    getBlackboardLayer().getBlackImageWindow().getWhiteboardView().invalidateTextBoundary();
                });

        subscriptionOfSelectMode = router.getSubjectByKey(EventKey.SelectModeEnable)
                .ofType(Boolean.class)
                .subscribe(aBoolean -> {
                    shapePaint.setPPtEditMode(LPConstants.PPTEditMode.SelectMode);
                    hideTitleFooter();
                    ((BlackboardScrollView) getBlackboardLayer().getBlackImageWindow().getView()).setScrollEnable(!aBoolean);
                });

        subscriptionOfDrawLineMode = router.getSubjectByKey(EventKey.DrawLineModeEnable)
                .filter(data -> data instanceof List && ((List<?>) data).get(0) instanceof DrawLineMode)
                .filter(drawLineMode -> drawLineMode != DrawLineMode.NONE).subscribe(data -> {
                    DrawLineMode drawLineMode = (DrawLineMode) ((List<?>) data).get(0);
                    shapePaint.setPPtEditMode(LPConstants.PPTEditMode.ShapeMode);
                    if (drawLineMode != DrawLineMode.NONE) {
                        if (drawLineMode == DrawLineMode.MARKER_MODE) {
                            shapePaint.setShapeType(SelectSrc.Marker, LPConstants.ShapeType.MarkerDoodle);
                        } else {
                            shapePaint.setShapeType(SelectSrc.Brush, LPConstants.ShapeType.Doodle);
                        }
                        router.getSubjectByKey(EventKey.DrawTextEnable).onNext(false);
                        router.getSubjectByKey(EventKey.LaserDrawEnable).onNext(false);
                    }
                    hideTitleFooter();
                    ((BlackboardScrollView) getBlackboardLayer().getBlackImageWindow().getView()).setScrollEnable(false);
                });

        Disposable disposableGraphDraw = router.getSubjectByKey(EventKey.GraphDrawEnable)
                .ofType(BaseGraphMenuWindow.OnShapeChangeModel.class)
                .filter(model -> !model.isInitDrawable())
                .subscribe(model -> {
                    shapePaint.setPPtEditMode(LPConstants.PPTEditMode.ShapeMode);
                    shapePaint.setShapeType(SelectSrc.Graph, model.getShapeType());
                    lastCustomShapeType = model.getShapeType();
                    hideTitleFooter();
                    if (getBlackboardLayer().getBlackImageWindow() != null) {
                        ((BlackboardScrollView) getBlackboardLayer().getBlackImageWindow().getView()).setScrollEnable(false);
                    }
                });

        Disposable disposableStrokeWidth = router.getSubjectByKey(EventKey.DrawWidthChange)
                .ofType(WidthSelectData.class)
                .subscribe(widthSelectData -> shapePaint.setDoodleStrokeWidth(widthSelectData));

        Disposable disposableCustomGraphWidth = router.getSubjectByKey(EventKey.CustomGraphWidthChange)
                .ofType(WidthSelectData.class)
                .subscribe(widthSelectData -> shapePaint.setCustomStrokeWidth(widthSelectData.getWidth()));

        Disposable disposableOfCustomGraphMenuEnable = router.getSubjectByKey(EventKey.GraphMenuEnable)
                .filter(view -> view instanceof View)
                .subscribe(view -> {
                    shapePaint.setPPtEditMode(LPConstants.PPTEditMode.ShapeMode);
                    shapePaint.setShapeType(SelectSrc.Graph, lastCustomShapeType);
                    hideTitleFooter();
                    ((BlackboardScrollView) getBlackboardLayer().getBlackImageWindow().getView()).setScrollEnable(false);
                });

        Disposable disposableEraseMode = router.getSubjectByKey(EventKey.GraphSelectEraseMode)
                .ofType(Boolean.class)
                .subscribe(aBoolean -> {
                    for (PPTWindow pptWindow : getPPTWindows()) {
                        pptWindow.getPPTView().eraseShapes();
                    }
                    getBlackboardLayer().getBlackImageWindow().eraseShapes();

                    for (SmallBlackboardWindow smallBlackboardWindow : smallBlackboardWindows) {
                        smallBlackboardWindow.eraseShapes();
                    }
                });

        compositeDisposable.add(router.getSubjectByKey(EventKey.GraphEraseMode)
                .ofType(Boolean.class)
                .subscribe(aBoolean -> {
                    LPConstants.PPTEditMode pptEditMode;
                    if (aBoolean) {
                        pptEditMode = LPConstants.PPTEditMode.EraserMode;
                        hideTitleFooter();
                    } else {
                        pptEditMode = LPConstants.PPTEditMode.Normal;
                        showTitleFooter();
                    }
                    if (shapePaint != null) {
                        shapePaint.setPPtEditMode(pptEditMode);
                    }
                    for (PPTWindow pptWindow : getPPTWindows()) {
                        pptWindow.getPPTView().setPPTEditMode(pptEditMode);
                    }
                    getBlackboardLayer().getBlackImageWindow().setPPTEditMode(pptEditMode);
                    ((BlackboardScrollView) getBlackboardLayer().getBlackImageWindow().getView()).setScrollEnable(!aBoolean);

                    for (SmallBlackboardWindow smallBlackboardWindow : smallBlackboardWindows) {
                        smallBlackboardWindow.setPPTEditMode(pptEditMode);
                    }
                    router.getSubjectByKey(EventKey.DrawTextEnable).onNext(false);
                }));

        compositeDisposable.add(router.getSubjectByKey(EventKey.GraphEraseAll)
                .ofType(Boolean.class)
                .subscribe(aBoolean -> {
                    if (isCheckNotRemind) {
                        getBlackboardLayer().getBlackImageWindow().eraseAll();
                    } else {
                        if (remindDialog == null) {
                            initRemindDialog();
                        }
                        remindDialog.show();
                    }
                }));

        Disposable disposableDrawColorSetting = router.getSubjectByKey(EventKey.DrawColorChange)
                .ofType(ColorSelectData.class)
                .subscribe(data -> shapePaint.setShapeColor(data));

        Disposable disposableTextEdit = router.getSubjectByKey(EventKey.DrawTextEnable)
                .filter(aBoolean -> aBoolean instanceof Boolean && (Boolean) aBoolean)
                .subscribe(aBoolean -> {
                    shapePaint.setPPtEditMode(LPConstants.PPTEditMode.ShapeMode);
                    shapePaint.setShapeType(SelectSrc.Text, LPConstants.ShapeType.Text);
                    hideTitleFooter();
                });

        Disposable disposableOfTextSend = router.getSubjectByKey(EventKey.DrawTextSend)
                .ofType(HashMap.class)
                .subscribe(map -> {
                    if (!Objects.equals(map.get("end"), "true")) {
                        shapePaint.sendTextConfirmed((String) map.get("beforeText"), (String) map.get("afterText"));
                    } else {
                        invalidateTextBoundary();
                    }
                });

        compositeDisposable.add(router.getSubjectByKey(EventKey.ClearEditText)
                .subscribe(o -> invalidateTextBoundary()));

        Disposable disposableOfTextSizeChange = router.getSubjectByKey(EventKey.DrawTextSizeChange)
                .ofType(Integer.class)
                .subscribe(integer -> shapePaint.setTextSize(integer));

        Disposable disposableOfBitmapShape = router.getSubjectByKey(EventKey.GraphBitmapEnable)
                .ofType(LPUploadDocModel.class)
                .subscribe(lpUploadDocModel -> {
                    float ratio = (float) lpUploadDocModel.width / (float) lpUploadDocModel.height;
                    if (lpUploadDocModel.width > getWidth() / 2) {
                        lpUploadDocModel.width = getWidth() / 2;
                        lpUploadDocModel.height = (int) (lpUploadDocModel.width / ratio);
                    }
                    getBlackboardLayer().getBlackImageWindow().getWhiteboardView().sendBitmapShape(lpUploadDocModel,
                            (getBlackboardLayer().getBlackImageWindow().getView()).getScrollY());
                });

        Disposable bitmapShapeSelectedDisposable = router.getSubjectByKey(EventKey.BitmapShapeSelected)
                .ofType(BitmapShape.class)
                .subscribe(bitmapShape -> bitmapShapeId = bitmapShape.id);


        Disposable disposableOfBitmapShapeLayerSwitch = router.getSubjectByKey(EventKey.BitmapShapeLayerSwitch)
                .ofType(Integer.class)
                .subscribe(integer -> {
                    if (TextUtils.isEmpty(bitmapShapeId)) {
                        return;
                    }
                    getBlackboardLayer().getBlackImageWindow().getWhiteboardView().switchBitmapLayer(bitmapShapeId, integer);
                });

        Disposable disposableOfBitmapShapeScale = router.getSubjectByKey(EventKey.BitmapShapeScale)
                .ofType(Integer.class)
                .subscribe(progress -> {
                    if (TextUtils.isEmpty(bitmapShapeId)) {
                        return;
                    }
                    float scale;
                    scale = (float) (progress) / 50f;
                    getBlackboardLayer().getBlackImageWindow().getWhiteboardView().scaleBitmapShape(bitmapShapeId, scale);
                });

        Disposable disposableOfBitmapShapeErase = router.getSubjectByKey(EventKey.BitmapShapeErase)
                .ofType(Boolean.class)
                .subscribe(aBoolean -> {
                    if (TextUtils.isEmpty(bitmapShapeId)) {
                        return;
                    }
                    getBlackboardLayer().getBlackImageWindow().eraseBitmapShape(bitmapShapeId);
                });

        Disposable disposableOfH5DocumentDelete = router.getSubjectByKey(EventKey.CoursewareH5DocumentDeleteConfirm)
                .ofType(List.class)
                .subscribe(list -> {
                    for (Object object : list) {
                        router.getSubjectByKey(EventKey.ClosePPTWindow).onNext(new Tuple((String) object, true));
                    }
                });

        Disposable disposableOfLaserShape = router.getSubjectByKey(EventKey.LaserDrawEnable)
                .ofType(Boolean.class)
                .subscribe(aBoolean -> {
                    if (laserShapeLayer != null) {
                        laserShapeLayer.enableDrawLaser(aBoolean);
                    }
                });

        Disposable disposableOfFullScreenOn = router.getSubjectByKey(EventKey.SetFullScreenWindowOn)
                .filter(c -> !router.getValueByKey(EventKey.SetFullScreenWindowOn, Boolean.class, false))
                .subscribe(window -> {
                    router.getSubjectByKey(EventKey.LaserLayerFullScreen).onNext(laserShapeLayer);
                    if (window instanceof PPTWindow) {
                        PPTWindow pptWindow = (PPTWindow) window;
                        pptTabLayer.show(true);
                        pptTabLayer.refreshTabs();
                        pptTabLayer.refreshBtn(true);
                        if (pptWindow.getId().contains(LPConstants.PREVIEW_PPT_DOC_ID_SUFFIX)) {
                            addToFullCache();
                            return;
                        } else {
                            // 仅非预览ppt发送同步信令
                            String docId = ((PPTWindow) window).getRealDocId();
                            if (((PPTWindow) window).isReceiveOrder()) {
                                return;
                            }
                            List<LPDocViewElementModel> allDocList = getAllDocList();
                            LPDocViewUpdateModel lpDocViewUpdateModel = new LPDocViewUpdateModel();
                            lpDocViewUpdateModel.docId = docId;
                            lpDocViewUpdateModel.action = "full";
                            if (allDocList == null || allDocList.isEmpty()) {
                                return;
                            }
                            for (LPDocViewElementModel elementModel : allDocList) {
                                if (elementModel.docId.equals(lpDocViewUpdateModel.docId)) {
                                    elementModel.full = 1;
                                    lpDocViewUpdateModel.all = allDocList;
                                    router.getLiveRoom().getDocListVM().requestDocViewUpdate(lpDocViewUpdateModel);
                                    break;
                                }
                            }
                        }
                    }

                    if (window instanceof BrowserWindow) {
                        if (window != browserWindow || browserWindow == null) {
                            return;
                        }
                        if (browserWindow.isReceiveOrder()) {
                            return;
                        }
                        if (webpageUpdateModeList.isEmpty()) {
                            return;
                        }
                        LPDocViewUpdateModel lpDocViewUpdateModel = new LPDocViewUpdateModel();
                        lpDocViewUpdateModel.docId = browserWindow.getId();
                        lpDocViewUpdateModel.userId = router.getLiveRoom().getCurrentUser().getUserId();
                        lpDocViewUpdateModel.action = "full";
                        for (LPDocViewElementModel elementModel : webpageUpdateModeList) {
                            if (TextUtils.equals(elementModel.docId, lpDocViewUpdateModel.docId)) {
                                elementModel.full = 1;
                                lpDocViewUpdateModel.all = webpageUpdateModeList;
                                router.getLiveRoom().getToolBoxVM().requestWebpageUpdate(lpDocViewUpdateModel);
                                break;
                            }
                        }
                        browserLayer.removeWindow(browserWindow);
                        browserWindow = null;
                    }

                    if (window instanceof MediaCoursewarePlayerWindow) {
                        Set<LPPlayerViewUpdateModel.PlayerPosition> allSet = router.getSetByKey(EventKey.AllPlayerViewList, LPPlayerViewUpdateModel.PlayerPosition.class);
                        LPPlayerViewUpdateModel model = new LPPlayerViewUpdateModel();
                        model.action = LPConstants.LPPlayerAction.FULL;
                        model.id = model.mediaId = FECompatUtil.getIOSMediaIdFromMediaId(FECompatUtil.getMediaId(router.getLiveRoom().getCurrentUser().getUserId(), LPConstants.MediaSourceType.Media.getValue()));
                        for (LPPlayerViewUpdateModel.PlayerPosition playerPosition : allSet) {
                            if (playerPosition.id.equals(model.id)) {
                                playerPosition.full = 1;
                                model.all = allSet;
                                router.getLiveRoom().getMediaVM().requestPlayerViewUpdate(model);
                                break;
                            }
                        }
                    }
                });

        Disposable disposableOfFullScreenOff = router.getSubjectByKey(EventKey.SetFullScreenWindowOff)
                .ofType(BaseWindow.class)
                .subscribe(baseTitledWindow -> {
                    if (baseTitledWindow instanceof PPTWindow) {
                        if (BaseUtilsKt.isAdmin(router.getLiveRoom())) {
                            removeViewFromParent(pptTabLayer);
                            int index = indexOfChild(documentLayer) + 1;
                            addView(pptTabLayer, index);
                            pptTabLayer.refreshBtn(false);
                        }
                        PPTWindow pptWindow = (PPTWindow) baseTitledWindow;
                        if (pptWindow.isPreviewPPT() && !pptWindow.isReceiveOrder()) {
                            pptWindow.maxInSync();
                            addToMaxCache();
                        }

                        String docId = pptWindow.getRealDocId();
                        if (!pptWindow.isReceiveOrder() && !pptWindow.isPreviewPPT()) {
                            List<LPDocViewElementModel> allDocList = getAllDocList();
                            LPDocViewUpdateModel lpDocViewUpdateModel = new LPDocViewUpdateModel();
                            lpDocViewUpdateModel.docId = docId;
                            lpDocViewUpdateModel.action = "max";
                            if (allDocList != null && !allDocList.isEmpty()) {
                                for (LPDocViewElementModel elementModel : allDocList) {
                                    if (elementModel.docId.equals(lpDocViewUpdateModel.docId)) {
                                        elementModel.full = 0;
                                        elementModel.max = 1;
                                        lpDocViewUpdateModel.all = allDocList;
                                        router.getLiveRoom().getDocListVM().requestDocViewUpdate(lpDocViewUpdateModel);
                                        break;
                                    }
                                }
                            }
                        }
                    }

                    removeViewFromParent(laserShapeLayer);
                    removeViewFromParent(baseTitledWindow.getView());

                    if (baseTitledWindow.getView() != null && baseTitledWindow instanceof PPTWindow) {
                        documentLayer.addWindow(baseTitledWindow, baseTitledWindow.getView().getLayoutParams());
                    }
                    laserShapeLayer.setDocInfo("0", 0);
                    addView(laserShapeLayer, lp);
                    if (baseTitledWindow instanceof VideoContainerWindow || baseTitledWindow instanceof MediaCoursewarePlayerWindow) {
                        videoLayer.addWindow(baseTitledWindow, ((BaseTitledWindow)baseTitledWindow).getLastLayoutParams());
                        Set<LPPlayerViewUpdateModel.PlayerPosition> allSet = router.getSetByKey(EventKey.AllPlayerViewList, LPPlayerViewUpdateModel.PlayerPosition.class);
                        LPPlayerViewUpdateModel model = new LPPlayerViewUpdateModel();
                        model.id = model.mediaId = FECompatUtil.getIOSMediaIdFromMediaId(FECompatUtil.getMediaId(router.getLiveRoom().getCurrentUser().getUserId(), LPConstants.MediaSourceType.Media.getValue()));
                        for (LPPlayerViewUpdateModel.PlayerPosition playerPosition : allSet) {
                            if (playerPosition.id.equals(model.id)) {
                                playerPosition.full = 0;
                                if (playerPosition.max == 1) {
                                    model.action = LPConstants.LPPlayerAction.MAX;
                                } else {
                                    model.action = LPConstants.LPPlayerAction.NORMAL;
                                }
                                model.all = allSet;
                                router.getLiveRoom().getMediaVM().requestPlayerViewUpdate(model);
                                break;
                            }
                        }
                    } else if (baseTitledWindow instanceof BrowserWindow) {
                        // 打开网页工具
                        browserLayer.removeAllViews();
                        browserWindow = (BrowserWindow) baseTitledWindow;
                        if (browserWindow.isMaxInSync()) {
                            browserLayer.addWindow(baseTitledWindow);
                        } else {
                            browserLayer.addWindow(baseTitledWindow, browserWindow.getLayoutParamsSmall());
                        }

                        if (browserWindow.isReceiveOrder()) {
                            return;
                        }
                        if (webpageUpdateModeList.isEmpty()) {
                            return;
                        }
                        LPDocViewUpdateModel lpDocViewUpdateModel = new LPDocViewUpdateModel();
                        lpDocViewUpdateModel.docId = browserWindow.getId();
                        lpDocViewUpdateModel.userId = router.getLiveRoom().getCurrentUser().getUserId();
                        lpDocViewUpdateModel.action = browserWindow.isMaxInSync() ? "max" : "normal";
                        for (LPDocViewElementModel elementModel : webpageUpdateModeList) {
                            if (TextUtils.equals(elementModel.docId, lpDocViewUpdateModel.docId)) {
                                final FrameLayout.LayoutParams layoutParamsSmall = (LayoutParams) browserWindow.getLayoutParamsSmall();
                                elementModel.full = 0;
                                elementModel.max = browserWindow.isMaxInSync() ? 1 : 0;
                                elementModel.width = String.valueOf((float) layoutParamsSmall.width / (float) getWidth());
                                elementModel.height = String.valueOf((float) layoutParamsSmall.height / (float) getHeight());
                                elementModel.x = String.valueOf((float) layoutParamsSmall.leftMargin / (float) getWidth());
                                elementModel.y = String.valueOf((float) layoutParamsSmall.topMargin / (float) getHeight());
                                lpDocViewUpdateModel.all = webpageUpdateModeList;
                                router.getLiveRoom().getToolBoxVM().requestWebpageUpdate(lpDocViewUpdateModel);
                                break;
                            }
                        }
                    }
                });

        Disposable disposableOfMaximumWindowOn = router.getSubjectByKey(EventKey.SetMaximumWindowOn)
                .subscribe(c -> {
                    updateToolbarWindow();
                    if (c instanceof BaseTitledWindow) {
                        maximumWindow = (BaseTitledWindow) c;
                        maximumWindow.bringToForeground();

                        if (c instanceof PPTWindow) {
                            pptTabLayer.show(true);
                            pptTabLayer.refreshTabs();
                            pptTabLayer.refreshBtn(false);
                            if (((PPTWindow) c).getId().contains(LPConstants.PREVIEW_PPT_DOC_ID_SUFFIX)) {
                                addToMaxCache();
                                return;
                            }
                            if (!BaseUtilsKt.isAdmin(router.getLiveRoom())) {
                                return;
                            }
                            BaseTitledWindow baseWindow = (BaseTitledWindow) c;
                            String docId = baseWindow.getId();
                            if (baseWindow.isReceiveOrder()) {
                                return;
                            }
                            List<LPDocViewElementModel> allDocList = getAllDocList();
                            LPDocViewUpdateModel lpDocViewUpdateModel = new LPDocViewUpdateModel();
                            lpDocViewUpdateModel.docId = docId;
                            lpDocViewUpdateModel.action = "max";
                            if (allDocList == null || allDocList.isEmpty()) {
                                return;
                            }
                            for (LPDocViewElementModel elementModel : allDocList) {
                                if (elementModel.docId.equals(lpDocViewUpdateModel.docId)) {
                                    elementModel.max = 1;
                                    lpDocViewUpdateModel.all = allDocList;
                                    router.getLiveRoom().getDocListVM().requestDocViewUpdate(lpDocViewUpdateModel);
                                    break;
                                }
                            }
                        }
                        if (c instanceof SmallBlackboardWindow) {
                            if (!BaseUtilsKt.isAdmin(router.getLiveRoom())) {
                                return;
                            }

                            LPDocViewUpdateModel lpDocViewUpdateModel = new LPDocViewUpdateModel();
                            lpDocViewUpdateModel.docId = ((BaseTitledWindow) c).getId();
                            lpDocViewUpdateModel.action = "max";
                            List<LPDocViewElementModel> allDocList = router.getListByKey(EventKey.AllSnippetViewList, LPDocViewElementModel.class);
                            if (allDocList == null || allDocList.isEmpty()) {
                                return;
                            }
                            for (LPDocViewElementModel elementModel : allDocList) {
                                if (elementModel.docId.equals(lpDocViewUpdateModel.docId)) {
                                    elementModel.max = 1;
                                    lpDocViewUpdateModel.all = allDocList;
                                    router.getLiveRoom().getToolBoxVM().requestSnippetViewUpdate(lpDocViewUpdateModel);
                                    break;
                                }
                            }
                        }
                        if (c instanceof MediaCoursewarePlayerWindow) {
                            Set<LPPlayerViewUpdateModel.PlayerPosition> allSet = router.getSetByKey(EventKey.AllPlayerViewList, LPPlayerViewUpdateModel.PlayerPosition.class);
                            LPPlayerViewUpdateModel model = new LPPlayerViewUpdateModel();
                            model.action = LPConstants.LPPlayerAction.MAX;
                            model.id = model.mediaId = FECompatUtil.getIOSMediaIdFromMediaId(FECompatUtil.getMediaId(router.getLiveRoom().getCurrentUser().getUserId(), LPConstants.MediaSourceType.Media.getValue()));
                            for (LPPlayerViewUpdateModel.PlayerPosition playerPosition : allSet) {
                                if (playerPosition.id.equals(model.id)) {
                                    playerPosition.max = 1;
                                    model.all = allSet;
                                    router.getLiveRoom().getMediaVM().requestPlayerViewUpdate(model);
                                    break;
                                }
                            }
                        }
                    } else if (c instanceof Boolean) {
                        if (maximumWindow instanceof PPTWindow) {
                            ((PPTWindow) maximumWindow).resetInSync(false);
                        }
                    } else if (c instanceof VideoWindow) {
                        Set<LPPlayerViewUpdateModel.PlayerPosition> allSet = router.getSetByKey(EventKey.AllPlayerViewList, LPPlayerViewUpdateModel.PlayerPosition.class);
                        LPPlayerViewUpdateModel model = new LPPlayerViewUpdateModel();
                        model.action = LPConstants.LPPlayerAction.MAX;
                        model.id = model.mediaId = FECompatUtil.getIOSMediaIdFromMediaId(((VideoWindow) c).getMediaId());
                        for (LPPlayerViewUpdateModel.PlayerPosition playerPosition : allSet) {
                            if (playerPosition.id.equals(model.id)) {
                                playerPosition.max = 1;
                                model.all = allSet;
                                router.getLiveRoom().getMediaVM().requestPlayerViewUpdate(model);
                                break;
                            }
                        }
                    } else if (c instanceof BrowserWindow) {
                        BrowserWindow baseWindow = (BrowserWindow) c;
                        if (baseWindow.isReceiveOrder()) {
                            return;
                        }
                        if (webpageUpdateModeList.isEmpty()) {
                            return;
                        }
                        LPDocViewUpdateModel lpDocViewUpdateModel = new LPDocViewUpdateModel();
                        lpDocViewUpdateModel.docId = baseWindow.getId();
                        lpDocViewUpdateModel.userId = router.getLiveRoom().getCurrentUser().getUserId();
                        lpDocViewUpdateModel.action = "max";
                        for (LPDocViewElementModel elementModel : webpageUpdateModeList) {
                            if (TextUtils.equals(elementModel.docId, lpDocViewUpdateModel.docId)) {
                                elementModel.max = 1;
                                lpDocViewUpdateModel.all = webpageUpdateModeList;
                                router.getLiveRoom().getToolBoxVM().requestWebpageUpdate(lpDocViewUpdateModel);
                                break;
                            }
                        }
                    }
                });

        Disposable disposableOfMaximumWindowOff = router.getSubjectByKey(EventKey.SetMaximumWindowOff)
                .subscribe(window -> {
                    if (window instanceof PPTWindow) {
                        updateToolbarWindow();

                        pptTabLayer.show(false);
                        if ((((PPTWindow) window).isPreviewPPT() && !((PPTWindow) window).isReceiveOrder())) {
                            backToNormalCache();
                            ((PPTWindow) window).bringToForeground();
                            return;
                        }
                        BaseTitledWindow baseWindow = (BaseTitledWindow) window;
                        String docId = baseWindow.getId();
                        if (baseWindow.isReceiveOrder() || !BaseUtilsKt.isAdmin(router.getLiveRoom())) {
                            return;
                        }
                        List<LPDocViewElementModel> allDocList = getAllDocList();
                        LPDocViewUpdateModel lpDocViewUpdateModel = new LPDocViewUpdateModel();
                        lpDocViewUpdateModel.docId = docId;
                        lpDocViewUpdateModel.action = "normal";
                        if (allDocList == null || allDocList.isEmpty()) {
                            return;
                        }
                        for (LPDocViewElementModel elementModel : allDocList) {
                            if (elementModel.docId.equals(lpDocViewUpdateModel.docId)) {
                                elementModel.max = 0;
                                lpDocViewUpdateModel.all = allDocList;
                                router.getLiveRoom().getDocListVM().requestDocViewUpdate(lpDocViewUpdateModel);
                                break;
                            }
                        }
                    }
                    if (window instanceof SmallBlackboardWindow) {
                        updateToolbarWindow();

                        if (BaseUtilsKt.isAdmin(router.getLiveRoom())) {
                            LPDocViewUpdateModel lpDocViewUpdateModel = new LPDocViewUpdateModel();
                            lpDocViewUpdateModel.docId = ((SmallBlackboardWindow) window).getId();
                            lpDocViewUpdateModel.action = "normal";
                            List<LPDocViewElementModel> allDocList = router.getListByKey(EventKey.AllSnippetViewList, LPDocViewElementModel.class);
                            if (allDocList == null || allDocList.isEmpty()) {
                                return;
                            }
                            for (LPDocViewElementModel elementModel : allDocList) {
                                if (elementModel.docId.equals(lpDocViewUpdateModel.docId)) {
                                    elementModel.max = 0;
                                    lpDocViewUpdateModel.all = allDocList;
                                    router.getLiveRoom().getToolBoxVM().requestSnippetViewUpdate(lpDocViewUpdateModel);
                                    break;
                                }
                            }
                        }
                    }
                    if (window instanceof MediaCoursewarePlayerWindow) {
                        LPPlayerViewUpdateModel playerViewUpdateModel = new LPPlayerViewUpdateModel();
                        playerViewUpdateModel.id = FECompatUtil.getIOSMediaIdFromMediaId(FECompatUtil.getMediaId(router.getLiveRoom().getCurrentUser().getUserId(),
                                LPConstants.MediaSourceType.Media.getValue()));
                        playerViewUpdateModel.action = LPConstants.LPPlayerAction.NORMAL;

                        Set<LPPlayerViewUpdateModel.PlayerPosition> allSet = router.getSetByKey(EventKey.AllPlayerViewList, LPPlayerViewUpdateModel.PlayerPosition.class);
                        for (LPPlayerViewUpdateModel.PlayerPosition playerPosition : allSet) {
                            if (playerPosition.id.equals(playerViewUpdateModel.id)) {
                                playerPosition.max = 0;
                                playerViewUpdateModel.all = allSet;
                                router.getLiveRoom().getMediaVM().requestPlayerViewUpdate(playerViewUpdateModel);
                                break;
                            }
                        }
                    }
                    if (window instanceof VideoWindow) {
                        Set<LPPlayerViewUpdateModel.PlayerPosition> allSet = router.getSetByKey(EventKey.AllPlayerViewList, LPPlayerViewUpdateModel.PlayerPosition.class);
                        LPPlayerViewUpdateModel model = new LPPlayerViewUpdateModel();
                        model.action = LPConstants.LPPlayerAction.NORMAL;
                        model.id = model.mediaId = FECompatUtil.getIOSMediaIdFromMediaId(((VideoWindow) window).getMediaId());
                        for (LPPlayerViewUpdateModel.PlayerPosition playerPosition : allSet) {
                            if (playerPosition.id.equals(model.id)) {
                                playerPosition.max = 0;
                                model.all = allSet;
                                router.getLiveRoom().getMediaVM().requestPlayerViewUpdate(model);
                                break;
                            }
                        }
                    }
                    if (window instanceof BrowserWindow) {
                        BrowserWindow baseWindow = (BrowserWindow) window;
                        if (baseWindow.isReceiveOrder()) {
                            return;
                        }
                        if (webpageUpdateModeList.isEmpty()) {
                            return;
                        }
                        LPDocViewUpdateModel lpDocViewUpdateModel = new LPDocViewUpdateModel();
                        lpDocViewUpdateModel.action = "normal";
                        lpDocViewUpdateModel.docId = baseWindow.getId();
                        lpDocViewUpdateModel.userId = router.getLiveRoom().getCurrentUser().getUserId();
                        for (LPDocViewElementModel elementModel : webpageUpdateModeList) {
                            if (TextUtils.equals(elementModel.docId, lpDocViewUpdateModel.docId)) {
                                final FrameLayout.LayoutParams layoutParamsSmall = (LayoutParams) baseWindow.getLayoutParamsSmall();
                                elementModel.max = 0;
                                elementModel.width = String.valueOf((float) layoutParamsSmall.width / (float) getWidth());
                                elementModel.height = String.valueOf((float) layoutParamsSmall.height / (float) getHeight());
                                elementModel.x = String.valueOf((float) layoutParamsSmall.leftMargin / (float) getWidth());
                                elementModel.y = String.valueOf((float) layoutParamsSmall.topMargin / (float) getHeight());
                                lpDocViewUpdateModel.all = webpageUpdateModeList;
                                router.getLiveRoom().getToolBoxVM().requestWebpageUpdate(lpDocViewUpdateModel);
                                break;
                            }
                        }
                    }
                });

        compositeDisposable.add(router.getSubjectByKey(EventKey.MinimizeWindowOn)
                .ofType(BaseTitledWindow.class)
                .observeOn(AndroidSchedulers.mainThread())
                .subscribe(window -> {
                    if (window instanceof SmallBlackboardWindow) {
                        for (SmallBlackboardWindow sbbWindow : smallBlackboardWindows) {
                            if (sbbWindow.getId().equals(window.getId())) {
                                FrameLayout.LayoutParams layoutParams = new FrameLayout.LayoutParams(UtilsKt.getDp(120), UtilsKt.getDp(30));
                                layoutParams.gravity = Gravity.BOTTOM | Gravity.START;
                                // 与 bottomMenuWindow 底部对齐
                                layoutParams.bottomMargin = (int) (DisplayUtils.getNavigationBarHeight((AppCompatActivity) getContext()) + getContext().getResources().getDimension(R.dimen.bjysc_bottom_menu_window_margin_bottom));
                                layoutParams.leftMargin = UtilsKt.getDp(10);
                                if (sbbWindow.getView() != null) {
                                    sbbWindow.getView().setLayoutParams(layoutParams);
                                }
                                break;
                            }
                        }
                    }
                })
        );

        compositeDisposable.add(router.getSubjectByKey(EventKey.MinimizeWindowOff)
                .ofType(BaseTitledWindow.class)
                .observeOn(AndroidSchedulers.mainThread())
                .subscribe(window -> {
                    if (window instanceof SmallBlackboardWindow) {
                        // reset之后所有最小化的都还原
                        final List<SmallBlackboardWindow> cacheSmallBlackboardWindows = router.getListByKey(EventKey.MinimizeWindows, SmallBlackboardWindow.class);
                        for (SmallBlackboardWindow smallBlackboardWindow : cacheSmallBlackboardWindows) {
                            if (smallBlackboardWindow.getView() != null) {
                                if (window != smallBlackboardWindow) {
                                    smallBlackboardWindow.resetMinInSyncWithoutEvent();
                                }
                                smallBlackboardWindow.resetMinSbbOwner();
                                smallBlackboardWindow.getView().setLayoutParams(smallBlackboardWindow.getLastLayoutParams());
                            }
                        }
                        cacheSmallBlackboardWindows.clear();
                        router.setObjectByKey(EventKey.MinimizeWindows, cacheSmallBlackboardWindows);
                    } else if (window instanceof MediaCoursewarePlayerWindow) {
                        if (window.getView() != null) {
                            window.getView().setLayoutParams(window.getLastLayoutParams());
                        }
                        LPPlayerViewUpdateModel playerViewUpdateModel = new LPPlayerViewUpdateModel();
                        playerViewUpdateModel.id = FECompatUtil.getIOSMediaIdFromMediaId(FECompatUtil.getMediaId(router.getLiveRoom().getCurrentUser().getUserId(),
                                LPConstants.MediaSourceType.Media.getValue()));
                        playerViewUpdateModel.action = window.isMaxInSync() ? LPConstants.LPPlayerAction.MAX : LPConstants.LPPlayerAction.NORMAL;
                        Set<LPPlayerViewUpdateModel.PlayerPosition> allSet = router.getSetByKey(EventKey.AllPlayerViewList, LPPlayerViewUpdateModel.PlayerPosition.class);
                        for (LPPlayerViewUpdateModel.PlayerPosition playerPosition : allSet) {
                            if (playerPosition.id.equals(playerViewUpdateModel.id)) {
                                playerPosition.max = window.isMaxInSync() ? 1 : 0;
                                playerPosition.full = 0;
                                playerViewUpdateModel.all = allSet;
                                router.getLiveRoom().getMediaVM().requestPlayerViewUpdate(playerViewUpdateModel);
                                break;
                            }
                        }
                    }
                }));

        Disposable disposableOfPPTWindowBringToFront = router.getSubjectByKey(EventKey.PPTWindowBringToFront)
                .ofType(String.class)
                .subscribe(docId -> {
                    if (!BaseUtilsKt.isAdmin(router.getLiveRoom())
                            || (docId != null && docId.contains(LPConstants.PREVIEW_PPT_DOC_ID_SUFFIX))) {
                        return;
                    }
                    LPDocViewUpdateModel lpDocViewUpdateModel = new LPDocViewUpdateModel();
                    lpDocViewUpdateModel.docId = docId;
                    lpDocViewUpdateModel.action = "stick";
                    List<LPDocViewElementModel> allDocList = router.getListByKey(EventKey.AllDocViewList, LPDocViewElementModel.class);
                    if (docId == null || allDocList == null || allDocList.isEmpty()) {
                        return;
                    }
                    for (LPDocViewElementModel elementModel : allDocList) {
                        if (elementModel.docId.equals(docId)) {
                            allDocList.remove(elementModel);
                            allDocList.add(elementModel);
                            lpDocViewUpdateModel.all = allDocList;
                            router.getLiveRoom().getDocListVM().requestDocViewUpdate(lpDocViewUpdateModel);
                            break;
                        }
                    }
                });

        Disposable disposableOfPPTAuth = router.getLiveRoom().getDocListVM().getPublishSubjectOfStudentPPTAuth()
                .filter(strings -> router.getLiveRoom().getCurrentUser().getType() == LPConstants.LPUserType.Student)
                .observeOn(AndroidSchedulers.mainThread())
                .subscribe(userNumbers -> {
                    if (userNumbers.contains(router.getLiveRoom().getCurrentUser().getNumber())) {
                        for (PPTWindow pptWindow : pptWindows) {
                            pptWindow.setPPTAuthView(true);
                        }
                    } else {
                        for (PPTWindow pptWindow : pptWindows) {
                            pptWindow.setPPTAuthView(false);
                        }
                    }
                    shapePaint.setPPtEditMode(LPConstants.PPTEditMode.Normal);
                });

        Disposable disposableOfDrawAuth = router.getLiveRoom().getSpeakQueueVM().getPublishSubjectOfStudentDrawingAuth()
                .observeOn(AndroidSchedulers.mainThread())
                .subscribe(aBoolean -> {
                    if (hasDrawingAuth && aBoolean) {
                        return;
                    }
                    hasDrawingAuth = aBoolean;
                    router.getSubjectByKey(EventKey.ResetToolbarStatus).onNext(true);
                });

        // 下台后需要收回所有权限
        Disposable disposableOfActiveUserRemove = router.getLiveRoom().getOnlineUserVM().getPublishSubjectOfActiveUserRemove()
                .filter(lpResRoomUserInModel -> lpResRoomUserInModel.getUser().getNumber().equals(router.getLiveRoom().getCurrentUser().getNumber()) &&
                        lpResRoomUserInModel.getUser().getType() == LPConstants.LPUserType.Student)
                .observeOn(AndroidSchedulers.mainThread())
                .subscribe(lpResRoomUserInModel -> {
                    for (PPTWindow pptWindow : pptWindows) { // 收回 PPT 授权
                        pptWindow.setPPTAuthView(false);
                    }
                    router.getSubjectByKey(EventKey.ResetToolbarStatus).onNext(true);
                });

        compositeDisposable.add(router.getLiveRoom().getDocListVM().getPublishSubjectOfStudentPPTAuth()
                .filter(strings -> !BaseUtilsKt.isAdmin(router.getLiveRoom()))
                .subscribe(userNumbers -> pptAuth = userNumbers.contains(router.getLiveRoom().getCurrentUser().getNumber())));

        compositeDisposable.add(router.getSubjectByKey(EventKey.CheckSyncPreviewDoc)
                .subscribe(ignore -> {
                    if (mPreviewDocModel == null) {
                        return;
                    }
                    LPDocModel docModel = null;
                    for (LPDocModel model : router.getLiveRoom().getDocListVM().getDocList()) {
                        if (model.docId.equals(mPreviewDocModel.id)) {
                            docModel = model;
                            break;
                        }
                    }
                    if (docModel == null) {
                        return;
                    }
                    PPTWindow tempPPTWindow = null;
                    for (PPTWindow pptWindow : pptWindows) {
                        if (TextUtils.equals(pptWindow.getId(), mPreviewDocModel.id)) {
                            tempPPTWindow = pptWindow;
                            break;
                        }
                    }
                    //已经存在预览课件的正式ppt点击上课后切换tab到正式课件
                    if (tempPPTWindow != null) {
                        PPTWindow previewPPTWindow = null;
                        for (PPTWindow pptWindow : pptWindows) {
                            if (pptWindow.isPreviewPPT()) {
                                previewPPTWindow = pptWindow;
                                break;
                            }
                        }
                        if (previewPPTWindow != null) {
                            previewPPTWindow.switchTab(tempPPTWindow);
                        }
                        return;
                    }
                    LPDocViewUpdateModel lpDocViewUpdateModel = new LPDocViewUpdateModel();
                    lpDocViewUpdateModel.docId = docModel.docId;
                    lpDocViewUpdateModel.action = "add";
                    LPDocViewElementModel lpDocViewElementModel = new LPDocViewElementModel();
                    lpDocViewElementModel.docId = docModel.docId;
                    lpDocViewElementModel.max = 1;
                    lpDocViewElementModel.full = 0;
                    lpDocViewElementModel.width = "0.33";
                    lpDocViewElementModel.height = String.valueOf((docModel.height / docModel.width * 0.66f));
                    List<LPDocViewElementModel> allDocList = new ArrayList<>(
                            router.getListByKey(EventKey.AllDocViewList, LPDocViewElementModel.class));
                    lpDocViewElementModel.x = String.valueOf(0.0125 * allDocList.size());
                    lpDocViewElementModel.y = "0";

                    for (LPDocViewElementModel elementModel : allDocList) {
                        if (docModel.docId.equals(elementModel.docId)) {
                            return;
                        }
                    }
                    allDocList.add(lpDocViewElementModel);
                    lpDocViewUpdateModel.all = allDocList;
                    router.getLiveRoom().getDocListVM().requestDocViewUpdate(lpDocViewUpdateModel);

                    removeAndDestroyPPTView(mPreviewDocModel.id + LPConstants.PREVIEW_PPT_DOC_ID_SUFFIX);
                }));

        compositeDisposable.add(router.getLiveRoom().getZXYBVM().getObservableOfConnectStatus()
                .observeOn(AndroidSchedulers.mainThread())
                .subscribe(zxybConnectStatus -> {
                    if (zxybConnectStatus == LPConstants.ZXYBConnectStatus.CONNECT_STATUS_SUCCESS) {
                        final ZXYBDeviceInfo connectedDevice = router.getLiveRoom().getZXYBVM().getConnectedDevice();
                        if (connectedDevice != null) {
                            calculateWritingBoardRatio(connectedDevice.maxX, connectedDevice.maxY);
                        }
                    }
                }));
        final ZXYBDeviceInfo connectedDevice = router.getLiveRoom().getZXYBVM().getConnectedDevice();
        if (connectedDevice != null) {
            calculateWritingBoardRatio(connectedDevice.maxX, connectedDevice.maxY);
        }
        compositeDisposable.add(router.getLiveRoom().getZXYBVM().getObservableOfXYDataPacket()
                .observeOn(AndroidSchedulers.mainThread())
                .subscribe(xyDataPacket -> {
                    //down事件需要判断落在哪里
                    final ZXYBDeviceInfo device = router.getLiveRoom().getZXYBVM().getConnectedDevice();
                    if (device != null) {
                        xyDataPacket.tx = xyDataPacket.x * writingBoardRatio;
                        xyDataPacket.ty = xyDataPacket.y * writingBoardRatio;
                        if (laserShapeLayer != null && laserShapeLayer.isEnableDrawLaser()) {
                            lpMotionEvent.setXyDataPacket(xyDataPacket);
                            laserShapeLayer.onTouchEvent(lpMotionEvent);
                        }
                        if (xyDataPacket.penStatus == XYConstant.XYPenStatus_Down) {
                            final PPTWindow maxPPTWindow = router.getValueByKey(EventKey.MaxScreenPPTWindow, PPTWindow.class);
                            final PPTWindow fullPPTWindow = router.getValueByKey(EventKey.FullScreenPPTWindow, PPTWindow.class);
                            destPPTWindow = fullPPTWindow != null ? fullPPTWindow : maxPPTWindow;
                            if (destPPTWindow != null) {
                                destPPTWindow.setOnTouchEvent(xyDataPacket);
                            } else {
                                //对应到黑板区的x,y,遍历那个PPT被选中
                                for (PPTWindow pptWindow : pptWindows) {
                                    if (pptWindow.contains(xyDataPacket.tx, xyDataPacket.ty)) {
                                        if (destPPTWindow == null) {
                                            destPPTWindow = pptWindow;
                                        } else {
                                            final int index = getIndexOfParentView(destPPTWindow.getView());
                                            final int index1 = getIndexOfParentView(pptWindow.getView());
                                            if (index1 > index) {
                                                destPPTWindow = pptWindow;
                                            }
                                        }
                                    }
                                }
                                if (destPPTWindow != null) {
                                    destPPTWindow.setOnTouchEvent(xyDataPacket);
                                } else {
                                    getBlackboardLayer().getBlackImageWindow().setOnTouchEvent(xyDataPacket);
                                }
                            }
                        } else {
                            if (destPPTWindow != null) {
                                destPPTWindow.setOnTouchEvent(xyDataPacket);
                            } else {
                                getBlackboardLayer().getBlackImageWindow().setOnTouchEvent(xyDataPacket);
                            }
                            if (xyDataPacket.penStatus == XYConstant.XYPenStatus_Leave || xyDataPacket.penStatus == XYConstant.XYPenStatus_Up) {
                                destPPTWindow = null;
                            }
                        }
                    }
                }));

        compositeDisposable.add(router.getLiveRoom().getZXYBVM()
                .getObservableOfSoftKey()
                .observeOn(AndroidSchedulers.mainThread())
                .subscribe(this::doSoftKeyCallBack));

        compositeDisposable.add(router.getSubjectByKey(EventKey.BdsRepaint)
                .ofType(String.class)
                .observeOn(AndroidSchedulers.mainThread())
                .subscribe(docId -> {
                    ((BlackboardLayer) blackboardLayer).getBlackImageWindow().bdsRepaintShape(docId);
                }));

        compositeDisposable.add(router.getSubjectByKey(EventKey.DocPreview)
                .ofType(LPDocModel.class)
                .observeOn(AndroidSchedulers.mainThread())
                .subscribe(previewDocModel -> {
                    router.getSubjectByKey(EventKey.ReminderMessage).onNext(getContext().getString(R.string.bjy_group_doc_preview_tip));
                    boolean hasMax = false;
                    boolean hasFull = false;
                    boolean hasAdd = false;
                    for (PPTWindow ppt : pptWindows) {
                        if (TextUtils.equals(ppt.getId(), previewDocModel.docId + LPConstants.PREVIEW_PPT_DOC_ID_SUFFIX)) {
                            hasAdd = true;
                        }
                        if (ppt.isMaxInFull()) {
                            hasFull = true;
                        }
                        if (ppt.isMaxInSync()) {
                            hasMax = true;
                        }
                    }
                    if (hasAdd) {
                        return;
                    }
                    // 构建模拟窗口，展示预览 ppt
                    LPDocViewUpdateModel mockDocViewUpdateModel = new LPDocViewUpdateModel();
                    mockDocViewUpdateModel.action = "add";
                    LPDocViewElementModel elementModel = new LPDocViewElementModel();
                    elementModel.docId = previewDocModel.docId + LPConstants.PREVIEW_PPT_DOC_ID_SUFFIX;
                    elementModel.full = hasFull? 1 : 0;
                    elementModel.max = hasMax? 1 : 0;
                    elementModel.width = "0.3333";
                    elementModel.height = String.valueOf((previewDocModel.height / previewDocModel.width * 0.66f));
                    elementModel.x = "0";
                    elementModel.y = "0";
                    List<LPDocViewElementModel> elementModels = new ArrayList<>();
                    elementModels.add(elementModel);
                    mockDocViewUpdateModel.all = elementModels;
                    mockDocViewUpdateModel.docId = previewDocModel.docId + LPConstants.PREVIEW_PPT_DOC_ID_SUFFIX;
                    mockDocViewUpdateModel.userId = "-1";
                    addPPTView(mockDocViewUpdateModel);
                }));

        compositeDisposable.add(disposableGraphDraw);
        compositeDisposable.add(disposableStrokeWidth);
        compositeDisposable.add(disposableCustomGraphWidth);
        compositeDisposable.add(disposableEraseMode);
        compositeDisposable.add(disposableDrawColorSetting);
        compositeDisposable.add(disposableOfCustomGraphMenuEnable);
        compositeDisposable.add(disposableTextEdit);
        compositeDisposable.add(disposableOfTextSend);
        compositeDisposable.add(disposableOfTextSizeChange);
        compositeDisposable.add(disposableOfBitmapShape);
        compositeDisposable.add(bitmapShapeSelectedDisposable);
        compositeDisposable.add(disposableOfBitmapShapeLayerSwitch);
        compositeDisposable.add(disposableOfBitmapShapeScale);
        compositeDisposable.add(disposableOfBitmapShapeErase);
        compositeDisposable.add(disposableOfLaserShape);
        compositeDisposable.add(disposableOfMaximumWindowOff);
        compositeDisposable.add(disposableOfMaximumWindowOn);
        compositeDisposable.add(disposableOfDocViewUpdate);
        compositeDisposable.add(disposableOfAuthPaintColor);
        compositeDisposable.add(disposableOfCloseWindow);
        compositeDisposable.add(disposableOfRepositionWindow);
        compositeDisposable.add(disposableOfPPTWindowBringToFront);
        compositeDisposable.add(disposableOfFullScreenOn);
        compositeDisposable.add(disposableOfFullScreenOff);
        compositeDisposable.add(disposableOfResetToolbarMode);
        compositeDisposable.add(disposableOfPPTAuth);
        compositeDisposable.add(disposableOfDrawAuth);
        compositeDisposable.add(disposableOfActiveUserRemove);
        compositeDisposable.add(disposableOfH5DocumentDelete);
        compositeDisposable.add(disposableOfWebpageUpdate);
        compositeDisposable.add(disposableOfRepositionWebpage);
        compositeDisposable.add(disposableOfAddWebpage);
    }

    private void initRemindDialog() {
        View remindView = View.inflate(getContext(), R.layout.bjy_base_ppt_clear_all_dialog, null);
        remindDialog = new Dialog(getContext());
        remindDialog.setContentView(remindView);
        remindDialog.setCancelable(true);
        remindDialog.setCanceledOnTouchOutside(true);
        WindowManager.LayoutParams layoutParams = remindDialog.getWindow().getAttributes();
        layoutParams.dimAmount = 0.50f;
        layoutParams.flags |= WindowManager.LayoutParams.FLAG_DIM_BEHIND;
        layoutParams.width = UtilsKt.getDp(420);
        layoutParams.height = UtilsKt.getDp(230);
        layoutParams.gravity = Gravity.CENTER;
        remindDialog.getWindow().setAttributes(layoutParams);
        TextView confirmTv = remindView.findViewById(R.id.dialog_confirm_tv);
        confirmTv.setBackground(ThemeDataUtil.getDrawableProductButtonBg(getContext()));
        confirmTv.setOnClickListener(v -> {
            getBlackboardLayer().getBlackImageWindow().eraseAll();
            remindDialog.dismiss();
        });
        CheckBox remindCb = remindView.findViewById(R.id.dialog_not_remind_cb);
        remindCb.setOnCheckedChangeListener((buttonView, isChecked) -> isCheckNotRemind = isChecked);
        remindView.findViewById(R.id.dialog_not_remind_tv).setOnClickListener(v -> remindCb.setChecked(!remindCb.isChecked()));
    }

    private void handleWebpageUpdate(LPDocViewUpdateModel lpDocViewUpdateModel) {
        if (lpDocViewUpdateModel.all == null) {
            return;
        }
        webpageUpdateModeList = lpDocViewUpdateModel.all;
        LPDocViewElementModel model = null;
        for (LPDocViewElementModel e : lpDocViewUpdateModel.all) {
            if (TextUtils.equals(lpDocViewUpdateModel.docId, e.docId)) {
                model = e;
                break;
            }
        }
        if (model == null || browserWindow == null) {
            // 缓存数据，browerWindow生成后处理位置
            webpageUpdateModel = lpDocViewUpdateModel;
            return;
        }
        webpageUpdateModel = null;
        if (!lpDocViewUpdateModel.isFromCache && router.getLiveRoom().getCurrentUser().getUserId().equals(lpDocViewUpdateModel.userId)) {
            return;
        }
        switch (lpDocViewUpdateModel.action) {
            case "add":
                addWebpage(lpDocViewUpdateModel);
                break;
            case "normal":
                backToNormalWebpage();
                break;
            case "max":
                maximumWebpage();
                break;
            case "full":
                fullscreenWebpage();
                break;
            case "reposition":
                repositionWebpage(lpDocViewUpdateModel);
                break;
            default:
                break;
        }
    }

    private void calculateWritingBoardRatio(int maxX, int maxY) {
        post(() -> {
            if (router != null && selfWidth != 0 && selfHeight != 0) {
                if (1.0f * maxX / maxY > 1.0f * selfWidth / selfHeight) {
                    writingBoardRatio = 1.0f * selfHeight / maxY;
                } else {
                    writingBoardRatio = 1.0f * selfWidth / maxX;
                }
            }
        });
    }


    private PPTWindow getTopPPTWindow() {
        if (pptWindows == null || pptWindows.isEmpty()) {
            return null;
        }
        final PPTWindow maxPPTWindow = router.getValueByKey(EventKey.MaxScreenPPTWindow, PPTWindow.class);
        final PPTWindow fullPPTWindow = router.getValueByKey(EventKey.FullScreenPPTWindow, PPTWindow.class);
        PPTWindow tempPPTWindow = fullPPTWindow != null ? fullPPTWindow : maxPPTWindow;
        if (tempPPTWindow != null) {
            return tempPPTWindow;
        }
        final int childCount = documentLayer.getChildCount();
        final View topView = documentLayer.getChildAt(childCount - 1);
        for (PPTWindow pptWindow : pptWindows) {
            if (pptWindow.getView() == topView) {
                return pptWindow;
            }
        }
        return null;
    }


    private int shapeStrokeWidthIndex, shapeColorIndex;

    public void doSoftKeyCallBack(int keyCode) {
        switch (keyCode) {
            case 101:
                //鼠标
                break;
            case 102:
                //上一页
                PPTWindow tempPPTWindow = getTopPPTWindow();
                if (tempPPTWindow != null && pptWindows != null && !pptWindows.isEmpty()) {
                    tempPPTWindow.gotoPrevPage();
                } else {
                    getBlackboardLayer().getBlackImageWindow().gotoPrevPage();
                }
                break;
            case 103:
                //下一页
                PPTWindow tempPPTWindowNext = getTopPPTWindow();
                if (tempPPTWindowNext != null && pptWindows != null && !pptWindows.isEmpty()) {
                    tempPPTWindowNext.gotoNextPage();
                } else {
                    getBlackboardLayer().getBlackImageWindow().gotoNextPage();
                }
                break;
            case 104:
                //选择
                break;
            case 105:
                //画笔
                break;
            case 106:
                //马克笔
                break;
            case 107:
                //箭头
                break;
            case 108:
                //橡皮
                break;
            case 109:
                //颜色
                if (shapePaint.getPPtEditMode() != LPConstants.PPTEditMode.ShapeMode) {
                    return;
                }
                if (getContext() instanceof GroupClassActivity) {
                    ((GroupClassActivity) getContext()).checkColorIndex(shapeColorIndex);
                }
                shapeColorIndex = (shapeColorIndex + 1) % BaseAutoArrangePopupWindow.colorIds.length;
                break;
            case 110:
                //粗细
                if (shapePaint.getPPtEditMode() != LPConstants.PPTEditMode.ShapeMode) {
                    return;
                }
                float brushStrokeWidth =
                        BaseDrawWidthSettingWindow.pencilPaintSize[shapeStrokeWidthIndex];
                float markerStrokeWidth =
                        BaseDrawWidthSettingWindow.markerPaintSize[shapeStrokeWidthIndex];
                float graphStrokeWidth = graphStrokeWidthArray[shapeStrokeWidthIndex];
                if (getContext() instanceof GroupClassActivity) {
                    ((GroupClassActivity) getContext()).checkIndex(shapeStrokeWidthIndex);
                }
                if (shapePaint.getShapeType() == LPConstants.ShapeType.Doodle) {
                    shapePaint.setDoodleStrokeWidth(new WidthSelectData(SelectSrc.Brush, brushStrokeWidth));
                } else if (shapePaint.getShapeType() == LPConstants.ShapeType.MarkerDoodle) {
                    shapePaint.setDoodleStrokeWidth(new WidthSelectData(SelectSrc.Marker, markerStrokeWidth));
                }
                shapePaint.setCustomStrokeWidth(graphStrokeWidth);
                shapeStrokeWidthIndex = (shapeStrokeWidthIndex + 1) % 4;
                break;
            case 111:
                //F1
                break;
            case 112:
                //F2
                break;
            default:
                break;
        }
        if (router.getLiveRoom().getCurrentUser().getType() == LPConstants.LPUserType.Teacher
                || router.getLiveRoom().getCurrentUser().getType() == LPConstants.LPUserType.Assistant
                || router.getLiveRoom().getSpeakQueueVM().getDrawingAuth()) {
            router.getSubjectByKey(EventKey.ZXYBSoftKey).onNext(keyCode);
        }
    }

    private static final int[] graphStrokeWidthArray = {0, 2, 4, 6};

    private int getIndexOfParentView(@Nullable View child) {
        if (child == null) {
            return -1;
        }
        final ViewParent parent = child.getParent();
        if (!(parent instanceof ViewGroup)) {
            return -1;
        }
        ViewGroup parentView = (ViewGroup) parent;
        return parentView.indexOfChild(child);
    }

    /**
     * 处理播放 预览PPT
     */
    private void handlePreviewDoc(LPDocumentModel previewDocModel) {
        // 判断是否应该展示预览ppt， 配置项启用此功能 && 已进入提前进教室时间 && 未到达预设的开始上课时间 && 未开始上课 && 有后台关联的文件
        if (router.getLiveRoom().getPartnerConfig().enablePreOpenDoc != 1 ||
                router.getLiveRoom().isClassStarted() || previewDocModel == null) {
            return;
        }
        if (mPreviewDocModel != null) {
            if (TextUtils.equals(previewDocModel.getDocId(), mPreviewDocModel.getDocId())) {
                // 跟当前预览 ppt 一致，不做操作
                return;
            } else {
                // 否则移除当前的 预览 ppt
                removeAndDestroyPPTView(mPreviewDocModel.id + LPConstants.PREVIEW_PPT_DOC_ID_SUFFIX);
            }
        }
        mPreviewDocModel = previewDocModel;
        // 构建模拟窗口，展示预览 ppt
        LPDocViewUpdateModel mockDocViewUpdateModel = new LPDocViewUpdateModel();
        mockDocViewUpdateModel.action = "max";
        LPDocViewElementModel elementModel = new LPDocViewElementModel();
        elementModel.docId = previewDocModel.id + LPConstants.PREVIEW_PPT_DOC_ID_SUFFIX;
        elementModel.full = 0;
        elementModel.max = 1;
        elementModel.x = "0";
        elementModel.y = "0";
        elementModel.width = "0.3333";
        elementModel.height = String.valueOf((previewDocModel.pageInfoModel.height / previewDocModel.pageInfoModel.width * 0.66f));
        List<LPDocViewElementModel> elementModels = new ArrayList<>();
        elementModels.add(elementModel);
        mockDocViewUpdateModel.all = elementModels;
        mockDocViewUpdateModel.docId = previewDocModel.id + LPConstants.PREVIEW_PPT_DOC_ID_SUFFIX;
        mockDocViewUpdateModel.userId = "-1";
        addPPTView(mockDocViewUpdateModel);
    }

    public List<LPDocViewElementModel> getAllDocList() {
        return router.getListByKey(EventKey.AllDocViewList, LPDocViewElementModel.class);
    }

    private boolean hasDrawingAuth;

    private void hideTitleFooter() {
        for (PPTWindow pptWindow : getPPTWindows()) {
            pptWindow.hideTitleFooter();
        }
        pptTabLayer.show(false);
    }

    private void showTitleFooter() {
        final PPTWindow maxPPTWindow = router.getValueByKey(EventKey.MaxScreenPPTWindow, PPTWindow.class);
        final PPTWindow fullPPTWindow = router.getValueByKey(EventKey.FullScreenPPTWindow, PPTWindow.class);
        boolean hasPPTMaxOrFull = !pptWindows.isEmpty() && pptWindows.size() > 1 && (maxPPTWindow != null || fullPPTWindow != null);
        for (PPTWindow pptWindow : getPPTWindows()) {
            pptWindow.showTitleFooter();
            pptWindow.getPPTView().invalidateCurrentPage();
            if (hasPPTMaxOrFull) {
                pptWindow.hideTitle();
            }
        }
        pptTabLayer.show(true);
    }

    private void initBrowser() {
        Disposable disposableOfPublishBrowser = router.getSubjectByKey(EventKey.OpenBrowserWindow)
                .ofType(Boolean.class)
                .subscribe(aBoolean -> {
                    if (aBoolean) {
                        if (browserWindow != null) {
                            return;
                        }
                        addNewWebPage();
                    } else {
                        browserLayer.removeWindow(browserWindow);
                        if (browserWindow != null) {
                            browserWindow.clearBroadcastCache();
                            browserWindow.onDestroy();
                            browserWindow = null;
                        }
                    }
                });
        // 区别以上带了关闭信令
        Disposable disposableOfCloseBrowser = router.getSubjectByKey(EventKey.CloseBrowserWindow)
                .ofType(Boolean.class)
                .subscribe(aBoolean -> {
                    browserLayer.removeWindow(browserWindow);
                    if (browserWindow != null) {
                        LPWebPageInfoModel webPageInfoModel = new LPWebPageInfoModel();
                        webPageInfoModel.status = 0;
                        webPageInfoModel.id = browserWindow.getId();
                        webPageInfoModel.actionType = 0;
                        router.getLiveRoom().getToolBoxVM().requestOpenWebPage(webPageInfoModel);
                        browserWindow.isAdd = false;
                        router.getSubjectByKey(EventKey.AddWebpage).onNext(browserWindow);
                        browserWindow.clearBroadcastCache();
                        browserWindow.onDestroy();
                        browserWindow = null;
                    }
                });

        Disposable disposableOfRandomSelect = router.getSubjectByKey(EventKey.OpenRandomSelectWindow)
                .mergeWith(router.getLiveRoom().getObservableOfRandomSelect())
                .observeOn(AndroidSchedulers.mainThread())
                .ofType(LPRandomSelectValueModel.class)
                .subscribe(randomSelectValueModel -> {
                    if (randomSelectValueModel.nameList != null) {
                        if (randomSelectWindow == null) {
                            randomSelectWindow = new RandomSelectWindow(getContext());
                            LayoutParams layoutParams =
                                    new LayoutParams(UtilsKt.getDp(460), UtilsKt.getDp(240));
                            layoutParams.gravity = Gravity.CENTER;
                            randomSelectLayer.addWindow(randomSelectWindow, layoutParams);
                        }
                        ((RandomSelectWindow) randomSelectWindow).initValues(randomSelectValueModel);
                        ((RandomSelectWindow) randomSelectWindow).startMission();
                    } else {
                        randomSelectLayer.removeWindow(randomSelectWindow);
                        randomSelectWindow.onDestroy();
                        randomSelectWindow = null;
                    }
                });

        Disposable disposableOfWebPageInfo = router.getLiveRoom().getToolBoxVM().getObservableOfWebPageInfo()
                .observeOn(AndroidSchedulers.mainThread())
                .subscribe(webPageInfoModel -> {
                    if (webPageInfoModel.isOpenStatus()) {
                        if (browserWindow == null) {
                            addNewWebPage();
                        }
                    } else {
                        if (TextUtils.equals(router.getLiveRoom().getCurrentUser().getUserId(), webPageInfoModel.userId)) {
                            return;
                        }
                        browserLayer.removeWindow(browserWindow);
                        if (browserWindow != null) {
                            browserWindow.onDestroy();
                            browserWindow = null;
                        }
                    }
                });

        LPWebPageInfoModel webPageInfo = router.getLiveRoom().getToolBoxVM().getWebPageInfo();
        if (webPageInfo != null && webPageInfo.isOpenStatus()) {
            addNewWebPage();
        }

        compositeDisposable.add(disposableOfRandomSelect);
        compositeDisposable.add(disposableOfPublishBrowser);
        compositeDisposable.add(disposableOfCloseBrowser);
        compositeDisposable.add(disposableOfWebPageInfo);
    }

    private BrowserWindow.BrowserChangeListener browserChangeListener = new BrowserWindow.BrowserChangeListener() {
        @Override
        public void onOpenBrowser(boolean isOpen) {
            router.getSubjectByKey(EventKey.OpenBrowserWindow).onNext(isOpen);
        }

        @Override
        public void onCloseBrowser() {
            router.getSubjectByKey(EventKey.CloseBrowserDialog).onNext(true);
        }

        @Override
        public void onRepositionWebpage(Tuple tuple) {
            router.getSubjectByKey(EventKey.RepositionWebpage).onNext(tuple);
        }

        @Override
        public void onOpenWebpage(BrowserWindow window) {
            router.getSubjectByKey(EventKey.AddWebpage).onNext(window);
        }

        @Override
        public void onMaxInSync(BaseTitleWindow2 window) {
            router.getSubjectByKey(EventKey.SetMaximumWindowOn).onNext(window);
        }

        @Override
        public void onResetMaxInSync(BaseTitleWindow2 window) {
            router.getSubjectByKey(EventKey.SetMaximumWindowOff).onNext(window);
        }

        @Override
        public void onMinInSync(BaseTitleWindow2 window) {
            router.getSubjectByKey(EventKey.MinimizeWindowOn).onNext(window);
        }

        @Override
        public void onResetMinInSync(BaseTitleWindow2 window) {
            router.getSubjectByKey(EventKey.MinimizeWindowOff).onNext(window);
        }

        @Override
        public void onMaxInFull(BaseTitleWindow2 window) {
            router.getSubjectByKey(EventKey.SetFullScreenWindowOn).onNext(window);
        }

        @Override
        public void onResetInFull(BaseTitleWindow2 window) {
            router.getSubjectByKey(EventKey.SetFullScreenWindowOff).onNext(window);
        }
    };

    private final Runnable webpageRunnable = () -> {
        browserWindow = new BrowserWindow(getContext());
        browserWindow.setBrowserChangeListener(browserChangeListener);
        LayoutParams layoutParams = new LayoutParams((int) getResources().getDimension(R.dimen.bjy_base_default_browser_width), (int) getResources().getDimension(R.dimen.bjy_base_default_browser_height));
        layoutParams.leftMargin = (getWidth() - layoutParams.width) / 2;
        layoutParams.topMargin = (getHeight() - layoutParams.height) / 2;
        browserLayer.addWindow(browserWindow, layoutParams);
        if (webpageUpdateModel != null) {
            handleWebpageUpdate(webpageUpdateModel);
        }
    };

    private void addNewWebPage() {
        post(webpageRunnable);
    }

    private void destroyToolBox() {
        destroyTeacherTimer();
        destroyStudentTimer();
        destroyTeacherAnswerer();
        destroyStudentAnswerer();
        removeGroupAwardWindow();
        if (browserWindow != null) {
            browserWindow.onDestroy();
            browserWindow = null;
        }
        cancelResponder();
        if (responderRobButton != null) {
            toolBoxLayer.removeView(responderRobButton);
        }
    }

    private void initTimer() {
        compositeDisposable.add(router.getLiveRoom().getToolBoxVM().getObservableOfTimerStart()
                .observeOn(AndroidSchedulers.mainThread())
                .subscribe(lpTimerModel -> {
                    if (!BaseUtilsKt.isAdmin(router.getLiveRoom())) {
                        initStudentTimer(lpTimerModel);
                    } else {
                        initTeacherTimer(lpTimerModel);
                    }
                }));
        compositeDisposable.add(router.getLiveRoom().getToolBoxVM().getObservableOfTimerRevoke()
                .observeOn(AndroidSchedulers.mainThread())
                .subscribe(lpDataUserModel -> {
                    if (!BaseUtilsKt.isAdmin(router.getLiveRoom())) {
                        destroyStudentTimer();
                    }
                }));
        router.getLiveRoom().getToolBoxVM().requestTimerCache();
        compositeDisposable.add(router.getSubjectByKey(EventKey.TeacherTimerWindow)
                .ofType(Boolean.class)
                .observeOn(AndroidSchedulers.mainThread())
                .subscribe(aBoolean -> {
                    if (aBoolean) {
                        initTeacherTimer(null);
                    } else {
                        destroyTeacherTimer();
                    }
                }));
    }

    private void initAnswerer() {
        compositeDisposable.add(router.getSubjectByKey(EventKey.StudentAnswererWindow)
                .ofType(Boolean.class)
                .subscribe(aBoolean -> {
                    if (!aBoolean) {
                        destroyStudentAnswerer();
                    }
                }));
        compositeDisposable.add(router.getLiveRoom().getToolBoxVM().getObservableOfAnswerStart()
                .observeOn(AndroidSchedulers.mainThread()).subscribe(lpAnswererModel -> {
                    if (!BaseUtilsKt.isAdmin(router.getLiveRoom())) {
                        initStudentAnswerer(lpAnswererModel);
                    } else {
                        initTeacherAnswerer(lpAnswererModel);
                    }
                }));
        compositeDisposable.add(router.getSubjectByKey(EventKey.TeacherAnswererWindow)
                .ofType(Boolean.class)
                .observeOn(AndroidSchedulers.mainThread())
                .subscribe(aBoolean -> {
                    if (aBoolean) {
                        initTeacherAnswerer(new LPAnswerModel());
                    } else {
                        // dismiss不走destroy
                        if (teacherAnswererWindow != null) {
                            toolBoxLayer.removeWindow(teacherAnswererWindow);
                        }
                    }
                }));
    }

    // 上次移动的计时器位置
    private PointF lastTimerPosition;
    // 上次设置的计时器时间
    private long[] lastTimerSetting;

    private void initStudentTimer(LPTimerModel lpAnswererModel) {
        if (studentTimerWindow == null) {
            studentTimerWindow = new StudentTimerWindow(getContext(), lpAnswererModel);
            FrameLayout.LayoutParams layoutParams = new FrameLayout.LayoutParams(
                    getResources().getDimensionPixelSize(R.dimen.bjysc_student_timer_root_width),
                    getResources().getDimensionPixelSize(R.dimen.bjysc_student_timer_root_height)
            );
            if (lastTimerPosition == null) {
                layoutParams.leftMargin = layoutParams.topMargin =
                        getResources().getDimensionPixelSize(R.dimen.bjysc_student_timer_default_margin);
            } else {
                layoutParams.leftMargin = (int) lastTimerPosition.x;
                layoutParams.topMargin = (int) lastTimerPosition.y;
            }
            layoutParams.gravity = Gravity.TOP;
            toolBoxLayer.addWindow(studentTimerWindow, layoutParams);
        }
    }

    private void destroyStudentTimer() {
        if (studentTimerWindow != null) {
            lastTimerPosition = new PointF(studentTimerWindow.getView().getX(), studentTimerWindow.getView().getY());
        }
        destroyToolBoxWindow(studentTimerWindow);
        studentTimerWindow = null;
    }

    private void initTeacherTimer(LPTimerModel lpTimerModel) {
        if (teacherTimerWindow == null) {
            if (lpTimerModel == null) {
                teacherTimerWindow = new TeacherTimerWindow(getContext());
                ((TeacherTimerWindow) teacherTimerWindow).recoverTimerSetting(lastTimerSetting);
            } else {
                teacherTimerWindow = new TeacherTimerWindow(getContext(), lpTimerModel);
            }
            FrameLayout.LayoutParams layoutParams = new FrameLayout.LayoutParams(UtilsKt.getDp(280), UtilsKt.getDp(180));
            if (lastTimerPosition == null) {
                layoutParams.gravity = Gravity.CENTER;
            } else {
                layoutParams.leftMargin = (int) lastTimerPosition.x;
                layoutParams.topMargin = (int) lastTimerPosition.y;
            }
            toolBoxLayer.addWindow(teacherTimerWindow, layoutParams);
        }
    }

    private void destroyTeacherTimer() {
        if (teacherTimerWindow != null) {
            lastTimerPosition = new PointF(teacherTimerWindow.getView().getX(), teacherTimerWindow.getView().getY());
            lastTimerSetting = ((TeacherTimerWindow) teacherTimerWindow).getLastTimerSetting();
        }
        destroyToolBoxWindow(teacherTimerWindow);
        teacherTimerWindow = null;
    }

    private void initStudentAnswerer(LPAnswerModel lpAnswerModel) {
        if (studentAnswererWindow == null) {
            studentAnswererWindow = new AnswererWindow(getContext(), lpAnswerModel);
            FrameLayout.LayoutParams layoutParams = new FrameLayout.LayoutParams((int) getResources().getDimension(R.dimen.bjysc_default_answer_student_width), ViewGroup.LayoutParams.WRAP_CONTENT);
            layoutParams.gravity = Gravity.CENTER;
            toolBoxLayer.addWindow(studentAnswererWindow, layoutParams);
        }
    }

    private void destroyStudentAnswerer() {
        destroyToolBoxWindow(studentAnswererWindow);
        studentAnswererWindow = null;
    }

    private void initTeacherAnswerer(LPAnswerModel newModel) {
        if (teacherAnswererWindow == null) {
            if (TextUtils.isEmpty(newModel.messageType)) {
                teacherAnswererWindow = new AdminAnswererWindow(getContext());
            } else {
                teacherAnswererWindow = new AdminAnswererWindow(getContext(), newModel);
            }
        }
        if (toolBoxLayer.indexOfChild(teacherAnswererWindow.getView()) == -1) {
            int width = (int) getResources().getDimension(R.dimen.bjysc_default_answer_teacher_width);
            if (router.getLiveRoom().getSmallClassTemplateType() == LPConstants.SmallClassTemplateType.ONEONONE) {
                width = (int) getResources().getDimension(R.dimen.bjysc_default_answer_teacher_width_oneonone);
            }
            FrameLayout.LayoutParams layoutParams = new FrameLayout.LayoutParams(width, ViewGroup.LayoutParams.WRAP_CONTENT);
            layoutParams.gravity = Gravity.CENTER;
            toolBoxLayer.addWindow(teacherAnswererWindow, layoutParams);
        }
    }

    private void destroyTeacherAnswerer() {
        destroyToolBoxWindow(teacherAnswererWindow);
        teacherAnswererWindow = null;
    }

    private void destroyToolBoxWindow(BaseWindow window) {
        if (window != null) {
            toolBoxLayer.removeWindow(window);
            window.onDestroy();
        }
    }

    private void initVideo() {
        videoWindows = new ConcurrentLinkedQueue<>();
        cachedViewPositions = new ConcurrentHashMap<>();
        Disposable disposableOfClassEnd = router.getLiveRoom().getObservableOfClassEnd()
                .observeOn(AndroidSchedulers.mainThread())
                .filter(integer -> integer == 0)
                .subscribe(integer -> destroyToolBox());

        Disposable disposableOfUserOut = router.getLiveRoom().getOnlineUserVM().getObservableOfUserOut()
                .mergeWith(router.getLiveRoom().getOnlineUserVM().getPublishSubjectOfActiveUserRemove().map(lpResRoomUserInModel -> lpResRoomUserInModel.user))
                .observeOn(AndroidSchedulers.mainThread())
                .subscribe(userModel -> {
                    if (router.getLiveRoom().getTeacherUser() == null || !TextUtils.equals(userModel.getUserId(), router.getLiveRoom().getTeacherUser().getUserId())) { // 处理老师异常退出教室没有发class end
                        removeVideoWindow(userModel.getUserId());
                    }
                    //用户退出。如果当前是老师，判断视频是否弹出，将此用户移除all，更新信令remove.
                    if (!BaseUtilsKt.isAdmin(router.getLiveRoom())) {
                        return;
                    }
                    Set<LPPlayerViewUpdateModel.PlayerPosition> all = router.getSetByKey(EventKey.AllPlayerViewList
                            , LPPlayerViewUpdateModel.PlayerPosition.class);
                    if (all == null || all.isEmpty()) {
                        return;
                    }
                    String mediaId = null;
                    for (LPPlayerViewUpdateModel.PlayerPosition playerPosition : all) {
                        if (playerPosition.id.equals(userModel.getUserId())) {
                            mediaId = playerPosition.mediaId;
                            all.remove(playerPosition);
                            break;
                        }
                    }
                    LPPlayerViewUpdateModel model = new LPPlayerViewUpdateModel();
                    model.action = LPConstants.LPPlayerAction.REMOVE;
                    model.id = userModel.getUserId();
                    model.mediaId = mediaId;
                    model.all = all;
                    router.getLiveRoom().getMediaVM().requestPlayerViewUpdate(model);
                });

        Disposable disposableOfPlayerViewUpdate = router.getLiveRoom().getMediaVM().getObservableOfPlayerViewUpdate()
                .observeOn(AndroidSchedulers.mainThread())
                .subscribe(this::handleVideoWindowPosition);

        compositeDisposable.add(router.getLiveRoom().getOnlineUserVM().getPublishSubjectOfActiveUserRemove()
                .observeOn(AndroidSchedulers.mainThread())
                .subscribe(lpResRoomUserInModel -> removeVideoWindow(lpResRoomUserInModel.user.userId))
        );

        Disposable disposableOfCloseVideoWindow = router.getSubjectByKey(EventKey.CloseVideoWindow)
                .ofType(String.class)
                .subscribe(this::requestVideoWindowRemove);

        Disposable disposableOfPlayerViewAdd = router.getSubjectByKey(EventKey.PlayerViewAdd)
                .ofType(PlayerViewActionModel.class)
                .subscribe(model -> post(() -> {
                    addVideoWindow(model);
                }));

        Disposable disposableOfStickVideoWindow = router.getSubjectByKey(EventKey.StickVideoWindow)
                .ofType(LPPlayerViewUpdateModel.PlayerPosition.class)
                .subscribe(playerPosition -> {
                    Set<LPPlayerViewUpdateModel.PlayerPosition> allList = router.getSetByKey(EventKey.AllPlayerViewList
                            , LPPlayerViewUpdateModel.PlayerPosition.class);
                    if (null == allList) {
                        return;
                    }

                    for (LPPlayerViewUpdateModel.PlayerPosition position : allList) {
                        if (position.id.equals(playerPosition.id)) {
                            allList.remove(position);
                            allList.add(playerPosition);
                            router.setObjectByKey(EventKey.AllPlayerViewList, allList);
                            break;
                        }
                    }

                    LPPlayerViewUpdateModel model = new LPPlayerViewUpdateModel();
                    model.id = playerPosition.id;
                    model.mediaId = playerPosition.mediaId;
                    model.action = LPConstants.LPPlayerAction.STICK;
                    model.all = allList;
                    router.getLiveRoom().getMediaVM().requestPlayerViewUpdate(model);
                });

        Disposable disposableOfMoveVideoWindow = router.getSubjectByKey(EventKey.MoveVideoWindow)
                .ofType(LPPlayerViewUpdateModel.PlayerPosition.class)
                .throttleLast(1, TimeUnit.SECONDS)
                .observeOn(AndroidSchedulers.mainThread())
                .subscribe(playerPosition -> {
                    Set<LPPlayerViewUpdateModel.PlayerPosition> allList = router.getSetByKey(EventKey.AllPlayerViewList
                            , LPPlayerViewUpdateModel.PlayerPosition.class);
                    if (null == allList) {
                        return;
                    }
                    bringVideoToFront(playerPosition.id);

                    for (LPPlayerViewUpdateModel.PlayerPosition position : allList) {
                        if (position.id.equals(playerPosition.id)) {
                            allList.remove(position);
                            allList.add(playerPosition);
                            router.setObjectByKey(EventKey.AllPlayerViewList, allList);
                            break;
                        }
                    }

                    LPPlayerViewUpdateModel model = new LPPlayerViewUpdateModel();
                    model.id = playerPosition.id;
                    model.action = LPConstants.LPPlayerAction.REPOSITION;
                    model.all = allList;
                    router.getLiveRoom().getMediaVM().requestPlayerViewUpdate(model);
                });


        Observable<IMediaModel> observableOfActiveUserTeacherExtStream = router.getLiveRoom().getSpeakQueueVM()
                .getObservableOfActiveUsers()
                .flatMap((Function<List<IMediaModel>, ObservableSource<IMediaModel>>) Observable::fromIterable)
                .filter(iMediaModel -> iMediaModel.getExtraStreams() != null)
                .flatMap((Function<IMediaModel, ObservableSource<IMediaModel>>) iMediaModel -> Observable.fromIterable(iMediaModel.getExtraStreams()));

        //老师走multi逻辑，助教屏幕分享走replace，媒体走multi，没有辅助摄像头
        Disposable disposableOfMediaPublish = router.getLiveRoom().getSpeakQueueVM()
                .getObservableOfMediaPublish()
                .mergeWith(observableOfActiveUserTeacherExtStream)
                .filter(iMediaModel -> {
                    if (iMediaModel.getUser().getType() == LPConstants.LPUserType.Teacher || router.getLiveRoom().getSmallClassTemplateType() == LPConstants.SmallClassTemplateType.ONEONONE) {
                        return iMediaModel.getMediaSourceType() != LPConstants.MediaSourceType.MainCamera;
                    } else {
                        return iMediaModel.getMediaSourceType() != LPConstants.MediaSourceType.MainCamera
                                && iMediaModel.getMediaSourceType() != LPConstants.MediaSourceType.MainScreenShare;
                    }
                })
                .observeOn(AndroidSchedulers.mainThread())
                .subscribe(this::handleExtStream);

        compositeDisposable.add(router.getLiveRoom().getMediaVM()
                .getObservableOfCloudVideo()
                .observeOn(AndroidSchedulers.mainThread())
                .subscribe(this::handleVideoWindow));

        compositeDisposable.add(router.getLiveRoom().getObservableOfRoomLayoutSwitch()
                .map(layoutMode -> layoutMode == LPConstants.RoomLayoutMode.GALLERY)
                .mergeWith(router.getLiveRoom().getStudyRoomVM().getObservableOfStudyRoomSwitch()
                .map(LPConstants.StudyRoomMode::isGalleryLayout))
                .filter(aBoolean -> aBoolean)
                .observeOn(AndroidSchedulers.mainThread())
                .subscribe(isGalleryLayout -> {
                    if (router.getValueByKey(EventKey.AllPlayerViewList, Set.class) == null) {
                        return;
                    }
                    final Boolean isReEnterRoom = router.getValueByKey(EventKey.StudyReEnterRoom, Boolean.class);
                    if (isReEnterRoom != null && isReEnterRoom) {
                        return;
                    }
                    Set<LPPlayerViewUpdateModel.PlayerPosition> playerPositionList = new HashSet<>(
                            router.getSetByKey(EventKey.AllPlayerViewList, LPPlayerViewUpdateModel.PlayerPosition.class));
                    LPPlayerViewUpdateModel model = new LPPlayerViewUpdateModel();
                    model.action = LPConstants.LPPlayerAction.REMOVE;
                    for (LPPlayerViewUpdateModel.PlayerPosition playerPosition : playerPositionList) {
                        model.all = playerPositionList;
                        model.id = playerPosition.id;
                        model.mediaId = playerPosition.mediaId;
                        handleVideoWindowPosition(model, true);
                    }
                }));
        compositeDisposable.add(router.getSubjectByKey(EventKey.PlayerViewHide)
                .ofType(VideoWindow.class)
                .subscribe(videoWindow -> {
                    for (VideoContainerWindow videoContainerWindow : videoWindows) {
                        if (videoContainerWindow.getVideoWindow() == videoWindow) {
                            videoContainerWindow.getView().setVisibility(videoWindow.isShowWindow() ? View.VISIBLE : View.GONE);
                            return;
                        }
                    }
                }));
        compositeDisposable.add(router.getLiveRoom().getOnlineUserVM().getObservableOfOnGroupItem()
                .subscribe(lpGroupItems -> {
                    updateGroupAwardInfo();
                    if (lpGroupItems.size() > 0) {
                        cancelGroup();
                        setGroup(router.getLiveRoom().getOnlineUserVM().getGroupList());
                    } else {
                        cancelGroup();
                        for (VideoContainerWindow videoContainerWindow : videoWindows) {
                            videoContainerWindow.getVideoWindow().setGroupItem(new GroupItem(0));
                        }
                    }
                }));
        compositeDisposable.add(disposableOfClassEnd);
        compositeDisposable.add(disposableOfUserOut);
        compositeDisposable.add(disposableOfPlayerViewUpdate);
        compositeDisposable.add(disposableOfPlayerViewAdd);
        compositeDisposable.add(disposableOfCloseVideoWindow);
        compositeDisposable.add(disposableOfStickVideoWindow);
        compositeDisposable.add(disposableOfMoveVideoWindow);
        compositeDisposable.add(disposableOfMediaPublish);
    }

    private void cancelGroup() {
        //如果已经分过组，解散分组,重置布局
        for (VideoContainerWindow videoContainerWindow : videoWindows) {
            videoContainerWindow.getVideoWindow().clearGroupColor();
        }
    }

    private void setGroup(List<LPGroupItem> groups) {
        // 更新分组信息
        Map<String, VideoContainerWindow> speakNums = new HashMap<>();
        for (VideoContainerWindow videoContainerWindow : videoWindows) {
            if (videoContainerWindow.getMediaModel() == null) {
                continue;
            }
            speakNums.put(videoContainerWindow.getMediaModel().getUser().getNumber(), videoContainerWindow);
        }
        int count = 0;
        for (LPGroupItem lpGroupItem : groups) {
            count += lpGroupItem.count;
        }
        if (count == 0) {
            for (VideoContainerWindow videoContainerWindow : videoWindows) {
                videoContainerWindow.getVideoWindow().setGroupItem(new GroupItem(0));
            }
        }
        for (LPGroupItem lpGroupItem : groups) {
            final List<LPUserModel> userModelList = lpGroupItem.userModelList;
            for (LPUserModel lpUserModel : userModelList) {
                GroupItem groupItemModel = lpGroupItem.groupItemModel;
                if (groupItemModel != null && speakNums.containsKey(lpUserModel.number)) {
                    final VideoContainerWindow videoContainerWindow = speakNums.remove(lpUserModel.number);
                    if (videoContainerWindow != null) {
                        if (groupItemModel.id != 0) {
                            videoContainerWindow.getVideoWindow().setGroupColor(groupItemModel.color);
                        }
                        if (router.getLiveRoom().getOnlineUserVM().isMediaGroup()) {
                            videoContainerWindow.getVideoWindow().setGroupItem(groupItemModel);
                        } else {
                            if (groupItemModel.id == 0) {
                                videoContainerWindow.getVideoWindow().setGroupItem(groupItemModel);
                            }
                        }
                    }
                }
            }
        }
        // 未在分组中的数据也需要处理
        for (VideoContainerWindow videoContainerWindow : speakNums.values()) {
            if (videoContainerWindow != null) {
                videoContainerWindow.getVideoWindow().setGroupItem(new GroupItem(0));
            }
        }
    }

    private boolean isOpenSbb;

    private void startSbbObservable() {
        smallBlackboardWindows = new ConcurrentLinkedQueue<>();
        router.getLiveRoom().getToolBoxVM().requestSnippetPullAllReq();
        compositeDisposable.add(router.getLiveRoom().getToolBoxVM().getObservableOfSnippetPullAllRes()
                .flatMap(Observable::fromIterable)
                .observeOn(AndroidSchedulers.mainThread())
                .subscribe(lpSnippetPullResModel -> {
                    LPSnippetPullReqModel lpSnippetPullReqModel = new LPSnippetPullReqModel(lpSnippetPullResModel.id);
                    router.getLiveRoom().getToolBoxVM().requestSnippetPullReq(lpSnippetPullReqModel);
                }));

        Disposable sbbOpenWindowDisposable = router.getSubjectByKey(EventKey.SbbOpenWindow)
                .subscribe(o -> {
                    final int childCount = smallBlackboardLayer.getChildCount();
                    if (childCount >= 10) {
                        router.getSubjectByKey(EventKey.ReminderErrorMessage).onNext(getContext().getString(R.string.bjy_group_sbb_out_of_max_limit));
                        return;
                    }
                    isOpenSbb = true;
                    if (BaseUtilsKt.isTeacher(router.getLiveRoom().getCurrentUser())) {
                        SmallBlackboardWindow sbbWindow = initSmallBlackboardView(SmallBlackboardWindow.SBB_ID_PREFIX + System.currentTimeMillis());
                        smallBlackboardWindows.add(sbbWindow);
                        sbbWindow.init();
                    }
                });

        //处于答题状态
        Disposable snippetPullResDisposable = router.getLiveRoom().getToolBoxVM().getObservableOfSnippetPullRes()
                .observeOn(AndroidSchedulers.mainThread())
                .subscribe(this::showSmallBlackboardWindow);

        Disposable disposableOfSnippetViewUpdate = router.getLiveRoom().getToolBoxVM().getObservableOfSnippetViewUpdate()
                .observeOn(AndroidSchedulers.mainThread())
                .subscribe(lpDocViewUpdateModel -> {
                    router.setObjectByKey(EventKey.AllSnippetViewList, lpDocViewUpdateModel.all);
                    switch (lpDocViewUpdateModel.action) {
                        case "add":
                            addSmallBlackboardView(lpDocViewUpdateModel);
                            break;
                        case "remove":
                            removeAndDestroyBlackboardView(lpDocViewUpdateModel.docId);
                            break;
                        case "stick":
                            if (router.getLiveRoom().getCurrentUser().getUserId().equals(lpDocViewUpdateModel.userId)) {
                                return;
                            }
                            sbbBringToFront(lpDocViewUpdateModel.docId);
                            break;
                        case "normal":
                            if (router.getLiveRoom().getCurrentUser().getUserId().equals(lpDocViewUpdateModel.userId)) {
                                return;
                            }
                            sbbBackToNormal(lpDocViewUpdateModel.docId);
                            break;
                        case "max":
                            if (router.getLiveRoom().getCurrentUser().getUserId().equals(lpDocViewUpdateModel.userId)) {
                                return;
                            }
                            sbbMaximumWindow(lpDocViewUpdateModel.docId);
                            break;
                        case "full":
                            if (router.getLiveRoom().getCurrentUser().getUserId().equals(lpDocViewUpdateModel.userId)) {
                                return;
                            }
                            sbbFullscreenWindow(lpDocViewUpdateModel.docId);
                            break;
                        case "reposition":
                            if (router.getLiveRoom().getCurrentUser().getUserId().equals(lpDocViewUpdateModel.userId)) {
                                return;
                            }
                            sbbRepositionWindow(lpDocViewUpdateModel);
                            break;
                        case "rename":
                            showSbbWindowName(lpDocViewUpdateModel);
                            break;
                        default:
                            break;
                    }
                });

        Disposable disposableOfSnippetViewUpdateCache = router.getLiveRoom().getToolBoxVM().getObservableOfSnippetViewUpdateCache()
                .observeOn(AndroidSchedulers.mainThread())
                .subscribe(viewUpdateModel -> {
                    router.setObjectByKey(EventKey.AllSnippetViewList, viewUpdateModel.all);
                    boolean continueFlag, isTeacherInPublishStatus = false;
                    //恢复all数组保存的窗口信息
                    for (LPDocViewElementModel elementModel : viewUpdateModel.all) {
                        continueFlag = false;
                        if (elementModel.docId.contains(SmallBlackboardWindow.FAKE_TEACHER_ID_PREFIX)) {
                            isTeacherInPublishStatus = true;
                        }
                        for (SmallBlackboardWindow window : smallBlackboardWindows) {
                            if (elementModel.docId.equals(window.getId())) {
                                continueFlag = true;
                                break;
                            }
                        }
                        if (continueFlag) {
                            continue;
                        }

                        SmallBlackboardWindow smallBlackboardWindow = initSmallBlackboardView(true, elementModel.docId,
                                Float.parseFloat(elementModel.x), Float.parseFloat(elementModel.y), Float.parseFloat(elementModel.width), Float.parseFloat(elementModel.height));
                        LPSnippetPullResModel pullResModel = new LPSnippetPullResModel();
                        pullResModel.id = elementModel.docId;
                        smallBlackboardWindow.initStatus(pullResModel, SmallBlackboardStatus.PUBLISH_TO_ALL);
                        if (elementModel.full == 1) {
                            smallBlackboardWindow.maxInFull();
                        } else if (elementModel.max == 1) {
                            smallBlackboardWindow.maxInSync();
                        }
                        smallBlackboardWindows.add(smallBlackboardWindow);
                    }
                    //先剔除已公开的小黑板再打开老师的管理页面
                    if (isOpenSbb && BaseUtilsKt.isTeacher(router.getLiveRoom().getCurrentUser()) && snippetPullResModel != null && snippetPullResModel.userSubmittedList != null) {
                        for (SmallBlackboardWindow window : smallBlackboardWindows) {
                            for (IUserModel userModel : snippetPullResModel.userSubmittedList) {
                                if (userModel.getNumber().equals(window.getId())) {
                                    snippetPullResModel.userSubmittedList.remove(userModel);
                                    break;
                                }
                            }
                        }
                        snippetPullResModel.isTeacherInPublishStatus = isTeacherInPublishStatus;
                        SmallBlackboardWindow sbbWindow = initSmallBlackboardView(snippetPullResModel.id);
                        sbbWindow.cursor = SbbUtils.getLastUserNumber(snippetPullResModel);
                        sbbWindow.initStatus(snippetPullResModel, SmallBlackboardStatus.ALL_COMMITTED);
                        smallBlackboardWindows.add(sbbWindow);
                        snippetPullResModel = null;
                    }
                    showSbbWindowName(viewUpdateModel);
                });

        Disposable disposableOfAddSbbWindow = router.getSubjectByKey(EventKey.SbbAddWindow)
                .ofType(LPSnippetSubmitModel.class)
                .filter(lpSnippetSubmitModel -> lpSnippetSubmitModel.from != null)
                .subscribe(lpSnippetSubmitModel -> {
                    List<LPDocViewElementModel> allDocList = router.getListByKey(EventKey.AllSnippetViewList, LPDocViewElementModel.class);
                    if (allDocList == null) {
                        allDocList = new ArrayList<>();
                    }
                    String id = lpSnippetSubmitModel.from.getNumber() + "_" + lpSnippetSubmitModel.id;
                    for (LPDocViewElementModel docViewElementModel : allDocList) {
                        if (docViewElementModel.docId.equals(id)) {
                            return;
                        }
                    }
                    LPDocViewUpdateModel lpDocViewUpdateModel = new LPDocViewUpdateModel();
                    //公开老师的docId为0_s_0
                    lpDocViewUpdateModel.docId = id;
                    lpDocViewUpdateModel.action = "add";
                    LPDocViewElementModel elementModel = new LPDocViewElementModel();
                    elementModel.docId = id;
                    elementModel.full = 0;
                    elementModel.height = String.valueOf(getResources().getDimension(R.dimen.bjysc_default_sbb_height) / getHeight());
                    elementModel.width = String.valueOf(getResources().getDimension(R.dimen.bjysc_default_sbb_width) / getWidth());
                    elementModel.max = 0;
                    elementModel.x = "0";
                    elementModel.y = "0";
                    //默认不显示name
                    elementModel.name = "";
                    allDocList.add(elementModel);
                    lpDocViewUpdateModel.all = allDocList;
                    sbbAllUserSet.add(lpSnippetSubmitModel.from);
                    router.getLiveRoom().getToolBoxVM().requestSnippetViewUpdate(lpDocViewUpdateModel);
                });

        Disposable disposableOfRemoveSbbWindow = router.getSubjectByKey(EventKey.SbbCloseWindow)
                .ofType(SbbCloseWindowEvent.class)
                .subscribe(closeWindowEvent -> {
                    removeAndDestroyBlackboardView(closeWindowEvent.windowId);
                    LPLogger.d("yjm", "sbbCloseWindow " + closeWindowEvent.windowId + ", broadcast=" + closeWindowEvent.shouldSendBroadcast);
                    if (closeWindowEvent.shouldSendBroadcast) {
                        LPDocViewUpdateModel lpDocViewUpdateModel = new LPDocViewUpdateModel();
                        lpDocViewUpdateModel.docId = closeWindowEvent.windowId;
                        lpDocViewUpdateModel.action = "remove";

                        if (router.getValueByKey(EventKey.AllSnippetViewList, ArrayList.class) == null) {
                            return;
                        }
                        List<LPDocViewElementModel> allDocList = router.getListByKey(EventKey.AllSnippetViewList, LPDocViewElementModel.class);
                        for (LPDocViewElementModel elementModel : allDocList) {
                            if (elementModel.docId.equals(closeWindowEvent.windowId)) {
                                allDocList.remove(elementModel);
                                lpDocViewUpdateModel.all = allDocList;
                                router.getLiveRoom().getToolBoxVM().requestSnippetViewUpdate(lpDocViewUpdateModel);
                                break;
                            }
                        }
                    }
                });

        Disposable disposableOfRepositionSbbWindow = router.getSubjectByKey(EventKey.SbbRepositionWindow)
                .ofType(Tuple.class)
                .throttleLast(1, TimeUnit.SECONDS)
                .subscribe(tuple -> {
                    LPDocViewUpdateModel viewUpdateModel = new LPDocViewUpdateModel();
                    viewUpdateModel.docId = tuple.docId;
                    viewUpdateModel.action = "reposition";
                    List<LPDocViewElementModel> allDocList = router.getListByKey(EventKey.AllSnippetViewList, LPDocViewElementModel.class);
                    if (tuple.docId == null || allDocList == null || allDocList.isEmpty()) {
                        return;
                    }
                    if (tuple.action.equals(PPT_WINDOW_MOVE)) {
                        for (LPDocViewElementModel elementModel : allDocList) {
                            if (elementModel.docId.equals(tuple.docId)) {
                                elementModel.x = String.valueOf((float) tuple.width / (float) getWidth());
                                elementModel.y = String.valueOf((float) tuple.height / (float) getHeight());
                                viewUpdateModel.all = allDocList;
                                router.getLiveRoom().getToolBoxVM().requestSnippetViewUpdate(viewUpdateModel);
                                break;
                            }
                        }
                    } else if (tuple.action.equals(PPT_WINDOW_SCALE)) {
                        for (LPDocViewElementModel elementModel : allDocList) {
                            if (elementModel.docId.equals(tuple.docId)) {
                                elementModel.width = String.valueOf((float) tuple.width / (float) getWidth());
                                elementModel.height = String.valueOf((float) tuple.height / (float) getHeight());
                                viewUpdateModel.all = allDocList;
                                router.getLiveRoom().getToolBoxVM().requestSnippetViewUpdate(viewUpdateModel);
                                break;
                            }
                        }
                    }
                });

        Disposable disposableOfSbbWindowBringToFront = router.getSubjectByKey(EventKey.SbbBringToFront)
                .ofType(String.class)
                .subscribe(docId -> {
                    if (!BaseUtilsKt.isAdmin(router.getLiveRoom())) {
                        return;
                    }
                    LPDocViewUpdateModel lpDocViewUpdateModel = new LPDocViewUpdateModel();
                    lpDocViewUpdateModel.docId = docId;
                    lpDocViewUpdateModel.action = "stick";
                    List<LPDocViewElementModel> allDocList = router.getListByKey(EventKey.AllSnippetViewList, LPDocViewElementModel.class);
                    if (docId == null || allDocList == null || allDocList.isEmpty()) {
                        return;
                    }
                    for (LPDocViewElementModel elementModel : allDocList) {
                        if (elementModel.docId.equals(docId)) {
                            allDocList.remove(elementModel);
                            allDocList.add(elementModel);
                            lpDocViewUpdateModel.all = allDocList;
                            router.getLiveRoom().getToolBoxVM().requestSnippetViewUpdate(lpDocViewUpdateModel);
                            break;
                        }
                    }
                });

        Disposable snippetShowNameDisposable = router.getSubjectByKey(EventKey.SbbShowName)
                .ofType(SmallBlackboardWindow.class)
                .subscribe(window -> {
                    if (BaseUtilsKt.isAdmin(router.getLiveRoom())) {
                        LPDocViewUpdateModel lpDocViewUpdateModel = new LPDocViewUpdateModel();
                        lpDocViewUpdateModel.docId = window.getId();
                        lpDocViewUpdateModel.action = "rename";
                        List<LPDocViewElementModel> allDocList = router.getListByKey(EventKey.AllSnippetViewList, LPDocViewElementModel.class);
                        if (allDocList == null || allDocList.isEmpty()) {
                            return;
                        }
                        String number = "";
                        final int index = window.getId().indexOf("_");
                        if (index != -1) {
                            number = window.getId().substring(0, index);
                        }
                        for (LPDocViewElementModel elementModel : allDocList) {
                            if (elementModel.docId.equals(lpDocViewUpdateModel.docId)) {
                                if (window.shouldShowOwnerName()) {
                                    for (IUserModel userModel : sbbAllUserSet) {
                                        LPLogger.e("yjm", "userModel= " + userModel.getNumber() + ", elementModel.docId=" + elementModel.docId);
                                        if (userModel.getNumber().equals(number)) {
                                            elementModel.name = userModel.getName();
                                            break;
                                        }
                                    }
                                } else {
                                    elementModel.name = "";
                                }
                                lpDocViewUpdateModel.all = allDocList;
                                router.getLiveRoom().getToolBoxVM().requestSnippetViewUpdate(lpDocViewUpdateModel);
                                break;
                            }
                        }
                    }
                });

        Disposable snippetPublishDisposable = router.getLiveRoom().getToolBoxVM().getObservableOfSnippetPublish()
                .observeOn(AndroidSchedulers.mainThread())
                .subscribe(snippetPublishModel -> {
                    if (snippetPublishModel.operate == 1) {
                        // 打开小黑板
                        if (router.getLiveRoom().getCurrentUser().getType() != LPConstants.LPUserType.Teacher) {
                            snippetPublishModel.toAll = snippetPublishModel.toUserList == null || snippetPublishModel.toUserList.isEmpty();
                            //伪造一个SnippetPullResModel
                            LPSnippetPullResModel pullResModel = new LPSnippetPullResModel();
                            pullResModel.isActive = true;
                            pullResModel.duration = snippetPublishModel.duration;
                            pullResModel.timeStart = System.currentTimeMillis() / 1000;
                            pullResModel.id = snippetPublishModel.id;
                            pullResModel.toAll = snippetPublishModel.toAll;
                            showSmallBlackboardWindow(pullResModel);
                        }
                    }
                });

        compositeDisposable.add(snippetPullResDisposable);
        compositeDisposable.add(disposableOfSnippetViewUpdate);
        compositeDisposable.add(disposableOfRepositionSbbWindow);
        compositeDisposable.add(disposableOfSbbWindowBringToFront);
        compositeDisposable.add(disposableOfRemoveSbbWindow);
        compositeDisposable.add(disposableOfAddSbbWindow);
        compositeDisposable.add(snippetPublishDisposable);
        compositeDisposable.add(snippetShowNameDisposable);
        compositeDisposable.add(sbbOpenWindowDisposable);
        compositeDisposable.add(disposableOfSnippetViewUpdateCache);
    }

    private Disposable responderButtonDelayDisposable;

    private void startResponderObservable() {
        compositeDisposable.add(router.getSubjectByKey(EventKey.Responder)
                .ofType(Boolean.class)
                .filter(aBoolean -> BaseUtilsKt.isAdmin(router.getLiveRoom()))
                .subscribe(this::showResponderWindow));

        compositeDisposable.add(router.getLiveRoom().getToolBoxVM().getObservableOfAnswerRacerEnd()
                .observeOn(AndroidSchedulers.mainThread())
                .subscribe(lpAnswerRacerEndModel -> {
                    if (lpAnswerRacerEndModel.isRevoke) {
                        cancelResponder();
                        toolBoxLayer.removeView(responderRobButton);
                        router.getSubjectByKey(EventKey.ReminderMessage).onNext(getContext().getString(R.string.responder_cancel));
                    } else {
                        if (!BaseUtilsKt.isAdmin(router.getLiveRoom())) {
                            if (lpAnswerRacerEndModel.winner != null) {
                                if (lpAnswerRacerEndModel.winner.equals(router.getLiveRoom().getCurrentUser())) {
                                    responderRobButton.changeRobButtonStatus(ResponderRobButton.RobButtonState.ROBED);
                                } else {
                                    responderRobButton.changeRobButtonStatus(ResponderRobButton.RobButtonState.ROB_FAIL);
                                }
                            } else {
                                router.getSubjectByKey(EventKey.ReminderMessage).onNext(getContext().getString(R.string.responder_nobody_rob_student));
                            }
                            responderButtonDelayDisposable = Observable.just("").delay(3, TimeUnit.SECONDS)
                                    .observeOn(AndroidSchedulers.mainThread())
                                    .subscribe(s -> toolBoxLayer.removeView(responderRobButton));
                            compositeDisposable.add(responderButtonDelayDisposable);
                            cancelResponder();
                        }
                    }
                }));

        compositeDisposable.add(router.getLiveRoom().getToolBoxVM().getObservableOfAnswerRacerStart()
                .observeOn(AndroidSchedulers.mainThread())
                .subscribe(lpAnswerRacerStartModel -> {
                    RxUtils.dispose(responderButtonDelayDisposable);
                    if (BaseUtilsKt.isAdmin(router.getLiveRoom())) {
                        showResponderWindow(true);
                        responderWindow.changeStatus(ResponderWindow.ResponderStatus.PUBLISHING, "");
                    } else {
                        if (lpAnswerRacerStartModel.prepareTime > 0) {
                            showResponderPrepare(lpAnswerRacerStartModel.prepareTime);
                        } else {
                            showResponderButton();
                        }
                    }
                }));

        compositeDisposable.add(router.getLiveRoom().getToolBoxVM().getObservableOfComponentDestroy()
                .filter(lpComponentDestroyModel -> BaseUtilsKt.isAdmin(router.getLiveRoom()))
                .observeOn(AndroidSchedulers.mainThread())
                .subscribe(lpComponentDestroyModel -> {
                    if (LPConstants.ComponentType.Responder.getComponentType().equals(lpComponentDestroyModel.value.component)) {
                        showResponderWindow(false);
                    } else if (LPConstants.ComponentType.Answerer.getComponentType().equals(lpComponentDestroyModel.value.component)) {
                        // 组件销毁不走destroy
                        if (teacherAnswererWindow != null) {
                            toolBoxLayer.removeWindow(teacherAnswererWindow);
                        }
                    } else if (LPConstants.ComponentType.Timer.getComponentType().equals(lpComponentDestroyModel.value.component) &&
                            !TextUtils.equals(router.getLiveRoom().getCurrentUser().getUserId(), lpComponentDestroyModel.userId)) {
                        destroyTeacherTimer();
                    }
                }));

        //在黑板区域匹配一次视频窗口，然后再转发EventKey.ShowAward事件
        compositeDisposable.add(router.getSubjectByKey(EventKey.ShowAwardTransfer)
                .ofType(NotifyAwardModel.class)
                .subscribe(notifyAwardModel -> {
                    VideoContainerWindow matchVideoWindow = null;
                    for (VideoContainerWindow videoContainerWindow : videoWindows) {
                        IUserModel userModel = videoContainerWindow.getVideoWindow().getUserModel();
                        if (userModel != null && userModel.getNumber().equals(notifyAwardModel.userModel.getNumber())) {
                            matchVideoWindow = videoContainerWindow;
                            break;
                        }
                    }
                    if (matchVideoWindow != null) {
                        if (notifyAwardModel.awardCount > 0) {
                            matchVideoWindow.getVideoWindow().setAwardCount(notifyAwardModel.awardCount);
                        }
                        int[] location = new int[2];
                        matchVideoWindow.getView().getLocationOnScreen(location);
                        location[0] += matchVideoWindow.getView().getMeasuredWidth() / 2;
                        location[1] += matchVideoWindow.getView().getMeasuredHeight() / 2;
                        notifyAwardModel.endPointLocation = location;
                    }
                    router.getSubjectByKey(EventKey.ShowAward).onNext(notifyAwardModel);
                }));

        compositeDisposable.add(router.getLiveRoom().getToolBoxVM().getObservableOfGroupInfoAward()
                .observeOn(AndroidSchedulers.mainThread())
                .flatMap((Function<LPGroupInfoAwardModel, ObservableSource<LPGroupInfoAwardModel.GroupsBean>>)
                        lpGroupInfoAwardModel -> Observable.fromIterable(lpGroupInfoAwardModel.groups))
                .filter(groupsBean -> groupsBean.group == router.getLiveRoom().getCurrentUser().getGroup())
                .filter(groupsBean -> groupsBean.count > 0)
                .subscribe(groupsBean -> initGroupAwardWindow()));

        compositeDisposable.add(router.getSubjectByKey(EventKey.GroupAward)
                .ofType(LPGroupAwardModel.class)
                .subscribe(lpGroupAwardModel -> {
                    if (lpGroupAwardModel.group == router.getLiveRoom().getCurrentUser().getGroup()) {
                        initGroupAwardWindow();
                    } else {
                        updateGroupAwardInfo();
                    }
                }));
    }

    private void initGroupAwardWindow() {
        final Integer groupAwardCount = router.getLiveRoom().getToolBoxVM().getAwardGroupMap().get(router.getLiveRoom().getCurrentUser().getGroup());
        if (groupAwardCount == null || groupAwardCount <= 0) {
            return;
        }
        if (groupAwardWindow == null) {
            groupAwardWindow = new GroupAwardWindow(getContext());
            FrameLayout.LayoutParams layoutParams = new FrameLayout.LayoutParams(ViewGroup.LayoutParams.WRAP_CONTENT, ViewGroup.LayoutParams.WRAP_CONTENT);
            layoutParams.topMargin = getContext().getResources().getDimensionPixelSize(R.dimen.bjysc_remind_label_height);
            toolBoxLayer.addWindow(groupAwardWindow, layoutParams);
        }
        groupAwardWindow.setGroupAwardCount(groupAwardCount);
        groupAwardWindow.updateGroupAwardContent();
    }

    private void removeGroupAwardWindow() {
        if (groupAwardWindow != null) {
            toolBoxLayer.removeWindow(groupAwardWindow);
            groupAwardWindow.dismissInfoWindow();
            groupAwardWindow = null;
        }
    }

    private void updateGroupAwardInfo() {
        final Integer groupAwardCount = router.getLiveRoom().getToolBoxVM().getAwardGroupMap().get(router.getLiveRoom().getCurrentUser().getGroup());
        //解散分组、分组点赞为0
        if (router.getLiveRoom().getCurrentUser().getGroup() == 0 || groupAwardCount == null || groupAwardCount <= 0) {
            removeGroupAwardWindow();
            return;
        }
        if (groupAwardWindow != null) {
            groupAwardWindow.setGroupAwardCount(groupAwardCount);
        } else {
            initGroupAwardWindow();
        }
        groupAwardWindow.updateGroupAwardContent();
    }


    private GroupAwardWindow groupAwardWindow;
    private LPSnippetPullResModel snippetPullResModel;
    private ResponderWindow responderWindow;

    /**
     * 是否已经包含小黑板
     *
     * @param windowId
     */
    private boolean containsSbb(String windowId) {
        if (smallBlackboardWindows == null || smallBlackboardWindows.isEmpty()) {
            return false;
        }
        for (SmallBlackboardWindow smallBlackboardWindow : smallBlackboardWindows) {
            if (TextUtils.equals(windowId, smallBlackboardWindow.getId())) {
                return true;
            }
        }
        return false;
    }

    /**
     * 小黑板入口
     */
    private void showSmallBlackboardWindow(LPSnippetPullResModel snippetPullResModel) {
        boolean isTeacher = BaseUtilsKt.isTeacher(router.getLiveRoom().getCurrentUser());
        String id = snippetPullResModel.id;
        if (snippetPullResModel.isActive) {
            //老师进入管理页面（teacher_view)状态
            //学生进入作答页面，需要判断是否在已提交名单中，已提交则不处理。
            //在participated数组中，恢复窗口信息。未在participate数组，打开新的窗口，并发snippet_participate信令
            if (isTeacher) {
                if (!containsSbb(snippetPullResModel.id)) {
                    SmallBlackboardWindow sbbWindow = initSmallBlackboardView(id);
                    sbbWindow.cursor = SbbUtils.getLastUserNumber(snippetPullResModel);
                    smallBlackboardWindows.add(sbbWindow);
                    sbbWindow.initStatus(snippetPullResModel, SmallBlackboardStatus.TEACHER_REVIEW);
                }
            } else {
                boolean hasParticipated = false, hasCommit = false;
                String currentUserNumber = router.getLiveRoom().getCurrentUser().getNumber();
                if (snippetPullResModel.userSubmittedList != null) {
                    for (LPUserModel userModel : snippetPullResModel.userSubmittedList) {
                        if (userModel.getNumber().equals(currentUserNumber)) {
                            hasCommit = true;
                            break;
                        }
                    }
                }
                if (!hasCommit) {
                    if (snippetPullResModel.userParticipatedList != null) {
                        for (LPUserModel userModel : snippetPullResModel.userParticipatedList) {
                            if (userModel.getNumber().equals(currentUserNumber)) {
                                hasParticipated = true;
                                break;
                            }
                        }
                    }
                }
                if (hasCommit) {
                    return;
                }
                SmallBlackboardWindow sbbWindow = initSmallBlackboardView(id);
                smallBlackboardWindows.add(sbbWindow);
                sbbWindow.setToAll(snippetPullResModel.toAll);
                sbbWindow.initStatus(snippetPullResModel, SmallBlackboardStatus.STUDENT_WRITING);
                //补发snippet_participate
                if (!hasParticipated) {
                    LPSnippetSubmitModel participateModel = new LPSnippetSubmitModel();
                    participateModel.id = id;
                    participateModel.from = (LPUserModel) router.getLiveRoom().getCurrentUser();
                    participateModel.isActive = true;
                    router.getLiveRoom().getToolBoxVM().requestSnippetParticipate(participateModel);
                }
            }
        } else {
            //请求snippet_view_update展示公开窗口
            if (!isTeacher) {
                router.getLiveRoom().getToolBoxVM().requestSnippetViewUpdateCache();
            }
        }
    }

    /**
     * 居中显示小黑板
     *
     * @param id 小黑板id
     */
    private SmallBlackboardWindow initSmallBlackboardView(String id) {
        float width = getResources().getDimension(R.dimen.bjysc_default_sbb_width) / getWidth();
        float height = getResources().getDimension(R.dimen.bjysc_default_sbb_height) / getHeight();
        return initSmallBlackboardView(false, id, ((getWidth() - getResources().getDimension(R.dimen.bjysc_default_sbb_width)) / 2.0f) / getWidth(),
                ((getHeight() - getResources().getDimension(R.dimen.bjysc_default_sbb_height)) / 2.0f) / getHeight(), width, height);
    }

    private SmallBlackboardWindow initSmallBlackboardView(boolean isPublishAll, String id, float x, float y, float width, float height) {
        FrameLayout.LayoutParams layoutParams = new FrameLayout.LayoutParams((int) (getWidth() * width), (int) (getHeight() * height));
        int defaultMargin = UtilsKt.getDp(10);
        final int childCount = smallBlackboardLayer.getChildCount();
        layoutParams.topMargin = (int) (y * getHeight()) + defaultMargin * childCount;
        layoutParams.leftMargin = (int) (x * getWidth()) + defaultMargin * childCount;
        SmallBlackboardWindow smallBlackboardWindow = new SmallBlackboardWindow(getContext(), shapePaint, isPublishAll, true);
        smallBlackboardWindow.setCurrentLayer(id);
        smallBlackboardWindow.setWindowLayoutParams(layoutParams);
        smallBlackboardLayer.addWindow(smallBlackboardWindow, layoutParams);
        if (!BaseUtilsKt.isTeacher(router.getLiveRoom().getCurrentUser())) {
            final int count = router.getValueByKey(EventKey.SbbWindowCount, Integer.class, 0);
            router.setObjectByKey(EventKey.SbbWindowCount, count + 1);
        }
        return smallBlackboardWindow;
    }

    private PPTWindow newPPTWindow(LPDocViewElementModel model) {
        if (model == null) {
            return null;
        }
        FrameLayout.LayoutParams layoutParams = new FrameLayout.LayoutParams((int) (getWidth() * Float.parseFloat(model.width)), (int) (getHeight() * Float.parseFloat(model.height)));
        layoutParams.topMargin = (int) (Float.parseFloat(model.y) * getHeight());
        layoutParams.leftMargin = (int) (Float.parseFloat(model.x) * getWidth());
        if (pptAuth) {
            // 新建 ppt 时，取当前 pptEditMode，不可使用定值，否则会打乱所有 ppt 的画笔状态
            shapePaint.setPPtEditMode(shapePaint.getPPtEditMode());
        }
        PPTWindow pptWindow = new PPTWindow(getContext(), model.docId, shapePaint, router.getLiveRoom().getCurrentUser().getType());
        pptWindow.setWindowLayoutParams(layoutParams);
        pptWindows.add(pptWindow);
        refreshPPTWindowCache();
        documentLayer.addWindow(pptWindow, layoutParams);
        return pptWindow;
    }

    private void refreshPPTWindowCache() {
        if (router == null) {
            return;
        }
        router.setObjectByKey(EventKey.PPTWindows, pptWindows);
    }

    private void handleExtStream(IMediaModel iMediaModel) {
        LPLogger.d(TAG, "handleExtStream " + iMediaModel.toString());
        switch (iMediaModel.getMediaSourceType()) {
            case MainScreenShare:
            case ExtCamera:
            case ExtScreenShare:
                handleVideoWindow(iMediaModel);
                break;
            case Media:
                if (!iMediaModel.isAudioOn() && !iMediaModel.isVideoOn()) {
                    videoLayer.hideMusicPlayIcon();
                    handleVideoWindow(iMediaModel);
                } else {
                    if (iMediaModel.isVideoOn()) {
                        handleVideoWindow(iMediaModel);
                    } else {
                        videoLayer.showMusicPlayIcon();
                        router.getLiveRoom().getPlayer().playAVClose(iMediaModel.getMediaId());
                        router.getLiveRoom().getPlayer().playAudio(iMediaModel.getMediaId());
                    }
                }
                break;
            default:
                break;
        }
    }

    private void handleVideoWindow(IMediaModel iMediaModel) {
        VideoContainerWindow videoWindowWrapper = null;
        for (VideoContainerWindow videoContainerWindow : videoWindows) {
            if (videoContainerWindow.getVideoWindow().getMediaId().equals(iMediaModel.getMediaId())) {
                videoWindowWrapper = videoContainerWindow;
                break;
            }
        }
        if (iMediaModel.isVideoOn()) {
            videoLayer.hideMusicPlayIcon();
            if (videoWindowWrapper == null) {
                VideoWindow videoWindow = VideoWindow.newInstance(getContext(), router);
                videoWindowWrapper = new VideoContainerWindow(getContext(), videoWindow, true);
                videoWindowWrapper.initMediaModel(iMediaModel);
                if (router.getLiveRoom().getSmallClassTemplateType() == LPConstants.SmallClassTemplateType.ONEONONE) {
                    videoWindowWrapper.getVideoWindow().setBottomVisibility(GONE);
                    videoWindowWrapper.getVideoWindow().setAwardTvVisibility(GONE);
                } else {
                    videoWindowWrapper.getVideoWindow().setBottomVisibility(View.INVISIBLE);
                }
                final int measuredWidth = getMeasuredWidth();
                final int measuredHeight = getMeasuredHeight();
                float ration = 16 / 9.0f;
                FrameLayout.LayoutParams layoutParams;
                if (iMediaModel.getMediaSourceType() == LPConstants.MediaSourceType.ExtScreenShare || iMediaModel.getMediaSourceType() == LPConstants.MediaSourceType.MainScreenShare) {
                    // 屏幕分享铺满黑板区域
                    layoutParams = new FrameLayout.LayoutParams(ViewGroup.LayoutParams.MATCH_PARENT, ViewGroup.LayoutParams.MATCH_PARENT);
                } else {
                    int height = measuredHeight == 0 ? ViewGroup.LayoutParams.MATCH_PARENT : (int) (measuredHeight * 0.7);
                    int width = measuredWidth == 0 ? ViewGroup.LayoutParams.MATCH_PARENT : (int) (height * ration);
                    layoutParams = new FrameLayout.LayoutParams(width, height);
                    if (measuredHeight != 0) {
                        layoutParams.leftMargin = (measuredWidth - width) / 2;
                        layoutParams.topMargin = (measuredHeight - height) / 2;
                    }
                }
                videoLayer.addWindow(videoWindowWrapper, layoutParams);
                videoWindowWrapper.getVideoWindow().changeVideoState(iMediaModel);
                videoWindows.add(videoWindowWrapper);
                if (cachedViewPositions.containsKey(iMediaModel.getMediaId())) {
                    handleVideoWindowPosition(cachedViewPositions.get(iMediaModel.getMediaId()));
                    cachedViewPositions.remove(iMediaModel.getMediaId());
                }
                if (iMediaModel.getMediaSourceType() == LPConstants.MediaSourceType.Media && mediaCachePlayerUpdateModel.action != LPConstants.LPPlayerAction.REMOVE) {
                    handleVideoWindowPosition(mediaCachePlayerUpdateModel, true);
                }
                // 老师/助教 辅助摄像头发player_view_update, 同步状态给学生
                if (iMediaModel.getMediaSourceType() == LPConstants.MediaSourceType.ExtCamera
                        && iMediaModel.getUser().getType() == LPConstants.LPUserType.Student
                        && BaseUtilsKt.isAdmin(router.getLiveRoom())) {
                    router.getSubjectByKey(EventKey.VideoWindowToBlackboard).onNext(videoWindowWrapper.getVideoWindow());
                }
            } else {
                if (videoWindowWrapper.isMinInSync()) {
                    videoLayer.showMusicPlayIcon();
                }
                videoWindowWrapper.initMediaModel(iMediaModel);
                videoWindowWrapper.getVideoWindow().changeVideoState(iMediaModel);
                if (router.getLiveRoom().getSmallClassTemplateType() == LPConstants.SmallClassTemplateType.ONEONONE) {
                    videoWindowWrapper.getVideoWindow().setBottomVisibility(GONE);
                    videoWindowWrapper.getVideoWindow().setAwardTvVisibility(GONE);
                }
            }
        } else if (!iMediaModel.isAudioOn()) {
            if (videoWindowWrapper == null) {
                router.getLiveRoom().getPlayer().playAVClose(iMediaModel.getMediaId());
            } else {
                videoLayer.removeWindow(videoWindowWrapper);
                videoWindows.remove(videoWindowWrapper);
                videoWindowWrapper.onDestroy();
                if (mediaCachePlayerUpdateModel.action == LPConstants.LPPlayerAction.FULL) {
                    router.getSubjectByKey(EventKey.RemoveFullScreenWindow).onNext(true);
                }
            }
        }
        final SparseArray<LPGroupItem> groupMap = router.getLiveRoom().getOnlineUserVM().getGroupMap();
        LPGroupItem lpGroupItem = groupMap.get(iMediaModel.getUser().getGroup());
        if (lpGroupItem == null) {
            lpGroupItem = new LPGroupItem(0);
        }
        if (lpGroupItem.groupItemModel == null) {
            lpGroupItem.groupItemModel = new GroupItem(0);
        }
        if (videoWindowWrapper != null && videoWindowWrapper.getVideoWindow() != null) {
            if (lpGroupItem.groupItemModel != null && lpGroupItem.id != 0) {
                videoWindowWrapper.getVideoWindow().setGroupColor(lpGroupItem.groupItemModel.color);
            }
            if (lpGroupItem.groupItemModel != null && router.getLiveRoom().getOnlineUserVM().isMediaGroup()) {
                videoWindowWrapper.getVideoWindow().setGroupItem(lpGroupItem.groupItemModel);
            }
            videoWindowWrapper.getView().setVisibility(videoWindowWrapper.getVideoWindow().isShowWindow() ? View.VISIBLE : View.GONE);
        }
    }

    private boolean isFirstCalledHandleVideoWindowPosition = false;

    private void handleVideoWindowPosition(LPPlayerViewUpdateModel playerViewUpdateModel) {
        handleVideoWindowPosition(playerViewUpdateModel, false);
        // 处理首次进教室时 外层playerViewUpdateModel.id非主摄像头不显示的问题
        if (!isFirstCalledHandleVideoWindowPosition) {
            isFirstCalledHandleVideoWindowPosition = true;
            for (LPPlayerViewUpdateModel.PlayerPosition position : playerViewUpdateModel.all) {
                if (!position.id.endsWith("0") && !playerViewUpdateModel.id.equals(position.id)) {
                    LPPlayerViewUpdateModel item = new LPPlayerViewUpdateModel();
                    item.all = playerViewUpdateModel.all;
                    item.id = position.id;
                    item.action = LPConstants.LPPlayerAction.REPOSITION;
                    item.from = playerViewUpdateModel.from;
                    item.mediaId = position.mediaId;
                    handleVideoWindowPosition(item, false);
                }
            }
        }
    }

    private void handleVideoWindowPosition(LPPlayerViewUpdateModel playerViewUpdateModel, boolean fakeBroadCast) {
        if (null == playerViewUpdateModel) {
            LPLogger.e(TAG, "player_view_update: not found player_view_update action....");
            return;
        }
        if (null == playerViewUpdateModel.action) {
            String mediaId = FECompatUtil.getMediaIdFromFEUserId(playerViewUpdateModel.id);
            if (videoWindows.isEmpty()) {
                // 学生进入时若云端插播处于最小化状态，videoWindows为空，需要缓存Cache供初始化window时使用
                if (playerViewUpdateModel.id.endsWith("2")) {
                    mediaCachePlayerUpdateModel = playerViewUpdateModel;
                }
            } else {
                for (VideoContainerWindow videoContainerWindow : videoWindows) {
                    VideoWindow videoWindow = videoContainerWindow.getVideoWindow();
                    if (FECompatUtil.isTargetWindow(videoWindow, mediaId)) {
                        videoContainerWindow.minInSync();
                        videoLayer.showMusicPlayIcon();
                        new ToastUtil(getContext()).setText("老师已收起播放器").show();
                        break;
                    }
                }
            }
            return;
        }
        if (playerViewUpdateModel.id.endsWith("2")) {
            mediaCachePlayerUpdateModel = playerViewUpdateModel;
        }
        switch (playerViewUpdateModel.action) {
            case REMOVE:
                removeVideoWindow(playerViewUpdateModel.id);
                break;
            case STICK:
                if (router.getLiveRoom().getCurrentUser().getUserId().equals(playerViewUpdateModel.from) || isEmptySet(playerViewUpdateModel.all)) {
                    return;
                }
                if (repositionVideoWindow(playerViewUpdateModel)) {
                    bringVideoToFront(playerViewUpdateModel.id);
                } else {
                    String mediaId = FECompatUtil.getMediaIdFromFEUserId(playerViewUpdateModel.id);
                    cachedViewPositions.put(mediaId, playerViewUpdateModel);
                }
                break;
            case ADD:
            case REPOSITION:
                if (router.getLiveRoom().getCurrentUser().getUserId().equals(playerViewUpdateModel.from) || isEmptySet(playerViewUpdateModel.all)) {
                    return;
                }
                if (!repositionVideoWindow(playerViewUpdateModel)) {
                    String mediaId = FECompatUtil.getMediaIdFromFEUserId(playerViewUpdateModel.id);
                    cachedViewPositions.put(mediaId, playerViewUpdateModel);
                }
                break;
            case MAX:
                if (!maximumVideoWindow(playerViewUpdateModel)) {
                    String mediaId = FECompatUtil.getMediaIdFromFEUserId(playerViewUpdateModel.id);
                    cachedViewPositions.put(mediaId, playerViewUpdateModel);
                }
                break;
            case FULL:
                if (!fulledVideoWindow(playerViewUpdateModel)) {
                    String mediaId = FECompatUtil.getMediaIdFromFEUserId(playerViewUpdateModel.id);
                    cachedViewPositions.put(mediaId, playerViewUpdateModel);
                }
                break;
            case NORMAL:
                if (!normalVideoWindow(playerViewUpdateModel)) {
                    String mediaId = FECompatUtil.getMediaIdFromFEUserId(playerViewUpdateModel.id);
                    cachedViewPositions.put(mediaId, playerViewUpdateModel);
                }
                break;
        }
        if (!fakeBroadCast) {
            //每次收到最新的改变数组，保存。
            router.setObjectByKey(EventKey.AllPlayerViewList, playerViewUpdateModel.all);
        }
    }


    private void addSmallBlackboardView(@NonNull LPDocViewUpdateModel lpDocViewUpdateModel) {
        for (LPDocViewElementModel model : lpDocViewUpdateModel.all) {
            if (model.docId.equals(lpDocViewUpdateModel.docId)) {
                SmallBlackboardWindow blackboardWindow = initSmallBlackboardView(true, model.docId, Float.parseFloat(model.x),
                        Float.parseFloat(model.y), Float.parseFloat(model.width), Float.parseFloat(model.height));
                LPSnippetPullResModel resModel = new LPSnippetPullResModel();
                resModel.id = lpDocViewUpdateModel.docId;
                resModel.isActive = true;
                blackboardWindow.initStatus(resModel, SmallBlackboardStatus.PUBLISH_TO_ALL);
                if (model.full == 1) {
                    blackboardWindow.maxInFull();
                } else if (model.max == 1) {
                    blackboardWindow.maxInSync();
                }
                smallBlackboardWindows.add(blackboardWindow);
                break;
            }
        }
    }

    private void removeAndDestroyBlackboardView(@NonNull String docId) {
        Iterator<SmallBlackboardWindow> iterator = smallBlackboardWindows.iterator();
        while (iterator.hasNext()) {
            SmallBlackboardWindow window = iterator.next();
            LPLogger.d(TAG, "removeAndDestroyBlackboardView " + window.getId() + ", toRemove=" + docId);
            if (docId.equals(window.getId())) {
                iterator.remove();
                window.onDestroy();
                break;
            }
        }
    }

    private void addPPTView(@NonNull LPDocViewUpdateModel lpDocViewUpdateModel) {
        PPTWindow pptWindow = null;
        for (LPDocViewElementModel model : lpDocViewUpdateModel.all) {
            if (model.docId.equals(lpDocViewUpdateModel.docId)) {
                pptWindow = newPPTWindow(model);
                if (model.full == 1) {
                    pptWindow.maxInFull(true);
                } else if (model.max == 1) {
                    pptWindow.maxInSync(true);
                }
                break;
            }
        }
        //存在全屏的pptWindow把预览课件切到全屏
        if (pptWindow != null && pptWindow.isPreviewPPT()) {
            final PPTWindow fullPPTWindow = router.getValueByKey(EventKey.FullScreenPPTWindow, PPTWindow.class);
            if (fullPPTWindow != null) {
                fullPPTWindow.switchTab(pptWindow);
            }
            return;
        }
        if (pptWindow == null || pptWindow.isMaxInSync() || pptWindow.isMaxInFull() || pptWindow.isPreviewPPT()) {
            return;
        }
        checkExistTopPreviewPPTWindow();
    }

    private void addWebpage(@NonNull LPDocViewUpdateModel lpDocViewUpdateModel) {
        if (browserWindow == null) {
            browserWindow = new BrowserWindow(getContext());
            browserWindow.setBrowserChangeListener(browserChangeListener);
        }
        for (LPDocViewElementModel model : lpDocViewUpdateModel.all) {
            if (TextUtils.equals(model.docId, lpDocViewUpdateModel.docId)) {
                LayoutParams layoutParams = new LayoutParams(Math.round(Float.parseFloat(model.width) * getWidth()), Math.round(Float.parseFloat(model.height) * getHeight()));
                layoutParams.leftMargin = Math.round(Float.parseFloat(model.x) * getWidth());
                layoutParams.topMargin = Math.round(Float.parseFloat(model.y) * getHeight());
                browserLayer.removeAllViews();
                browserLayer.addWindow(browserWindow, layoutParams);
                if (model.full == 1) {
                    browserWindow.setReceiveOrder(true);
                    browserWindow.maxInFull();
                } else if (model.max == 1) {
                    browserWindow.setReceiveOrder(true);
                    browserWindow.maxInSync();
                }
                break;
            }
        }
    }

    /**
     * 打开normal状态ppt时，检查是否存在预览ppt在max、full状态
     */
    private void checkExistTopPreviewPPTWindow() {
        //不是预览ppt，且ppt不在max或者全屏，则把ppt置底
        final PPTWindow fullPPTWindow = router.getValueByKey(EventKey.FullScreenPPTWindow, PPTWindow.class);
        final PPTWindow maxPPTWindow = router.getValueByKey(EventKey.MaxScreenPPTWindow, PPTWindow.class);
        final PPTWindow topPPTWindow = fullPPTWindow != null ? fullPPTWindow : maxPPTWindow;
        if (topPPTWindow == null || !topPPTWindow.isPreviewPPT()) {
            return;
        }
        if (topPPTWindow.isMaxInFull()) {
            addToFullCache();
        } else if (topPPTWindow.isMaxInSync()) {
            addToMaxCache();
        }
        if (BaseUtilsKt.isAdmin(router.getLiveRoom())) {
            pptTabLayer.refreshTabs();
        }
    }

    private boolean checkStoreContainsPPT(LPDocViewElementModel elementModel) {
        List<LPDocModel> docStoreList = router.getLiveRoom().getDocListVM().getDocList();
        if (docStoreList == null || docStoreList.size() == 0 || elementModel == null) {
            return false;
        }

        for (LPDocModel docModel : docStoreList) {
            if (docModel.docId != null && docModel.docId.equals(elementModel.docId)) {
                return true;
            }
        }
        return false;
    }

    private void removeAndDestroyPPTView(@NonNull String docId) {
        int status = 0;
        for (PPTWindow pptWindow : pptWindows) {
            if (docId.equals(pptWindow.getId())) {
                if (pptWindow.isMaxInFull()) {
                    pptWindow.resetInFull(true);
                    status += 0x02;
                }
                if (pptWindow.isMaxInSync()) {
                    pptWindow.resetInSync(true);
                    status += 0x01;
                }
                ViewGroup viewGroup = pptWindow.getParentViewGroup();
                if (viewGroup != null) {
                    viewGroup.removeView(pptWindow.getView());
                }
                pptWindows.remove(pptWindow);
                pptWindow.onDestroy();
                updateToolbarWindow();
                break;
            }
        }
        //刷新doc缓存
        List<LPDocViewElementModel> allDocList = new ArrayList<>(router.getListByKey(EventKey.AllDocViewList, LPDocViewElementModel.class));
        if (!allDocList.isEmpty()) {
            for (LPDocViewElementModel elementModel : allDocList) {
                if (TextUtils.equals(elementModel.docId, docId)) {
                    allDocList.remove(elementModel);
                    router.setObjectByKey(EventKey.AllDocViewList, allDocList);
                    break;
                }
            }
        }
        refreshPPTWindowCache();
        if (pptWindows.size() >= 1) {
            List<PPTWindow> tempWindows = new ArrayList<>(pptWindows);
            final PPTWindow destPPTWindow = tempWindows.get(tempWindows.size() - 1);
            //预览课件收不到信令，需要本地自行处理
            if (destPPTWindow.isPreviewPPT()) {
                if ((status & 0x02) == 0x02) {
                    destPPTWindow.maxInFull();
                } else if ((status & 0x01) == 0x01) {
                    destPPTWindow.maxInSync();
                }
            }
        }
        pptTabLayer.refreshTabs();
    }

    private void sbbBringToFront(@NonNull String docId) {
        for (SmallBlackboardWindow window : smallBlackboardWindows) {
            if (docId.equals(window.getId())) {
                window.bringToForeground();
            }
        }
    }

    private void bringToFront(@NonNull String docId) {
        for (PPTWindow pptWindow : pptWindows) {
            if (docId.equals(pptWindow.getId())) {
                pptWindow.bringToForeground();
            }
        }
    }

    private void sbbBackToNormal(@NonNull String id) {
        for (SmallBlackboardWindow window : smallBlackboardWindows) {
            if (id.equals(window.getId())) {
                if (window.isMaxInSync()) {
                    window.resetInSync();
                } else if (window.isMaxInFull()) {
                    window.resetInFull();
                }
                break;
            }
        }
    }

    private void backToNormal(@NonNull String docId) {
        PPTWindow tempPPTWindow = null;
        for (PPTWindow pptWindow : pptWindows) {
            if (docId.equals(pptWindow.getId())) {
                tempPPTWindow = pptWindow;
                if (pptWindow.isMaxInFull()) {
                    pptWindow.resetInFull(true);
                } else if (pptWindow.isMaxInSync()) {
                    pptWindow.resetInSync(true);
                }
                break;
            }
        }
        backToNormalCache();
        if (tempPPTWindow != null && !tempPPTWindow.isCacheStateMax() && !tempPPTWindow.isCacheStateFull()) {
            tempPPTWindow.bringToForeground();
        }
    }

    private void backToNormalWebpage() {
        if (browserWindow == null) {
            return;
        }
        if (browserWindow.isMaxInFull()) {
            browserWindow.setReceiveOrder(true);
            browserWindow.resetInFull();
        } else if (browserWindow.isMaxInSync()) {
            browserWindow.setReceiveOrder(true);
            browserWindow.resetInSync();
        }
    }

    private void backToNormalCache() {
        //遍历还原cache状态
        final PPTWindow maxPPTWindow = router.getValueByKey(EventKey.MaxScreenPPTWindow, PPTWindow.class);
        final PPTWindow fullPPTWindow = router.getValueByKey(EventKey.FullScreenPPTWindow, PPTWindow.class);
        if (maxPPTWindow != null || fullPPTWindow != null) {
            return;
        }
        for (PPTWindow pptWindow : pptWindows) {
            if (pptWindow.isCacheStateFull()) {
                pptWindow.resetInFull(true);
            }
            if (pptWindow.isCacheStateMax()) {
                pptWindow.resetInSync(true);
            }
            if (!pptWindow.isCacheStateMax() && !pptWindow.isCacheStateFull()) {
                pptWindow.showTitle();
            }
        }
    }

    private void sbbMaximumWindow(@NonNull String docId) {
        for (SmallBlackboardWindow window : smallBlackboardWindows) {
            if (docId.equals(window.getId())) {
                if (window.isMaxInFull()) {
                    window.resetInFull();
                }
                if (!window.isMaxInSync()) {
                    window.maxInSync();
                }
                break;
            }
        }
    }

    private void maximumWindow(@NonNull String docId) {
        for (PPTWindow pptWindow : pptWindows) {
            if (docId.equals(pptWindow.getId())) {
                if (pptWindow.isMaxInFull()) {
                    pptWindow.resetInFull(true);
                }
                if (!pptWindow.isMaxInSync()) {
                    pptWindow.maxInSync(true);
                }
                break;
            }
        }
        addToMaxCache();
    }

    private void maximumWebpage() {
        if (browserWindow == null) {
            return;
        }
        if (browserWindow.isMaxInFull()) {
            browserWindow.setReceiveOrder(true);
            browserWindow.resetInFull();
        }
        if (!browserWindow.isMaxInSync()) {
            browserWindow.setReceiveOrder(true);
            browserWindow.maxInSync();
        }
    }

    private void addToMaxCache() {
        //遍历还原cache状态
        final PPTWindow fullPPTWindow = router.getValueByKey(EventKey.FullScreenPPTWindow, PPTWindow.class);
        if (fullPPTWindow != null) {
            return;
        }
        for (PPTWindow pptWindow : pptWindows) {
            if (pptWindow.isCacheStateFull()) {
                pptWindow.resetInFull(true);
            }
        }
        //把所有ppt页面也max
        final PPTWindow maxPPTWindow = router.getValueByKey(EventKey.MaxScreenPPTWindow, PPTWindow.class);
        if (maxPPTWindow == null) {
            return;
        }
        for (PPTWindow pptWindow : pptWindows) {
            if (!pptWindow.isMaxInSync() && !pptWindow.isCacheStateMax()) {
                pptWindow.maxInSyncCache(true);
            }
        }
        maxPPTWindow.bringToForeground();
    }


    private void sbbFullscreenWindow(@NonNull String docId) {
        for (SmallBlackboardWindow window : smallBlackboardWindows) {
            if (docId.equals(window.getId())) {
                if (!window.isMaxInFull()) {
                    window.maxInFull();
                }
                break;
            }
        }
    }

    private void fullscreenWindow(@NonNull String docId) {
        for (PPTWindow pptWindow : pptWindows) {
            if (docId.equals(pptWindow.getId())) {
                if (!pptWindow.isMaxInFull()) {
                    pptWindow.maxInFull(true);
                }
                break;
            }
        }
        addToFullCache();
    }

    private void fullscreenWebpage() {
        if (browserWindow != null && !browserWindow.isMaxInFull()) {
            browserWindow.setReceiveOrder(true);
            browserWindow.maxInFull();
        }
    }

    private void addToFullCache() {
        final PPTWindow fullPPTWindow = router.getValueByKey(EventKey.FullScreenPPTWindow, PPTWindow.class);
        if (fullPPTWindow == null) {
            return;
        }
        boolean hasChanged = false;
        for (PPTWindow pptWindow : pptWindows) {
            if (!pptWindow.isMaxInFull() && !pptWindow.isCacheStateFull()) {
                pptWindow.maxInFullCache(true);
                hasChanged = true;
            }
        }
        if (hasChanged) {
            fullPPTWindow.maxInFull(true);
        }
    }

    private void sbbRepositionWindow(@NonNull LPDocViewUpdateModel lpDocViewUpdateModel) {
        LPDocViewElementModel model = null;
        for (LPDocViewElementModel e : lpDocViewUpdateModel.all) {
            if (lpDocViewUpdateModel.docId.equals(e.docId)) {
                model = e;
                break;
            }
        }
        if (model == null) {
            return;
        }
        for (SmallBlackboardWindow window : smallBlackboardWindows) {
            if (model.docId.equals(window.getId())) {
                window.moveTo(Math.round(Float.parseFloat(model.x) * getWidth()), Math.round(Float.parseFloat(model.y) * getHeight()));
                window.scaleTo(Math.round(Float.parseFloat(model.width) * getWidth()), Math.round(Float.parseFloat(model.height) * getHeight()));
                break;
            }
        }
    }


    private void repositionWindow(@NonNull LPDocViewUpdateModel lpDocViewUpdateModel) {
        LPDocViewElementModel model = null;
        for (LPDocViewElementModel e : lpDocViewUpdateModel.all) {
            if (lpDocViewUpdateModel.docId.equals(e.docId)) {
                model = e;
                break;
            }
        }
        if (model == null) {
            return;
        }
        for (PPTWindow pptWindow : pptWindows) {
            if (model.docId.equals(pptWindow.getId())) {
                pptWindow.moveTo(Math.round(Float.parseFloat(model.x) * getWidth()), Math.round(Float.parseFloat(model.y) * getHeight()));
                pptWindow.scaleTo(Math.round(Float.parseFloat(model.width) * getWidth()), Math.round(Float.parseFloat(model.height) * getHeight()));
                break;
            }
        }
    }

    private void repositionWebpage(@NonNull LPDocViewUpdateModel lpDocViewUpdateModel) {
        LPDocViewElementModel model = null;
        for (LPDocViewElementModel e : lpDocViewUpdateModel.all) {
            if (TextUtils.equals(lpDocViewUpdateModel.docId, e.docId)) {
                model = e;
                break;
            }
        }
        if (model == null || browserWindow == null) {
            return;
        }
        browserWindow.scaleTo(Math.round(Float.parseFloat(model.width) * getWidth()), Math.round(Float.parseFloat(model.height) * getHeight()));
        browserWindow.moveTo(Math.round(Float.parseFloat(model.x) * getWidth()), Math.round(Float.parseFloat(model.y) * getHeight()));
    }

    /**
     * 展示窗口显示昵称
     */
    private void showSbbWindowName(LPDocViewUpdateModel viewUpdateModel) {
        LPDocViewElementModel model = null;
        for (LPDocViewElementModel e : viewUpdateModel.all) {
            if (viewUpdateModel.docId.equals(e.docId)) {
                model = e;
                break;
            }
        }
        if (model == null) {
            return;
        }
        for (SmallBlackboardWindow window : smallBlackboardWindows) {
            if (model.docId.equals(window.getId())) {
                window.showWindowOwnerName(model);
                break;
            }
        }
    }

    private void addVideoWindow(PlayerViewActionModel model) {
        if (router == null) {
            return;
        }
        boolean isExist = false;
        LPPlayerViewUpdateModel playerViewUpdateModel = model.getLpPlayerViewUpdateModel();
        String mediaId = FECompatUtil.getMediaIdFromFEUserId(playerViewUpdateModel.id);
        if (playerViewUpdateModel.all.isEmpty()) {
            return;
        }
        for (VideoContainerWindow videoContainerWindow : videoWindows) {
            if (videoContainerWindow.getVideoWindow().getMediaId().equals(mediaId)) {
                isExist = true;
                break;
            }
        }
        if (isExist) {
            return;
        }
        VideoWindow seatVideoWindow = model.getVideoContainerWindow();
        if (seatVideoWindow.isDestroyed()) {
            return;
        }
        //黑板区域拉大流
        seatVideoWindow.setRemoteVideoStreamType(BJYRtcCommon.DualStreamType.VIDEO_STREAM_HIGH);
        VideoContainerWindow videoContainerWindow = new VideoContainerWindow(getContext(), seatVideoWindow);
        LPPlayerViewUpdateModel.PlayerPosition playerPosition = null;

        for (LPPlayerViewUpdateModel.PlayerPosition position : playerViewUpdateModel.all) {
            if (mediaId.equals(FECompatUtil.getMediaIdFromFEUserId(position.id))) {
                playerPosition = position;
                break;
            }
        }
        if (playerPosition == null) {

            return;
        }
        LayoutParams params;
        try {
            int width = Math.round(getWidth() * Float.parseFloat(playerPosition.width));
            int height = Math.round(getHeight() * Float.parseFloat(playerPosition.height));
            params = new LayoutParams(width, height);
            params.leftMargin = Math.round(getWidth() * Float.parseFloat(playerPosition.x));
            params.topMargin = Math.round(getHeight() * Float.parseFloat(playerPosition.y));
        } catch (Exception e) {
            //出错后默认放中间
            params = new LayoutParams(400, 300);
            params.leftMargin = getMeasuredWidth() / 2 - 200;
            params.topMargin = getMeasuredHeight() / 2 - 150;
        }
        videoWindows.add(videoContainerWindow);
        bringVideoToFront(playerViewUpdateModel.id);
        videoLayer.addWindow(videoContainerWindow, params);

        if (playerPosition.max == 1) {
            maximumVideoWindow(playerViewUpdateModel);
        }
        if (playerPosition.full == 1) {
            fulledVideoWindow(playerViewUpdateModel);
        }
        if (!videoWindows.isEmpty()) {
            router.getSubjectByKey(EventKey.ResumeButton).onNext(true);
        }
        videoContainerWindow.getView().setVisibility(seatVideoWindow.isShowWindow() ? View.VISIBLE : View.GONE);
        List<LPGroupItem> lpGroupItems = router.getLiveRoom().getOnlineUserVM().getGroupList();
        if (null != lpGroupItems && lpGroupItems.size() > 0) {
            for (LPGroupItem lpGroupItem : lpGroupItems) {
                if (lpGroupItem.id == 0) {
                    continue;
                }
                final List<LPUserModel> userModelList = lpGroupItem.userModelList;
                for (LPUserModel lpUserModel : userModelList) {
                    if (lpGroupItem.groupItemModel != null && TextUtils.equals(lpUserModel.number, model.userNum)) {
                        videoContainerWindow.getVideoWindow().setGroupColor(lpGroupItem.groupItemModel.color);
                        break;
                    }
                }
            }
        }
    }

    private void removeVideoWindow(@NonNull String uid) {
        String mediaId = FECompatUtil.getMediaIdFromFEUserId(uid);
        for (VideoContainerWindow videoContainerWindow : videoWindows) {
            VideoWindow videoWindow = videoContainerWindow.getVideoWindow();
            //禅道#15521
            //不用checkVideoWindowMediaId判断，seatLayer里面收到media_publish调用onDestroy之后变量置为false
            if (FECompatUtil.isTargetWindow(videoWindow, mediaId)) {
                if (videoContainerWindow.isMaxInFull()) {
                    videoContainerWindow.resetInFull();
                }
                videoLayer.removeWindow(videoContainerWindow);
                videoWindows.remove(videoContainerWindow);
                router.getSubjectByKey(EventKey.PlayerViewRemove).onNext(videoWindow);
                break;
            }
        }
        if (BaseUtilsKt.isTeacher(router.getLiveRoom().getCurrentUser()) && videoWindows.isEmpty()) {
            router.getSubjectByKey(EventKey.ResumeButton).onNext(false);
        }
    }

    /**
     * 信令同步删除指定窗口
     *
     * @param mediaId
     */
    private void requestVideoWindowRemove(String mediaId) {
        Set<LPPlayerViewUpdateModel.PlayerPosition> allList = router.getSetByKey(EventKey.AllPlayerViewList, LPPlayerViewUpdateModel.PlayerPosition.class);
        if (null == allList) {
            return;
        }

        LPPlayerViewUpdateModel model = new LPPlayerViewUpdateModel();
        model.id = mediaId;
        model.action = LPConstants.LPPlayerAction.REMOVE;
        for (LPPlayerViewUpdateModel.PlayerPosition playerPosition : allList) {
            if (playerPosition.id.equals(mediaId)) {
                allList.remove(playerPosition);
                model.mediaId = playerPosition.mediaId;
                model.all = allList;
                router.getLiveRoom().getMediaVM().requestPlayerViewUpdate(model);
                break;
            }
        }
    }

    private void bringVideoToFront(@NonNull String uid) {
        String mediaId = FECompatUtil.getMediaIdFromFEUserId(uid);
        // 移除代码备注：现在逻辑是全屏一个会把其余的自动返回座位席

        for (VideoContainerWindow videoContainerWindow : videoWindows) {
            VideoWindow videoWindow = videoContainerWindow.getVideoWindow();
            if (FECompatUtil.checkVideoWindowMediaId(videoWindow, mediaId)) {
                videoContainerWindow.bringToForeground();
                if (videoContainerWindow.getVideoWindow().isOverlay()) {
                    continue;
                }
                videoWindow.setZOrderMediaOverlay(true);
            } else {
                if (!videoContainerWindow.getVideoWindow().isOverlay()) {
                    continue;
                }
                videoWindow.setZOrderMediaOverlay(false);
            }
        }
    }

    private LPPlayerViewUpdateModel.PlayerPosition getCurrentUpdatedPosition(@NonNull LPPlayerViewUpdateModel model) {
        LPPlayerViewUpdateModel.PlayerPosition currPosition = null;
        for (LPPlayerViewUpdateModel.PlayerPosition position : model.all) {
            if (position.id.equals(model.id)) {
                currPosition = position;
            }
        }
        return currPosition;
    }

    /**
     * @return 对于直接发布在大黑板的流 可能mediaPublish比view update信令晚到 true表示找到了对应的window做了位移，false反之
     */
    private boolean repositionVideoWindow(@NonNull LPPlayerViewUpdateModel model) {
        LPPlayerViewUpdateModel.PlayerPosition currPosition = getCurrentUpdatedPosition(model);

        if (currPosition == null) {
            return false;
        }

        for (VideoContainerWindow videoContainerWindow : videoWindows) {
            String mediaId = FECompatUtil.getMediaIdFromFEUserId(model.id);
            VideoWindow videoWindow = videoContainerWindow.getVideoWindow();
            if (FECompatUtil.checkVideoWindowMediaId(videoWindow, mediaId)) {
                if (videoContainerWindow.isMaxInFull() && currPosition.full == 0) {
                    videoContainerWindow.resetInFull();
                } else if (!videoContainerWindow.isMaxInFull() && currPosition.full == 1) {
                    videoContainerWindow.maxInFull();
                }
                if (videoContainerWindow.isMaxInSync() && currPosition.max == 0) {
                    videoContainerWindow.resetInSync();
                } else if (!videoContainerWindow.isMaxInSync() && currPosition.max == 1 && currPosition.full != 1) {
                    videoContainerWindow.maxInSync();
                }
                videoContainerWindow.moveTo(Math.round(getWidth() * Float.parseFloat(currPosition.x))
                        , Math.round(getHeight() * Float.parseFloat(currPosition.y)));
                videoContainerWindow.scaleTo(Math.round(getWidth() * Float.parseFloat(currPosition.width))
                        , Math.round(getHeight() * Float.parseFloat(currPosition.height)));
                bringVideoToFront(model.id);
                return true;
            }
        }
        return false;
    }

    private boolean normalVideoWindow(LPPlayerViewUpdateModel model) {
        LPPlayerViewUpdateModel.PlayerPosition currPosition = getCurrentUpdatedPosition(model);
        if (currPosition == null) {
            return false;
        }
        for (VideoContainerWindow videoContainerWindow : videoWindows) {
            String mediaId = FECompatUtil.getMediaIdFromFEUserId(model.id);
            VideoWindow videoWindow = videoContainerWindow.getVideoWindow();
            if (FECompatUtil.checkVideoWindowMediaId(videoWindow, mediaId)) {
                if (videoContainerWindow.isMaxInFull()) {
                    videoContainerWindow.resetInFull();
                }
                if (videoContainerWindow.isMaxInSync()) {
                    videoContainerWindow.resetInSync();
                }
                if (videoContainerWindow.isMinInSync()) {
                    // 由最小化 -> normal
                    videoContainerWindow.resetMinInSync();
                }
                videoContainerWindow.moveTo(Math.round(getWidth() * Float.parseFloat(currPosition.x))
                        , Math.round(getHeight() * Float.parseFloat(currPosition.y)));
                videoContainerWindow.scaleTo(Math.round(getWidth() * Float.parseFloat(currPosition.width))
                        , Math.round(getHeight() * Float.parseFloat(currPosition.height)));
                if (currPosition.max == 1) {
                    maximumVideoWindow(model);
                } else {
                    bringVideoToFront(model.id);
                }
                return true;
            }
        }
        return false;
    }

    private boolean fulledVideoWindow(LPPlayerViewUpdateModel model) {
        LPPlayerViewUpdateModel.PlayerPosition currPosition = getCurrentUpdatedPosition(model);
        if (currPosition == null) {
            return false;
        }
        for (VideoContainerWindow videoContainerWindow : videoWindows) {
            String mediaId = FECompatUtil.getMediaIdFromFEUserId(model.id);
            VideoWindow videoWindow = videoContainerWindow.getVideoWindow();
            if (FECompatUtil.checkVideoWindowMediaId(videoWindow, mediaId)) {
                if (videoContainerWindow.isMaxInSync()) {
                    videoContainerWindow.resetInSync();
                }
                bringVideoToFront(model.id);
                videoContainerWindow.maxInFull();
                return true;
            }
        }
        return false;
    }

    private boolean maximumVideoWindow(LPPlayerViewUpdateModel model) {
        LPPlayerViewUpdateModel.PlayerPosition currPosition = getCurrentUpdatedPosition(model);
        if (currPosition == null) {
            return false;
        }
        for (VideoContainerWindow videoContainerWindow : videoWindows) {
            String mediaId = FECompatUtil.getMediaIdFromFEUserId(model.id);
            VideoWindow videoWindow = videoContainerWindow.getVideoWindow();
            if (FECompatUtil.checkVideoWindowMediaId(videoWindow, mediaId)) {
                if (videoContainerWindow.isMaxInFull()) {
                    videoContainerWindow.resetInFull();
                }
                bringVideoToFront(model.id);
                videoContainerWindow.maxInSync();
                return true;
            }
        }
        return false;
    }

    private void showBlackboardPage(float y) {
        router.getSubjectByKey(EventKey.ReminderBlackboardPage).onNext(y);
    }

    public ConcurrentLinkedQueue<PPTWindow> getPPTWindows() {
        return pptWindows;
    }

    public BlackboardListener getBlackboardLayer() {
        return (BlackboardListener) blackboardLayer;
    }

    @Override
    public void onDestroy() {
        super.onDestroy();
        RxUtils.dispose(subscriptionOfDocDel);
        RxUtils.dispose(subscriptionOfSelectMode);
        RxUtils.dispose(subscriptionOfDrawLineMode);
        if (laserShapeLayer != null) {
            laserShapeLayer.onDestroy();
        }
        laserShapeLayer = null;

        clearPPTWindows();
        if (shapePaint != null) {
            shapePaint.removeAllListener();
        }
        clearVideoWindows();
        router = null;
        videoLayer = null;
        if (smallBlackboardWindows != null) {
            for (SmallBlackboardWindow window : smallBlackboardWindows) {
                window.onDestroy();
            }
            smallBlackboardWindows.clear();
        }
        if (sbbAllUserSet != null) {
            sbbAllUserSet.clear();
        }
        removeCallbacks(webpageRunnable);
        destroyToolBox();
        isFirstCalledHandleVideoWindowPosition = false;
        if (mediaPlayerWindow != null) {
            mediaPlayerWindow.onDestroy();
            mediaPlayerWindow = null;
        }
    }

    private void clearVideoWindows() {
        if (videoWindows != null) {
            for (VideoContainerWindow videoContainerWindow : videoWindows) {
                videoContainerWindow.onDestroy();
            }
            videoWindows.clear();
        }
    }

    private void clearPPTWindows() {
        if (pptWindows != null) {
            for (PPTWindow pptWindow : pptWindows) {
                pptWindow.onDestroy();
            }
            pptWindows.clear();
        }
        refreshPPTWindowCache();
    }

    private View responderPrepareView;
    private ResponderRobButton responderRobButton;
    Disposable responderIntervalDisposable, responderButtonDisposable;

    /**
     * 展示抢答器管理页面或者移除
     */
    private void showResponderWindow(boolean show) {
        if (show) {
            if (responderWindow == null) {
                FrameLayout.LayoutParams layoutParams = new FrameLayout.LayoutParams(UtilsKt.getDp(400), UtilsKt.getDp(220));
                layoutParams.gravity = Gravity.CENTER;
                responderWindow = new ResponderWindow(getContext());
                toolBoxLayer.addWindow(responderWindow, layoutParams);
            }
        } else {
            if (responderWindow != null) {
                toolBoxLayer.removeWindow(responderWindow);
                responderWindow.onDestroy();
                responderWindow = null;
            }
        }
    }

    private void showResponderPrepare(int prepareTime) {
        if (responderPrepareView == null) {
            responderPrepareView = LayoutInflater.from(getContext()).inflate(R.layout.uibase_layout_responder_student_prepare_tip, null);
        }
        if (responderPrepareView.getParent() != null) {
            toolBoxLayer.removeView(responderPrepareView);
        }
        LayoutParams layoutParams = new FrameLayout.LayoutParams(LayoutParams.WRAP_CONTENT, LayoutParams.WRAP_CONTENT);
        layoutParams.gravity = Gravity.CENTER;
        toolBoxLayer.addView(responderPrepareView, layoutParams);
        responderIntervalDisposable = Observable.interval(0, 1, TimeUnit.SECONDS)
                .take(prepareTime + 1)
                .observeOn(AndroidSchedulers.mainThread())
                .subscribe(aLong -> {
                    if (aLong == prepareTime) {
                        toolBoxLayer.removeView(responderPrepareView);
                        showResponderButton();
                    }
                    QueryPlus.with(responderPrepareView).id(R.id.responder_student_counting_down).text(String.valueOf(prepareTime - aLong));
                });
        compositeDisposable.add(responderIntervalDisposable);
    }

    private void showResponderButton() {
        if (responderRobButton == null) {
            responderRobButton = new ResponderRobButton(getContext());
            responderRobButton.setDefaultSize(80);
        }
        if (responderRobButton.getParent() == null) {
            int _80dp = UtilsKt.getDp(80);
            FrameLayout.LayoutParams layoutParams = new FrameLayout.LayoutParams(ViewGroup.LayoutParams.WRAP_CONTENT, ViewGroup.LayoutParams.WRAP_CONTENT);
            Random random = new Random();
            FrameLayout robButtonParent = toolBoxLayer;
            int leftBound = robButtonParent.getWidth() - _80dp;
            int topBound = robButtonParent.getWidth() - _80dp;
            if (robButtonParent.getWidth() == 0) {
                post(() -> {
                    layoutParams.leftMargin = leftBound <= 0 ? 0 : random.nextInt(leftBound);
                    layoutParams.topMargin = topBound <= 0 ? 0 : random.nextInt(topBound);
                    toolBoxLayer.addView(responderRobButton, layoutParams);
                });
            } else {
                layoutParams.leftMargin = leftBound <= 0 ? 0 : random.nextInt(leftBound);
                layoutParams.topMargin = topBound <= 0 ? 0 : random.nextInt(topBound);
                toolBoxLayer.addView(responderRobButton, layoutParams);
            }
        }
        responderRobButton.changeRobButtonStatus(ResponderRobButton.RobButtonState.NORMAL);
        if (router.getLiveRoom().isAudition()) {
            responderRobButton.setEnabled(false);
        }
        compositeDisposable.add(RxUtils.clicks(responderRobButton)
                .throttleFirst(1, TimeUnit.SECONDS)
                .subscribe(o -> {

                    responderRobButton.changeRobButtonStatus(ResponderRobButton.RobButtonState.READY_TO_SUBMIT);
                    responderRobButton.setClickable(false);
                    router.getLiveRoom().getToolBoxVM().requestAnswerRacerParticipate(router.getLiveRoom().getCurrentUser());
                    RxUtils.dispose(responderButtonDisposable);
                }));

        responderButtonDisposable = Observable.interval(2, 2, TimeUnit.SECONDS)
                .observeOn(AndroidSchedulers.mainThread())
                .subscribe(aLong -> {
                    if (responderRobButton == null) {
                        RxUtils.dispose(responderButtonDisposable);
                    } else {
                        responderRobButton.changePositionRandom(toolBoxLayer);
                    }
                });
        compositeDisposable.add(responderButtonDisposable);
    }

    private void cancelResponder() {
        if (responderPrepareView != null && responderPrepareView.getParent() != null) {
            toolBoxLayer.removeView(responderPrepareView);
        }
        RxUtils.dispose(responderIntervalDisposable);
        RxUtils.dispose(responderButtonDisposable);
    }

    /**
     * 更新画笔工具栏的激光笔状态
     */
    private void updateToolbarWindow() {
        if (!BaseUtilsKt.isAdmin(router.getLiveRoom())) {
            return;
        }
        if (pptWindows == null || pptWindows.size() == 0) {
            return;
        }
        for (PPTWindow pptWindow : pptWindows) {
            if (pptWindow.isMaxInFull() || pptWindow.isMaxInSync()) {
                //有全屏或者最大化（隐藏激光笔
                router.getSubjectByKey(EventKey.LaserShowState).onNext(false);
                return;
            }
        }
        router.getSubjectByKey(EventKey.LaserShowState).onNext(true);
    }

    //销毁textShape边框
    public void invalidateTextBoundary() {
        for (PPTWindow pptWindow : getPPTWindows()) {
            pptWindow.getPPTView().invalidateCurrentPage(); // 刷新text位置
        }
        getBlackboardLayer().getBlackImageWindow().getWhiteboardView().invalidateTextBoundary();
        for (SmallBlackboardWindow smallBlackboardWindow : smallBlackboardWindows) {
            smallBlackboardWindow.invalidateTextBoundary();
        }
    }

    public void updatePPTView(boolean isUpdate) {
        if (!pptWindows.isEmpty()) {
            for (PPTWindow pptWindow : pptWindows) {
                PPTView pptView = pptWindow.getPPTView();
                if (isUpdate && pptView.getTargetPPTViewType() == LPConstants.PPTViewType.STATIC) {
                    pptView.updateStaticPPT();
                }
            }
        }
    }

    private void startMediaCoursewareObservable() {
        compositeDisposable.add(router.getSubjectByKey(EventKey.openMediaPlayerWindow)
                .ofType(LPMediaCoursewareModel.class)
                .observeOn(AndroidSchedulers.mainThread())
                .subscribe(mediaCoursewareModel -> {
                    boolean isMediaPlaying = false;
                    for (VideoContainerWindow videoContainerWindow : videoWindows) {
                        if (LPMediaIdUtils.getMediaSourceType(videoContainerWindow.getVideoWindow().getMediaId()) == LPConstants.MediaSourceType.Media) {
                            videoLayer.removeWindow(videoContainerWindow);
                            videoWindows.remove(videoContainerWindow);
                            videoContainerWindow.onDestroy();
                            isMediaPlaying = true;
                            break;
                        }
                    }
                    if (isMediaPlaying) {
                        new CommonDialog(getContext(), CommonDialog.ChoiceMode.Double_Blue)
                                .setMainDisplayText(getContext().getString(R.string.bjy_group_play_media_conflict_tips))
                                .setSubtitleDisplayText(getContext().getString(R.string.bjy_group_play_media_conflict_detail))
                                .setPositive(getContext().getString(R.string.bjysc_confirm), (dialog, which) -> {
                                    dialog.dismiss();
                                    router.getLiveRoom().getMediaVM().sendBroadcastOfTerminateExtraStream(LPConstants.MediaSourceType.Media);
                                    startPlayMediaCourseware(mediaCoursewareModel);
                                })
                                .setNegative(getContext().getString(R.string.bjysc_cancel), (dialog, which) -> dialog.dismiss())
                                .show();
                    } else {
                        startPlayMediaCourseware(mediaCoursewareModel);
                    }
                }));

        compositeDisposable.add(router.getSubjectByKey(EventKey.closeMediaPlayerWindow)
                .ofType(Boolean.class)
                .observeOn(AndroidSchedulers.mainThread())
                .subscribe(aBoolean -> {
                    if (mediaPlayerWindow != null) {
                        videoLayer.removeWindow(mediaPlayerWindow);
                        mediaPlayerWindow.onDestroy();
                        mediaPlayerWindow = null;
                        String mediaId = FECompatUtil.getIOSMediaIdFromMediaId(FECompatUtil.getMediaId(router.getLiveRoom().getCurrentUser().getUserId(),
                                LPConstants.MediaSourceType.Media.getValue()));
                        requestVideoWindowRemove(mediaId);
                    }
                }));

        compositeDisposable.add(router.getLiveRoom().getMediaVM().getObservableOfTerminateExtraStream()
                .observeOn(AndroidSchedulers.mainThread())
                .subscribe(s -> {
                    if ("2".equals(s) && mediaPlayerWindow != null) {
                        videoLayer.removeWindow(mediaPlayerWindow);
                        mediaPlayerWindow.onDestroy();
                        mediaPlayerWindow = null;
                    }
                    for (VideoContainerWindow videoContainerWindow : videoWindows) {
                        int mediaType = LPMediaIdUtils.getMediaSourceType(videoContainerWindow.getVideoWindow().getMediaId()).getValue();
                        if (s.equals(LPMediaIdUtils.transferBackMediaId(String.valueOf(mediaType)))) {
                            videoLayer.removeWindow(videoContainerWindow);
                            videoWindows.remove(videoContainerWindow);
                            videoContainerWindow.onDestroy();
                        }
                    }
                }));
    }

    private void showAdminRollCallWindow(int duration, LPRoomRollCallResultModel lpRoomRollCallResultModel) {
        if (adminRollCallWindow == null) {
            adminRollCallWindow = new AdminRollCallWindow(getContext());
            ((AdminRollCallWindow) adminRollCallWindow).setRouterListener((RouterListener) getContext());
            ((AdminRollCallWindow) adminRollCallWindow).setDuration(duration);
            ((AdminRollCallWindow) adminRollCallWindow).setRollCallResultModel(lpRoomRollCallResultModel);
            ((AdminRollCallWindow) adminRollCallWindow).init();
            FrameLayout.LayoutParams layoutParams = new FrameLayout.LayoutParams(
                    getContext().getResources().getDimensionPixelSize(R.dimen.bjy_base_live_roll_call_width),
                    LayoutParams.WRAP_CONTENT
            );
            layoutParams.gravity = Gravity.CENTER;
            toolBoxLayer.addWindow(adminRollCallWindow, layoutParams);
        } else {
            ((AdminRollCallWindow) adminRollCallWindow).setRollCallResultModel(lpRoomRollCallResultModel);
            ((AdminRollCallWindow) adminRollCallWindow).setDuration(duration);
            ((AdminRollCallWindow) adminRollCallWindow).showRollCallState(BaseUtilsKt.getRollCallStatus(), duration);
        }
    }

    private void dismissAdminRollCallWindow() {
        if (adminRollCallWindow != null) {
            toolBoxLayer.removeWindow(adminRollCallWindow);
            adminRollCallWindow = null;
        }
    }

    private void showRollCallWindow(int time, OnPhoneRollCallListener.RollCall rollCallListener) {
        if (rollCallWindow == null) {
            rollCallWindow = new RollCallWindow(getContext());
            rollCallDialogPresenter = new RollCallDialogPresenter((RollCallDialogContract.View) rollCallWindow);
            rollCallDialogPresenter.setRollCallInfo(time, rollCallListener);
            ((RollCallDialogContract.View) rollCallWindow).setPresenter(rollCallDialogPresenter);
            int screenWidth = DisplayUtils.getScreenWidthPixels(getContext());
            int screenHeight = DisplayUtils.getScreenHeightPixels(getContext());
            FrameLayout.LayoutParams layoutParams = new FrameLayout.LayoutParams(
                    Math.min(screenHeight, screenWidth),
                    LayoutParams.WRAP_CONTENT
            );
            layoutParams.gravity = Gravity.CENTER;
            toolBoxLayer.addWindow(rollCallWindow, layoutParams);
        }
    }

    private void dismissRollCallWindow() {
        if (rollCallWindow != null) {
            toolBoxLayer.removeWindow(rollCallWindow);
            rollCallWindow = null;
        }
    }

    private void showTurntableWindow(boolean isTeacherOrAssistant) {
        if (turntableWindow == null) {
            if (isTeacherOrAssistant) {
                LPTurntableModel model = new LPTurntableModel();
                model.action = "open";
                router.getLiveRoom().requestTurntable(model);
            }
            turntableWindow = new TurntableWindow(getContext());
            ((TurntableWindow) turntableWindow).setCloseEnable(isTeacherOrAssistant);
            ((TurntableWindow) turntableWindow).setCloseListener(() -> {
                LPTurntableModel model = new LPTurntableModel();
                model.action = "close";
                router.getLiveRoom().requestTurntable(model);
                removeTurntableWindow();
                return null;
            });
            ((TurntableWindow) turntableWindow).setOnClickListener(view -> {
                LPTurntableModel model = new LPTurntableModel();
                model.action = "start";
                model.value = ((TurntableWindow) turntableWindow).teacherTurn();
                router.getLiveRoom().requestTurntable(model);
            });
            ((TurntableWindow) turntableWindow).setClickable(isTeacherOrAssistant);
            FrameLayout.LayoutParams layoutParams = new FrameLayout.LayoutParams(
                    UtilsKt.getDp(280),
                    UtilsKt.getDp(280)
            );
            layoutParams.gravity = Gravity.CENTER;
            toolBoxLayer.addWindow(turntableWindow, layoutParams);
        }
    }

    private void removeTurntableWindow() {
        if (turntableWindow != null) {
            turntableWindow.onDestroy();
            toolBoxLayer.removeWindow(turntableWindow);
            turntableWindow = null;
        }
    }

    private void startOtherObservable() {
        Disposable rollCallCountDownDisposable = router.getSubjectByKey(EventKey.RollCallCountDown)
                .ofType(Pair.class)
                .subscribe(pair -> {
                    if (adminRollCallWindow != null) {
                        ((AdminRollCallWindow) adminRollCallWindow).setRollCallCountDown((Integer) pair.first, (Boolean) pair.second);
                    }
                });

        Disposable adminRollCallWindowDisposable = router.getSubjectByKey(EventKey.OpenAdminRollCallWindow)
                .ofType(Pair.class)
                .subscribe(pair -> {
                    showAdminRollCallWindow((Integer) pair.first, (LPRoomRollCallResultModel) pair.second);
                });

        Disposable studentRollCallWindowDisposable = router.getSubjectByKey(EventKey.OpenStudentRollCallWindow)
                .ofType(Pair.class)
                .subscribe(pair -> {
                    showRollCallWindow((Integer) pair.first, (OnPhoneRollCallListener.RollCall) pair.second);
                });

        Disposable closeRollCallWindowDisposable = router.getSubjectByKey(EventKey.CloseRollCallWindow)
                .subscribe(a -> {
                    dismissAdminRollCallWindow();
                    dismissRollCallWindow();
                });

        Disposable openTurntableWindowDisposable = router.getSubjectByKey(EventKey.Turntable)
                .subscribe(show -> {
                    showTurntableWindow(BaseUtilsKt.isAdmin(router.getLiveRoom()));
                });

        Disposable turntableDisposable = router.getLiveRoom().getObservableOfTurntable()
                .observeOn(AndroidSchedulers.mainThread())
                .subscribe(lpTurntableModel -> {
                    if ("open".equals(lpTurntableModel.action)) {
                        showTurntableWindow(BaseUtilsKt.isAdmin(router.getLiveRoom()));
                    } else if ("close".equals(lpTurntableModel.action)) {
                        removeTurntableWindow();
                    } else {
                        showTurntableWindow(BaseUtilsKt.isAdmin(router.getLiveRoom()));
                        if (turntableWindow != null) {
                            ((TurntableWindow) turntableWindow).studentTurn(String.valueOf(lpTurntableModel.value));
                        }
                    }
                });

        compositeDisposable.add(rollCallCountDownDisposable);
        compositeDisposable.add(adminRollCallWindowDisposable);
        compositeDisposable.add(studentRollCallWindowDisposable);
        compositeDisposable.add(closeRollCallWindowDisposable);
        compositeDisposable.add(turntableDisposable);
        compositeDisposable.add(openTurntableWindowDisposable);
    }

    private void startPlayMediaCourseware(LPMediaCoursewareModel mediaCoursewareModel) {
        float ration = 5 / 3.0f;
        int windowWidth = (int) (getMeasuredWidth() * 0.45413f);
        if (mediaPlayerWindow == null) {
            mediaPlayerWindow = new MediaCoursewarePlayerWindow(getContext(), mediaCoursewareModel);
            videoLayer.addWindow(mediaPlayerWindow, new FrameLayout.LayoutParams(windowWidth, (int) (windowWidth / ration)));
        } else {
            mediaPlayerWindow.bringToForeground();
            mediaPlayerWindow.startPlay(mediaCoursewareModel);
        }
        Runnable runnable = () -> {
            Set<LPPlayerViewUpdateModel.PlayerPosition> allSet = router.getSetByKey(EventKey.AllPlayerViewList, LPPlayerViewUpdateModel.PlayerPosition.class);
            LPPlayerViewUpdateModel model = new LPPlayerViewUpdateModel();
            model.action = LPConstants.LPPlayerAction.ADD;
            LPPlayerViewUpdateModel.PlayerPosition playerPosition = mediaPlayerWindow.getPlayerPosition();
            model.id = model.mediaId = playerPosition.id;
            if (null == allSet) {
                allSet = new HashSet<>();
            }
            allSet.add(playerPosition);
            router.setObjectByKey(EventKey.AllPlayerViewList, allSet);
            model.all = allSet;
            router.getLiveRoom().getMediaVM().requestPlayerViewUpdate(model);
        };
        if (mediaPlayerWindow.getView() != null) {
            mediaPlayerWindow.getView().post(runnable);
        } else {
            getRootView().postDelayed(runnable, 1000);
        }
    }
}
