package com.baijiayun.groupclassui.dialog

import android.os.Bundle
import android.view.Gravity
import android.view.View
import android.view.WindowManager
import com.baijiayun.bjyutils.drawable.DrawableBuilder
import com.baijiayun.bjyutils.kt.dp
import com.baijiayun.groupclassui.R
import com.baijiayun.groupclassui.base.BaseGroupDialogFragment
import com.baijiayun.livebase.utils.ThemeDataUtil
import com.baijiayun.livecore.models.LPStudyRoomNote
import kotlinx.android.synthetic.main.bjysc_dialog_study_note.*

/**
 * Created by pengwenjian on 2020/12/14
 * Describe:
 */
class StudyNoteDialog : BaseGroupDialogFragment() {
    var studyRoomNote: LPStudyRoomNote? = null

    override fun getLayoutId() = R.layout.bjysc_dialog_study_note

    override fun init(savedInstanceState: Bundle?, arguments: Bundle?) {
        // do nothing
    }

    override fun onViewCreated(view: View, savedInstanceState: Bundle?) {
        super.onViewCreated(view, savedInstanceState)
        tvConfirm.background = DrawableBuilder()
            .solidColor(
                ThemeDataUtil.getColorFromThemeConfigByAttrId(
                    context,
                    R.attr.base_theme_live_product_color
                )
            )
            .cornerRadius(view.context.resources.getDimensionPixelSize(R.dimen.bjy_base_common_bg_radius))
            .build()
        tvContent.letterSpacing = 0.05f
        tvConfirm.setOnClickListener { dismissAllowingStateLoss() }
        studyRoomNote?.run {
            tvTitle.text = title
            tvContent.text = content
        }
    }

    override fun onStart() {
        super.onStart()
        dialog?.setCanceledOnTouchOutside(false)
        dialog?.window?.setBackgroundDrawable(
            DrawableBuilder()
                .rectangle()
                .solidColor(
                    ThemeDataUtil.getColorFromThemeConfigByAttrId(
                        context!!,
                        R.attr.base_theme_window_bg_color
                    )
                )
                .cornerRadius(context!!.resources.getDimensionPixelSize(R.dimen.bjy_base_common_bg_radius))
                .build()
        )
    }

    override fun setWindowParams(windowParams: WindowManager.LayoutParams) {
        super.setWindowParams(windowParams)
        windowParams.width = 500.dp
        windowParams.height = 340.dp
        windowParams.gravity = Gravity.CENTER
    }
}