package com.baijiayun.groupclassui.global;

import static com.baijiayun.bjyutils.kt.UtilsKt.getEncodePhoneNumber;
import static com.baijiayun.bjyutils.kt.UtilsKt.getParentViewGroup;
import static com.baijiayun.bjyutils.kt.UtilsKt.isFocus;
import static com.baijiayun.bjyutils.kt.UtilsKt.removeViewFromParent;

import android.Manifest;
import android.annotation.SuppressLint;
import android.app.Activity;
import android.content.Context;
import android.content.Intent;
import android.graphics.Bitmap;
import android.graphics.Color;
import android.graphics.drawable.BitmapDrawable;
import android.media.AudioManager;
import android.net.Uri;
import android.os.Build;
import android.os.Bundle;
import android.text.TextUtils;
import android.util.Pair;
import android.view.Gravity;
import android.view.View;
import android.view.ViewGroup;
import android.view.WindowManager;
import android.view.inputmethod.InputMethodManager;
import android.widget.FrameLayout;
import android.widget.TextView;

import androidx.annotation.NonNull;
import androidx.annotation.Nullable;
import androidx.appcompat.app.AppCompatActivity;
import androidx.appcompat.app.AppCompatDelegate;
import androidx.constraintlayout.widget.ConstraintLayout;
import androidx.constraintlayout.widget.ConstraintSet;
import androidx.core.content.ContextCompat;
import androidx.fragment.app.DialogFragment;
import androidx.fragment.app.Fragment;
import androidx.recyclerview.widget.RecyclerView;

import com.baijiahulian.common.permission.AppPermissions;
import com.baijiayun.bjyrtcengine.Defines.BJYRtcCommon;
import com.baijiayun.bjyutils.drawable.DrawableBuilder;
import com.baijiayun.bjyutils.kt.UtilsKt;
import com.baijiayun.bjyutils.log.LPLogger;
import com.baijiayun.bjyutils.reactivex.RxUtils;
import com.baijiayun.bjyutils.screen.DisplayUtils;
import com.baijiayun.glide.Glide;
import com.baijiayun.groupclassui.BuildConfig;
import com.baijiayun.groupclassui.InteractiveClassUI;
import com.baijiayun.groupclassui.R;
import com.baijiayun.groupclassui.base.BaseGroupPresenter;
import com.baijiayun.groupclassui.chat.ChatWindow;
import com.baijiayun.groupclassui.chat.FloatChatMessageAdapter;
import com.baijiayun.groupclassui.chat.GroupMessageSendFragment;
import com.baijiayun.groupclassui.chat.preview.IChatMessageCallback;
import com.baijiayun.groupclassui.container.FullScreenContainer;
import com.baijiayun.groupclassui.container.MenuContainer;
import com.baijiayun.groupclassui.container.RoomBackgroundContainer;
import com.baijiayun.groupclassui.container.SeatContainer;
import com.baijiayun.groupclassui.container.StudyRoomContainer;
import com.baijiayun.groupclassui.container.SyncContainer;
import com.baijiayun.groupclassui.container.VideoContainerListener;
import com.baijiayun.groupclassui.container.VideoMenuContainer;
import com.baijiayun.groupclassui.dialog.QRcodeDialog;
import com.baijiayun.groupclassui.dialog.StudyNoteDialog;
import com.baijiayun.groupclassui.dialog.TimerNoteDialog;
import com.baijiayun.groupclassui.layer.GroupLayer;
import com.baijiayun.groupclassui.layer.ReminderLayer;
import com.baijiayun.groupclassui.model.NotifyAwardModel;
import com.baijiayun.groupclassui.model.VideoMenuControlModel;
import com.baijiayun.groupclassui.studyreport.StudyReportActivity;
import com.baijiayun.groupclassui.user.OnlineUserWindow;
import com.baijiayun.groupclassui.user.ReplaceUserWithStatus;
import com.baijiayun.groupclassui.user.StudentOnlineUserWindow;
import com.baijiayun.groupclassui.user.UserStatus;
import com.baijiayun.groupclassui.util.FECompatUtil;
import com.baijiayun.groupclassui.util.IntentDataHolder;
import com.baijiayun.groupclassui.util.InteractiveUtils;
import com.baijiayun.groupclassui.util.LinearLayoutWrapManager;
import com.baijiayun.groupclassui.util.ReplaceWindowGenerateUtil;
import com.baijiayun.groupclassui.widget.DragRelativeLayout;
import com.baijiayun.groupclassui.window.IRoomStatusListener;
import com.baijiayun.groupclassui.window.multiupload.PreviewImgWindow;
import com.baijiayun.groupclassui.window.setting.SettingWindow;
import com.baijiayun.groupclassui.window.status.StatusBarWindow;
import com.baijiayun.groupclassui.window.study.DisplayStudyQuestion;
import com.baijiayun.groupclassui.window.study.QuestionRecordWindow;
import com.baijiayun.groupclassui.window.study.QuickQuestionState;
import com.baijiayun.groupclassui.window.study.QuickQuestionWindow;
import com.baijiayun.groupclassui.window.studyreport.StudyReportDialogFragment;
import com.baijiayun.groupclassui.window.studyreport.StudyReportDialogPresenter;
import com.baijiayun.groupclassui.window.toolbar.BitmapSettingWindow;
import com.baijiayun.groupclassui.window.toolbar.DrawLineMode;
import com.baijiayun.groupclassui.window.toolbar.DrawTextSettingWindow;
import com.baijiayun.groupclassui.window.toolbar.DrawWidthSettingWindow;
import com.baijiayun.groupclassui.window.toolbar.GraphMenuWindow;
import com.baijiayun.groupclassui.window.toolbar.TextEditWindow;
import com.baijiayun.groupclassui.window.toolbar.ToolbarWindow;
import com.baijiayun.groupclassui.window.video.VideoContainerWindow;
import com.baijiayun.groupclassui.window.video.VideoWindow;
import com.baijiayun.livebase.base.BaseDialogFragment;
import com.baijiayun.livebase.base.BasePresenter;
import com.baijiayun.livebase.base.BaseView;
import com.baijiayun.livebase.context.LPConstants;
import com.baijiayun.livebase.context.LPError;
import com.baijiayun.livebase.models.LPHorseLamp;
import com.baijiayun.livebase.models.LPJoinCodeEnterRoomModel;
import com.baijiayun.livebase.models.LPJsonModel;
import com.baijiayun.livebase.models.LPSignEnterRoomModel;
import com.baijiayun.livebase.models.LPUserModel;
import com.baijiayun.livebase.models.imodels.IUserModel;
import com.baijiayun.livebase.utils.FileUtils;
import com.baijiayun.livebase.utils.LPDeviceUuidFactory;
import com.baijiayun.livebase.utils.LPObservable;
import com.baijiayun.livebase.utils.ThemeDataUtil;
import com.baijiayun.livebase.widgets.HorseLampView;
import com.baijiayun.livebase.widgets.dialog.CommonDialog;
import com.baijiayun.livebase.widgets.dialog.NoteDialog;
import com.baijiayun.livebase.widgets.dialog.preview.ChatPictureViewFragment;
import com.baijiayun.livebase.widgets.dialog.preview.ChatSavePicDialogFragment;
import com.baijiayun.livecore.LiveSDK;
import com.baijiayun.livecore.context.LiveRoom;
import com.baijiayun.livecore.listener.LPRoomStatusListener;
import com.baijiayun.livecore.listener.OnCountDownListener;
import com.baijiayun.livecore.listener.OnPhoneRollCallListener;
import com.baijiayun.livecore.models.LPPlayerViewUpdateModel;
import com.baijiayun.livecore.models.LPRedPacketModel;
import com.baijiayun.livecore.models.LPRoomRollCallResultModel;
import com.baijiayun.livecore.models.imodels.IMediaModel;
import com.baijiayun.livecore.models.imodels.IMessageModel;
import com.baijiayun.livecore.ppt.whiteboard.shape.BitmapShape;
import com.baijiayun.livecore.utils.LPSdkVersionUtils;
import com.baijiayun.liveuibase.base.BaseUIConstant;
import com.baijiayun.liveuibase.base.BaseWindow;
import com.baijiayun.liveuibase.loading.LoadingWindow;
import com.baijiayun.liveuibase.skin.SkinInflateFactory;
import com.baijiayun.liveuibase.toolbox.ToolboxWindow;
import com.baijiayun.liveuibase.toolbox.bonuspoints.BonusPointsWindow;
import com.baijiayun.liveuibase.toolbox.browser.Tuple;
import com.baijiayun.liveuibase.toolbox.evaluation.EvaDialogFragment;
import com.baijiayun.liveuibase.toolbox.evaluation.EvaDialogPresenter;
import com.baijiayun.liveuibase.toolbox.redpacket.RedPacketFragment;
import com.baijiayun.liveuibase.toolbox.redpacket.RedPacketPresenter;
import com.baijiayun.liveuibase.toolbox.rollcall.RollCallStatus;
import com.baijiayun.liveuibase.toolbox.screenshare.ScreenShareHelper;
import com.baijiayun.liveuibase.utils.BaseUtilsKt;
import com.baijiayun.liveuibase.utils.ToastUtil;
import com.baijiayun.liveuibase.widgets.AwardView;
import com.baijiayun.liveuibase.widgets.dialog.QuestionDialogFragment;
import com.baijiayun.liveuibase.widgets.dialog.ReportDialog;
import com.baijiayun.liveuibase.widgets.popupwindow.BaseAutoArrangePopupWindow;
import com.google.gson.JsonObject;
import com.tencent.mmkv.MMKV;

import org.jetbrains.annotations.NotNull;

import java.io.File;
import java.lang.ref.WeakReference;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.Objects;
import java.util.Random;
import java.util.Set;
import java.util.concurrent.CopyOnWriteArrayList;
import java.util.concurrent.TimeUnit;

import io.reactivex.Observable;
import io.reactivex.ObservableOnSubscribe;
import io.reactivex.android.schedulers.AndroidSchedulers;
import io.reactivex.disposables.CompositeDisposable;
import io.reactivex.disposables.Disposable;
import io.reactivex.functions.Function;
import io.reactivex.functions.Predicate;
import io.reactivex.schedulers.Schedulers;
import kotlin.Unit;


/**
 * Created by Shubo on 2018/9/3.
 */
public class GroupClassActivity extends AppCompatActivity implements IChatMessageCallback, RouterListener {
    private FrameLayout videoDragContainer, menuContainer, statusBarContainer,
            chatWindowContainer, userWindowContainer, bonusPointsContainer, popupWindowContainer, settingContainer;
    private LoadingWindow loadingWindow;
    private StatusBarWindow statusBarWindow;
    private RoomBackgroundContainer roomBackgroundContainer;
    private VideoContainerListener videoContainer;
    private SyncContainer syncContainer;
    private FullScreenContainer fullContainer;
    private View fullBgContainer;
    private VideoMenuContainer videoMenuContainer;
    private final CompositeDisposable disposables = new CompositeDisposable();
    private Disposable disposableOfAuditionTimer;
    private CommonDialog exitDialog, helpDialog, closeBrowserDialog, networkTipsDialog;
    private RouterImpl router;
    private ChatWindow chatWindow;
    private QuickQuestionWindow quickQuestionWindow;
    private QuestionRecordWindow questionRecordWindow;
    private PreviewImgWindow previewImgWindow;
    private OnlineUserWindow onlineUserWindow;
    private StudentOnlineUserWindow studentOnlineUserWindow;
    private BonusPointsWindow bonusPointsWindow;
    private AwardView awardView;
    private ConstraintLayout clContainer;
    private ToolboxWindow toolboxWindow;
    private View eyeCareWindow;
    private GroupMessageSendFragment messageSendFragment;
    private SettingWindow settingWindow;

    private boolean isReconnect = false;
    private boolean isFullScreenOn = false;
    private boolean isSelfForbidChat = false;
    private boolean hasSetContentView = false;
    //进房间成功标志位 重连重进都置空
    private boolean enterRoomSuccess = false;

    private final String FRAGMENTS_TAG = "android:support:fragments";

    private QRcodeDialog qrCodeDialog;
    private NoteDialog noteDialog;
    private boolean attachLocalVideo;
    private String qrCodeUrl;
    private Disposable disposableOfQRCode;
    private Disposable disposableOfSbbToolsbarDelay;
    private Disposable disposableOfQuestionBeforeClass;

    //默认下课是否进入表情报告
    private boolean isEnterExpReport = true;
    private Bundle localSaveBundle = new Bundle();
    private EvaDialogFragment evaDialogFragment;
    private StudyReportDialogFragment studyReportDialogFragment;
    private SkinInflateFactory skinInflateFactory;
    private List<IRoomStatusListener> roomStatusListeners = new CopyOnWriteArrayList<>();
    private boolean hasShowStudyNote = false;
    private Disposable disposableOfReEnter;
    // 红包雨
    private RedPacketFragment redPacketFragment;
    private RedPacketPresenter redPacketPresenter;

    private CommonDialog errorDialog;
    private RecyclerView chatFloatWindowRecyclerView;
    private FloatChatMessageAdapter floatChatMessageAdapter;
    private boolean floatChatWindowStatus;
    private ScreenShareHelper screenShareHelper;
    private boolean isMusicModeOn = false;
    private boolean isReEnterRoom;
    private HorseLampView horseLampView;

    LPRoomStatusListener roomStatusListener = new LPRoomStatusListener() {
        @Override
        public void onLivingError(LPError error) {
            switch (error.getCode()) {
                case LPError.CODE_ERROR_ROOMSERVER_LOSE_CONNECTION:
                    router.getSubjectByKey(EventKey.ReminderErrorMessage).onNext(error.getMessage());
                    disposables.clear();
                    reconnect();
                    break;
                case LPError.CODE_ERROR_NETWORK_FAILURE:
                    router.getSubjectByKey(EventKey.ReEnterDialog).onNext(error);
                    break;
                case LPError.CODE_WARNING_PLAYER_LAG:
                    LPLogger.w("PLAYER_LAG " + error.getMessage());
                    break;
                case LPError.CODE_ERROR_CAMERA_SHARE:
                case LPError.CODE_ERROR_SCREEN_SHARE:
                    if (!TextUtils.isEmpty(error.getMessage())) {
                        router.getSubjectByKey(EventKey.ReminderMessage).onNext(error.getMessage());
                    }
                    break;
                default:
                    if (!TextUtils.isEmpty(error.getMessage())) {
                        router.getSubjectByKey(EventKey.ReminderErrorMessage).onNext(error.getMessage());
                    }
                    break;
            }
        }

        @Override
        public void onQuitRoom() {
            // do nothing
        }

        @Override
        public void onLaunchSteps(int step, int totalStep) {
            loadingWindow.onLaunchSteps(step, totalStep);
            if (!isReEnterRoom) {
                return;
            }
            String message = getString(R.string.reconnecting);
            message += step + "/" + totalStep;
            router.getSubjectByKey(EventKey.ReminderMessage).onNext(message);
        }

        @Override
        public void onLaunchError(LPError error) {
            removeViewFromParent(loadingWindow.getView());
            if (router != null) {
                router.getSubjectByKey(EventKey.ReEnterDialog).onNext(error);
            } else {
                GroupClassActivity.this.finish();
            }
        }

        @Override
        public void onLaunchSuccess(LiveRoom liveRoom) {
            loadingWindow.onLaunchSuccess(liveRoom);
            initSuccess();
            dismissLoadingWindow();
            if (!isTeacherOrAssistant()) {
                startMarqueeTape();
            }
            if (router.getLiveRoom().getPartnerConfig().enablePreventScreenCapture == 1) {
                getWindow().addFlags(WindowManager.LayoutParams.FLAG_SECURE);
            }
            if (!isReEnterRoom) {
                return;
            }
            router.setLiveRoom(liveRoom);
            subscribeWithEventKey();
            String message = "连接成功！";
            router.getSubjectByKey(EventKey.ReminderMessage).onNext(message);
        }
    };


    public GroupClassActivity() {
        super();
        // androidx.fragment 1.3.6 save/restore fragment 逻辑发生改变，主动unregister屏蔽恢复fragment的逻辑
        getSavedStateRegistry().unregisterSavedStateProvider(FRAGMENTS_TAG);
    }

    @Override
    protected void onCreate(@Nullable Bundle savedInstanceState) {
        if (savedInstanceState != null) {
            //如果系统回收的Activity， 但是系统却保留了Fragment， 当Activity被重新初始化， 此时， 系统保存的Fragment 的getActivity为空，
            //所以要移除旧的Fragment ， 重新初始化新的Fragment
            //support包的为android:support:fragments 原生为 android:fragments
            savedInstanceState.remove(FRAGMENTS_TAG);
            final Bundle bundle = savedInstanceState.getBundle("androidx.lifecycle.BundlableSavedStateRegistry.key");
            if (bundle != null) {
                bundle.remove(FRAGMENTS_TAG);
            }
        }
        skinInflateFactory = new SkinInflateFactory();
        getLayoutInflater().setFactory(skinInflateFactory);
        super.onCreate(savedInstanceState);
        doCreate(savedInstanceState);
    }

    private void doCreate(Bundle savedInstanceState) {
        initRoomData(savedInstanceState, getIntent());
        getWindow().setFlags(WindowManager.LayoutParams.FLAG_FULLSCREEN,
                WindowManager.LayoutParams.FLAG_FULLSCREEN);
        AppCompatDelegate.setCompatVectorFromResourcesEnabled(true);

        LiveSDK.AUTO_PLAY_SHARING_SCREEN_AND_MEDIA = false;
        if (TextUtils.isEmpty(MMKV.getRootDir())) {
            MMKV.initialize(this);
        }
        enterRoom(false, true);
        showLoading();
    }

    private void initRoomData(Bundle savedInstanceState, Intent intent) {
        LPJoinCodeEnterRoomModel joinCodeEnterRoomModel;
        LPSignEnterRoomModel signEnterRoomModel;
        if (savedInstanceState == null) {
            joinCodeEnterRoomModel = (LPJoinCodeEnterRoomModel) intent.getSerializableExtra("code");
            signEnterRoomModel = (LPSignEnterRoomModel) intent.getSerializableExtra("sign");
        } else {
            joinCodeEnterRoomModel = (LPJoinCodeEnterRoomModel) savedInstanceState.getSerializable("code");
            signEnterRoomModel = (LPSignEnterRoomModel) savedInstanceState.getSerializable("sign");
            LiveSDK.customEnvironmentPrefix = savedInstanceState.getString("custom_domain");
        }
        localSaveBundle.putSerializable("code", joinCodeEnterRoomModel);
        localSaveBundle.putSerializable("sign", signEnterRoomModel);
        localSaveBundle.putString("custom_domain", LiveSDK.customEnvironmentPrefix);
    }

    /**
     * 是否有权限上下课
     *
     * @return
     */
    private boolean enableClassStart() {
        return router.getLiveRoom().getCurrentUser().getType() == LPConstants.LPUserType.Teacher
                || (router.getLiveRoom().getCurrentUser().getType() == LPConstants.LPUserType.Assistant &&
                router.getLiveRoom().getPartnerConfig().enableAssistantStartClass == 1);
    }

    /**
     * 订阅EventKey中自定义的事件
     */
    private void subscribeWithEventKey() {
        disposables.add(router.getSubjectByKey(EventKey.CloseDialog)
                .ofType(Boolean.class)
                .filter(aBoolean -> aBoolean)
                .subscribe(aBoolean -> {
                    if (exitDialog == null) {
                        String mainText = getResources().getString(R.string.bjysc_exit_student_label);
                        String positiveText = getResources().getText(R.string.bjysc_close_room).toString();
                        boolean showStudyReport = getLiveRoom().getCurrentUser().getType() == LPConstants.LPUserType.Teacher
                                && !getLiveRoom().getStudyRoomVM().isStudyRoom()
                                && (getLiveRoom().getPartnerConfig().autoShowStudyReport
                                && getLiveRoom().getPartnerConfig().enableStudyReport)
                                && router.getLiveRoom().getSmallClassTemplateType() != LPConstants.SmallClassTemplateType.ONEONONE;
                        if (router.getLiveRoom().getSmallClassTemplateType() == LPConstants.SmallClassTemplateType.ONEONONE) {
                            if (router.getLiveRoom().getStudyRoomVM().isFromTutorOutside()) {
                                mainText = getResources().getString(R.string.bjysc_exit_outside_tutor_label);
                                positiveText = getResources().getString(R.string.bjysc_confirm);
                            }
                        } else {
                            if (router.getLiveRoom().getStudyRoomVM().isStudyRoom()) {
                                mainText = getResources().getString(R.string.bjysc_exit_student_label);
                            } else {
                                if (enableClassStart()) {
                                    mainText = getResources().getString(R.string.bjysc_exit_teacher_label);
                                } else {
                                    mainText = getResources().getString(R.string.bjysc_exit_student_label);
                                }
                            }
                        }
                        exitDialog = new CommonDialog(GroupClassActivity.this
                                , CommonDialog.ChoiceMode.Double_Red)
                                .setMainDisplayText(mainText)
                                .setNegative(getResources().getText(R.string.bjysc_cancel).toString()
                                        , ((dialog, which) -> {
                                            dialog.dismiss();
                                        }))
                                .setPositive(positiveText
                                        , ((dialog, which) -> {
                                            isEnterExpReport = false;
                                            if (router.getLiveRoom().getSmallClassTemplateType() == LPConstants.SmallClassTemplateType.ONEONONE) {
                                                if (router.getLiveRoom().getStudyRoomVM().isFromTutorOutside()) {
                                                    router.getLiveRoom().requestClassEnd();
                                                    syncRemoveAllBlackboardVideoWindow();
                                                    exitDialog.dismiss();
                                                    back2PreviousPage();
                                                    return;
                                                }
                                            }
                                            if (router.getLiveRoom().getCurrentUser().getType()
                                                    == LPConstants.LPUserType.Teacher
                                                    && router.getLiveRoom().isClassStarted()
                                                    && !router.getLiveRoom().getStudyRoomVM().isStudyRoom()) {
                                                router.getLiveRoom().requestClassEnd();
                                                syncRemoveAllBlackboardVideoWindow();
                                            }
                                            exitDialog.dismiss();
                                            finish();
                                        }))
                                .setStudyReportBtn(showStudyReport, (dialog, which) -> {
                                    router.getLiveRoom().requestClassEnd();
                                    syncRemoveAllBlackboardVideoWindow();
                                    router.getSubjectByKey(EventKey.OpenExpressionReportActivity).onNext(LPConstants.HOSTS_WEB[LiveSDK.getDeployType().getType()]);
                                    exitDialog.dismiss();
                                    finish();
                                });
                    }
                    exitDialog.show();
                }));

        disposables.add(router.getSubjectByKey(EventKey.ReEnterDialog)
                .ofType(LPError.class)
                .subscribe(lpError -> showReEnterDialog(lpError, null)));

        disposables.add(router.getSubjectByKey(EventKey.HelpWindow)
                .ofType(Boolean.class)
                .filter(aBoolean -> aBoolean)
                .subscribe(aBoolean -> {
                    if (helpDialog == null) {
                        helpDialog = new CommonDialog(GroupClassActivity.this
                                , CommonDialog.ChoiceMode.Single_Blue)
                                .setIconDrawableId(R.drawable.ic_vector_help_phone)
                                .setMainDisplayText("请拨打技术支持电话：712832614\n工作时间：9:00～24:00")
                                .setPositive(getResources().getText(R.string.bjysc_i_know).toString()
                                        , ((dialog, which) -> {
                                            dialog.dismiss();
                                        }));
                    }
                    helpDialog.show();
                }));

        disposables.add(router.getSubjectByKey(EventKey.GroupManageLayout)
                .ofType(Boolean.class)
                .subscribe(aBoolean -> {
                    if (aBoolean) {
                        fullContainer.addView(new GroupLayer(this));
                    } else {
                        for (int i = 0; i < fullContainer.getChildCount(); i++) {
                            if (fullContainer.getChildAt(i) instanceof GroupLayer) {
                                fullContainer.removeViewAt(i);
                                break;
                            }
                        }
                    }
                }));

        disposables.add(router.getSubjectByKey(EventKey.ToolBox)
                .ofType(View.class)
                .subscribe(view -> {
                    if (toolboxWindow == null) {
                        toolboxWindow = new ToolboxWindow(this);
                        toolboxWindow.setOnDismissListener(() -> router.getSubjectByKey(EventKey.ResetToolbarStatus).onNext(true));
                        toolboxWindow.setClickListener(new ToolboxWindow.OnClickListener() {
                            @Override
                            public void onTurntableClick() {
                                router.getSubjectByKey(EventKey.Turntable).onNext(true);
                            }

                            @Override
                            public void onScreenShareClick() {
                                if (!router.getLiveRoom().getOnlineUserVM().isActiveUser(router.getLiveRoom().getCurrentUser())) {
                                    router.getSubjectByKey(EventKey.ReminderMessage).onNext(getString(R.string.bjy_group_screen_share_not_seat));
                                    return;
                                }
                                if (screenShareHelper == null) {
                                    screenShareHelper = new ScreenShareHelper(GroupClassActivity.this, router.getLiveRoom());
                                    screenShareHelper.setScreenShareListener(new ScreenShareHelper.ScreenShareListener() {
                                        @Override
                                        public void onScreenShareState(@NonNull LPConstants.LPScreenShareState state) {
                                            if (state == LPConstants.LPScreenShareState.START) {
                                                router.getSubjectByKey(EventKey.ScreenShare).onNext(true);
                                            } else if (state == LPConstants.LPScreenShareState.STOP || state == LPConstants.LPScreenShareState.ERROR) {
                                                router.getSubjectByKey(EventKey.ScreenShare).onNext(false);
                                            }
                                        }

                                        @Override
                                        public void onScreenShareStop() {
                                            closeScreenShareDialog();
                                        }
                                    });
                                }
                                screenShareHelper.startScreenCapture();
                            }

                            @Override
                            public boolean isClickable() {
                                return checkClassStart();
                            }

                            @Override
                            public void onBrowserClick() {
                                router.getSubjectByKey(EventKey.OpenBrowserWindow).onNext(true);
                            }

                            @Override
                            public void onSmallBlackboardClick() {
                                router.getSubjectByKey(EventKey.SbbOpenWindow).onNext(true);
                            }

                            @Override
                            public void onTimerClick() {
                                router.getSubjectByKey(EventKey.TeacherTimerWindow).onNext(true);
                            }

                            @Override
                            public void onAnswererClick() {
                                router.getSubjectByKey(EventKey.TeacherAnswererWindow).onNext(true);
                            }

                            @Override
                            public void onResponderClick() {
                                router.getSubjectByKey(EventKey.Responder).onNext(true);
                            }

                            @Override
                            public void onRedPacketClick() {
                                // do nothing
                            }

                            @Override
                            public void onRollCallClick() {
                                router.getSubjectByKey(EventKey.RollCallWindow).onNext(true);
                            }
                        });
                    }
                    changePopupWindowState(toolboxWindow, view);
                }));

        disposables.add(router.getSubjectByKey(EventKey.CloseBrowserDialog)
                .ofType(Boolean.class)
                .filter(aBoolean -> aBoolean)
                .subscribe(aBoolean -> {
                    if (closeBrowserDialog == null) {
                        closeBrowserDialog = new CommonDialog(GroupClassActivity.this
                                , CommonDialog.ChoiceMode.Double_Blue)
                                .setMainDisplayText(getString(R.string.bjy_base_browser_close_center_tips))
                                .setNegative(getString(R.string.bjysc_cancel), ((dialog, which) -> {
                                    dialog.dismiss();
                                }))
                                .setPositive(getString(R.string.bjy_base_browser_close_btn_close), ((dialog, which) -> {
                                    dialog.dismiss();
                                    router.getSubjectByKey(EventKey.CloseBrowserWindow).onNext(false);
                                }));
                    }
                    closeBrowserDialog.show();
                }));

        disposables.add(router.getSubjectByKey(EventKey.CloseScreenShare)
                .ofType(Boolean.class)
                .filter(aBoolean -> aBoolean)
                .subscribe(aBoolean -> {
                    closeScreenShareDialog();
                }));

        disposables.add(router.getSubjectByKey(EventKey.NetworkTipsDialog)
                .ofType(String.class)
                .subscribe(tips -> {
                    if (networkTipsDialog == null) {
                        networkTipsDialog = new CommonDialog(GroupClassActivity.this
                                , CommonDialog.ChoiceMode.Single_Blue)
                                .setMainDisplayText(tips)
                                .setPositive(getString(R.string.bjysc_confirm), ((dialog, which) -> {
                                    networkTipsDialog.dismiss();
                                    finish();
                                }))
                                .setNegative(getString(R.string.bjysc_cancel), ((dialog, which) -> {
                                    networkTipsDialog.dismiss();
                                    finish();
                                }));
                    }
                    networkTipsDialog.show();
                }));

        disposables.add(router.getSubjectByKey(EventKey.GraphMenuEnable)
                .ofType(View.class)
                .subscribe(view -> {
                            if (view != null) {
                                final Object tag = view.getTag();
                                if (tag != null) {
                                    graphMenu.checkedIndex(1);
                                } else {
                                    changePopupWindowState(graphMenu, view);
                                }
                                router.getSubjectByKey(EventKey.DrawTextEnable).onNext(false);
                                router.getSubjectByKey(EventKey.LaserDrawEnable).onNext(false);
                            }
                        }
                ));

        disposables.add(router.getSubjectByKey(EventKey.BgSingleTapConfirmed)
                .ofType(Boolean.class)
                .filter(aBoolean -> toolbarWindow != null && toolbarWindow.getView().getParent() != null)
                .subscribe(aBoolean -> {
                    Object drawTextEnableValue = router.getSubjectByKey(EventKey.DrawTextEnable).getValue();
                    boolean isTrue = drawTextEnableValue instanceof Boolean && (Boolean) drawTextEnableValue;
                    boolean isView = router.getSubjectByKey(EventKey.DrawTextEnable).getValue() instanceof View;
                    if (isTrue || isView) {
                        // 展示输入框，拉起键盘
                        showEditTextWindow("");
                    } else if (drawTextEdit.getParent() != null) {
                        removeViewFromParent(drawTextEdit);
                    }
                    if (bitmapShapeSettingBar.getParent() != null) {
                        removeViewFromParent(bitmapShapeSettingBar);
                    }
                }));

        disposables.add(router.getSubjectByKey(EventKey.EditTextShape)
                .ofType(String.class)
                .subscribe(this::showEditTextWindow)
        );

        disposables.add(router.getSubjectByKey(EventKey.SelectModeEnable)
                .ofType(Boolean.class)
                .subscribe(aBoolean -> {
                    if (aBoolean) {
                        router.getSubjectByKey(EventKey.DrawTextEnable).onNext(false);
                        router.getSubjectByKey(EventKey.LaserDrawEnable).onNext(false);
                    }
                }));

        disposables.add(router.getSubjectByKey(EventKey.ResetToolbarStatus)
                .ofType(Boolean.class)
                .subscribe(aBoolean -> {
                    changePopupWindowState(drawWidthMenuForMarker, null);
                    changePopupWindowState(drawWidthMenuForBrush, null);
                    changePopupWindowState(graphMenu, null);
                    router.getSubjectByKey(EventKey.DrawTextEnable).onNext(false);
                    router.getSubjectByKey(EventKey.LaserDrawEnable).onNext(false);
                }));

        disposables.add(router.getSubjectByKey(EventKey.LaserDrawEnable)
                .ofType(Boolean.class)
                .subscribe(aBoolean -> {
                    if (aBoolean) {
                        router.getSubjectByKey(EventKey.DrawTextEnable).onNext(false);
                    }
                }));

        disposables.add(router.getSubjectByKey(EventKey.DrawLineModeEnable)
                .filter(data -> data instanceof List && ((List<?>) data).size() == 2
                        && ((List<?>) data).get(0) instanceof DrawLineMode && ((List<?>) data).get(1) instanceof View)
                .subscribe(data -> {
                    DrawLineMode drawLineMode = (DrawLineMode) ((List<?>) data).get(0);
                    View anchor = (View) ((List<?>) data).get(1);
                    if (drawLineMode != DrawLineMode.NONE) {
                        BaseAutoArrangePopupWindow drawWidthMenu = drawLineMode == DrawLineMode.MARKER_MODE
                                ? drawWidthMenuForMarker : drawWidthMenuForBrush;
                        changePopupWindowState(drawWidthMenu, anchor);
                    }
                }));

        disposables.add(router.getSubjectByKey(EventKey.DrawTextEnable)
                .subscribe(data -> {
                    if (data instanceof Boolean && !(Boolean) data) {
                        changePopupWindowState(drawTextMenu, null);
                    } else if (data instanceof View) {
                        changePopupWindowState(drawTextMenu, (View) data);
                    }
                }));

        disposables.add(router.getSubjectByKey(EventKey.ClearToolbarWindow)
                .ofType(Boolean.class)
                .subscribe(aBoolean -> {
                    changePopupWindowState(drawWidthMenuForBrush, null);
                    changePopupWindowState(drawWidthMenuForMarker, null);
                    changePopupWindowState(graphMenu, null);
                    changePopupWindowState(drawTextMenu, null);
                }));

        disposables.add(router.getSubjectByKey(EventKey.DrawTextSend)
                .ofType(HashMap.class)
                .subscribe(map -> {
                    if (Objects.equals(map.get("end"), "true")) {
                        removeViewFromParent(drawTextEdit);
                    }
                }));

        disposables.add(router.getSubjectByKey(EventKey.ClearEditText)
                .subscribe(o -> {
                    removeViewFromParent(drawTextEdit);
                    InputMethodManager inputMethodManager = (InputMethodManager) getSystemService(INPUT_METHOD_SERVICE);
                    if (inputMethodManager.isActive() && this.getCurrentFocus() != null) {
                        inputMethodManager.hideSoftInputFromWindow(this.getCurrentFocus().getWindowToken(), 0);
                    }
                }));

        disposables.add(router.getSubjectByKey(EventKey.BitmapShapeSelected)
                .ofType(BitmapShape.class)
                .subscribe(bitmapShape -> {
                    router.getSubjectByKey(EventKey.DrawTextEnable).onNext(false);
                }));

        disposables.add(router.getSubjectByKey(EventKey.BitmapShapeErase)
                .ofType(Boolean.class)
                .subscribe(aBoolean -> {
                    menuContainer.removeView(bitmapShapeSettingBar);
                    router.getSubjectByKey(EventKey.DrawTextEnable).onNext(false);
                }));

        disposables.add(router.getSubjectByKey(EventKey.GraphBitmapEnable)
                .ofType(Boolean.class)
                .subscribe(aBoolean -> router.getSubjectByKey(EventKey.DrawTextEnable).onNext(false)));

        disposables.add(router.getSubjectByKey(EventKey.DisplayUserList)
                .ofType(UserStatus.class)
                .subscribe(userStatus -> {
                    if (userStatus == UserStatus.UserList || userStatus == UserStatus.HandsupList) {
                        router.getSubjectByKey(EventKey.DisplayChat).onNext(false);
                        userWindowContainer.removeAllViews();
                        if (BaseUtilsKt.isAdmin(router.getLiveRoom())) {
                            if (onlineUserWindow == null) {
                                onlineUserWindow = new OnlineUserWindow(GroupClassActivity.this);
                            }
                            if (userStatus == UserStatus.HandsupList) {
                                onlineUserWindow.startHandsUpList();
                            }
                            if (onlineUserWindow.getView() != null) {
                                FrameLayout.LayoutParams layoutParams;
                                if (DisplayUtils.isPad(GroupClassActivity.this)) {
                                    int width = GroupClassActivity.this.getResources().getDimensionPixelSize(R.dimen.bjysc_user_window_width);
                                    int height = GroupClassActivity.this.getResources().getDimensionPixelSize(R.dimen.bjysc_user_window_height);
                                    layoutParams = new FrameLayout.LayoutParams(width, height);
                                } else {
                                    layoutParams = new FrameLayout.LayoutParams(ViewGroup.LayoutParams.MATCH_PARENT, ViewGroup.LayoutParams.MATCH_PARENT);
                                    int margin = GroupClassActivity.this.getResources().getDimensionPixelSize(R.dimen.bjysc_window_user_margin);
                                    layoutParams.setMargins(margin, margin, margin, margin);
                                }
                                layoutParams.gravity = Gravity.CENTER;
                                userWindowContainer.addView(onlineUserWindow.getView(), layoutParams);
                                userWindowContainer.setVisibility(View.VISIBLE);
                                userWindowContainer.setFocusable(true);
                                userWindowContainer.setClickable(true);
                            }
                        } else {
                            if (studentOnlineUserWindow == null) {
                                studentOnlineUserWindow = new StudentOnlineUserWindow(GroupClassActivity.this, router);
                            }
                            if (studentOnlineUserWindow.getView() != null) {
                                FrameLayout.LayoutParams lp = new FrameLayout.LayoutParams(
                                        UtilsKt.getDp(200),
                                        syncContainer.getMeasuredHeight()
                                );
                                lp.gravity = Gravity.CENTER;
                                userWindowContainer.addView(studentOnlineUserWindow.getView(), lp);
                                userWindowContainer.setVisibility(View.VISIBLE);
                                userWindowContainer.setFocusable(true);
                            }
                        }
                    } else {
                        if (onlineUserWindow != null) {
                            onlineUserWindow.destroy();
                            onlineUserWindow = null;
                        }
                        if (studentOnlineUserWindow != null) {
                            studentOnlineUserWindow.onDestroy();
                            studentOnlineUserWindow = null;
                        }
                        userWindowContainer.setVisibility(View.GONE);
                        userWindowContainer.removeAllViews();
                    }
                }));

        disposables.add(router.getSubjectByKey(EventKey.ShowBonusPointWindow)
                .ofType(Boolean.class)
                .subscribe(aBoolean -> {
                    if (aBoolean) {
                        bonusPointsContainer.removeAllViews();
                        bonusPointsWindow = new BonusPointsWindow(GroupClassActivity.this);
                        bonusPointsWindow.setCloseListener(v -> {
                            if (bonusPointsWindow != null) {
                                bonusPointsWindow.onDestroy();
                                bonusPointsWindow = null;
                            }
                            bonusPointsContainer.setVisibility(View.GONE);
                            bonusPointsContainer.removeAllViews();
                        });
                        if (bonusPointsWindow.getView() != null) {
                            int widthDimenRes, heightDimenRes;
                            if (BaseUtilsKt.isAdmin(router.getLiveRoom())) {
                                widthDimenRes = R.dimen.bjy_base_live_bonus_points_window_width;
                                heightDimenRes = R.dimen.bjy_base_live_bonus_points_window_height;
                            } else {
                                widthDimenRes = R.dimen.bjy_base_live_bonus_points_window_width;
                                if (router.getLiveRoom().getStudyRoomVM().isStudyRoom()) {
                                    heightDimenRes = R.dimen.bjy_base_live_bonus_points_window_height_student_small;
                                } else {
                                    heightDimenRes = R.dimen.bjy_base_live_bonus_points_window_height_student;
                                }
                            }
                            int width = GroupClassActivity.this.getResources().getDimensionPixelSize(widthDimenRes);
                            int height = GroupClassActivity.this.getResources().getDimensionPixelSize(heightDimenRes);
                            FrameLayout.LayoutParams layoutParams = new FrameLayout.LayoutParams(width, height);
                            layoutParams.gravity = Gravity.CENTER;
                            bonusPointsContainer.addView(bonusPointsWindow.getView(), layoutParams);
                            bonusPointsContainer.setVisibility(View.VISIBLE);
                            bonusPointsContainer.setFocusable(true);
                            bonusPointsContainer.setClickable(true);
                        }
                    } else {
                        if (bonusPointsWindow != null) {
                            bonusPointsWindow.onDestroy();
                            bonusPointsWindow = null;
                        }
                        bonusPointsContainer.setVisibility(View.GONE);
                        bonusPointsContainer.removeAllViews();
                    }
                }));

        disposables.add(router.getSubjectByKey(EventKey.DisplayChat)
                .ofType(Boolean.class)
                .observeOn(AndroidSchedulers.mainThread())
                .subscribe(aBoolean -> {
                    if (aBoolean) {
                        router.getSubjectByKey(EventKey.NewMsgCount).onNext(0);
                        router.getSubjectByKey(EventKey.DisplayUserList).onNext(UserStatus.Close);
                        setFloatChatWindowVisible(false);
                        if (chatWindow == null) {
                            initChatWindow();
                        } else {
                            removeViewFromParent(chatWindow.getView());
                            chatWindow.notifyMessageDataSetChange();
                        }
                        chatWindowContainer.addView(chatWindow.getView());
                        if (router.getLiveRoom().enableFixChatPanel1v1()) {
                            chatWindowContainer.setVisibility(View.VISIBLE);
                        }
                    } else {
                        if (chatWindow != null) {
                            removeViewFromParent(chatWindow.getView());
                        }
                        if (router.getLiveRoom().enableFixChatPanel1v1()) {
                            chatWindowContainer.setVisibility(View.GONE);
                        }
                        //关闭聊天窗口后恢复聊天飘窗的状态
                        setFloatChatWindowVisible(floatChatWindowStatus);
                    }
                }));

        disposables.add(router.getSubjectByKey(EventKey.DisplayFloatChat)
                .ofType(Boolean.class)
                .observeOn(AndroidSchedulers.mainThread())
                .subscribe(show -> {
                    floatChatWindowStatus = show;
                    setFloatChatWindowVisible(show);
                }));

        disposables.add(router.getSubjectByKey(EventKey.DisplayEyeCare)
                .ofType(Boolean.class)
                .observeOn(AndroidSchedulers.mainThread())
                .subscribe(aBoolean -> {
                    if (eyeCareWindow != null) {
                        eyeCareWindow.setVisibility(aBoolean ? View.VISIBLE : View.GONE);
                    }
                }));

        disposables.add(router.getSubjectByKey(EventKey.SetFullScreenWindowOn)
                .ofType(BaseWindow.class)
                .subscribe(baseWindow -> {
                    isFullScreenOn = true;
                    fullBgContainer.setVisibility(View.VISIBLE);
                }));

        disposables.add(router.getSubjectByKey(EventKey.SetFullScreenWindowOff)
                .ofType(BaseWindow.class)
                .subscribe(baseWindow -> {
                    isFullScreenOn = false;
                    fullBgContainer.setVisibility(View.GONE);
                    removeAllToolbarWindow();

                    boolean hasAuth = hasDrawingAuth() || hasSbbDrawingAuth() || hasPPTAuth() || hasScreenShareAuth();
                    if (toolbarWindow != null && (hasAuth || BaseUtilsKt.isAdmin(router.getLiveRoom()))) {
                        menuContainer.addView(toolbarWindow.getView());
                    }
                }));

        disposables.add(router.getSubjectByKey(EventKey.ClosePPTWindow)
                .ofType(Tuple.class)
                .subscribe(s -> isFullScreenOn = false));

        disposables.add(router.getSubjectByKey(EventKey.ShowVideoMenu)
                .ofType(VideoMenuControlModel.class)
                .subscribe(videoMenuControlModel -> {
                    if (videoMenuControlModel.isShow() && router.getLiveRoom().isClassStarted()) {
                        videoMenuContainer.addMenu(videoMenuControlModel);
                    } else {
                        videoMenuContainer.removeMenu();
                    }
                }));

        disposables.add(router.getSubjectByKey(EventKey.ShowAward)
                .ofType(NotifyAwardModel.class)
                .subscribe(notifyAwardModel -> {
                    if (notifyAwardModel.isAwardAllActive) {
                        awardView.setAwardText("台上奖励");
                        awardView.setAwardMedal(AwardView.TYPE_AWARD_ALL);
                    } else {
                        awardView.setAwardText(getEncodePhoneNumber(notifyAwardModel.userModel.getName()));
                        awardView.setAwardMedal(notifyAwardModel.awardType, notifyAwardModel.pictureUrl);
                        awardView.setEndPointLocation(notifyAwardModel.endPointLocation);
                    }
                    awardView.setVisibility(View.VISIBLE);
                    awardView.startAnim();
                }));

        disposables.add(router.getSubjectByKey(EventKey.KickOutConfirm)
                .ofType(IUserModel.class)
                .subscribe(this::showKickOutDialog));

        disposables.add(router.getSubjectByKey(EventKey.OpenExpressionReportActivity)
                .ofType(String.class)
                .observeOn(AndroidSchedulers.mainThread())
                .subscribe(url -> {
                    if (router == null || router.getLiveRoom().getCurrentUser() == null) {
                        return;
                    }
                    router.getSubjectByKey(EventKey.CloseExpressionReportActivity).onNext(false);
                    Intent intent = new Intent(GroupClassActivity.this, StudyReportActivity.class);
                    IntentDataHolder.getInstance().setData("router", router);
                    IntentDataHolder.getInstance().setData("url", url);
                    IntentDataHolder.getInstance().setData("liveroom", getLiveRoom());
                    startActivity(intent);
                }));

        disposables.add(router.getSubjectByKey(EventKey.SbbShowToolBarWindow)
                .ofType(Integer.class)
                .filter(new Predicate<Integer>() {
                    @Override
                    public boolean test(@NonNull Integer integer) throws Exception {
                        return !router.getLiveRoom().isAudition();
                    }
                })
                .subscribe(showToolbar -> {
                    RxUtils.dispose(disposableOfSbbToolsbarDelay);
                    if (showToolbar != -1) {
                        showToolbarWindow();
                    } else {
                        disposableOfSbbToolsbarDelay = Observable.timer(3, TimeUnit.SECONDS)
                                .observeOn(AndroidSchedulers.mainThread())
                                .subscribe(aLong -> {
                                    if (router != null) {
                                        router.getSubjectByKey(EventKey.SbbShowToolBarWindow).onNext(0);
                                    }
                                });
                    }
                }));

        disposables.add(router.getPublishSubjectByKey(EventCode.DismissEvaDialog)
                .observeOn(AndroidSchedulers.mainThread())
                .subscribe(o -> {
                    dismissDialog(evaDialogFragment);
                    if (!router.getLiveRoom().getStudyRoomVM().isStudyRoom()
                            && isEnterExpReport
                            && router.getLiveRoom().getSmallClassTemplateType() != LPConstants.SmallClassTemplateType.ONEONONE
                            && (router.getLiveRoom().getPartnerConfig().autoShowStudyReport && router.getLiveRoom().getPartnerConfig().enableStudyReport)) {
                        showStudyReport();
                    }
                }));

        disposables.add(router.getSubjectByKey(EventKey.DismissStudyReportDialog)
                .subscribe(o -> dismissDialog(studyReportDialogFragment)));

        disposables.add(router.getSubjectByKey(EventKey.UpdatePPTView)
                .ofType(Boolean.class)
                .subscribe(this::updatePPTView));
        disposables.add(router.getSubjectByKey(EventKey.ShowQrCode)
                .ofType(Boolean.class)
                .observeOn(AndroidSchedulers.mainThread())
                .subscribe(aBoolean -> {
                    if (aBoolean) {
                        startScannerCamera();
                    } else {
                        endScannerCamera();
                    }
                }));

        disposables.add(router.getSubjectByKey(EventKey.VideoWindowToBlackboard)
                .ofType(VideoWindow.class)
                .subscribe(videoWindow -> {
                    moveVideoWindowToBlackboard(videoWindow, false);
                }));

        disposables.add(router.getSubjectByKey(EventKey.VideoWindowToBlackboardAndMax)
                .ofType(VideoWindow.class)
                .subscribe(videoWindow -> {
                    moveVideoWindowToBlackboard(videoWindow, true);
                }));

        disposables.add(router.getSubjectByKey(EventKey.RemoveAllBlackboardVideoWindow)
                .ofType(Boolean.class)
                .subscribe(aBoolean -> syncRemoveAllBlackboardVideoWindow()));

        disposables.add(router.getSubjectByKey(EventKey.StudyReEnterRoom)
                .ofType(String.class)
                .subscribe(s -> {
                    LPJoinCodeEnterRoomModel joinCodeEnterRoomModel = (LPJoinCodeEnterRoomModel) localSaveBundle.getSerializable("code");
                    localSaveBundle.putString("code_copy", TextUtils.isEmpty(joinCodeEnterRoomModel.joinCode) ? "" : joinCodeEnterRoomModel.joinCode);
                    joinCodeEnterRoomModel.joinCode = s;
                    localSaveBundle.putSerializable("code", joinCodeEnterRoomModel);
                    reEnterRoom(true, true, true);
                }));

        disposables.add(router.getSubjectByKey(EventKey.RollCallWindow)
                .ofType(Boolean.class)
                .subscribe(aBoolean -> showRollCall(-1, null)));

        disposables.add(router.getSubjectByKey(EventKey.DisplayStudyQuestion)
                .ofType(DisplayStudyQuestion.class)
                .observeOn(AndroidSchedulers.mainThread())
                .subscribe(studyQuestion -> {
                    int width = (int) (popupWindowContainer.getMeasuredWidth() * 0.9);
                    int height = (int) (popupWindowContainer.getMeasuredHeight() * 0.9);
                    FrameLayout.LayoutParams layoutParams = new FrameLayout.LayoutParams(width, height);
                    layoutParams.gravity = Gravity.CENTER;
                    switch (studyQuestion) {
                        case Quick_Question_Open:
                            if (quickQuestionWindow == null) {
                                quickQuestionWindow = new QuickQuestionWindow(this);
                            }
                            quickQuestionWindow.setShowing(true);
                            popupWindowContainer.removeAllViews();
                            popupWindowContainer.addView(quickQuestionWindow.getView(), layoutParams);
                            popupWindowContainer.setVisibility(View.VISIBLE);
                            break;
                        case Question_Record_Open:
                            if (questionRecordWindow == null) {
                                questionRecordWindow = new QuestionRecordWindow(this);
                            }
                            popupWindowContainer.removeAllViews();
                            popupWindowContainer.addView(questionRecordWindow.getView(), layoutParams);
                            popupWindowContainer.setVisibility(View.VISIBLE);
                            break;
                        case Quick_Question_Close:
                            if (quickQuestionWindow != null) {
                                quickQuestionWindow.setShowing(false);
                                if (quickQuestionWindow.getQuestionState() == QuickQuestionState.Replyed) {
                                    quickQuestionWindow.refreshQuestionState();
                                }
                            }
                            popupWindowContainer.removeAllViews();
                            popupWindowContainer.setVisibility(View.GONE);
                            break;
                        case Question_Record_Close:
                            popupWindowContainer.removeAllViews();
                            popupWindowContainer.setVisibility(View.GONE);
                            break;
                        default:
                            break;
                    }
                }));

        disposables.add(router.getSubjectByKey(EventKey.DisplayImgPreview)
                .ofType(String.class)
                .observeOn(AndroidSchedulers.mainThread())
                .subscribe(s -> {
                    if (TextUtils.isEmpty(s)) {
                        popupWindowContainer.removeView(previewImgWindow.getView());
                    } else {
                        int width = (int) (popupWindowContainer.getMeasuredWidth() * 0.9);
                        int height = (int) (popupWindowContainer.getMeasuredHeight() * 0.9);
                        FrameLayout.LayoutParams layoutParams = new FrameLayout.LayoutParams(width, height);
                        layoutParams.gravity = Gravity.CENTER;
                        if (previewImgWindow == null) {
                            previewImgWindow = new PreviewImgWindow(this, s);
                        } else {
                            previewImgWindow.setImgPath(s);
                        }
                        popupWindowContainer.addView(previewImgWindow.getView(), layoutParams);
                        if (previewImgWindow.getView() != null) {
                            previewImgWindow.getView().bringToFront();
                        }
                    }
                }));
        disposables.add(router.getSubjectByKey(EventKey.NewMsgCount)
                .ofType(Integer.class)
                .observeOn(AndroidSchedulers.mainThread())
                .subscribe(integer -> {
                    TextView tvChatName = findViewById(R.id.tv_chat_name);
                    if (tvChatName != null) {
                        String chatName = getString(R.string.bjysc_chat);
                        if (integer > 0) {
                            chatName += getString(R.string.bjysc_brackets_nums, integer);
                        }
                        tvChatName.setText(chatName);
                    }
                }));

        disposables.add(router.getSubjectByKey(EventKey.ShowMessageSendFragment)
                .ofType(String.class)
                .observeOn(AndroidSchedulers.mainThread())
                .subscribe(message -> {
                    if (messageSendFragment == null) {
                        messageSendFragment = new GroupMessageSendFragment();
                        messageSendFragment.setMessageCallBack(new GroupMessageSendFragment.MessageSendCallBack() {
                            @Override
                            public void onMessageEdited(@NotNull String message) {
                                if (chatWindow != null) {
                                    chatWindow.setMessageText(message);
                                }
                            }

                            @Override
                            public void onSendEmoji() {
                                chatWindow.showEmojiMenu();
                            }

                            @Override
                            public void onSendPicture() {
                                chatWindow.showPictureSelect();
                            }

                            @Override
                            public void onSendMessage(@NotNull String message) {
                                chatWindow.sendTextMessage(message);
                            }
                        });
                    }
                    messageSendFragment.setMessage(message);
                    messageSendFragment.setQuickReplyList(chatWindow.getQuickReplyList());
                    if (messageSendFragment.isAdded()) {
                        return;
                    }
                    final Fragment fragment = getSupportFragmentManager().findFragmentByTag(messageSendFragment.getClass().getSimpleName());
                    if (fragment instanceof DialogFragment) {
                        ((DialogFragment) fragment).dismissAllowingStateLoss();
                    }
                    messageSendFragment.show(getSupportFragmentManager(), messageSendFragment.getClass().getName());
                    getSupportFragmentManager().executePendingTransactions();
                }));

        disposables.add(router.getSubjectByKey(EventKey.SettingWindow)
                .ofType(Boolean.class)
                .observeOn(AndroidSchedulers.mainThread())
                .subscribe(show -> {
                    if (show) {
                        if (settingWindow == null) {
                            settingContainer.removeAllViews();
                            settingWindow = new SettingWindow(this);
                            settingWindow.setMusicModeChangeListener(isOpen ->
                                    isMusicModeOn = isOpen
                            );
                            FrameLayout.LayoutParams layoutParams = new FrameLayout.LayoutParams(
                                    UtilsKt.getDp(520),
                                    UtilsKt.getDp(300)
                            );
                            layoutParams.gravity = Gravity.CENTER;
                            settingContainer.addView(settingWindow.getView(), layoutParams);
                        }
                    } else {
                        if (settingWindow != null) {
                            settingContainer.removeAllViews();
                            settingWindow.onDestroy();
                            settingWindow = null;
                        }
                    }
                }));

        disposables.add(router.getSubjectByKey(EventKey.ReportDialog)
                .observeOn(AndroidSchedulers.mainThread())
                .subscribe(obj -> {
                    showReportDialog(obj instanceof IMessageModel ? (IMessageModel) obj : null);
                }));
    }

    private void showReportDialog(@Nullable IMessageModel messageModel) {
        ReportDialog reportDialog = new ReportDialog(this,
                (int) getResources().getDimension(R.dimen.bjy_base_live_report_dialog_width),
                (int) getResources().getDimension(R.dimen.bjy_base_live_report_dialog_height));
        reportDialog.setSubmitListener(reasonList -> {
            disposables.add(router.getLiveRoom().report(reasonList, messageModel)
                    .subscribe(aBoolean -> {
                        router.getSubjectByKey(EventKey.ReminderMessage).onNext(getString(R.string.bjy_base_submit_success));
                    }, throwable -> {
                        router.getSubjectByKey(EventKey.ReminderErrorMessage).onNext(getString(R.string.bjy_base_submit_fail));
                    }));
            reportDialog.dismiss();
        });
        reportDialog.setHotlineInfo(
                router.getLiveRoom().getPartnerConfig().reportTelephone,
                router.getLiveRoom().getPartnerConfig().reportEmail
        );
        reportDialog.show();
    }

    /**
     * 把videoWindow移到黑板区
     *
     * @param videoWindow 目标VideoWindow
     * @param max         true: 移到黑板区放大 false: 移到黑板区
     */
    private void moveVideoWindowToBlackboard(VideoWindow videoWindow, boolean max) {
        float scale = VideoContainerWindow.JOIN_BLACKBOARD_RATIO * VideoContainerWindow.PRESS_SCALE_RATIO;
        if (router.getLiveRoom().getSmallClassTemplateType() == LPConstants.SmallClassTemplateType.ONEONONE) {
            if (DisplayUtils.isPad(this)) {
                scale = VideoContainerWindow.ONE2ONE_PRESS_SCALE_RATIO * VideoContainerWindow.ONE2ONE_JOIN_SCALE_RATIO_PAD;
            } else {
                scale = VideoContainerWindow.ONE2ONE_PRESS_SCALE_RATIO * VideoContainerWindow.ONE2ONE_PRESS_SCALE_RATIO;
            }
        }
        Set<LPPlayerViewUpdateModel.PlayerPosition> allSet = router.getSetByKey(EventKey.AllPlayerViewList, LPPlayerViewUpdateModel.PlayerPosition.class);
        LPPlayerViewUpdateModel model = new LPPlayerViewUpdateModel();
        model.action = LPConstants.LPPlayerAction.ADD;
        model.id = model.mediaId = FECompatUtil.getIOSMediaIdFromMediaId(videoWindow.getMediaId());
        LPPlayerViewUpdateModel.PlayerPosition playerPosition = new LPPlayerViewUpdateModel.PlayerPosition();
        playerPosition.id = model.id;
        playerPosition.width = String.valueOf(videoWindow.getView().getWidth() * scale / syncContainer.getWidth());
        playerPosition.height = String.valueOf(videoWindow.getView().getHeight() * scale / syncContainer.getHeight());
        playerPosition.x = String.valueOf((syncContainer.getWidth() - videoWindow.getView().getWidth() * scale) / (2 * syncContainer.getWidth()));
        playerPosition.y = String.valueOf((syncContainer.getHeight() - videoWindow.getView().getHeight() * scale) / (2 * syncContainer.getHeight()));
        playerPosition.max = max ? 1 : 0;
        if (null == allSet) {
            allSet = new HashSet<>();
        }
        allSet.add(playerPosition);
        router.setObjectByKey(EventKey.AllPlayerViewList, allSet);
        model.all = allSet;
        router.getLiveRoom().getMediaVM().requestPlayerViewUpdate(model);
    }

    public void checkColorIndex(int index) {
        //颜色,更新所有颜色
        //画笔和马克笔上面有4种线宽，图像则有9个图像+4个线宽
        drawWidthMenuForBrush.checkedColorIndex(index + 4);
        drawWidthMenuForMarker.checkedColorIndex(index + 4);
        graphMenu.checkedColorIndex(index + 9 + 4);
        drawTextMenu.checkedColorIndex(index);
    }

    public void checkIndex(int index) {
        drawWidthMenuForBrush.checkedIndex(index);
        drawWidthMenuForMarker.checkedIndex(index);
        graphMenu.checkedIndex(index + 9);
    }

    @SuppressLint("ClickableViewAccessibility")
    private void initView() {
        clContainer = findViewById(R.id.activity_group_class_room_root_container);
        eyeCareWindow = findViewById(R.id.activity_group_class_eye_care_layer);
        roomBackgroundContainer = findViewById(R.id.activity_group_class_room_background_container);
        if (router.getLiveRoom().getStudyRoomVM().isStudyRoom()) {
            final StudyRoomContainer studyRoomContainer = findViewById(R.id.activity_group_study_room_container);
            studyRoomContainer.setVisibility(View.VISIBLE);
            videoContainer = studyRoomContainer;
        } else {
            SeatContainer seatContainer = findViewById(R.id.activity_group_class_video_container);
            seatContainer.setVisibility(View.VISIBLE);
            videoContainer = seatContainer;
        }
        syncContainer = findViewById(R.id.activity_group_class_sync_container);
        videoDragContainer = findViewById(R.id.activity_group_class_video_drag_container);
        menuContainer = findViewById(R.id.activity_group_class_menu_container);
        statusBarContainer = findViewById(R.id.activity_group_class_status_bar_container);
        fullContainer = findViewById(R.id.activity_group_class_full_container);
        fullBgContainer = findViewById(R.id.activity_group_class_full_bg_container);
        settingContainer = findViewById(R.id.activity_group_class_setting_window_container);
        popupWindowContainer = findViewById(R.id.activity_group_class_popup_window_container);
        popupWindowContainer.setBackgroundColor(ContextCompat.getColor(this, R.color.base_half_black));
        popupWindowContainer.setOnTouchListener((v, event) -> true);
        chatWindowContainer = findViewById(R.id.activity_group_class_chat_window_container);
        userWindowContainer = findViewById(R.id.activity_group_class_user_window_container);
        userWindowContainer.setVisibility(View.GONE);
        userWindowContainer.setBackgroundColor(ContextCompat.getColor(this, router.getLiveRoom().isTeacherOrAssistant() ? R.color.bjysc_half_black : R.color.base_transparent));
        bonusPointsContainer = findViewById(R.id.activity_group_class_bonus_points_window_container);
        bonusPointsContainer.setVisibility(View.GONE);
        bonusPointsContainer.setBackgroundColor(ContextCompat.getColor(this, R.color.bjysc_half_black));
        videoMenuContainer = findViewById(R.id.activity_group_class_video_menu_container);
        awardView = findViewById(R.id.award_view);
        chatFloatWindowRecyclerView = findViewById(R.id.float_chat_window_rv);
        InputMethodManager imm = (InputMethodManager) getSystemService(Context.INPUT_METHOD_SERVICE);
        if (imm != null && imm.isActive()) {
            imm.hideSoftInputFromWindow(getWindow().getDecorView().getWindowToken(), 0);
        }

        fullContainer.setOnUpdateLayoutParamsListener(new DragRelativeLayout.OnUpdateLayoutParamsListener() {
            @Override
            public void onUpdateLayoutParams(int left, int top, int right, int bottom) {
                // do nothing
            }

            @Override
            public void onActionDown() {
                removeAllFunctionToolbarWindow();
            }
        });
        roomBackgroundContainer.setBgUrl(router.getLiveRoom().getRoomBackgroundUrl());
    }

    private void closeScreenShareDialog() {
        NoteDialog noteDialog = new NoteDialog();
        noteDialog.setDimAmount(1.0f);
        noteDialog.setHideCheckBox(true);
        noteDialog.setHideAssistantText(true);
        noteDialog.setMainText(getString(R.string.bjy_base_screen_share_stop_title));
        noteDialog.setAssistantText("");
        noteDialog.setOnPositiveClickListener((dialog1, checked1) -> screenShareHelper.stopScreenCapture());
        noteDialog.show(getSupportFragmentManager(), "screen share stop");
    }

    private void initChatWindow() {
        //避免初始化两次
        if (chatWindow == null) {
            chatWindow = new ChatWindow(GroupClassActivity.this);
        }
        if (getLiveRoom() != null && getLiveRoom().getPartnerConfig().enableFloatChatPanel) {
            router.getSubjectByKey(EventKey.DisplayFloatChat).onNext(true);
        }
    }

    private void setFloatChatWindowVisible(boolean show) {
        chatFloatWindowRecyclerView.setVisibility(show && !router.getLiveRoom().enableFixChatPanel1v1() ? View.VISIBLE : View.GONE);
        if (show) {
            if (floatChatMessageAdapter == null) {
                floatChatMessageAdapter = new FloatChatMessageAdapter(this, router);
                chatFloatWindowRecyclerView.setLayoutManager(new LinearLayoutWrapManager(this));
                chatFloatWindowRecyclerView.setAdapter(floatChatMessageAdapter);
            }
            floatChatMessageAdapter.subscribe();
        } else {
            if (floatChatMessageAdapter != null) {
                floatChatMessageAdapter.unSubscribe();
            }
        }
    }

    private boolean checkClassStart() {
        if (!router.getLiveRoom().isClassStarted()) {
            router.getSubjectByKey(EventKey.ReminderMessage).onNext(getString(R.string.base_class_not_start_tips));
            return false;
        }
        return true;
    }

    /**
     * 切换PopupWindow状态
     *
     * @param popupWindow popupWindow
     * @param anchor      为空则隐藏 popupWindow
     */
    private void changePopupWindowState(BaseAutoArrangePopupWindow popupWindow, View anchor) {
        if (popupWindow == null) {
            return;
        }
        if (anchor != null && !popupWindow.isShowing()) {
            popupWindow.initLimitView(new WeakReference<>(syncContainer));
            popupWindow.show(anchor);
            return;
        }
        if (anchor == null && popupWindow.isShowing()) {
            popupWindow.dismiss();
        }
    }

    /**
     * 移除 toolbar 的所有附带相关挂件
     */
    private void removeAllFunctionToolbarWindow() {
        changePopupWindowState(drawWidthMenuForBrush, null);
        changePopupWindowState(drawWidthMenuForMarker, null);
        changePopupWindowState(drawTextMenu, null);
        changePopupWindowState(graphMenu, null);

        if (drawTextEdit != null && drawTextEdit.getParent() != null) {
            syncContainer.invalidateTextBoundary();
        }
        removeViewFromParent(drawTextEdit);
    }

    /**
     * 移除 toolbar 本身以及 附带相关挂件
     */
    private void removeAllToolbarWindow(boolean removeFullToolbar) {
        if (toolbarWindow != null) {
            removeViewFromParent(toolbarWindow.getView());
        }
        if (removeFullToolbar && fullContainer != null && fullContainer.getToolBarVindow() != null) {
            removeViewFromParent(fullContainer.getToolBarVindow().getView());
        }

        removeAllFunctionToolbarWindow();

        router.getSubjectByKey(EventKey.LaserDrawEnable).onNext(false);
    }

    private void removeAllToolbarWindow() {
        removeAllToolbarWindow(true);
    }

    private void enterRoom(boolean isReEnterRoom, boolean checkUnique) {
        this.isReEnterRoom = isReEnterRoom;
        isReconnect = false;
        LiveSDK.checkTeacherUnique = checkUnique;
        loadingWindow = new LoadingWindow(this);
        loadingWindow.checkDevice(() -> {
            LiveRoom liveRoom;
            if (localSaveBundle.getSerializable("code") == null) {
                liveRoom = LiveSDK.enterRoom(this, (LPSignEnterRoomModel) localSaveBundle.getSerializable("sign"), roomStatusListener);
            } else {
                liveRoom = LiveSDK.enterRoom(this, (LPJoinCodeEnterRoomModel) localSaveBundle.getSerializable("code"), roomStatusListener);
            }
            //attention 重进需要传入新的liveRoom, SyncContainer没有重新创建不会重新走init()，不能直接new router
            if (isReEnterRoom) {
                router.setLiveRoom(liveRoom);
            } else {
                router = new RouterImpl(liveRoom);
            }
            subscribeWithEventKey();
            //默认拉小流
            liveRoom.setRemoteDefaultVideoStreamType(BJYRtcCommon.DualStreamType.VIDEO_STREAM_LOW);
            return null;
        });
    }

    private boolean isTeacherOrAssistant() {
        if (router.getLiveRoom().getCurrentUser() == null) {
            return false;
        } else {
            return (router.getLiveRoom().getCurrentUser().getType() == LPConstants.LPUserType.Teacher
                    || router.getLiveRoom().getCurrentUser().getType() == LPConstants.LPUserType.Assistant);
        }
    }

    private void initSuccess() {
        ThemeDataUtil.initThemeConfig(router.getLiveRoom().getRoomInfo().customColor);
        skinInflateFactory.updateTheme(ThemeDataUtil.getThemeConfig());
        LiveSDK.checkTeacherUnique = false;
        router.getLiveRoom().getRecorder().setCaptureVideoDefinition(InteractiveClassUI.defaultResolution);
        router.getLiveRoom().getRecorder().enableDualStreamMode(true);
        if (isMusicModeOn) {
            router.getLiveRoom().getRecorder().changeMusicModeOn(isMusicModeOn);
        }
        router.getSubjectByKey(EventKey.ReminderMessage).onNext(getString(R.string.bjysc_enter_room_success));
        LPSdkVersionUtils.setSdkVersion(LPSdkVersionUtils.SMALL_CLASS_UI.concat(BuildConfig.VERSION_NAME));

        if (!hasSetContentView) {
            if (router.getLiveRoom().getSmallClassTemplateType() == LPConstants.SmallClassTemplateType.ONEONONE) {
                setContentView(R.layout.bjysc_activity_oneonone_class);
                final ConstraintLayout.LayoutParams layoutParams = (ConstraintLayout.LayoutParams) findViewById(R.id.activity_group_class_room_real_container).getLayoutParams();
                if (DisplayUtils.isAspectRatioSmall(this)) {
                    layoutParams.dimensionRatio = "H,16:9";
                } else {
                    layoutParams.dimensionRatio = "W,16:9";
                }
            } else {
                setContentView(R.layout.bjysc_activity_group_class);
                changeLayoutParams();
            }
            initView();
            hasSetContentView = true;
        }
        if (router.getLiveRoom().getSmallClassTemplateType() == LPConstants.SmallClassTemplateType.ONEONONE) {
            changeOneOnOneTemplateParams();
        }
        subscribeWithLiveRoom();
        router.getSubjectByKey(EventKey.DisplayEyeCare).onNext(eyeCareWindow.getVisibility() == View.VISIBLE);
        if (statusBarWindow != null) {
            removeViewFromParent(statusBarWindow.getView());
            statusBarWindow.onDestroy();
            statusBarWindow = null;
        }
        statusBarWindow = new StatusBarWindow(this);
        statusBarContainer.addView(statusBarWindow.getView());
        syncContainer.initView();
        // showToolbarWindow 应在 syncContainer.initView() 后，因为断线重连后 黑板销毁，
        // 需要在 syncContainer 初始化后再 操作，Bugly id : #303221
        showToolbarWindow();
        notifyRoomStatusChange(true);
        videoContainer.initVideo();
        videoDragContainer.addView(videoContainer.getVideoDragLayer());
        initSwitchLayout();
        //提前初始化chatPresenter
        initChatWindow();
        if (router.getLiveRoom().enableFixChatPanel1v1()) {
            removeViewFromParent(chatWindow.getView());
            chatWindowContainer.addView(chatWindow.getView());
            chatWindowContainer.setVisibility(View.GONE);
        }
        checkStudyRoomNote();
    }

    //改变1v1布局
    private void changeOneOnOneTemplateParams() {
        final ConstraintLayout.LayoutParams topSeatParams = (ConstraintLayout.LayoutParams) findViewById(R.id.rl_placeholder_top).getLayoutParams();
        final ConstraintLayout.LayoutParams bottomSeatParams = (ConstraintLayout.LayoutParams) findViewById(R.id.rl_placeholder_bottom).getLayoutParams();
        final View viewPlaceholderBottom = findViewById(R.id.view_placeholder_bottom);
        final ConstraintLayout.LayoutParams placeholderBottomParams = (ConstraintLayout.LayoutParams) viewPlaceholderBottom.getLayoutParams();
        final ConstraintLayout.LayoutParams chatContainerParams = (ConstraintLayout.LayoutParams) chatWindowContainer.getLayoutParams();
        topSeatParams.dimensionRatio = bottomSeatParams.dimensionRatio = "H,16:9";
        if (router.getLiveRoom().enableFixChatPanel1v1()) {
            View chatBtn = findViewById(R.id.activity_group_class_chat_container);
            chatBtn.setOnClickListener(v -> router.getSubjectByKey(EventKey.DisplayChat).onNext(true));
            findViewById(R.id.view_gap_top).setVisibility(View.GONE);
            findViewById(R.id.view_gap_bottom).setVisibility(View.GONE);
            placeholderBottomParams.topMargin = UtilsKt.getDp(1);
            roomBackgroundContainer.setBackgroundColor(Color.BLACK);
            if (DisplayUtils.isPad(this)) {
                chatContainerParams.width = 0;
                chatContainerParams.height = 0;
                chatContainerParams.startToStart = R.id.activity_group_class_video_container;
                chatContainerParams.endToEnd = R.id.activity_group_class_video_container;
                chatContainerParams.topToBottom = R.id.activity_group_class_guide_line;
                chatContainerParams.topToTop = ConstraintSet.UNSET;
                chatContainerParams.bottomToBottom = ConstraintSet.PARENT_ID;
                router.getSubjectByKey(EventKey.DisplayChat).onNext(true);
                chatBtn.setVisibility(View.GONE);
            } else {
                chatContainerParams.width = 0;
                chatContainerParams.height = 0;
                chatContainerParams.startToStart = R.id.activity_group_class_video_container;
                chatContainerParams.endToEnd = R.id.activity_group_class_video_container;
                chatContainerParams.topToTop = R.id.activity_group_class_video_container;
                chatContainerParams.topToBottom = ConstraintSet.UNSET;
                chatContainerParams.bottomToBottom = ConstraintSet.PARENT_ID;
                chatBtn.setVisibility(View.VISIBLE);
            }
            chatContainerParams.startToEnd = ConstraintSet.UNSET;
        } else {
            findViewById(R.id.view_gap_top).setVisibility(View.INVISIBLE);
            findViewById(R.id.view_gap_bottom).setVisibility(View.INVISIBLE);
            placeholderBottomParams.topMargin = UtilsKt.getDp(8);
            roomBackgroundContainer.setBackgroundColor(ThemeDataUtil.getColorFromThemeConfigByAttrId(this, R.attr.base_theme_window_assistant_text_color));
            chatContainerParams.width = getResources().getDimensionPixelSize(R.dimen.bjysc_chat_window_width);
            chatContainerParams.height = 0;
            chatContainerParams.startToStart = ConstraintSet.UNSET;
            chatContainerParams.endToEnd = ConstraintSet.UNSET;
            chatContainerParams.topToBottom = ConstraintSet.UNSET;
            chatContainerParams.topToTop = R.id.activity_group_class_sync_container;
            chatContainerParams.bottomToBottom = R.id.activity_group_class_sync_container;
            chatContainerParams.startToEnd = R.id.activity_group_class_left_tool_container;
        }
        viewPlaceholderBottom.post(() -> {
            //不能调整topToBottom因为viewPlacehodlerBottom不能作为guideLine的id
            final ConstraintLayout.LayoutParams guideLineParams = (ConstraintLayout.LayoutParams) findViewById(R.id.activity_group_class_guide_line).getLayoutParams();
            guideLineParams.topMargin = viewPlaceholderBottom.getBottom();
        });
    }

    /**
     * 自习室公告
     */
    private void checkStudyRoomNote() {
        if (!hasShowStudyNote && router.getLiveRoom().getStudyRoomVM().isStudyRoom()) {
            disposables.add(router.getLiveRoom().getStudyRoomVM().getObservableOfStudyRoomNote()
                    .observeOn(AndroidSchedulers.mainThread())
                    .filter(lpStudyRoomNote -> !TextUtils.isEmpty(lpStudyRoomNote.title) || !TextUtils.isEmpty(lpStudyRoomNote.content))
                    .subscribe(lpStudyRoomNote -> {
                        StudyNoteDialog studyNoteDialog = new StudyNoteDialog();
                        studyNoteDialog.setStudyRoomNote(lpStudyRoomNote);
                        showDialogFragment(studyNoteDialog);
                        hasShowStudyNote = true;
                    }, throwable -> {
                    }));
        }
    }

    /**
     * 默认模板 原本手机默认W,16:10 pad默认H,16:10改为判断宽高比
     */
    private void changeLayoutParams() {
        final double screenAspectRatio = DisplayUtils.getScreenAspectRatio(this);
        final ViewGroup.LayoutParams layoutParams = findViewById(R.id.activity_group_class_room_root_container).getLayoutParams();
        if (layoutParams instanceof ConstraintLayout.LayoutParams) {
            ConstraintLayout.LayoutParams params = (ConstraintLayout.LayoutParams) layoutParams;
            //宽高比小于16：10 例如16：11
            if (screenAspectRatio < DisplayUtils.ASPECT_RATIO_16_10 || DisplayUtils.ASPECT_RATIO_16_10.equals(screenAspectRatio)) {
                params.dimensionRatio = "H,16:10";
            } else {
                //宽高比小于16：10 例如16：9
                params.dimensionRatio = "W,16:10";
            }
        }

        final ViewGroup.LayoutParams fullContainerParams = findViewById(R.id.activity_group_class_full_container).getLayoutParams();
        if (layoutParams instanceof ConstraintLayout.LayoutParams) {
            final ConstraintLayout.LayoutParams params = (ConstraintLayout.LayoutParams) fullContainerParams;
            if (screenAspectRatio < DisplayUtils.ASPECT_RATIO_16_9 || DisplayUtils.ASPECT_RATIO_16_9.equals(screenAspectRatio)) {
                params.dimensionRatio = "H,16:9";
            } else {
                params.dimensionRatio = "W,16:9";
            }
        }
    }

    /**
     * initSuccess之后的liveRoom信令订阅
     */
    private void subscribeWithLiveRoom() {
        enterRoomSuccess = true;
        if (router.getLiveRoom().getCurrentUser().getType() == LPConstants.LPUserType.Assistant) {
            router.getLiveRoom().getOnlineUserVM().requestRemoveActiveUser(router.getLiveRoom().getCurrentUser());
        }

        disposables.add(router.getLiveRoom().getChatVM()
                .getObservableOfReceiveMessage()
                .subscribe(iMessageModel -> {
                    router.getSubjectByKey(EventKey.ChatMessageReceived).onNext(true);
                }));

        disposables.add(router.getLiveRoom().getDocListVM().getPublishSubjectOfStudentPPTAuth()
                .filter(strings -> !BaseUtilsKt.isAdmin(router.getLiveRoom()))
                .map(userNumbers -> userNumbers.contains(router.getLiveRoom().getCurrentUser().getNumber()))
                .mergeWith(router.getLiveRoom().getSpeakQueueVM().getPublishSubjectOfStudentDrawingAuth())
                .mergeWith(router.getLiveRoom().getMediaVM().getPublishSubjectOfStudentScreenShare()
                        .filter(new Predicate<List<String>>() {
                            @Override
                            public boolean test(@NonNull List<String> strings) throws Exception {
                                for (String s : strings) {
                                    if (s.equals(router.getLiveRoom().getCurrentUser().getNumber())) {
                                        return true;
                                    }
                                }
                                return false;
                            }
                        })
                        .map(new Function<List<String>, Boolean>() {
                            @Override
                            public Boolean apply(@NonNull List<String> strings) throws Exception {
                                return true;
                            }
                        }))
                .subscribe(o -> showToolbarWindow()));


        disposables.add(router.getLiveRoom().getObservableOfClassStart()
                .observeOn(AndroidSchedulers.mainThread())
                .subscribe(integer -> {
                    router.getSubjectByKey(EventKey.ReminderMessage).onNext(getString(R.string.bjysc_start_class));
                    router.getSubjectByKey(EventKey.CloseExpressionReportActivity).onNext(true);
                }));

        disposables.add(router.getLiveRoom().getObservableOfClassEnd()
                .observeOn(AndroidSchedulers.mainThread())
                .subscribe(integer -> {
                    if (router.getLiveRoom().getCurrentUser().getType() == LPConstants.LPUserType.Student
                            && router.getLiveRoom().isShowEvaluation()
                            && !router.getLiveRoom().getStudyRoomVM().isStudyRoom()
                            && !router.getLiveRoom().getStudyRoomVM().isFromTutorOutside()) {
                        showEvaluation();
                    }
                    if (router.getLiveRoom().getCurrentUser().getType() != LPConstants.LPUserType.Teacher) {
                        router.getSubjectByKey(EventKey.ReminderMessage).onNext(getString(R.string.bjysc_end_class));
                    }
                    router.getSubjectByKey(EventKey.CloseExpressionReportActivity).onNext(false);
                    if (router.getLiveRoom().getCurrentUser().getType() != LPConstants.LPUserType.Teacher) {
                        router.getSubjectByKey(EventKey.ReminderMessage).onNext(getString(R.string.bjysc_end_class));
                    }
                    if (BaseUtilsKt.isTeacher(router.getLiveRoom().getCurrentUser())) {
                        ((ReminderLayer) findViewById(R.id.activity_group_class_reminderlayer)).showStartClassButton();
                        router.getLiveRoom().requestCloudRecord(LPConstants.CloudRecordStatus.Stopped);
                    } else if (router.getLiveRoom().getCurrentUser().getType() == LPConstants.LPUserType.Assistant && router.getLiveRoom().getPartnerConfig().enableAssistantStartClass == 1) {
                        ((ReminderLayer) findViewById(R.id.activity_group_class_reminderlayer)).showStartClassButton();
                    }
                    if (router.getLiveRoom().getCurrentUser().getType() == LPConstants.LPUserType.Student
                            && router.getLiveRoom().isShowEvaluation()
                            && !router.getLiveRoom().getStudyRoomVM().isStudyRoom()
                            && !router.getLiveRoom().getStudyRoomVM().isFromTutorOutside()) {
                        showEvaluation();
                        return;
                    }
                    if (!router.getLiveRoom().getStudyRoomVM().isStudyRoom()
                            && isEnterExpReport
                            && router.getLiveRoom().getSmallClassTemplateType() != LPConstants.SmallClassTemplateType.ONEONONE
                            && router.getLiveRoom().getPartnerConfig().autoShowStudyReport
                            && router.getLiveRoom().getPartnerConfig().enableStudyReport) {
                        if (router.getLiveRoom().getCurrentUser().getType() == LPConstants.LPUserType.Student) {
                            showStudyReport();
                        } else if (router.getLiveRoom().getCurrentUser().getType() == LPConstants.LPUserType.Assistant) {
                            router.getSubjectByKey(EventKey.OpenExpressionReportActivity).onNext(LPConstants.HOSTS_WEB[LiveSDK.getDeployType().getType()]);
                        }
                    }
                }));

        disposables.add(router.getLiveRoom().getObservableOfLoginConflict()
                .observeOn(AndroidSchedulers.mainThread())
                .subscribe(iLoginConflictModel -> {
                    String endTypeName = InteractiveUtils.getEndTypeName(iLoginConflictModel.getConflictEndType());
                    if (isFinishing() || isDestroyed()) {
                        return;
                    }
                    if (router != null) {
                        notifyRoomStatusChange(false);
                        router.release();
                    }
                    release();
                    new CommonDialog(GroupClassActivity.this, CommonDialog.ChoiceMode.Single_Blue)
                            .setMainDisplayText(String.format(getString(R.string.bjysc_login_conflict), endTypeName))
                            .setPositive(getResources().getText(R.string.bjysc_confirm).toString(), ((dialog, which) -> {
                                GroupClassActivity.super.finish();
                            })).show();
                }));

        disposables.add(router.getLiveRoom().getOnlineUserVM().getObservableOfBlockedUser()
                .observeOn(AndroidSchedulers.mainThread())
                .subscribe(lpResRoomBlockedUserModel -> {
                    if (router.getLiveRoom().getCurrentUser().getType() == LPConstants.LPUserType.Teacher) {
                        router.getSubjectByKey(EventKey.ReminderMessage).onNext(getString(R.string.remove_from_class, router.getLiveRoom().getOnlineUserVM().getUserById(lpResRoomBlockedUserModel.to).getName()));
                    }
                }));

        disposables.add(router.getLiveRoom().getChatVM().getObservableOfIsSelfChatForbid()
                .subscribe(aBoolean -> {
                    if (aBoolean == isSelfForbidChat) {
                        return;
                    }
                    isSelfForbidChat = aBoolean;
                    if (aBoolean) {
                        router.getSubjectByKey(EventKey.ReminderMessage).onNext(getString(R.string.bjysc_reminder_forbid_chat));
                    } else {
                        router.getSubjectByKey(EventKey.ReminderMessage).onNext(getString(R.string.bjysc_reminder_un_forbid_chat));
                    }
                }));

        //被请出房间，logout
        disposables.add(router.getLiveRoom().getOnlineUserVM().getObservableOfKickOut()
                .observeOn(AndroidSchedulers.mainThread())
                .subscribe(lpError -> {
                    if (router != null) {
                        notifyRoomStatusChange(false);
                        router.release();
                    }
                    release();
                    if (lpError.getCode() == LPError.CODE_ERROR_LOGIN_KICK_OUT || lpError.getCode() == LPError.CODE_ERROR_LOGIN_KICK_OUT_WITHOUT_BLOCK) {
                        showKickOutDialog(lpError.getCode() == LPError.CODE_ERROR_LOGIN_KICK_OUT);
                    } else if (lpError.getCode() == LPError.CODE_ERROR_KICK_OUT_WITH_API) {
                        showApiKickOutDialog(lpError.getParams());
                    } else if (lpError.getCode() == LPError.CODE_ERROR_LOGIN_AUDITION) {
                        CommonDialog dlg = showErrorDialog(lpError.getMessage(), CommonDialog.ChoiceMode.Single_Red)
                                .setPositive(getString(R.string.bjysc_confirm_suffix, 5), (dialog, which) -> {
                                    GroupClassActivity.this.finish();
                                });
                        dlg.show();
                        disposableOfAuditionTimer = Observable.interval(0,1, TimeUnit.SECONDS)
                                .observeOn(AndroidSchedulers.mainThread())
                                .subscribe(aLong -> {
                                    dlg.refreshPositive(getString(R.string.bjysc_confirm_suffix, 5 - aLong));
                                    if (aLong == 5) {
                                        RxUtils.dispose(disposableOfAuditionTimer);
                                        finish();
                                    }
                                });
                    } else {
                        showErrorDialog(lpError.getMessage(), CommonDialog.ChoiceMode.Single_Red)
                                .setPositive(getString(R.string.bjysc_confirm), (dialog, which) -> {
                                    GroupClassActivity.this.finish();
                                })
                                .show();
                    }
                }));

        disposables.add(router.getLiveRoom().getToolBoxVM().getObservableOfAttentionDetection()
                .observeOn(AndroidSchedulers.mainThread())
                .filter(lpJsonModel -> !BaseUtilsKt.isAdmin(router.getLiveRoom()))
                .subscribe(lpJsonModel -> router.getLiveRoom().getToolBoxVM().requestAttentionReport(
                        isFocus(this), (LPUserModel) router.getLiveRoom().getCurrentUser())));

        disposables.add(router.getLiveRoom().getToolBoxVM().getObservableOfAttentionAlert()
                .observeOn(AndroidSchedulers.mainThread())
                .subscribe(this::showToastMessage));

        disposables.add(router.getLiveRoom().getObservableOfRoomReload()
                .subscribe(lpResRoomReloadModel -> {
                    if (lpResRoomReloadModel.eventType.equals("webrtc_type_change")) {
                        actionRoomReload();
                    }
                }));

        disposables.add(router.getLiveRoom().getObservableOfWebrtcChange()
                .subscribe(lpResRoomReloadModel -> {
                    actionRoomReload();
                }));
        disposables.add(router.getLiveRoom().getRecorder().getObservableOfCameraOn()
                .observeOn(AndroidSchedulers.mainThread())
                .subscribe(aBoolean -> {
                    if (qrCodeDialog != null && qrCodeDialog.isAdded()) {
                        qrCodeDialog.dismissAllowingStateLoss();
                    }
                    //关闭扫码视频后打开本地视频
                    if (!aBoolean && attachLocalVideo) {
                        attachLocalVideo = false;
                        router.getPublishSubjectByKey(EventCode.AttachVideo).onNext(true);
                    }
                }));
        disposables.add(router.getLiveRoom().getSpeakQueueVM().getObservableOfStopAsCamera()
                .observeOn(AndroidSchedulers.mainThread())
                .subscribe(aBoolean -> {
                    qrCodeUrl = "";
                }));
        disposables.add(router.getLiveRoom().getStudyRoomVM().getObservableOfStudyRoomSwitch()
                .observeOn(AndroidSchedulers.mainThread())
                .subscribe(studyRoomMode -> {
                    if (toolbarWindow != null && toolbarWindow.getView() != null) {
                        toolbarWindow.getView().setVisibility(studyRoomMode.isGalleryLayout() ? View.GONE : View.VISIBLE);
                    }
                    //切换模式老师需要重新进入
                    final Boolean isReEnterRoom = router.getValueByKey(EventKey.StudyReEnterRoom, Boolean.class);
                    if (isReEnterRoom != null && isReEnterRoom) {
                        return;
                    }
                    if (router.getLiveRoom().getCurrentUser().getType() == LPConstants.LPUserType.Teacher && studyRoomMode.isGalleryLayout()) {
                        disposableOfReEnter = router.getLiveRoom().getStudyRoomVM().getObservableOfReEnterInfo()
                                .observeOn(AndroidSchedulers.mainThread())
                                .subscribe(lpStudyReEnterInfo ->
                                        router.getSubjectByKey(EventKey.StudyReEnterRoom).onNext(lpStudyReEnterInfo.code), throwable -> {
                                });
                    }
                    router.getSubjectByKey(EventKey.StudyRoomSwitch).onNext(studyRoomMode);
                    //切换模式之后重新请求，避免在辅导模式切换过来不能显示时间
                    if (studyRoomMode.isGalleryLayout()) {
                        router.getLiveRoom().getStudyRoomVM().requestActiveUserStatus();
                    }
                    clContainer.post(() -> {
                        if (videoContainer != null) {
                            videoContainer.switchStudyRoomMode(studyRoomMode);
                        }
                    });
                }));
        router.getLiveRoom().getToolBoxVM().setOnRollCallListener(new OnPhoneRollCallListener() {
            @Override
            public void onRollCall(int time, RollCall rollCallListener) {
                showRollCall(time, rollCallListener);
                router.getSubjectByKey(EventKey.ShowRollCallDot).onNext(true);
            }

            @Override
            public void onRollCallTimeOut() {
                dismissRollCall();
                router.getSubjectByKey(EventKey.ShowRollCallDot).onNext(false);
            }
        });
        disposables.add(router.getLiveRoom().getToolBoxVM().getObservableOfRollCallResult()
                .observeOn(AndroidSchedulers.mainThread())
                .subscribe(lpRoomRollCallResultModel1 -> {
                    if (BaseUtilsKt.isAdmin(router.getLiveRoom())) {
                        BaseUtilsKt.setRollCallStatus(RollCallStatus.CoolDown);
                        rollCallTime = ROLL_CALL_CD_TIME;
                        startRollCallTimer(false);
                        this.lpRoomRollCallResultModel = lpRoomRollCallResultModel1;
                        router.getSubjectByKey(EventKey.OpenAdminRollCallWindow).onNext(new Pair<>(rollCallTime, lpRoomRollCallResultModel));
                    }
                }));
        disposables.add(router.getLiveRoom().getStudyRoomVM().getObservableOfTutorClose()
                .observeOn(AndroidSchedulers.mainThread())
                .subscribe(this::showStudyCloseDialog));

        disposables.add(router.getLiveRoom().getToolBoxVM().getObservableOfBonusPointsRemainUpdate()
                .observeOn(AndroidSchedulers.mainThread())
                .subscribe(lpBonusPointRemain -> {
                    if (!lpBonusPointRemain.success) {
                        showToastMessage(getString(R.string.base_bouns_points_not_enough_tip));
                    }
                }));

        disposables.add(router.getLiveRoom().getObservableOfRedPacket()
                .observeOn(AndroidSchedulers.mainThread())
                .subscribe(this::showRedPacketDlg));

        disposables.add(router.getSubjectByKey(EventKey.MusicMode)
                .ofType(Boolean.class)
                .observeOn(AndroidSchedulers.mainThread())
                .subscribe(isOpen -> {
                    isMusicModeOn = isOpen;
                }));
    }

    private void showStudyCloseDialog(boolean hasTimer) {
        String mainText;
        String assistantText;
        String positiveText;
        if (BaseUtilsKt.isAdmin(router.getLiveRoom())) {
            mainText = getString(hasTimer ? R.string.bjysc_study_room_question_tutor_close_student_not_enter : R.string.bjysc_study_room_question_tutor_student_close);
            assistantText = getString(R.string.bjysc_study_room_question_tutor_close_teacher_not_enter_assistant);
        } else {
            mainText = getString(hasTimer ? R.string.bjysc_study_room_question_tutor_close_teacher_not_enter : R.string.bjysc_study_room_question_tutor_teacher_close);
            assistantText = getString(R.string.bjysc_study_room_question_tutor_close_student_not_enter_assistant);
        }
        positiveText = hasTimer ? getString(R.string.bjysc_study_room_question_back_1v1_tutor_countdown, 5) : getString(R.string.base_confirm);
        TimerNoteDialog timerNoteDialog = new TimerNoteDialog();
        timerNoteDialog.setMainText(mainText);
        timerNoteDialog.setHasTimer(hasTimer);
        timerNoteDialog.setAssistantText(assistantText);
        timerNoteDialog.setPositiveText(positiveText);
        if (!hasTimer) {
            timerNoteDialog.setOnPositiveClickListener((dialog, checked) -> {
                dialog.dismissAllowingStateLoss();
                back2PreviousPage();
            });
        }
        timerNoteDialog.setCountDownListener(new OnCountDownListener() {
            @Override
            public void onTimeOut() {
                timerNoteDialog.dismissAllowingStateLoss();
                back2PreviousPage();
            }

            @Override
            public void onTimeCountDown(int counter, int timeOut) {
                timerNoteDialog.setText(getString(R.string.bjysc_study_room_question_back_1v1_tutor_countdown, timeOut - counter));
            }
        });
        timerNoteDialog.setWidth(getResources().getDimensionPixelSize(R.dimen.bjy_base_common_dialog_container_width));
        timerNoteDialog.setHeight(getResources().getDimensionPixelSize(R.dimen.bjy_base_common_dialog_container_height));
        timerNoteDialog.show(getSupportFragmentManager(), "showStudyCloseDialog");
    }

    private void back2PreviousPage() {
        if (BaseUtilsKt.isAdmin(router.getLiveRoom())) {
            finish();
        } else {
            String code = localSaveBundle.getString("code_copy");
            router.getSubjectByKey(EventKey.StudyReEnterRoom).onNext(TextUtils.isEmpty(code) ? "" : code);
        }
    }

    //退后台不切教室，回到前台再重进教室 #7136 避免界面黑屏问题
    private boolean reEnterOnBackground = false;
    private boolean isAppBackground = false;

    private void actionRoomReload() {
        router.getSubjectByKey(EventKey.ReminderErrorMessage).onNext(getString(R.string.switch_webrtc_type));
        disposables.add(Observable.timer(1 + new Random().nextInt(3), TimeUnit.SECONDS)
                .observeOn(AndroidSchedulers.mainThread())
                .subscribe(aLong -> {
                    if (isAppBackground) {
                        reEnterOnBackground = true;
                        release();
                        if (router != null) {
                            if (hasSetContentView) {
                                notifyRoomStatusChange(false);
                            }
                            router.getLiveRoom().quitRoom();
                            router.clear();
                        }
                    } else {
                        reEnterRoom(true, true);
                    }
                }));
    }

    /**
     * 显示课后评价
     */
    public void showEvaluation() {
        if (evaDialogFragment != null) {
            dismissDialog(evaDialogFragment);
        }
        evaDialogFragment = new EvaDialogFragment();
        EvaDialogPresenter evaDialogPresenter = new EvaDialogPresenter(evaDialogFragment);
        LPJsonModel lpJsonModel = new LPJsonModel();
        JsonObject data = new JsonObject();
        data.addProperty("message_type", "class_end");
        lpJsonModel.data = data;
        evaDialogFragment.onClassEnd(lpJsonModel);
        evaDialogPresenter.setLiveRoom(router.getLiveRoom());
        evaDialogPresenter.setDismissCallback(() -> router.getPublishSubjectByKey(EventCode.DismissEvaDialog).onNext(true));
        bindVP(evaDialogFragment, evaDialogPresenter);
        showDialogFragment(evaDialogFragment);
    }

    /**
     * 显示学生的学情报告
     */
    public void showStudyReport() {
        studyReportDialogFragment = new StudyReportDialogFragment();
        StudyReportDialogPresenter studyReportDialogPresenter = new StudyReportDialogPresenter(studyReportDialogFragment, this);
        bindVP(studyReportDialogFragment, studyReportDialogPresenter);
        showDialogFragment(studyReportDialogFragment);
    }

    public void dismissDialog(BaseDialogFragment dialogFragment) {
        if (dialogFragment != null && dialogFragment.isAdded()) {
            dialogFragment.dismissAllowingStateLoss();
        }
    }

    private <V extends BaseView<P>, P extends BaseGroupPresenter> void bindVP(V view, P presenter) {
        presenter.setRouter(router);
        view.setPresenter(presenter);
    }

    private <V extends BaseView<P>, P extends BasePresenter> void bindVP(V view, P presenter) {
        view.setPresenter(presenter);
    }

    private boolean hasPPTAuth() {
        if (router == null) {
            return false;
        }
        List<String> userNumbers = router.getLiveRoom().getDocListVM().getPublishSubjectOfStudentPPTAuth().getValue();
        return isTeacherOrAssistant() || (userNumbers != null && userNumbers.contains(router.getLiveRoom().getCurrentUser().getNumber()));
    }

    private boolean hasScreenShareAuth() {
        if (router == null) {
            return false;
        }
        List<String> userNumbers = router.getLiveRoom().getMediaVM().getStudentScreenShareList();
        return isTeacherOrAssistant() || (userNumbers != null && userNumbers.contains(router.getLiveRoom().getCurrentUser().getNumber()));
    }

    private boolean hasSbbDrawingAuth() {
        if (router == null) {
            return false;
        }
        Object auth = router.getSubjectByKey(EventKey.SbbShowToolBarWindow).getValue();
        return auth instanceof Integer && ((Integer) auth) == 1;
    }

    private boolean hasDrawingAuth() {
        return router.getLiveRoom().getSpeakQueueVM().getDrawingAuth();
    }

    /**
     * 更新toolbarWindow状态
     */
    private void showToolbarWindow() {
        boolean showBrush =  isTeacherOrAssistant()|| hasSbbDrawingAuth() || hasDrawingAuth();
        if (isFullScreenOn) {
            if (fullContainer.getToolBarVindow().getParentViewGroup() == null) {
                fullContainer.addToolbarWindow();
            }
        }
        boolean isFull = false;
        if (fullContainer.getToolBarVindow() != null) {
            //控制显示隐藏，全屏切换仍走add和remove
            fullContainer.getToolBarVindow().getView().bringToFront();
            fullContainer.getToolBarVindow().updateView(hasPPTAuth(), showBrush, hasScreenShareAuth());
            isFull = true;
        }
        if (showBrush || hasPPTAuth() || hasScreenShareAuth()) {
            if (toolbarWindow == null) {
                initToolbarViews();
            }
            removeAllToolbarWindow(!isFull);
            if (router.getLiveRoom().getCurrentRoomLayout() == LPConstants.RoomLayoutMode.GALLERY) {
                return;
            }
            toolbarWindow.updateView(hasPPTAuth(), showBrush, hasScreenShareAuth());
            menuContainer.addView(toolbarWindow.getView());
            router.getSubjectByKey(EventKey.ResetToolbarStatus).onNext(true);
        } else {
            removeAllToolbarWindow();
        }
    }

    private void initSwitchLayout() {
        if (router.getLiveRoom().getStudyRoomVM().isStudyRoom()) {
            return;
        }
        disposables.add(router.getLiveRoom().getObservableOfRoomLayoutSwitch()
                .observeOn(AndroidSchedulers.mainThread())
                .subscribe(this::switchLayout));
        switchLayout(router.getLiveRoom().getCurrentRoomLayout());
    }

    private void switchLayout(LPConstants.RoomLayoutMode layoutMode) {
        if (layoutMode == null) {
            return;
        }
        switch (layoutMode) {
            case GALLERY:
                //画廊布局
                videoContainer.switchLayoutMode(false);
                removeAllToolbarWindow();
                syncContainer.setVisibility(View.INVISIBLE);
                fullContainer.setVisibility(View.INVISIBLE);
                break;
            case BOARD:
                //板书布局
                videoContainer.switchLayoutMode(true);
                showToolbarWindow();
                syncContainer.setVisibility(View.VISIBLE);
                fullContainer.setVisibility(View.VISIBLE);
                break;
            case SPEECH:
                //演讲布局,暂时没有
                break;
        }
    }

    private void reconnect() {
        isReconnect = true;
        isFullScreenOn = false;
        fullBgContainer.setVisibility(View.GONE);
        enterRoomSuccess = false;
        if (screenShareHelper != null) {
            screenShareHelper.destroy();
            screenShareHelper = null;
        }
        removeAllFragment();
        removeAllToolbarWindow();
        //attention 手动destroy videoWindow，尝试解决 https://bugly.qq.com/v2/crash-reporting/crashes/d80df85494/264594/report?pid=1&crashDataType=undefined
        if (videoContainer != null) {
            videoContainer.release();
        }
        router.clear();
        subscribeWithEventKey();
        notifyRoomStatusChange(false);
        router.getLiveRoom().reconnect(roomStatusListener);
    }

    private void showToastMessage(String message) {
        new ToastUtil(this).setText(message).show();
    }

    private GraphMenuWindow graphMenu;
    private DrawWidthSettingWindow drawWidthMenuForMarker;
    private DrawWidthSettingWindow drawWidthMenuForBrush;
    private DrawTextSettingWindow drawTextMenu;
    private View drawTextEdit;
    private TextEditWindow textEditWindow;
    private BitmapSettingWindow bitmapSettingWindow;
    private View bitmapShapeSettingBar;
    private ToolbarWindow toolbarWindow;

    private void initToolbarViews() {
        if (toolbarWindow == null) {
            toolbarWindow = new ToolbarWindow(this, false);
            toolbarWindow.setOnUpdateLayoutParamsListener(new DragRelativeLayout.OnUpdateLayoutParamsListener() {
                @Override
                public void onUpdateLayoutParams(int left, int top, int right, int bottom) {
                    // do nothing
                }

                @Override
                public void onActionDown() {
                    //清空当前事件
                    removeAllFunctionToolbarWindow();
                }
            });
            menuContainer.addOnLayoutChangeListener((v, left, top, right, bottom, oldLeft, oldTop, oldRight, oldBottom) -> {
                toolbarWindow.setDragParam(right - left, bottom - top);
            });
        }

        drawTextMenu = new DrawTextSettingWindow(this, router);
        graphMenu = new GraphMenuWindow(this, router);
        drawWidthMenuForBrush = new DrawWidthSettingWindow(false, this, router);
        drawWidthMenuForMarker = new DrawWidthSettingWindow(true, this, router);

        bitmapSettingWindow = new BitmapSettingWindow(this);
        bitmapShapeSettingBar = bitmapSettingWindow.getView();


        textEditWindow = new TextEditWindow(this);
        drawTextEdit = textEditWindow.getView();
    }

    @Override
    public IRouter getRouter() {
        return router;
    }

    @Override
    public void addRoomStatusListener(IRoomStatusListener listener) {
        roomStatusListeners.add(listener);
        if (isRoomActive) {
            listener.onRoomStatusChange(true);
        }
    }

    @Override
    public void removeRoomStatusListener(IRoomStatusListener listener) {
        roomStatusListeners.remove(listener);
    }

    private boolean isRoomActive;

    private void notifyRoomStatusChange(boolean isRoomActive) {
        this.isRoomActive = isRoomActive;
        for (IRoomStatusListener listener : roomStatusListeners) {
            listener.onRoomStatusChange(isRoomActive);
        }
    }

    private void showKickOutDialog(boolean isBlock) {
        NoteDialog noteDialog = new NoteDialog();
        noteDialog.setMainText(getString(R.string.kicked_out_tips));
        String blockTip = isBlock ? getString(R.string.kicked_out_assistant_block) : getString(R.string.kicked_out_assistant_without_block);
        noteDialog.setAssistantText(blockTip);
        noteDialog.setPositiveText(getString(R.string.base_live_confirm));
        noteDialog.setHideNegativeButton(true);
        noteDialog.setHideCheckBox(true);
        noteDialog.setPositiveTextColor(ThemeDataUtil.getColorFromThemeConfigByAttrId(this, R.attr.base_theme_dialog_positive_text_color));
        noteDialog.setOnPositiveClickListener((dialog, checked) -> {
            GroupClassActivity.this.finish();
        });
        showDialogFragment(noteDialog);
    }

    private void showKickOutDialog(IUserModel userModel) {
        NoteDialog noteDialog = new NoteDialog();
        noteDialog.setMainText(getString(R.string.kick_out_tips, userModel.getName()));
        noteDialog.setAssistantText(getString(R.string.kick_out_block_tips));
        noteDialog.setNegativeText(getString(R.string.base_cancel));
        noteDialog.setPositiveText(getString(R.string.base_ui_kickout_room));
        noteDialog.setPositiveTextColor(ContextCompat.getColor(this, R.color.base_white));
        noteDialog.setPositiveBackgroundDrawable(new DrawableBuilder()
                .solidColor(ContextCompat.getColor(this, R.color.base_warning_color))
                .cornerRadius(getResources().getDimensionPixelSize(R.dimen.bjy_base_common_bg_radius))
                .build());
        noteDialog.setOnPositiveClickListener((dialog, checked) -> {
            if (checked != null) {
                router.getLiveRoom().getOnlineUserVM().requestKickOutUser(userModel.getUserId(), checked);
            }
        });
        showDialogFragment(noteDialog);
    }

    private void showApiKickOutDialog(JsonObject params) {
        String content = params.get("content").getAsString();
        Long countdown = params.get("countdown").getAsLong();
        TimerNoteDialog timerNoteDialog = new TimerNoteDialog();
        timerNoteDialog.setMainText(content);
        timerNoteDialog.setPositiveText(getString(R.string.bjysc_confirm_with_countdown, countdown));
        timerNoteDialog.setHasTimer(true);
        timerNoteDialog.setTimerCount(countdown);
        timerNoteDialog.setHideAssistantText(true);
        timerNoteDialog.setOnPositiveClickListener((dialog, checked) -> {
            timerNoteDialog.dismissAllowingStateLoss();
            GroupClassActivity.this.finish();
        });
        timerNoteDialog.setCountDownListener(new OnCountDownListener() {
            @Override
            public void onTimeOut() {
                timerNoteDialog.dismissAllowingStateLoss();
                GroupClassActivity.this.finish();
            }

            @Override
            public void onTimeCountDown(int counter, int timeOut) {
                timerNoteDialog.setText(getString(R.string.bjysc_confirm_with_countdown, timeOut - counter));
            }
        });
        timerNoteDialog.show(getSupportFragmentManager(), "showApiKickOutDialog");
    }

    private CommonDialog showErrorDialog(String mainTips, CommonDialog.ChoiceMode choiceMode) {
        return new CommonDialog(GroupClassActivity.this, choiceMode)
                .setMainDisplayText(mainTips)
                .setNegative(getString(R.string.bjysc_cancel), ((dialog, which) -> dialog.dismiss()))
                .setPositive(getString(R.string.bjysc_confirm), ((dialog, which) -> {

                }));
    }

    private void showReEnterDialog(LPError lpError, String errorMessage) {
        if (errorDialog != null) {
            errorDialog.dismiss();
        }
        String mainText = "";
        String negativeText = getString(R.string.bjysc_back);
        String positiveText = getString(R.string.bjysc_reenter);
        CommonDialog.ChoiceMode choiceMode = CommonDialog.ChoiceMode.Double_Blue;
        if (lpError != null) {
            negativeText = getString(R.string.bjysc_i_know);
            if (lpError.getCode() == LPError.CODE_ERROR_NEW_SMALL_COURSE) {
                choiceMode = CommonDialog.ChoiceMode.Single_Blue;
            } else if (lpError.getCode() == LPError.CODE_ERROR_LOGIN_UNIQUE_CONFLICT) {
                positiveText = getString(R.string.bjysc_enter_room);
                mainText = getString(R.string.bjysc_login_conflict_tip) + "\n"
                        + getString(R.string.bjysc_teacher_in);
            }
        }

        if (!TextUtils.isEmpty(errorMessage)) {
            mainText = errorMessage;
        }
        if (TextUtils.isEmpty(mainText) && lpError != null) {
            mainText = lpError.getMessage();
        }
        //网络断开 提示：网络连接失败，您可以退出或者继续
        if (lpError != null) {
            if (lpError.getCode() == LPError.CODE_ERROR_NETWORK_FAILURE) {
                mainText = getString(R.string.bjysc_reconnect_tip);
            }
            negativeText = getString(R.string.bjysc_exit_room);
            positiveText = getString(R.string.bjysc_reconnect_continue);
        }

        errorDialog = new CommonDialog(GroupClassActivity.this, choiceMode)
                .setMainDisplayText(mainText)
                .setCancelOnPressBack(false)
                .setNegativeType((lpError != null && lpError.getCode() == LPError.CODE_ERROR_NETWORK_FAILURE)
                        ? CommonDialog.NegativeType.Red : CommonDialog.NegativeType.Gray)
                .setNegative(negativeText, ((dialog, which) -> {
                    dialog.cancel();
                    finish();
                }))
                .setPositive(positiveText, ((dialog, which) -> {
                    if (lpError != null) {
                        if (isReconnect) {
                            disposables.clear();
                            reconnect();
                        } else {
                            reEnterRoom(true,
                                    lpError.getCode() != LPError.CODE_ERROR_LOGIN_UNIQUE_CONFLICT);
                        }
                    }
                }));
        errorDialog.show();
    }

    @Override
    protected void onActivityResult(int requestCode, int resultCode, Intent data) {
        if (screenShareHelper != null) {
            screenShareHelper.onActivityResult(requestCode, resultCode, data);
        }
        if (resultCode == Activity.RESULT_OK && data != null) {
            if (BaseUIConstant.UploadType.containsValue(requestCode)) {
                Uri uri = data.getData();
                try {
                    if (uri != null) {
                        String path = FileUtils.getPath(this, uri);

                        if (path == null) {
                            showToastMessage("文件路径不存在");
                            return;
                        }
                        Map<BaseUIConstant.UploadType, String> value = new HashMap<>();
                        BaseUIConstant.UploadType uploadType = BaseUIConstant.UploadType.valueOf(requestCode);
                        if (uploadType != null) {
                            value.put(uploadType, path);
                        }
                        router.getSubjectByKey(EventKey.UploadPPTPath).onNext(value);
                    }
                } catch (Exception e) {
                    if (router != null) {
                        router.getSubjectByKey(EventKey.ReminderMessage).onNext("无法加载文件夹内课件");
                    }
                    e.printStackTrace();
                }
            }
        }
        super.onActivityResult(requestCode, resultCode, data);
    }

    @Override
    public void onBackPressed() {
        if (drawTextEdit != null && drawTextEdit.getParent() != null) {
            HashMap<String, String> map = new HashMap<>();
            map.put("end", "true");
            router.getSubjectByKey(EventKey.DrawTextSend).onNext(map);
            return;
        }

        if (router != null && enterRoomSuccess) {
            router.getSubjectByKey(EventKey.CloseDialog).onNext(true);
        } else {
            super.onBackPressed();
        }
    }

    private boolean isSelfActive() {
        return router != null && router.getLiveRoom() != null && router.getLiveRoom().getOnlineUserVM() != null
                && router.getLiveRoom().getOnlineUserVM().isActiveUser(router.getLiveRoom().getCurrentUser());
    }

    @Override
    protected void onResume() {
        super.onResume();
        if (screenShareHelper != null) {
            screenShareHelper.refresh();
        }
        if (enterRoomSuccess && isSelfActive() && (screenShareHelper == null || !screenShareHelper.isScreenSharing())) {
            router.getLiveRoom().getOnlineUserVM().updateMediaState();
        }
        getWindow().addFlags(WindowManager.LayoutParams.FLAG_KEEP_SCREEN_ON);
        isAppBackground = false;
        if (reEnterOnBackground) {
            reEnterRoom(true, true);
        }
        reEnterOnBackground = false;
    }

    @Override
    protected void onStop() {
        super.onStop();
        if (screenShareHelper != null && !isFinishing() && !isDestroyed()) {
            screenShareHelper.refresh();
        }
        if (enterRoomSuccess && isSelfActive() && (screenShareHelper == null || !screenShareHelper.isScreenSharing())) {
            router.getLiveRoom().getOnlineUserVM().updateMediaState();
        }
        getWindow().clearFlags(WindowManager.LayoutParams.FLAG_KEEP_SCREEN_ON);
        isAppBackground = true;
    }

    @Override
    protected void onDestroy() {
        super.onDestroy();
        disposables.dispose();
        RxUtils.dispose(disposableOfAuditionTimer);
        RxUtils.dispose(disposableOfCourseware);
        release();
        if (router != null) {
            router.release();
        }
        roomStatusListeners.clear();
        //删除上传课件的临时文件夹
        FileUtils.safeDeleteFile(FileUtils.getFileUploadDir(this));
        ThemeDataUtil.clearConfig();
        if (floatChatMessageAdapter != null) {
            floatChatMessageAdapter.unSubscribe();
        }
    }

    private void resetAudioMode() {
        AudioManager audioManager = (AudioManager) getSystemService(Context.AUDIO_SERVICE);
        if (audioManager != null) {
            audioManager.setMode(AudioManager.MODE_NORMAL);
        }
    }

    private void release() {
        if (screenShareHelper != null) {
            screenShareHelper.destroy();
            screenShareHelper = null;
        }
        if (toolboxWindow != null) {
            toolboxWindow.dismiss();
            toolboxWindow = null;
        }
        if (exitDialog != null && exitDialog.isShowing()) {
            exitDialog.cancel();
        }
        if (helpDialog != null && helpDialog.isShowing()) {
            helpDialog.cancel();
        }

        if (closeBrowserDialog != null && closeBrowserDialog.isShowing()) {
            closeBrowserDialog.cancel();
        }

        if (networkTipsDialog != null && networkTipsDialog.isShowing()) {
            networkTipsDialog.cancel();
        }
        if (qrCodeDialog != null && qrCodeDialog.isAdded()) {
            qrCodeDialog.dismissAllowingStateLoss();
        }

        if (noteDialog != null && noteDialog.isAdded()) {
            noteDialog.dismissAllowingStateLoss();
        }

        if (quickQuestionWindow != null) {
            quickQuestionWindow.onDestroy();
            quickQuestionWindow = null;
        }
        if (questionRecordWindow != null) {
            questionRecordWindow.onDestroy();
            questionRecordWindow = null;
        }
        if (previewImgWindow != null) {
            previewImgWindow.onDestroy();
            previewImgWindow = null;
        }
        if (popupWindowContainer != null) {
            popupWindowContainer.removeAllViews();
            popupWindowContainer.setVisibility(View.GONE);
        }
        if (settingContainer != null) {
            settingContainer.removeAllViews();
        }
        if (settingWindow != null) {
            settingWindow.onDestroy();
            settingWindow = null;
        }
        if (chatWindow != null) {
            chatWindow.onDestroy();
            chatWindow = null;
        }
        removeAllFragment();
        if (statusBarWindow != null) {
            statusBarWindow.onDestroy();
        }

        disposables.clear();
        RxUtils.dispose(disposableOfQRCode);
        RxUtils.dispose(disposableOfReEnter);
        RxUtils.dispose(disposableOfQuestionBeforeClass);
        resetAudioMode();

        BaseUtilsKt.setRollCallStatus(RollCallStatus.None);
    }

    private void reEnterRoom(boolean isNeedLoading, boolean checkUnique) {
        reEnterRoom(isNeedLoading, checkUnique, false);
    }

    private void reEnterRoom(boolean isNeedLoading, boolean checkUnique, boolean reInit) {
        enterRoomSuccess = false;
        release();
        if (router != null) {
            if (hasSetContentView) {
                notifyRoomStatusChange(false);
            }
            router.getLiveRoom().quitRoom();
            router.clear();
        }
        if (reInit) {
            hasSetContentView = false;
        }
        enterRoom(true, checkUnique);
        if (isNeedLoading) {
            showLoading();
        }
    }

    protected void showDialogFragment(DialogFragment dialogFragment) {
        if (isFinishing() || isDestroyed()) {
            return;
        }
        closeExistSameDialog(dialogFragment);
        dialogFragment.show(getSupportFragmentManager(), dialogFragment.getClass().getSimpleName());
        getSupportFragmentManager().executePendingTransactions();
    }

    protected void removeAllFragment() {
        for (Fragment fragment : getSupportFragmentManager().getFragments()) {
            if (fragment != null) {
                getSupportFragmentManager().beginTransaction().remove(fragment).commitAllowingStateLoss();
            }
        }
    }

    private void closeExistSameDialog(DialogFragment dialogFragment) {
        final Fragment fragment = getSupportFragmentManager().findFragmentByTag(dialogFragment.getClass().getSimpleName());
        if (fragment instanceof DialogFragment) {
            ((DialogFragment) fragment).dismissAllowingStateLoss();
        }
    }

    @Override
    public void displayImage(List<String> imageUrl, int position) {
        ChatPictureViewFragment chatPictureViewFragment = ChatPictureViewFragment.newInstance((ArrayList<String>) imageUrl, position, Objects.requireNonNull(BaseUtilsKt.isAdmin(router.getLiveRoom())));
        chatPictureViewFragment.setCallback(new ChatPictureViewFragment.SimpleChatPicCallback() {
            @Override
            public void save(String url) {
                // 由ChatSavePicDialogFragment实现
                ChatSavePicDialogFragment fragment = new ChatSavePicDialogFragment(url);
                showDialogFragment(fragment);
            }

            @Override
            public void toCourseware(String url) {
                parseCourseware(url);
            }
        });
        showDialogFragment(chatPictureViewFragment);
    }

    Disposable disposableOfCourseware;

    public void parseCourseware(String url) {
        RxUtils.dispose(disposableOfCourseware);
        // 首先保存图片
        // 课件只能加载静态图片、gif保存为bitmap
        String[] permissions = new String[1];
        if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.TIRAMISU) {
            permissions[0] = Manifest.permission.READ_MEDIA_IMAGES;
        } else {
            permissions[0] = Manifest.permission.WRITE_EXTERNAL_STORAGE;
        }
        disposableOfCourseware = AppPermissions.newPermissions(this)
                .request(permissions)
                .filter(aBoolean -> {
                    if (!aBoolean) {
                        showToastMessage(getString(R.string.live_no_write_permission));
                    }
                    return aBoolean;
                })
                .flatMap(aBoolean -> LPObservable.create((ObservableOnSubscribe<String>) emitter -> {
                    BitmapDrawable bitmapDrawable;
                        final Bitmap bitmap = Glide.with(this)
                                .asBitmap()
                                .load(url)
                                .into(500, 500)
                                .get();
                        bitmapDrawable = new BitmapDrawable(null, bitmap);
                    File file = BaseUtilsKt.saveChatImageFile(bitmapDrawable
                            , "聊天图片(" + System.currentTimeMillis() + ").jpg");
                    if (file != null) {
                        emitter.onNext(file.getAbsolutePath());
                        emitter.onComplete();
                    }
                }))
                .subscribeOn(Schedulers.io())
                .observeOn(AndroidSchedulers.mainThread())
                .subscribe(this::transferToCourseware);
    }

    @Override
    public void transferToCourseware(String imagePath) {
        Map<BaseUIConstant.UploadType, String> value = new HashMap<>();
        value.put(BaseUIConstant.UploadType.TransferFromChatImg, imagePath);
        router.getSubjectByKey(EventKey.UploadPPTPath).onNext(value);
        showToastMessage(getString(R.string.bjy_group_transfer_to_courseware_success));
    }

    /**
     * 跑马灯
     */
    private void startMarqueeTape() {
        LPHorseLamp horseLamp = LiveSDK.horseLamp == null ? getRouter().getLiveRoom().getPartnerConfig().liveHorseLamp : LiveSDK.horseLamp;
        if (horseLamp == null) {
            return;
        }
        if (horseLamp.type == 4) {
            horseLamp.value = router.getLiveRoom().getCurrentUser().getNumber();
        }
        if (TextUtils.isEmpty(horseLamp.value)) {
            return;
        }
        if (horseLampView != null) {
            removeViewFromParent(horseLampView);
        }
        horseLampView = new HorseLampView(this);
        clContainer.addView(horseLampView, new ViewGroup.LayoutParams(ViewGroup.LayoutParams.MATCH_PARENT, ViewGroup.LayoutParams.MATCH_PARENT));
        horseLampView.startHorseLamp(horseLamp);
    }

    /**
     * 显示文字画笔输入框
     *
     * @param originText 初始值
     */
    private void showEditTextWindow(String originText) {
        if (isFullScreenOn) {
            if (drawTextEdit.getParent() == null) {
                fullContainer.addView(drawTextEdit);
            } else if (drawTextEdit.getParent() instanceof MenuContainer) {
                removeViewFromParent(drawTextEdit);
                fullContainer.addView(drawTextEdit);
            }
        } else {
            if (drawTextEdit.getParent() == null) {
                menuContainer.addView(drawTextEdit);
            } else if (drawTextEdit.getParent() instanceof FullScreenContainer) {
                removeViewFromParent(drawTextEdit);
                menuContainer.addView(drawTextEdit);
            }
        }
        if (textEditWindow != null) {
            textEditWindow.setEditText(originText);
        }
    }

    @Override
    protected void onSaveInstanceState(Bundle outState) {
        super.onSaveInstanceState(outState);
        outState.putAll(localSaveBundle);
    }

    /**
     * 显示loading
     */
    private void showLoading() {
        ViewGroup viewGroup = (ViewGroup) getWindow().getDecorView().getRootView();
        viewGroup.addView(loadingWindow.getView());
    }

    private void dismissLoadingWindow() {
        if (getParentViewGroup(loadingWindow.getView()) != null) {
            ((ViewGroup) getWindow().getDecorView().getRootView()).removeView(loadingWindow.getView());
        }
        if (!BaseUtilsKt.isAdmin(router.getLiveRoom())) {
            disposableOfQuestionBeforeClass = router.getLiveRoom().requestQuestionBeforeClass(LPDeviceUuidFactory.getInstance().getDeviceUuid(this).toString())
                    .observeOn(AndroidSchedulers.mainThread())
                    .subscribe(questionUrl -> {
                        if (!TextUtils.isEmpty(questionUrl)) {
                            QuestionDialogFragment questionDialogFragment = QuestionDialogFragment.newInstance(questionUrl);
                            questionDialogFragment.setOnSubmitQuestionListener(isSubmit -> {
                                if (isSubmit) {
                                    questionDialogFragment.dismissAllowingStateLoss();
                                } else {
                                    finish();
                                }
                            });
                            questionDialogFragment.show(getSupportFragmentManager(), QuestionDialogFragment.class.getName());
                        }
                    }, throwable -> {
                        // do nothing
                    });
        }
    }

    /**
     * 刷新pptView
     */
    private void updatePPTView(Boolean o) {
        syncContainer.updatePPTView(o);
    }


    private void showQRcodeDialog(String qrCodeUrl) {
        qrCodeDialog = new QRcodeDialog();
        Bundle bundle = new Bundle();
        String url = TextUtils.isEmpty(qrCodeUrl) ? "http:www.baijiayun.com" : qrCodeUrl;
        bundle.putString("url", url);
        qrCodeDialog.setArguments(bundle);
        qrCodeDialog.show(getSupportFragmentManager(), QRcodeDialog.class.getSimpleName());
    }

    private void startScannerCamera() {
        if (TextUtils.isEmpty(qrCodeUrl)) {
            disposableOfQRCode = router.getLiveRoom().getSpeakQueueVM().getObservableOfAsCameraUrl(0)
                    .observeOn(AndroidSchedulers.mainThread())
                    .subscribe(s -> {
                        qrCodeUrl = s;
                        showQRcodeDialog(s);
                    }, throwable -> {
                    });
        } else {
            showQRcodeDialog(qrCodeUrl);
        }
    }

    private void endScannerCamera() {
        noteDialog = new NoteDialog();
        noteDialog.setMainText(getString(R.string.base_live_scanner_ext_camera_end_tip));
        noteDialog.setAssistantText(getString(R.string.base_live_open_main_camera));
        noteDialog.setOnPositiveClickListener((dialog, checked) -> {
            router.getLiveRoom().getSpeakQueueVM().stopAsCameraUser();
            attachLocalVideo = checked != null && checked;
            qrCodeUrl = "";
        });
        noteDialog.setWidth(getResources().getDimensionPixelSize(R.dimen.bjy_base_common_dialog_container_width));
        noteDialog.setHeight(getResources().getDimensionPixelSize(R.dimen.bjy_base_common_dialog_container_height));
        noteDialog.show(getSupportFragmentManager(), QRcodeDialog.class.getSimpleName());
    }


    /**
     * 移除黑板区域所有的视频窗口
     */
    private void syncRemoveAllBlackboardVideoWindow() {
        Set<LPPlayerViewUpdateModel.PlayerPosition> allList = router.getSetByKey(EventKey.AllPlayerViewList, LPPlayerViewUpdateModel.PlayerPosition.class);
        if (null == allList) {
            return;
        }
        Iterator<LPPlayerViewUpdateModel.PlayerPosition> iterator = allList.iterator();
        while (iterator.hasNext()) {
            LPPlayerViewUpdateModel.PlayerPosition playerPosition = iterator.next();
            LPPlayerViewUpdateModel model = new LPPlayerViewUpdateModel();
            model.id = playerPosition.id;
            model.action = LPConstants.LPPlayerAction.REMOVE;
            iterator.remove();
            model.mediaId = playerPosition.mediaId;
            model.all = allList;
            router.getLiveRoom().getMediaVM().requestPlayerViewUpdate(model);
        }
    }

    @Override
    public LiveRoom getLiveRoom() {
        return router != null ? router.getLiveRoom() : null;
    }

    @Override
    public void onDismissAnswerer() {
        router.getSubjectByKey(EventKey.StudentAnswererWindow).onNext(false);
        router.getSubjectByKey(EventKey.TeacherAnswererWindow).onNext(false);
    }

    @Override
    public void onDismissRedPacketPublish() {
        // do nothing
    }

    private void showRedPacketDlg(LPRedPacketModel lpRedPacketModel) {
        if (redPacketPresenter != null && redPacketPresenter.isRobRedPacket()) {
            return;
        }
        redPacketFragment = RedPacketFragment.newInstance(lpRedPacketModel);
        redPacketPresenter = new RedPacketPresenter(redPacketFragment, lpRedPacketModel);
        redPacketPresenter.setRouter(this);
        redPacketFragment.setPresenter(redPacketPresenter);
        showDialogFragment(redPacketFragment);
    }

    private void dismissRedPacketDlg() {
        if (redPacketFragment != null && redPacketFragment.isAdded()) {
            redPacketFragment.dismissAllowingStateLoss();
            redPacketFragment = null;
            redPacketPresenter.unSubscribe();
            redPacketPresenter = null;
        }
    }

    private Disposable rollcallCdTimer;
    private LPRoomRollCallResultModel lpRoomRollCallResultModel;
    private int rollCallTime = 0;
    private int ROLL_CALL_CD_TIME = 60;

    private void startRollCallTimer(boolean isRollCallStatusGoing) {
        RxUtils.dispose(rollcallCdTimer);
        rollcallCdTimer = Observable.interval(1, TimeUnit.SECONDS)
                .observeOn(AndroidSchedulers.mainThread())
                .subscribe(aLong -> {
                    //点名计时器
                    rollCallTime--;
                    if (rollCallTime == 0) {
                        RxUtils.dispose(rollcallCdTimer);
                        if (!isRollCallStatusGoing) {
                            //点名cd完成 —> 结束状态
                            BaseUtilsKt.setRollCallStatus(RollCallStatus.End);
                            router.getSubjectByKey(EventKey.RollCallCountDown).onNext(new Pair<>(rollCallTime, false));
                        }
                        //倒计时结束会收到点名结果回调，这里状态不需要本地处理
                    } else {
                        router.getSubjectByKey(EventKey.RollCallCountDown).onNext(new Pair<>(rollCallTime, isRollCallStatusGoing));
                    }
                });
    }

    private void dismissRollCall() {
        router.getSubjectByKey(EventKey.CloseRollCallWindow).onNext(Unit.INSTANCE);
    }

    private void showRollCall(int time, OnPhoneRollCallListener.RollCall rollCallListener) {
        if (router.getLiveRoom().getCurrentUser().getType() == LPConstants.LPUserType.Student) {
            router.getSubjectByKey(EventKey.OpenStudentRollCallWindow).onNext(new Pair<>(time, rollCallListener));
            //小班老师，没有工具箱，不反应也不显示同步状态
        } else if (BaseUtilsKt.isAdmin(router.getLiveRoom())) {
            if (time == -1) {
                if (BaseUtilsKt.getRollCallStatus() == RollCallStatus.None) {
                    lpRoomRollCallResultModel = null;
                    BaseUtilsKt.setRollCallStatus(RollCallStatus.Start);
                    router.getSubjectByKey(EventKey.OpenAdminRollCallWindow).onNext(new Pair<>(rollCallTime, null));
                } else {
                    if (lpRoomRollCallResultModel != null) {
                        router.getSubjectByKey(EventKey.OpenAdminRollCallWindow).onNext(new Pair<>(rollCallTime, lpRoomRollCallResultModel));
                    } else {
                        router.getSubjectByKey(EventKey.OpenAdminRollCallWindow).onNext(new Pair<>(rollCallTime, null));
                    }
                }
            } else {
                RxUtils.dispose(rollcallCdTimer);
                BaseUtilsKt.setRollCallStatus(RollCallStatus.Going);
                rollCallTime = time;
                router.getSubjectByKey(EventKey.OpenAdminRollCallWindow).onNext(new Pair<>(time, null));
                startRollCallTimer(true);
            }
        }
    }

    @Override
    public void onDismissRollCall(boolean isAdmin) {
        router.getSubjectByKey(EventKey.CloseRollCallWindow).onNext(Unit.INSTANCE);
    }

    @Override
    public void inviteToSpeak(@NotNull LPUserModel user) {
        LPUserModel winner = (LPUserModel) router.getLiveRoom().getOnlineUserVM().getUserByNumber(user.number);
        if (winner == null) {
            showToastMessage(getString(R.string.base_responder_winner_out));
            return;
        }
        List<IUserModel> curList = router.getLiveRoom().getOnlineUserVM().getActiveUserList();
        // 新list避免影响对activeList
        List<IUserModel> curNewList = new ArrayList<>();
        if (curList != null) {
            for (IUserModel iUserModel : curList) {
                if (iUserModel.getType() != LPConstants.LPUserType.Teacher) {
                    curNewList.add(iUserModel);
                }
            }
        }
        if (router.getLiveRoom().getOnlineUserVM().isActiveUser(winner)) {
            List<IMediaModel> activeUserList = router.getLiveRoom().getSpeakQueueVM().getActiveUserList();
            for (int i = 0; i < activeUserList.size(); i++) {
                if (TextUtils.equals(activeUserList.get(i).getUser().getUserId(), winner.userId)) {
                    if (!activeUserList.get(i).isVideoOn() || !activeUserList.get(i).isAudioOn()) {
                        router.getLiveRoom().getSpeakQueueVM().controlRemoteUser(winner.userId, true, true);
                    } else {
                        showToastMessage(getString(R.string.base_student_has_been_actived));
                    }
                    return;
                }
            }
        } else if (curNewList.size() >= router.getLiveRoom().getMaxActiveUsers()) {
            ReplaceUserWithStatus replaceUserWithStatus = new ReplaceUserWithStatus(user);
            replaceUserWithStatus.isHandsUp = true;
            replaceUserWithStatus.isResponder = true;
            ReplaceWindowGenerateUtil.generateWindow(this, router, replaceUserWithStatus);
        } else {
            router.getLiveRoom().getSpeakQueueVM().controlRemoteUser(winner.userId, true, true);
        }
    }

    @Override
    public void switchRedPacketUI(boolean isShow, @Nullable LPRedPacketModel lpRedPacketModel) {
        if (isShow) {
            showRedPacketDlg(lpRedPacketModel);
        } else {
            dismissRedPacketDlg();
        }
    }

    @Override
    public void onRepublishRedPacket() {
        // do nothing
    }

    @Override
    public void onDismissAnnouncement() {
        // do nothing
    }

    @Override
    public void onDismissQAInteractive() {
        // do nothing
    }

    @Override
    public void onDismissSetting() {
        router.getSubjectByKey(EventKey.SettingWindow).onNext(false);
    }

    @Override
    public void onDismissAdminTimer() {
        // do nothing
    }

    @Override
    public boolean isTvModel() {
        return false;
    }
}