package com.baijiayun.groupclassui.layer;

import android.content.Context;
import android.util.AttributeSet;
import android.view.Gravity;
import android.view.View;
import android.view.ViewGroup;
import android.widget.FrameLayout;
import android.widget.ImageView;

import androidx.annotation.NonNull;
import androidx.annotation.Nullable;

import com.baijiayun.bjyutils.kt.UtilsKt;
import com.baijiayun.groupclassui.R;

/**
 * Created by Shubo on 2019/3/19.
 */
public class VideoLayer extends BaseLayerOfProfessionalClass {

    private ImageView imgMusicPlay;

    public VideoLayer(@NonNull Context context) {
        super(context);
    }

    public VideoLayer(@NonNull Context context, @Nullable AttributeSet attrs) {
        super(context, attrs);
    }

    public VideoLayer(@NonNull Context context, @Nullable AttributeSet attrs, int defStyleAttr) {
        super(context, attrs, defStyleAttr);
    }

    public VideoLayer(@NonNull Context context, @Nullable AttributeSet attrs, int defStyleAttr, int defStyleRes) {
        super(context, attrs, defStyleAttr, defStyleRes);
    }

    @Override
    protected void init() {
        super.init();
        imgMusicPlay = new ImageView(getContext());
        imgMusicPlay.setImageResource(R.drawable.ic_music_play);
        FrameLayout.LayoutParams lp = new FrameLayout.LayoutParams(ViewGroup.LayoutParams.WRAP_CONTENT, ViewGroup.LayoutParams.WRAP_CONTENT);
        lp.gravity = Gravity.END;
        lp.topMargin = UtilsKt.getDp(4);
        lp.rightMargin = UtilsKt.getDp(4);
        addView(imgMusicPlay, lp);
        hideMusicPlayIcon();
    }

    public void showMusicPlayIcon(){
        imgMusicPlay.setVisibility(View.VISIBLE);
    }

    public void hideMusicPlayIcon(){
        imgMusicPlay.setVisibility(View.GONE);
    }
}
