package com.baijiayun.groupclassui.user

import android.content.Context
import android.view.View
import androidx.appcompat.app.AppCompatActivity
import com.baijiayun.groupclassui.R
import com.baijiayun.groupclassui.global.EventKey
import com.baijiayun.groupclassui.global.IRouter
import com.baijiayun.groupclassui.window.InteractiveBaseWindow
import com.baijiayun.livebase.utils.ThemeDataUtil

class StudentOnlineUserWindow(context: Context, val router: IRouter) : InteractiveBaseWindow(context) {

    private var onlineUserListFragment: AllOnlineUserListFragment? = null

    override fun onCreateView(context: Context): View {
        val view = View.inflate(context, R.layout.bjy_group_dialog_student_online_user, null)
        view.background = ThemeDataUtil.getCommonWindowBg(context)
        return view
    }

    private fun initView() {
        setAllowTouch(true)
        `$`.id(R.id.online_user_close_iv).clicked {
            router.getSubjectByKey<Any>(EventKey.DisplayUserList).onNext(UserStatus.Close)
        }
        onlineUserListFragment = AllOnlineUserListFragment.newInstance()
        if (context == null) return
        (context as AppCompatActivity).supportFragmentManager
            .beginTransaction()
            .replace(R.id.online_user_container, onlineUserListFragment!!)
            .commitAllowingStateLoss()
    }

    private fun removeAllFragment() {
        if (context == null) return
        for (fragment in (context as AppCompatActivity).supportFragmentManager.fragments) {
            if (fragment != null) {
                (context as AppCompatActivity).supportFragmentManager
                    .beginTransaction()
                    .remove(fragment)
                    .commitAllowingStateLoss()
            }
        }
    }

    override fun onDestroy() {
        super.onDestroy()
        removeAllFragment()
    }

    override fun onRoomStatusChange(isActive: Boolean): Boolean {
        val isWindowInit = super.onRoomStatusChange(isActive)
        if (isWindowInit) {
            if (!isActive) {
                removeAllFragment()
            } else {
                initView()
            }
        }
        return true
    }
}