package com.baijiayun.groupclassui.widget;

import android.content.Context;
import android.content.res.ColorStateList;
import androidx.annotation.Nullable;
import androidx.core.content.ContextCompat;
import androidx.appcompat.widget.AppCompatEditText;
import android.util.AttributeSet;

import com.baijiayun.groupclassui.R;
import com.baijiayun.livebase.utils.ThemeDataUtil;

/**
 * Created by pengwenjian on 2020/6/30
 * Describe:
 */
public class TimerEditText extends AppCompatEditText {
    public TimerEditText(Context context) {
        this(context,null);
    }

    public TimerEditText(Context context, @Nullable AttributeSet attrs) {
        this(context, attrs,0);
    }

    public TimerEditText(Context context, @Nullable AttributeSet attrs, int defStyleAttr) {
        super(context, attrs, defStyleAttr);
        init(context);
    }

    private void init(Context context) {
        int[][] states = new int[3][];
        states[0] = new int[]{android.R.attr.state_enabled};
        states[1] = new int[]{android.R.attr.state_focused};
        states[2] = new int[]{};
        int[] colors = new int[]{ThemeDataUtil.getColorFromThemeConfigByAttrId(context, R.attr.base_theme_window_main_text_color),
                ContextCompat.getColor(context, R.color.bjysc_warning_color), ContextCompat.getColor(context, R.color.bjysc_warning_color)};
        ColorStateList colorStateList = new ColorStateList(states, colors);
        setTextColor(colorStateList);
        setFocusableInTouchMode(true);
    }
}
