package com.baijiayun.groupclassui.window;

import androidx.lifecycle.LifecycleObserver;
import android.content.Context;

import com.baijiayun.groupclassui.global.EventKey;
import com.baijiayun.groupclassui.global.IRouter;
import com.baijiayun.liveuibase.widgets.popupwindow.BaseAutoArrangePopupWindow;

import io.reactivex.disposables.Disposable;

public abstract class BasePopupWindow extends BaseAutoArrangePopupWindow implements LifecycleObserver {

    private Disposable disposableOfColorAllChange;
    protected IRouter iRouter;

    public BasePopupWindow(Context context) {
        this(context, null);
    }

    public BasePopupWindow(Context context, IRouter iRouter) {
        super(context);
        this.iRouter = iRouter;
    }

    /**
     * 初始化颜色选中
     */
    @Override
    protected boolean initColorsSelect() {
        boolean rst = super.initColorsSelect();
        if (rst) {
            if (disposableOfColorAllChange != null) {
                disposableOfColorAllChange.dispose();
            }
            disposableOfColorAllChange = iRouter.getSubjectByKey(EventKey.DrawColorAllChange)
                    .ofType(String.class)
                    .subscribe(this::handleColorAllChangeRst);
        }
        return rst;
    }

    public void onDestroy() {
        if (disposableOfColorAllChange != null) {
            disposableOfColorAllChange.dispose();
            disposableOfColorAllChange = null;
        }
    }
}
