package com.baijiayun.groupclassui.window.bottommenu;

import android.animation.Animator;
import android.animation.AnimatorSet;
import android.animation.ObjectAnimator;
import android.annotation.SuppressLint;
import android.content.Context;
import android.graphics.Color;
import android.graphics.drawable.ColorDrawable;
import android.graphics.drawable.Drawable;
import android.text.TextUtils;
import android.view.Gravity;
import android.view.LayoutInflater;
import android.view.MotionEvent;
import android.view.View;
import android.view.ViewGroup;
import android.widget.FrameLayout;
import android.widget.ImageView;
import android.widget.PopupWindow;
import android.widget.TextView;

import androidx.annotation.DrawableRes;
import androidx.annotation.NonNull;
import androidx.appcompat.app.AppCompatActivity;
import androidx.core.content.ContextCompat;
import androidx.fragment.app.FragmentActivity;

import com.baijiayun.bjyutils.drawable.DrawableBuilder;
import com.baijiayun.bjyutils.kt.UtilsKt;
import com.baijiayun.bjyutils.log.LPLogger;
import com.baijiayun.bjyutils.reactivex.RxUtils;
import com.baijiayun.bjyutils.screen.DisplayUtils;
import com.baijiayun.groupclassui.R;
import com.baijiayun.groupclassui.dialog.HandsUpRemindPopupWindow;
import com.baijiayun.groupclassui.dialog.StudyHangDialog;
import com.baijiayun.groupclassui.dialog.StudyRankDialog;
import com.baijiayun.groupclassui.dialog.TimerNoteDialog;
import com.baijiayun.groupclassui.global.EventCode;
import com.baijiayun.groupclassui.global.EventKey;
import com.baijiayun.groupclassui.user.UserStatus;
import com.baijiayun.groupclassui.widget.ToggleSpeakerVolumeView;
import com.baijiayun.groupclassui.window.InteractiveBaseWindow;
import com.baijiayun.groupclassui.window.study.DisplayStudyQuestion;
import com.baijiayun.groupclassui.window.study.QuestionNewWindow;
import com.baijiayun.groupclassui.window.study.QuestionSelectWindow;
import com.baijiayun.groupclassui.window.study.StudyModeWindow;
import com.baijiayun.livebase.context.LPConstants;
import com.baijiayun.livebase.utils.ThemeDataUtil;
import com.baijiayun.livebase.widgets.dialog.CommonDialog;
import com.baijiayun.livebase.widgets.dialog.NoteDialog;
import com.baijiayun.livecore.listener.OnCountDownListener;
import com.baijiayun.livecore.models.LPStudyRoomTutorModel;
import com.baijiayun.livecore.models.LPStudyUserStatus;
import com.baijiayun.livecore.models.roomresponse.LPResCloudRecordModel;
import com.baijiayun.liveuibase.toolbox.bonuspoints.BonusPointsPopupWindow;
import com.baijiayun.liveuibase.toolbox.zxyb.WritingBoardWrapper;
import com.baijiayun.liveuibase.utils.BaseUtilsKt;
import com.baijiayun.liveuibase.utils.ShadowUtil;
import com.baijiayun.liveuibase.utils.ToastUtil;
import com.baijiayun.liveuibase.widgets.common.DotProgressView;
import com.baijiayun.liveuibase.widgets.common.ProgressCircleView;
import com.zxyb.zxybbaselib.ble.entity.BleDevice;

import org.jetbrains.annotations.Nullable;

import java.lang.ref.WeakReference;
import java.util.List;
import java.util.concurrent.TimeUnit;

import io.reactivex.Observable;
import io.reactivex.android.schedulers.AndroidSchedulers;
import io.reactivex.disposables.Disposable;
import io.reactivex.subjects.BehaviorSubject;

/**
 * Created by Shubo on 2018/9/21.
 * 底部菜单栏
 */
public class BottomMenuWindow extends InteractiveBaseWindow implements BottomMenuContract.View {

    private BottomMenuContract.Presenter presenter;
    private AnimatorSet animatorSet;
    private boolean isChatDialogShowing = false, isFloatChatWindowShowing;
    private ImageView ivMic, ivCamera;
    private boolean isFirstCallRecordStatus = true;
    private boolean eyeCareIsEnable = false;
    private StudyModeWindow studyModeWindow;

    private HandsUpRemindPopupWindow handsUpRemindPopupWindow;
    private PopupWindow recordTipPopupWindow;
    private StudyHangDialog studyHangDialog;
    private Disposable disposableOfReEnter;
    private QuestionNewWindow questionNewWindow;
    private Disposable disposableOfTimer;
    private WritingBoardWrapper writingboardWrapper;
    private BonusPointsPopupWindow bonusPointsPopupWindow;
    private Disposable disposableOfBonusPointsTimer;

    public BottomMenuWindow(Context context) {
        super(context);
        animatorSet = new AnimatorSet();
        animatorSet.addListener(new AnimationSetListener($.id(R.id.window_bottom_menu_container).view()));

        if (iRouter.getLiveRoom().getSmallClassTemplateType() == null || iRouter.getLiveRoom().getSmallClassTemplateType() == LPConstants.SmallClassTemplateType.DEFAULT) {
            FrameLayout.LayoutParams lp = new FrameLayout.LayoutParams(ViewGroup.LayoutParams.WRAP_CONTENT, ViewGroup.LayoutParams.WRAP_CONTENT);
            lp.gravity = Gravity.BOTTOM | Gravity.END;
            lp.bottomMargin = (int) (DisplayUtils.getNavigationBarHeight((AppCompatActivity) context) + context.getResources().getDimension(R.dimen.bjysc_bottom_menu_window_margin_bottom));
            this.view.setLayoutParams(lp);
        }
        changeTextDrawableSize($.id(R.id.window_bottom_menu_record).view(), R.drawable.ic_interactive_cloud_record_normal);
        changeTextDrawableSize($.id(R.id.window_bottom_menu_mute_all_student).view(), R.drawable.ic_close_all_stu_mic);
        changeTextDrawableSize($.id(R.id.window_bottom_menu_unmute_all_student).view(), R.drawable.ic_open_all_stu_mic);
        changeTextDrawableSize($.id(R.id.window_bottom_menu_forbid_hands_up).view(), R.drawable.ic_interactive_forbid_handsup_off);
        changeTextDrawableSize($.id(R.id.window_bottom_menu_user_list).view(), R.drawable.ic_interactive_user_list_off);
        changeTextDrawableSize($.id(R.id.window_bottom_menu_homework_enter).view(), R.drawable.base_ic_homework_enter);
        changeTextDrawableSize($.id(R.id.window_bottom_menu_bonus_points).view(), R.drawable.bjy_group_ic_bonus_points);
        changeTextDrawableSize($.id(R.id.window_bottom_menu_user_chat).view(), R.drawable.bjy_group_ic_chat_off);

        if (iRouter.getLiveRoom().getStudyRoomVM().isStudyRoom()) {
            $.id(R.id.window_bottom_menu_record).gone();
            $.id(R.id.window_bottom_menu_mute_all_student).gone();
            $.id(R.id.window_bottom_menu_unmute_all_student).gone();
            $.id(R.id.window_bottom_menu_study_rank).visible();
            changeTextDrawableSize($.id(R.id.window_bottom_menu_study_rank).view(), R.drawable.bjysc_ic_study_rank);
            changeTextDrawableSize($.id(R.id.window_bottom_menu_gallery).view(), R.drawable.bjysc_ic_mode_study);
            if (DisplayUtils.isPad(getView().getContext())) {
                $.id(R.id.window_bottom_menu_gallery).text(view.getContext().getString(R.string.bjysc_study_room_mode_study));
            }
            if (iRouter.getLiveRoom().getCurrentUser().getType() == LPConstants.LPUserType.Student ||
                    iRouter.getLiveRoom().getCurrentUser().getType() == LPConstants.LPUserType.Visitor) {
                $.id(R.id.window_bottom_menu_study_hang).visible();
                changeTextDrawableSize($.id(R.id.window_bottom_menu_quick_question).view(), R.drawable.bjysc_ic_study_quick_question);
                changeTextDrawableSize($.id(R.id.window_bottom_menu_study_hang).view(), R.drawable.bjysc_ic_study_hang);
            }
        } else {
            changeTextDrawableSize($.id(R.id.window_bottom_menu_gallery).view(), R.drawable.ic_interactive_gallery);
        }
        if (iRouter.getLiveRoom().getPartnerConfig().disableRecordStatus()) {
            $.id(R.id.window_bottom_menu_record).gone();
        }
        if (!iRouter.getLiveRoom().getPartnerConfig().enableOperateAllMic) {
            $.id(R.id.window_bottom_menu_mute_all_student).gone();
            $.id(R.id.window_bottom_menu_unmute_all_student).gone();
        }
        if (!iRouter.getLiveRoom().getPartnerConfig().enableSwitchRoomLayout) {
            $.id(R.id.window_bottom_menu_gallery).gone();
        }
        if (!iRouter.getLiveRoom().getPartnerConfig().enableForbidRaiseHand) {
            $.id(R.id.window_bottom_menu_forbid_hands_up).gone();
        }
        if (iRouter.getLiveRoom().getToolBoxVM().enableUseBonusPoints()) {
            $.id(R.id.window_bottom_menu_bonus_points).visible();
        } else {
            $.id(R.id.window_bottom_menu_bonus_points).gone();
        }
    }

    @SuppressLint("NewApi")
    private void initView() {
        presenter = new BottomMenuPresenter(this, context);
        setBasePresenter(presenter);
        ShadowUtil.setViewBoundShadow(view.findViewById(R.id.window_bottom_menu_container_copy));

        if (iRouter.getLiveRoom().getCurrentUser().getType() == LPConstants.LPUserType.Student) {
            showStudentView();
        }
        if (iRouter.getLiveRoom().getCurrentUser().getType() == LPConstants.LPUserType.Teacher) {
            showTeacherView();
        }
        if (iRouter.getLiveRoom().getCurrentUser().getType() == LPConstants.LPUserType.Assistant) {
            showAssistantView();
        }
        if (iRouter.getLiveRoom().getZXYBVM().enableUseHandWritingBoard()
                && (iRouter.getLiveRoom().getZXYBVM().getConnectType() != LPConstants.ZXYBConnectType.TYPE_BLE
                || !iRouter.getLiveRoom().getZXYBVM().getRecentBleDevices().isEmpty())) {
            $.id(R.id.window_bottom_writingboard_container).visible();
        }
        writingboardWrapper = new WritingBoardWrapper((AppCompatActivity) context, iRouter.getLiveRoom(), $.id(R.id.window_bottom_writingboard).view());
        WritingBoardWrapper.Config config = new WritingBoardWrapper.Config();
        config.setBleConnectResId(R.drawable.bjy_group_ic_ble_connected);
        config.setBleDisconnectResId(R.drawable.bjy_group_ic_ble_disconnected);
        config.setBleSleepResId(R.drawable.bjy_group_ic_ble_sleep);
        config.setUsbConnectResId(R.drawable.bjy_group_ic_usb_connected);
        config.setUsbDisconnectResId(R.drawable.bjy_group_ic_usb_disconnected);
        config.setUsbSleepResId(R.drawable.bjy_group_ic_usb_sleep);
        writingboardWrapper.setConfig(config);
        writingboardWrapper.setDeviceScanCallback(new WritingBoardWrapper.DeviceScanCallback() {
            @Override
            public void onStartScan() {
                $.id(R.id.window_bottom_writingboard_progress).visible();
                DotProgressView dotProgressView = $.id(R.id.window_bottom_writingboard_progress).view();
                dotProgressView.invalidate();
            }

            @Override
            public void onScanDevice(@Nullable BleDevice bleDevice) {
                // do nothing
            }

            @Override
            public void onStopScan() {
                $.id(R.id.window_bottom_writingboard_progress).gone();
            }
        });
        writingboardWrapper.setConnectStateCallback(connectState -> {
            if (connectState == LPConstants.ZXYBConnectStatus.CONNECT_STATUS_SUCCESS) {
                $.id(R.id.window_bottom_writingboard_container).visible();
            }
            if (connectState == LPConstants.ZXYBConnectStatus.CONNECT_STATUS_CONNECTING) {
                $.id(R.id.window_bottom_writingboard_progress).visible();
                DotProgressView dotProgressView = $.id(R.id.window_bottom_writingboard_progress).view();
                dotProgressView.invalidate();
            } else {
                $.id(R.id.window_bottom_writingboard_progress).gone();
            }
        });

        compositeDisposable.add(iRouter.getSubjectByKey(EventKey.DisPlayBleDialog).ofType(Boolean.class)
                .filter(aBoolean -> aBoolean)
                .observeOn(AndroidSchedulers.mainThread())
                .subscribe(aBoolean -> {
                    if (writingboardWrapper != null) {
                        writingboardWrapper.showBleDialogWithPermission();
                    }
                }));

        compositeDisposable.add($.id(R.id.window_bottom_menu_gallery).clicks().throttleFirst(500, TimeUnit.MILLISECONDS)
                .observeOn(AndroidSchedulers.mainThread())
                .subscribe(o -> {
                    if (iRouter.getLiveRoom().getStudyRoomVM().isStudyRoom()) {
                        //只有自习模式
                        if (!iRouter.getLiveRoom().getStudyRoomVM().enableDiscussMode()
                                && !iRouter.getLiveRoom().getStudyRoomVM().enableTutorMode()) {
                            return;
                        }
                        studyModeWindow = new StudyModeWindow(context, iRouter);
                        studyModeWindow.setOutsideTouchable(true);
                        studyModeWindow.setFocusable(true);
                        studyModeWindow.setItemClickListener(studyRoomMode -> {
                            final boolean enableSingleTutor = iRouter.getLiveRoom().getStudyRoomVM().enableSingleTutor();
                            final List<LPStudyRoomTutorModel> tutorModels = iRouter.getLiveRoom().getStudyRoomVM().getStudyRoomCurrentTutorGroup();
                            if (enableSingleTutor && !tutorModels.isEmpty()) {
                                endTutorHelp(tutorModels, studyRoomMode);
                            } else {
                                switchStudyRoomMode(studyRoomMode);
                            }
                        });
                        studyModeWindow.show($.id(R.id.window_bottom_menu_gallery).view());
                    } else {
                        if (presenter.isMediaCoursewarePlaying()) {
                            new CommonDialog(context, CommonDialog.ChoiceMode.Double_Blue)
                                    .setMainDisplayText(context.getString(R.string.bjy_group_switch_layout_tips))
                                    .setSubtitleDisplayText(context.getString(R.string.bjy_group_switch_layout_detail))
                                    .setPositive(context.getString(R.string.bjysc_confirm), (dialog, which) -> {
                                        presenter.navigateToGalleryMode();
                                        iRouter.getSubjectByKey(EventKey.closeMediaPlayerWindow).onNext(true);
                                        dialog.dismiss();
                                    })
                                    .setNegative(context.getString(R.string.bjysc_cancel), (dialog, which) -> dialog.dismiss())
                                    .show();
                        } else {
                            presenter.navigateToGalleryMode();
                        }
                    }
                }));

        compositeDisposable.add($.id(R.id.window_bottom_question_container).clicks().throttleFirst(500, TimeUnit.MILLISECONDS)
                .observeOn(AndroidSchedulers.mainThread())
                .subscribe(o -> {
                    QuestionSelectWindow questionSelectWindow = new QuestionSelectWindow(context, iRouter, $.id(R.id.red_point_iv_question).view().getVisibility() == View.VISIBLE);
                    questionSelectWindow.setOutsideTouchable(true);
                    questionSelectWindow.setFocusable(true);
                    questionSelectWindow.setItemClickListener(position -> {
                        if (position == 0) {
                            iRouter.getSubjectByKey(EventKey.DisplayStudyQuestion).onNext(DisplayStudyQuestion.Quick_Question_Open);
                        } else {
                            iRouter.getSubjectByKey(EventKey.DisplayStudyQuestion).onNext(DisplayStudyQuestion.Question_Record_Open);
                        }
                    });
                    questionSelectWindow.show($.id(R.id.window_bottom_question_container).view());
                }));

        compositeDisposable.add(iRouter.getSubjectByKey(EventKey.DisplayStudyQuestion)
                .ofType(DisplayStudyQuestion.class)
                .observeOn(AndroidSchedulers.mainThread())
                .subscribe(displayStudyQuestion -> {
                    if (displayStudyQuestion == DisplayStudyQuestion.Question_Record_Open) {
                        $.id(R.id.red_point_iv_question).gone();
                    }
                }));

        compositeDisposable.add($.id(R.id.window_bottom_menu_record).clicks().throttleFirst(1, TimeUnit.SECONDS)
                .observeOn(AndroidSchedulers.mainThread())
                .subscribe(o -> {
                    if (!iRouter.getLiveRoom().isClassStarted()) {
                        showToastMessage(BaseUtilsKt.isTeacher(iRouter.getLiveRoom().getCurrentUser()) ? "请先点击开始上课按钮" : "课程未开始");
                    } else {
                        presenter.changeRecordStatus();
                    }
                }));

        compositeDisposable.add($.id(R.id.window_bottom_menu_forbid_hands_up).clicks().throttleFirst(500, TimeUnit.MILLISECONDS)
                .observeOn(AndroidSchedulers.mainThread())
                .subscribe(o -> presenter.changeForbidHandsUpStatus()));

        compositeDisposable.add($.id(R.id.window_bottom_speak_wrapper).clicks().throttleFirst(500, TimeUnit.MILLISECONDS)
                .observeOn(AndroidSchedulers.mainThread())
                .subscribe(c -> {
                    //自习室台上学生不能举手
                    if (!canHandsUp()) {
                        return;
                    }
                    presenter.speakApply();
                }));

        compositeDisposable.add(iRouter.getSubjectByKey(EventKey.StudyRoomSwitch)
                .ofType(LPConstants.StudyRoomMode.class)
                .subscribe(studyRoomMode -> {
                    if (iRouter.getLiveRoom().getCurrentUser().getType() == LPConstants.LPUserType.Student) {
                        showStudentView();
                    }
                    showStudyGalleryModel(studyRoomMode);
                }));
        compositeDisposable.add(iRouter.getLiveRoom().getStudyRoomVM().getObservableOfTutorAnswer()
                .observeOn(AndroidSchedulers.mainThread())
                .subscribe(lpStudyRoomTutorAnswerModel -> {
                    if (lpStudyRoomTutorAnswerModel.answerType == 1) {
                        $.id(R.id.red_point_iv_question).visible();
                        questionNewWindow = new QuestionNewWindow(context, iRouter);
                        questionNewWindow.setItemClickListener(position -> {
                            iRouter.getSubjectByKey(EventKey.DisplayStudyQuestion).onNext(DisplayStudyQuestion.Question_Record_Open);
                            questionNewWindow.dismiss();
                            RxUtils.dispose(disposableOfTimer);
                        });
                        questionNewWindow.show($.id(R.id.window_bottom_question_container).view());
                        RxUtils.dispose(disposableOfTimer);
                        disposableOfTimer = Observable.timer(5, TimeUnit.SECONDS)
                                .observeOn(AndroidSchedulers.mainThread())
                                .subscribe(aLong -> questionNewWindow.dismiss());
                    } else if (lpStudyRoomTutorAnswerModel.answerType == 2) {
                        TimerNoteDialog timerNoteDialog = new TimerNoteDialog();
                        timerNoteDialog.setHasTimer(true);
                        timerNoteDialog.setMainText(getString(R.string.bjysc_study_room_question_enter_1v1_tutor));
                        timerNoteDialog.setAssistantText(getString(R.string.bjysc_study_room_question_enter_1v1_tutor_assistant_tip));
                        timerNoteDialog.setPositiveText(context.getString(R.string.bjysc_study_room_question_enter_1v1_tutor_countdown, 5));
                        timerNoteDialog.setOnPositiveClickListener((dialog, checked) -> {
                            timerNoteDialog.dismissAllowingStateLoss();
                            iRouter.getSubjectByKey(EventKey.StudyReEnterRoom).onNext(lpStudyRoomTutorAnswerModel.studentCode);
                        });
                        timerNoteDialog.setCountDownListener(new OnCountDownListener() {
                            @Override
                            public void onTimeOut() {
                                timerNoteDialog.dismissAllowingStateLoss();
                                iRouter.getSubjectByKey(EventKey.StudyReEnterRoom).onNext(lpStudyRoomTutorAnswerModel.studentCode);
                            }

                            @Override
                            public void onTimeCountDown(int counter, int timeOut) {
                                timerNoteDialog.setText(context.getString(R.string.bjysc_study_room_question_enter_1v1_tutor_countdown, timeOut - counter));
                            }
                        });
                        timerNoteDialog.setWidth(context.getResources().getDimensionPixelSize(R.dimen.bjy_base_common_dialog_container_width));
                        timerNoteDialog.setHeight(context.getResources().getDimensionPixelSize(R.dimen.bjy_base_common_dialog_container_height));
                        if (context instanceof FragmentActivity) {
                            FragmentActivity activity = (FragmentActivity) context;
                            timerNoteDialog.show(activity.getSupportFragmentManager(), "enter1v1");
                        }
                    }
                }));

        ivMic = $.id(R.id.window_bottom_mic).view();
        ivCamera = $.id(R.id.window_bottom_camera).view();
        ivMic.setSelected(true);
        ivCamera.setSelected(true);
        $.id(R.id.window_bottom_menu_user_list).clicked(v -> {
            presenter.navigateToUserList();
            $.id(R.id.window_bottom_menu_user_count).invisible();
        });
        $.id(R.id.window_bottom_menu_user_chat).clicked(v -> {
            $.id(R.id.red_point_iv).visibility(View.INVISIBLE);
            presenter.navigateToChat();
        });
        $.id(R.id.window_bottom_menu_homework_enter).clicked(v -> presenter.navigateToHomework());
        $.id(R.id.window_bottom_menu_bonus_points).clicked(v -> presenter.navigateToBonusPoints());
        if (DisplayUtils.isPad(context)) {
            if (isAdmin()) {
                $.id(R.id.window_bottom_menu_bonus_points).text(getString(R.string.base_bonus_points_rank));
            } else {
                $.id(R.id.window_bottom_menu_bonus_points).text(getString(R.string.base_my_bonus_points));
            }
        }
        $.id(R.id.window_bottom_menu_btn).clicked(v -> changeBottomMenuVisibility());
        $.id(R.id.window_bottom_menu_btn_copy).clicked(v -> changeBottomMenuVisibility());
        compositeDisposable.add($.id(R.id.window_bottom_menu_mute_all_student).clicks().throttleFirst(1000, TimeUnit.MILLISECONDS)
                .observeOn(AndroidSchedulers.mainThread()).subscribe(c -> presenter.quickMuteAllStudentMic(true)));
        compositeDisposable.add($.id(R.id.window_bottom_menu_unmute_all_student).clicks().throttleFirst(1000, TimeUnit.MILLISECONDS)
                .observeOn(AndroidSchedulers.mainThread()).subscribe(c -> presenter.quickMuteAllStudentMic(false)));
        $.id(R.id.window_bottom_menu_study_rank).clicked(v -> {
            if (context instanceof FragmentActivity) {
                FragmentActivity activity = (FragmentActivity) context;
                StudyRankDialog studyRankDialog = new StudyRankDialog();
                final BehaviorSubject<List<LPStudyUserStatus>> subjectByKey = iRouter.getSubjectByKey(EventKey.StudyRankList);
                final List<LPStudyUserStatus> userStatuses = subjectByKey.getValue();
                if (userStatuses != null) {
                    studyRankDialog.setStudyRankList(userStatuses);
                }
                studyRankDialog.show(activity.getSupportFragmentManager(), studyRankDialog.getClass().getSimpleName());
            }
        });
        $.id(R.id.window_bottom_menu_study_hang).clicked(v -> {
            if (context instanceof FragmentActivity) {
                if (studyHangDialog != null && studyHangDialog.isAdded()) {
                    return;
                }
                final boolean isForHelping = iRouter.getSubjectValueByKey(EventKey.StudyStatusForHelping, Boolean.class, false);
                String tutorId = iRouter.getSubjectValueByKey(EventKey.StudyStatusTutor, String.class, "");
                if (isForHelping || !TextUtils.isEmpty(tutorId)) {
                    LPLogger.e("在求助中,辅导中...不能挂机");
                    return;
                }
                FragmentActivity activity = (FragmentActivity) context;
                studyHangDialog = new StudyHangDialog();
                studyHangDialog.setRouter(iRouter);
                studyHangDialog.setEndHangListener(v1 -> {
                    if (studyHangDialog != null) {
                        studyHangDialog.dismissAllowingStateLoss();
                    }
                    iRouter.setObjectByKey(EventKey.StudyStatusHangUp, false);
                    iRouter.getPublishSubjectByKey(EventCode.PublishDefaultStream).onNext(true);
                    iRouter.getLiveRoom().getStudyRoomVM().requestHangUp(false,
                            iRouter.getLiveRoom().getCurrentUser().getNumber());
                });
                //挂机
                studyHangDialog.show(activity.getSupportFragmentManager(), studyHangDialog.getClass().getSimpleName());
                iRouter.setObjectByKey(EventKey.StudyStatusHangUp, true);
                iRouter.getLiveRoom().getStudyRoomVM().requestHangUp(true, iRouter.getLiveRoom().getCurrentUser().getNumber());
            }
        });
        initDrawable();

        $.id(R.id.window_bottom_speaker).clicked((View v) -> {
            ToggleSpeakerVolumeView volumeView = new ToggleSpeakerVolumeView(getView().getContext());
            volumeView.setListener(this::showSpeakerIcon);
            PopupWindow popupWindow = new PopupWindow(volumeView, UtilsKt.getDp(148),
                    UtilsKt.getDp(20));
            popupWindow.setOutsideTouchable(true);
            popupWindow.setFocusable(true);
            popupWindow.setBackgroundDrawable(new ColorDrawable(Color.TRANSPARENT));
            popupWindow.showAsDropDown($.id(R.id.window_bottom_speaker).view(), 0, -UtilsKt.getDp(60));
        });
        eyeCareIsEnable = (boolean) iRouter.getSubjectByKey(EventKey.DisplayEyeCare).getValue();
        $.id(R.id.ct_eye_care).view().setSelected(eyeCareIsEnable);
        $.id(R.id.ct_eye_care).clicked(v -> {
            presenter.navigateToEyeCare(!eyeCareIsEnable);
            eyeCareIsEnable = !eyeCareIsEnable;
            $.id(R.id.ct_eye_care).view().setSelected(eyeCareIsEnable);
        });
        compositeDisposable.add($.id(R.id.window_bottom_mic).clicks().throttleFirst(1, TimeUnit.SECONDS)
                .observeOn(AndroidSchedulers.mainThread())
                .subscribe(o -> {
                    if (!iRouter.getLiveRoom().getOnlineUserVM().isActiveUser(iRouter.getLiveRoom().getCurrentUser())) {
                        iRouter.getSubjectByKey(EventKey.ReminderMessage).onNext(getString(iRouter.getLiveRoom().isClassStarted()
                                ? R.string.bjysc_microphone_not_up_seat
                                : R.string.bjysc_microphone_class_not_not_start));
                        return;
                    }
                    //学生开麦克风需要举手。举手同意之后才能开麦克风，主动关闭麦克风之后再想打开需要再次举手
                    //自习室，自习模式不能打开音频，讨论模式自行控制音视频，辅导模式与非自习室相同
                    if (iRouter.getLiveRoom().getCurrentUser().getType() == LPConstants.LPUserType.Student) {
                        if (iRouter.getLiveRoom().getStudyRoomVM().isStudyRoom()) {
                            String tutorId = iRouter.getSubjectValueByKey(EventKey.StudyStatusTutor, String.class, "");
                            //在辅导中自由开关麦克风
                            if (TextUtils.isEmpty(tutorId)) {
                                if (iRouter.getLiveRoom().getStudyRoomVM().getStudyRoomMode() == LPConstants.StudyRoomMode.Tutor
                                        || iRouter.getLiveRoom().getStudyRoomVM().getStudyRoomMode() == LPConstants.StudyRoomMode.SelfStudy) {
                                    if (ivMic.isSelected()) {
                                        iRouter.getSubjectByKey(EventKey.ReminderMessage).onNext(getString(R.string.bjysc_hands_up_pls));
                                        return;
                                    }
                                }
                            }
                        } else {
                            if (ivMic.isSelected()) {
                                iRouter.getSubjectByKey(EventKey.ReminderMessage).onNext(getString(R.string.bjysc_hands_up_pls));
                                return;
                            }
                        }
                    }
                    iRouter.getPublishSubjectByKey(EventCode.AttachAudio).onNext(!iRouter.getLiveRoom().getRecorder().isAudioAttached());
                }));
        compositeDisposable.add(
                $.id(R.id.window_bottom_camera).clicks().throttleFirst(1, TimeUnit.SECONDS)
                        .observeOn(AndroidSchedulers.mainThread())
                        .subscribe(o -> {
                            if (!iRouter.getLiveRoom().getOnlineUserVM().isActiveUser(iRouter.getLiveRoom().getCurrentUser())) {
                                iRouter.getSubjectByKey(EventKey.ReminderMessage).onNext(getString(iRouter.getLiveRoom().isClassStarted()
                                        ? R.string.bjysc_camera_not_up_seat
                                        : R.string.bjysc_camera_class_not_start));
                                return;
                            }
                            if (!iRouter.getLiveRoom().isClassStarted()) {
                                iRouter.getSubjectByKey(EventKey.ReminderMessage).onNext(getString(R.string.bjysc_camera_class_not_start));
                                return;
                            }
                            if (iRouter.getLiveRoom().getRecorder().isScreenSharing()) {
                                iRouter.getSubjectByKey(EventKey.CloseScreenShare).onNext(true);
                                return;
                            }
                            iRouter.getPublishSubjectByKey(EventCode.AttachVideo).onNext(!iRouter.getLiveRoom().getRecorder().isVideoAttached());
                        }));
        compositeDisposable.add(
                iRouter.getSubjectByKey(EventKey.StudyStatusForHelping)
                        .observeOn(AndroidSchedulers.mainThread())
                        .ofType(Boolean.class)
                        .subscribe(aBoolean -> showStudyHangUpState(!aBoolean))
        );
        compositeDisposable.add(
                iRouter.getSubjectByKey(EventKey.StudyStatusTutor)
                        .observeOn(AndroidSchedulers.mainThread())
                        .ofType(String.class)
                        .subscribe(s -> showStudyHangUpState(TextUtils.isEmpty(s)))
        );
    }

    @SuppressLint("NewApi")
    private void showStudyHangUpState(boolean isEnable) {
        if (!isEnable) {
            final TextView textView = $.id(R.id.window_bottom_menu_study_hang).view();
            textView.setTextColor(Color.GRAY);
            Context context = textView.getContext();
            final Drawable drawable = ContextCompat.getDrawable(context, R.drawable.bjysc_ic_study_hang);
            if (drawable != null) {
                int size = context.getResources().getDimensionPixelSize(R.dimen.bjysc_toolbar_item_width);
                drawable.setTint(Color.GRAY);
                drawable.setBounds(0, 0, size, size);
                textView.setCompoundDrawables(drawable, null, null, null);
            }
        } else {
            final TextView textView = $.id(R.id.window_bottom_menu_study_hang).view();
            textView.setTextColor(ThemeDataUtil.getColorFromThemeConfigByAttrId(textView.getContext(), R.attr.base_theme_bottom_menu_text_color));
            Context context = textView.getContext();
            final Drawable drawable = ContextCompat.getDrawable(context, R.drawable.bjysc_ic_study_hang);
            if (drawable != null) {
                int size = context.getResources().getDimensionPixelSize(R.dimen.bjysc_toolbar_item_width);
                drawable.setTint(0xff9FA8B5);
                drawable.setBounds(0, 0, size, size);
                textView.setCompoundDrawables(drawable, null, null, null);
            }
        }
    }

    private void switchStudyRoomMode(LPConstants.StudyRoomMode studyRoomMode) {
        //切换人自己用老师链接重进 切辅导模式
        if (studyRoomMode == LPConstants.StudyRoomMode.Tutor) {
            iRouter.setObjectByKey(EventKey.StudyReEnterRoom, true);
            disposableOfReEnter = iRouter.getLiveRoom().getStudyRoomVM().getObservableOfReEnterInfo()
                    .observeOn(AndroidSchedulers.mainThread())
                    .subscribe(lpStudyReEnterInfo ->
                            iRouter.getSubjectByKey(EventKey.StudyReEnterRoom).onNext(lpStudyReEnterInfo.code), throwable -> {
                    });
        } else {
            //从辅导模式切到自习模式或讨论模式
            if (iRouter.getLiveRoom().getCurrentUser().getType() == LPConstants.LPUserType.Teacher && iRouter.getLiveRoom().getStudyRoomVM().getStudyRoomMode() == LPConstants.StudyRoomMode.Tutor) {
                iRouter.setObjectByKey(EventKey.StudyReEnterRoom, true);
                disposableOfReEnter = iRouter.getLiveRoom().getStudyRoomVM().getObservableOfReEnterInfo()
                        .observeOn(AndroidSchedulers.mainThread())
                        .subscribe(lpStudyReEnterInfo ->
                                iRouter.getSubjectByKey(EventKey.StudyReEnterRoom).onNext(lpStudyReEnterInfo.code), throwable -> {
                        });
            }
        }
        iRouter.getLiveRoom().getStudyRoomVM().switchStudyRoomMode(studyRoomMode);
    }

    /**
     * 结束辅导
     */
    private void endTutorHelp(List<LPStudyRoomTutorModel> lpStudyRoomTutorModels, LPConstants.StudyRoomMode studyRoomMode) {
        NoteDialog noteDialog = new NoteDialog();
        noteDialog.setMainText(context.getString(R.string.bjysc_study_switch_mode_tutor_end_tip));
        noteDialog.setHideAssistantText(true);
        noteDialog.setOnPositiveClickListener((dialog, checked) -> {
            if (lpStudyRoomTutorModels != null && !lpStudyRoomTutorModels.isEmpty()) {
                for (LPStudyRoomTutorModel lpStudyRoomTutorModel : lpStudyRoomTutorModels) {
                    iRouter.getLiveRoom().getStudyRoomVM().requestTutorEnd(lpStudyRoomTutorModel.tutorId);
                }
            } else {
                LPLogger.e("lpStudyRoomTutorModels == null or empty");
            }
            switchStudyRoomMode(studyRoomMode);
            dialog.dismissAllowingStateLoss();
        });
        noteDialog.setOnNegativeClickListener((dialog, checked) -> dialog.dismissAllowingStateLoss());
        noteDialog.setWidth(context.getResources().getDimensionPixelSize(R.dimen.bjy_base_common_dialog_container_width));
        noteDialog.setHeight(context.getResources().getDimensionPixelSize(R.dimen.bjy_base_common_dialog_container_height));
        FragmentActivity activity = (FragmentActivity) context;
        noteDialog.show(activity.getSupportFragmentManager(), "endTutorHelp");
    }

    private void initDrawable() {
        view.findViewById(R.id.window_bottom_menu_container).setBackground(new DrawableBuilder()
                .solidColor(ThemeDataUtil.getColorFromThemeConfigByAttrId(context, R.attr.base_theme_brand_container_color))
                .strokeColor(ContextCompat.getColor(context, R.color.bjysc_bg_stroke_10))
                .strokeWidth(UtilsKt.getDp(1))
                .cornerRadius(context.getResources().getDimensionPixelSize(R.dimen.bjy_base_common_bg_radius))
                .build());
        view.findViewById(R.id.window_bottom_menu_container_copy).setBackground(new DrawableBuilder()
                .solidColor(ThemeDataUtil.getColorFromThemeConfigByAttrId(context, R.attr.base_theme_brand_container_color))
                .strokeColor(ContextCompat.getColor(context, R.color.bjysc_bg_stroke_10))
                .strokeWidth(UtilsKt.getDp(1))
                .cornerRadius(context.getResources().getDimensionPixelSize(R.dimen.bjy_base_common_bg_radius))
                .build());
    }

    private boolean canHandsUp() {
        //自习室台上学生不能举手,在辅导中学生能举手
        //不是空即在辅导中
        String tutorId = iRouter.getSubjectValueByKey(EventKey.StudyStatusTutor, String.class, "");
        return !iRouter.getLiveRoom().getStudyRoomVM().getStudyRoomMode().isGalleryLayout() || !TextUtils.isEmpty(tutorId)
                || !iRouter.getLiveRoom().getOnlineUserVM().isActiveUser(iRouter.getLiveRoom().getCurrentUser());
    }

    private void showSpeakerIcon(int volumeLevel, int min, int max) {
        //可能此window已经销毁，popup window 未销毁
        if ($ == null) {
            return;
        }
        int percent = (max - min) / 3 + 1;
        if (volumeLevel == min) {
            $.id(R.id.window_bottom_speaker).image(R.drawable.ic_interactive_speaker_normal_0);
        } else if (volumeLevel <= percent) {
            $.id(R.id.window_bottom_speaker).image(R.drawable.ic_interactive_speaker_normal_1);
        } else if (volumeLevel <= percent * 2) {
            $.id(R.id.window_bottom_speaker).image(R.drawable.ic_interactive_speaker_normal_2);
        } else {
            $.id(R.id.window_bottom_speaker).image(R.drawable.ic_interactive_speaker_normal_3);
        }
    }

    @Override
    protected View onCreateView(Context context) {
        return LayoutInflater.from(context).inflate(R.layout.bjy_group_window_bottom_menu, null);
    }

    @Override
    public void showStudentView() {
        $.id(R.id.window_bottom_menu_record).gone();
        $.id(R.id.window_bottom_menu_forbid_hands_up).gone();
        if (iRouter.getLiveRoom().getPartnerConfig().enableUseHomeWork == 1) {
            //辅导模式有作业
            if (iRouter.getLiveRoom().getStudyRoomVM().getStudyRoomMode().isGalleryLayout()) {
                $.id(R.id.window_bottom_menu_homework_enter).gone();
            } else {
                $.id(R.id.window_bottom_menu_homework_enter).visible();
            }
        }
        if (iRouter.getLiveRoom().getStudyRoomVM().enableTutorOutside()) {
            $.id(R.id.window_bottom_question_container).visible();
        }
        if (!iRouter.getLiveRoom().getPartnerConfig().enableStudentShowUserList) {
            $.id(R.id.window_bottom_menu_user_list).gone();
            $.id(R.id.window_bottom_menu_user_container).gone();
        }
        $.id(R.id.window_bottom_menu_gallery).gone();
        $.id(R.id.window_bottom_menu_mute_all_student).gone();
        $.id(R.id.window_bottom_menu_unmute_all_student).gone();
    }

    @Override
    public void showTeacherView() {
        $.id(R.id.window_bottom_speak_wrapper).gone();
    }

    @Override
    public void showAssistantView() {
        $.id(R.id.window_bottom_speak_wrapper).gone();
    }

    @Override
    public void showRecordingStatus(LPResCloudRecordModel recordStatus) {
        if (!isFirstCallRecordStatus) {
            String needShow = getNeedShowMessage(recordStatus);
            if (!TextUtils.isEmpty(needShow)) {
                new ToastUtil(context).setText(needShow).show();
            }
        }
        if (isFirstCallRecordStatus && recordStatus.status == LPConstants.CloudRecordStatus.Recording.getStatus()) {
            isFirstCallRecordStatus = false;
        }
        //在CloudRecordControlPanel未初始化时，若云端改变了录制状态，需要暂存，并在初始化时显示
        if (iRouter.getLiveRoom().getSmallClassTemplateType() == LPConstants.SmallClassTemplateType.DEFAULT) {
            if (recordStatus.status != LPConstants.CloudRecordStatus.Stopped.getStatus()) {
                changeTextDrawableSize($.id(R.id.window_bottom_menu_record).view(), R.drawable.ic_interactive_cloud_record_recording);
            } else {
                changeTextDrawableSize($.id(R.id.window_bottom_menu_record).view(), R.drawable.ic_interactive_cloud_record_normal);
            }
        }
        if (recordStatus.status == LPConstants.CloudRecordStatus.Paused.getStatus()) {
            if (DisplayUtils.isPad(getView().getContext()) && iRouter.getLiveRoom().getSmallClassTemplateType() == LPConstants.SmallClassTemplateType.DEFAULT) {
                ((TextView) $.id(R.id.window_bottom_menu_record).text(R.string.bjysc_record_paused)
                        .view()).setTextColor(ThemeDataUtil.getColorFromThemeConfigByAttrId(
                        view.getContext(), R.attr.base_theme_live_product_color));
            }
        } else if (recordStatus.status == LPConstants.CloudRecordStatus.Stopped.getStatus()) {
            if (DisplayUtils.isPad(getView().getContext()) && iRouter.getLiveRoom().getSmallClassTemplateType() == LPConstants.SmallClassTemplateType.DEFAULT) {
                ((TextView) $.id(R.id.window_bottom_menu_record).text(R.string.bjysc_record)
                        .view()).setTextColor(ThemeDataUtil.getColorFromThemeConfigByAttrId(view.getContext(), R.attr.base_theme_bottom_menu_text_color));
            }
        } else if (recordStatus.status == LPConstants.CloudRecordStatus.Recording.getStatus()) {
            if (DisplayUtils.isPad(getView().getContext()) && iRouter.getLiveRoom().getSmallClassTemplateType() == LPConstants.SmallClassTemplateType.DEFAULT) {
                ((TextView) $.id(R.id.window_bottom_menu_record).text(R.string.bjysc_record_recording)
                        .view()).setTextColor(ThemeDataUtil.getColorFromThemeConfigByAttrId(view.getContext(), R.attr.base_theme_live_product_color));
            }
        }
    }

    @Override
    public void showForbidHandsUpStatus(boolean isForbidden) {
        if (isForbidden) {
            changeTextDrawableSize($.id(R.id.window_bottom_menu_forbid_hands_up).view(), R.drawable.ic_interactive_forbid_handsup_on);
            if (iRouter.getLiveRoom().getSmallClassTemplateType() == LPConstants.SmallClassTemplateType.DEFAULT) {
                if (DisplayUtils.isPad(getView().getContext())) {
                    $.id(R.id.window_bottom_menu_forbid_hands_up).text(R.string.bjysc_un_forbid_hands_up);
                }
            }
        } else {
            changeTextDrawableSize($.id(R.id.window_bottom_menu_forbid_hands_up).view(), R.drawable.ic_interactive_forbid_handsup_off);
            if (iRouter.getLiveRoom().getSmallClassTemplateType() == LPConstants.SmallClassTemplateType.DEFAULT) {
                if (DisplayUtils.isPad(getView().getContext())) {
                    $.id(R.id.window_bottom_menu_forbid_hands_up).text(R.string.bjysc_forbid_hands_up);
                }
            }
        }
        iRouter.getSubjectByKey(EventKey.ReminderMessage).onNext(isForbidden
                ? getString(R.string.bjysc_toast_hands_up_forbidden)
                : getString(R.string.bjysc_toast_hands_up_allowed));
        if (!isAdmin() && !isForbidden) {
            showSpeakApplyNormal();
        } else {
            showSpeakApplyDisable();
        }
    }

    @Override
    public void showUserListWindowShowingStatus(boolean isShowing) {
        if (isShowing) {
            changeTextDrawableSize($.id(R.id.window_bottom_menu_user_list).view(), R.drawable.ic_interactive_user_list_on);
        } else {
            changeTextDrawableSize($.id(R.id.window_bottom_menu_user_list).view(), R.drawable.ic_interactive_user_list_off);
        }
    }

    @Override
    public void showChatWindowShowingStatus(boolean isShowing) {
        isChatDialogShowing = isShowing;
        if (view.getContext() == null) {
            return;
        }
        if (iRouter.getLiveRoom().getSmallClassTemplateType() == LPConstants.SmallClassTemplateType.DEFAULT) {
            if (isShowing) {
                changeTextDrawableSize($.id(R.id.window_bottom_menu_user_chat).view(), R.drawable.ic_interactive_chat_on);
            } else {
                changeTextDrawableSize($.id(R.id.window_bottom_menu_user_chat).view(), R.drawable.bjy_group_ic_chat_off);
            }
        }
    }

    @Override
    public void showFloatChatWindowShowingStatus(boolean isShowing) {
        isFloatChatWindowShowing = isShowing;
    }

    @Override
    public void showGalleryModel(boolean isOn) {
        if (iRouter.getLiveRoom().getStudyRoomVM().isStudyRoom()) {
            return;
        }
        if (isOn) {
            changeTextDrawableSize($.id(R.id.window_bottom_menu_gallery).view(), R.drawable.ic_interactive_gallery);
            if (DisplayUtils.isPad(getView().getContext())) {
                $.id(R.id.window_bottom_menu_gallery).text(view.getContext().getString(R.string.bjysc_gallery_layout));
            }
        } else {
            changeTextDrawableSize($.id(R.id.window_bottom_menu_gallery).view(), R.drawable.ic_interactive_board);
            if (DisplayUtils.isPad(getView().getContext())) {
                $.id(R.id.window_bottom_menu_gallery).text(view.getContext().getString(R.string.bjysc_board_layout));
            }
        }
    }

    @Override
    public void showStudyGalleryModel(LPConstants.StudyRoomMode studyRoomMode) {
        if (!iRouter.getLiveRoom().getStudyRoomVM().isStudyRoom()) {
            return;
        }
        switch (studyRoomMode) {
            case SelfStudy:
                changeTextDrawableSize($.id(R.id.window_bottom_menu_gallery).view(), R.drawable.bjysc_ic_mode_study);
                if (DisplayUtils.isPad(getView().getContext())) {
                    $.id(R.id.window_bottom_menu_gallery).text(view.getContext().getString(R.string.bjysc_study_room_mode_study));
                }
                break;
            case Discuss:
                changeTextDrawableSize($.id(R.id.window_bottom_menu_gallery).view(), R.drawable.bjysc_ic_mode_discuss);
                if (DisplayUtils.isPad(getView().getContext())) {
                    $.id(R.id.window_bottom_menu_gallery).text(view.getContext().getString(R.string.bjysc_study_room_mode_discuss));
                }
                break;
            default:
                changeTextDrawableSize($.id(R.id.window_bottom_menu_gallery).view(), R.drawable.bjysc_ic_mode_tutor);
                if (DisplayUtils.isPad(getView().getContext())) {
                    $.id(R.id.window_bottom_menu_gallery).text(view.getContext().getString(R.string.bjysc_study_room_mode_tutor));
                }
                break;
        }
    }

    @Override
    public void showChatWindowRedPoint(boolean isVisible) {
        $.id(R.id.red_point_iv).visibility(isVisible && !isChatDialogShowing && !isFloatChatWindowShowing ? View.VISIBLE : View.INVISIBLE);
    }

    @Override
    public void showShortTermClassAlreadyHasPlayback() {
        iRouter.getSubjectByKey(EventKey.ReminderMessage).onNext(getString(R.string.bjysc_record_short_term));
    }

    @Override
    public void showCloudRecordHint() {
        //延时1s弹框，避免loading页面还未消失就弹框
        getView().postDelayed(() -> {
            if (getView() == null || isDestroy()) {
                return;
            }
            if (!presenter.showCloudRecord()) {
                return;
            }
            String hint = getView().getContext().getString(R.string.bjysc_record_on) + "\n"
                    + getView().getContext().getString(R.string.bjysc_record_hint);
            TextView textView = new TextView(getView().getContext());
            textView.setText(hint);
            textView.setTextColor(ThemeDataUtil.getColorFromThemeConfigByAttrId(view.getContext(), R.attr.base_theme_bottom_menu_text_color));
            textView.setLineSpacing(UtilsKt.getDp(10), 1.0f);
            ShadowUtil.ShadowGroup shadowGroup = ShadowUtil.initShadowView(context, textView);
            if (shadowGroup == null) {
                return;
            }
            ShadowUtil.setViewBoundShadow(shadowGroup.getShadowContainer());

            textView.setPadding(
                    UtilsKt.getDp(10),
                    UtilsKt.getDp(10),
                    UtilsKt.getDp(10),
                    UtilsKt.getDp(10));
            textView.setGravity(Gravity.CENTER_VERTICAL);
            textView.setBackground(new DrawableBuilder()
                    .solidColor(ThemeDataUtil.getColorFromThemeConfigByAttrId(context, R.attr.base_theme_brand_container_color))
                    .cornerRadius(context.getResources().getDimensionPixelSize(R.dimen.bjy_base_common_bg_radius))
                    .build());
            recordTipPopupWindow = new PopupWindow(shadowGroup.getContentView(),
                    UtilsKt.getDp(376),
                    UtilsKt.getDp(116));
            recordTipPopupWindow.setOutsideTouchable(true);
            recordTipPopupWindow.setFocusable(true);
            recordTipPopupWindow.setBackgroundDrawable(new ColorDrawable(Color.TRANSPARENT));
            recordTipPopupWindow.showAsDropDown($.id(R.id.window_bottom_menu_record).view(),
                    -UtilsKt.getDp(180),
                    (int) getView().getContext().getResources().getDimension(R.dimen.bjysc_bottom_menu_record_pupup_offset));
        }, 1000);
    }

    @Override
    public void showCloudRecordRestartDialog() {
        new CommonDialog(getView().getContext(), CommonDialog.ChoiceMode.Double_Blue)
                .setMainDisplayText(getString(R.string.bjysc_record_restart_hint))
                .setPositive(getString(R.string.bjysc_record_continue), ((dialog, which) -> presenter.continueCloudRecord()))
                .setNegative(getString(R.string.bjysc_record_new), ((dialog, which) -> presenter.startNewCloudRecord())).show();
    }

    @Override
    public void showMicStatus(boolean isMicOn) {
        if (ivMic != null) {
            ivMic.setSelected(!isMicOn);
        }
    }

    @Override
    public void showCameraStatus(boolean isCameraOn) {
        if (ivCamera != null) {
            ivCamera.setSelected(!isCameraOn);
        }
    }

    @Override
    public void showUserListStatus(boolean isShow) {
        $.id(R.id.window_bottom_menu_user_container).visibility(isShow ? View.VISIBLE : View.GONE);
    }

    @Override
    public void showSpeakApplyCountDown(int countDownTime, int total) {
        $.id(R.id.window_bottom_hand_countdown).visible();
        ((ProgressCircleView) $.id(R.id.window_bottom_hand_countdown).view()).setRatio(countDownTime / (float) total);
        $.id(R.id.window_bottom_speak_apply).view().setEnabled(true);
        $.id(R.id.window_bottom_speak_apply).view().setSelected(true);
    }

    @Override
    public void showSpeakApplyNormal() {
        if (canHandsUp()) {
            $.id(R.id.window_bottom_speak_apply).view().setEnabled(true);
            $.id(R.id.window_bottom_speak_apply).view().setSelected(false);
        }
        $.id(R.id.window_bottom_hand_countdown).invisible();
    }

    @Override
    public void showSpeakApplyDisable() {
        $.id(R.id.window_bottom_speak_apply).view().setEnabled(false);
        $.id(R.id.window_bottom_speak_apply).view().setSelected(false);
        $.id(R.id.window_bottom_hand_countdown).invisible();
    }

    @Override
    public void showHandsUpRemind(int count, String name) {
        View users = $.id(R.id.window_bottom_menu_user_container).view();
        if (DisplayUtils.isPad(getView().getContext())) {
            $.id(R.id.window_bottom_menu_user_count).text(String.valueOf(count));
        }
        $.id(R.id.window_bottom_menu_user_count).visible();
        if (handsUpRemindPopupWindow == null) {
            handsUpRemindPopupWindow = new HandsUpRemindPopupWindow.Builder(getView().getContext())
                    .build()
                    .setHandsUpCount(count, name)
                    .getPopupWindow();
        } else {
            handsUpRemindPopupWindow.setRemindText(count, name);
        }

        int offsetX, offsetY;
        handsUpRemindPopupWindow.getContentView().measure(View.MeasureSpec.UNSPECIFIED, View.MeasureSpec.UNSPECIFIED);
        offsetX = -UtilsKt.getDp(6);
        offsetY = -(handsUpRemindPopupWindow.getContentView().getMeasuredHeight() + users.getMeasuredHeight() - UtilsKt.getDp(6));
        handsUpRemindPopupWindow.getContentView().setOnClickListener(v -> {
            iRouter.getSubjectByKey(EventKey.DisplayUserList).onNext(UserStatus.HandsupList);
            $.id(R.id.window_bottom_menu_user_count).invisible();
            if (handsUpRemindPopupWindow != null && handsUpRemindPopupWindow.isShowing()) {
                handsUpRemindPopupWindow.dismiss();
            }
        });
        handsUpRemindPopupWindow.showAsDropDown(users, offsetX, offsetY);
    }

    @Override
    public void hideHandsUpCount() {
        $.id(R.id.window_bottom_menu_user_count).invisible();
        if (handsUpRemindPopupWindow != null && handsUpRemindPopupWindow.isShowing()) {
            handsUpRemindPopupWindow.dismiss();
        }
    }

    @Override
    public void showCloudRecordButton(boolean cloudRecord) {
        $.id(R.id.window_bottom_menu_record).view().setVisibility(cloudRecord ? View.VISIBLE : View.GONE);
    }

    @Override
    public void showMuteAllStateChange(boolean mute) {
        if (mute) {
            iRouter.getSubjectByKey(EventKey.ReminderMessage).onNext(context.getString(R.string.bjysc_mute_all_tip));
        } else {
            iRouter.getSubjectByKey(EventKey.ReminderMessage).onNext(context.getString(R.string.bjysc_unmute_all_tip));
        }
    }

    @Override
    public void showBonusPointsAdd(Integer integer) {
        if (bonusPointsPopupWindow != null) {
            bonusPointsPopupWindow.dismiss();
        }
        bonusPointsPopupWindow = new BonusPointsPopupWindow(context, integer);
        bonusPointsPopupWindow.setOnDismissListener(() -> RxUtils.dispose(disposableOfBonusPointsTimer));
        bonusPointsPopupWindow.show($.id(R.id.window_bottom_menu_bonus_points).view());
        RxUtils.dispose(disposableOfBonusPointsTimer);
        disposableOfBonusPointsTimer = Observable.timer(2, TimeUnit.SECONDS)
                .observeOn(AndroidSchedulers.mainThread())
                .subscribe(aLong -> {
                    if (bonusPointsPopupWindow != null) {
                        bonusPointsPopupWindow.dismiss();
                    }
                });
    }

    private void changeBottomMenuVisibility() {
        View bottomMenu = $.id(R.id.window_bottom_menu_container).view();
        bottomMenu.setPivotX(bottomMenu.getWidth());
        animatorSet.cancel();
        ObjectAnimator animatorTranslation, animatorAlpha;
        if (bottomMenu.getVisibility() == View.VISIBLE) {
            animatorTranslation = ObjectAnimator.ofFloat(bottomMenu, "scaleX", bottomMenu.getScaleX(), 0.2f);
            animatorAlpha = ObjectAnimator.ofFloat(bottomMenu, "alpha", bottomMenu.getAlpha(), 0f);
            $.id(R.id.window_bottom_menu_btn).image(R.drawable.ic_interactive_bottom_menu_off);
            //让动画统一弄个替的容器
            $.id(R.id.window_bottom_menu_container_copy).visible();
            $.id(R.id.window_bottom_menu_btn_copy).image(R.drawable.ic_interactive_bottom_menu_off);
        } else {
            animatorTranslation = ObjectAnimator.ofFloat(bottomMenu, "scaleX", bottomMenu.getScaleX(), 1f);
            animatorAlpha = ObjectAnimator.ofFloat(bottomMenu, "alpha", bottomMenu.getAlpha(), 1f);
            $.id(R.id.window_bottom_menu_btn).image(R.drawable.ic_interactive_bottom_menu_on);
            $.id(R.id.window_bottom_menu_container_copy).invisible();
            $.id(R.id.window_bottom_menu_btn_copy).image(R.drawable.ic_interactive_bottom_menu_on);
        }
        animatorSet.play(animatorTranslation).with(animatorAlpha);
        animatorSet.setDuration(300);
        animatorSet.start();
    }

    @Override
    public void setPresenter(BottomMenuContract.Presenter presenter) {
        // do nothing
    }

    @Override
    public boolean onRoomStatusChange(boolean isActive) {
        boolean isWindowInit = super.onRoomStatusChange(isActive);
        if (isWindowInit) {
            if (isActive) {
                initView();
            } else {
                onDestroy();
            }
        }
        return true;
    }

    @Override
    protected void unSubscribe() {
        super.unSubscribe();
        RxUtils.dispose(disposableOfReEnter);
    }

    @Override
    public void onDestroy() {
        super.onDestroy();
        if (animatorSet != null) {
            animatorSet.removeAllListeners();
            animatorSet.cancel();
            animatorSet = null;
        }
        if (recordTipPopupWindow != null) {
            recordTipPopupWindow.dismiss();
            recordTipPopupWindow = null;
        }
        RxUtils.dispose(disposableOfReEnter);
        RxUtils.dispose(disposableOfTimer);
        RxUtils.dispose(disposableOfBonusPointsTimer);
        if (writingboardWrapper != null) {
            writingboardWrapper.onDestroy();
        }
    }

    @Override
    protected boolean onTouchEvent(View v, MotionEvent event) {
        return false;
    }

    private static class AnimationSetListener implements Animator.AnimatorListener {

        private WeakReference<View> weakReferenceView;
        private boolean needToChangeVisibility = true;

        AnimationSetListener(View view) {
            this.weakReferenceView = new WeakReference<>(view);
        }

        @Override
        public void onAnimationStart(Animator animation) {
            if (weakReferenceView.get() == null) {
                return;
            }
            View view = weakReferenceView.get();
            if (view.getVisibility() == View.GONE) {
                view.setVisibility(View.VISIBLE);
                needToChangeVisibility = false;
            }
        }

        @Override
        public void onAnimationEnd(Animator animation) {
            if (weakReferenceView.get() == null) {
                return;
            }
            View view = weakReferenceView.get();
            if (view.getVisibility() == View.VISIBLE && needToChangeVisibility) {
                view.setVisibility(View.GONE);
            }
            needToChangeVisibility = true;
        }

        @Override
        public void onAnimationCancel(Animator animation) {
            needToChangeVisibility = true;
        }

        @Override
        public void onAnimationRepeat(Animator animation) {
            // do nothing
        }
    }

    private void changeTextDrawableSize(TextView textView, @DrawableRes int drawableRes) {
        Context context = textView.getContext();
        final Drawable drawable = ContextCompat.getDrawable(context, drawableRes);
        if (drawable != null) {
            int size = context.getResources().getDimensionPixelSize(R.dimen.bjysc_toolbar_item_width);
            drawable.setBounds(0, 0, size, size);
            textView.setCompoundDrawables(drawable, null, null, null);
        }
    }

    private String getNeedShowMessage(LPResCloudRecordModel nowStatus) {
        String s = "";
        if (!isAdmin()) {
            return s;
        }
        if (nowStatus.status == LPConstants.CloudRecordStatus.Recording.getStatus()) {
            s = getString(R.string.bjy_group_bottom_menu_cloud_record_enable);
            if (nowStatus.operator == LPConstants.LPUserType.Teacher && !BaseUtilsKt.isTeacher(iRouter.getLiveRoom().getCurrentUser())) {
                s = getString(R.string.bjy_group_bottom_menu_teacher_started_cloud_record);
            } else if (nowStatus.operator == LPConstants.LPUserType.Assistant && BaseUtilsKt.isTeacher(iRouter.getLiveRoom().getCurrentUser())) {
                s = getString(R.string.bjy_group_bottom_menu_assistant_started_cloud_record);
            }
        } else {
            s = getString(R.string.bjy_group_bottom_menu_cloud_record_disable);
            if (nowStatus.operator == LPConstants.LPUserType.Teacher && !BaseUtilsKt.isTeacher(iRouter.getLiveRoom().getCurrentUser())) {
                s = getString(R.string.bjy_group_bottom_menu_teacher_stopped_cloud_record);
            } else if (nowStatus.operator == LPConstants.LPUserType.Assistant && BaseUtilsKt.isTeacher(iRouter.getLiveRoom().getCurrentUser())) {
                s = getString(R.string.bjy_group_bottom_menu_assistant_stopped_cloud_record);
            }
        }
        return s;
    }
}
