package com.baijiayun.groupclassui.window.toolbar;

import android.content.Context;
import android.view.View;

import com.baijiayun.groupclassui.global.EventKey;
import com.baijiayun.groupclassui.global.IRouter;
import com.baijiayun.liveuibase.widgets.toolbar.BaseDrawTextSettingWindow;
import com.baijiayun.liveuibase.widgets.toolbar.ColorSelectData;

import io.reactivex.disposables.Disposable;

public class DrawTextSettingWindow extends BaseDrawTextSettingWindow {
    private Disposable disposableOfColorAllChange;
    IRouter iRouter;

    public DrawTextSettingWindow(Context context, IRouter iRouter) {
        super(context);
        this.iRouter = iRouter;
    }

    /**
     * 初始化颜色选中
     */
    @Override
    protected boolean initColorsSelect() {
        boolean rst = super.initColorsSelect();
        if (rst) {
            if (disposableOfColorAllChange != null) {
                disposableOfColorAllChange.dispose();
            }
            disposableOfColorAllChange = iRouter.getSubjectByKey(EventKey.DrawColorAllChange)
                    .ofType(String.class)
                    .subscribe(this::handleColorAllChangeRst);
        }
        return rst;
    }

    @Override
    protected void onChangeColor(ColorSelectData colorSelectData) {
        iRouter.setObjectByKey(EventKey.IsChangedPaintColor, true);
        iRouter.getSubjectByKey(EventKey.DrawColorChange).onNext(colorSelectData);
    }

    @Override
    protected void onChangeTextSize(int textSize) {
        iRouter.getSubjectByKey(EventKey.DrawTextSizeChange).onNext(textSize);
    }

    @Override
    public void show(View anchor) {
        super.show(anchor);
        if (iRouter != null) {
            iRouter.getSubjectByKey(EventKey.DrawTextEnable).onNext(true);
        }
    }

    public void onDestroy() {
        if (disposableOfColorAllChange != null) {
            disposableOfColorAllChange.dispose();
            disposableOfColorAllChange = null;
        }
    }
}
